; ====================================================;
;                                                     ;
;      ws2_32.inc for EC v2 Fasm visual projects      ;
;                   (version 1.0.4)                   ;
;                                                     ;
;         Copyright  Ramon Sala - 2018-2022          ;
;                                                     ;
; ====================================================;

if ~defined WS2_32_INC
define WS2_32_INC 1

if ~defined INCL_WINSOCK_API_TYPEDEFS
    INCL_WINSOCK_API_TYPEDEFS                       equ     0
end if

if ~defined INCL_WINSOCK_API_PROTOTYPES
    INCL_WINSOCK_API_PROTOTYPES                     equ     1
end if

if ~defined FD_SETSIZE
    FD_SETSIZE                                      equ     64
end if

IOCPARM_MASK                                        equ     07FH

IOC_VOID                                            equ     020000000H
IOC_OUT                                             equ     040000000H
IOC_IN                                              equ     080000000H
IOC_INOUT                                           equ     0C0000000H

IPPROTO_IP                                          equ     0
IPPROTO_ICMP                                        equ     1
IPPROTO_IGMP                                        equ     2
IPPROTO_GGP                                         equ     3
IPPROTO_TCP                                         equ     6
IPPROTO_PUP                                         equ     12
IPPROTO_UDP                                         equ     17
IPPROTO_IDP                                         equ     22
IPPROTO_ND                                          equ     77
IPPROTO_RAW                                         equ     255
IPPROTO_MAX                                         equ     256

IPPORT_ECHO                                         equ     7
IPPORT_DISCARD                                      equ     9
IPPORT_SYSTAT                                       equ     11
IPPORT_DAYTIME                                      equ     13
IPPORT_NETSTAT                                      equ     15
IPPORT_FTP                                          equ     21
IPPORT_TELNET                                       equ     23
IPPORT_SMTP                                         equ     25
IPPORT_TIMESERVER                                   equ     37
IPPORT_NAMESERVER                                   equ     42
IPPORT_WHOIS                                        equ     43
IPPORT_MTP                                          equ     57
IPPORT_TFTP                                         equ     69
IPPORT_RJE                                          equ     77
IPPORT_FINGER                                       equ     79
IPPORT_TTYLINK                                      equ     87
IPPORT_SUPDUP                                       equ     95
IPPORT_EXECSERVER                                   equ     512
IPPORT_LOGINSERVER                                  equ     513
IPPORT_CMDSERVER                                    equ     514
IPPORT_EFSSERVER                                    equ     520
IPPORT_BIFFUDP                                      equ     512
IPPORT_WHOSERVER                                    equ     513
IPPORT_ROUTESERVER                                  equ     520
IPPORT_RESERVED                                     equ     1024

IMPLINK_IP                                          equ     155
IMPLINK_LOWEXPER                                    equ     156
IMPLINK_HIGHEXPER                                   equ     158

IN_CLASSA_NET                                       equ     0FF000000H
IN_CLASSA_NSHIFT                                    equ     24
IN_CLASSA_HOST                                      equ     000FFFFFFH
IN_CLASSA_MAX                                       equ     128

IN_CLASSB_NET                                       equ     0FFFF0000H
IN_CLASSB_NSHIFT                                    equ     16
IN_CLASSB_HOST                                      equ     00000FFFFH
IN_CLASSB_MAX                                       equ     65536

IN_CLASSC_NET                                       equ     0FFFFFF00H
IN_CLASSC_NSHIFT                                    equ     8
IN_CLASSC_HOST                                      equ     0000000FFH

IN_CLASSD_NET                                       equ     0F0000000H
IN_CLASSD_NSHIFT                                    equ     28
IN_CLASSD_HOST                                      equ     00FFFFFFFH

INADDR_ANY                                          equ     000000000H
INADDR_LOOPBACK                                     equ     07F000001H
INADDR_BROADCAST                                    equ     0FFFFFFFFH
INADDR_NONE                                         equ     0FFFFFFFFH

ADDR_ANY                                            equ     INADDR_ANY

if ~defined SOCKET_ERROR
    SOCKET_ERROR                                    equ     (-1)
end if

FROM_PROTOCOL_INFO                                  equ     (-1)

if ~defined SOCK_STREAM
    SOCK_STREAM                                     equ     1
    SOCK_DGRAM                                      equ     2
    SOCK_RAW                                        equ     3
    SOCK_RDM                                        equ     4
    SOCK_SEQPACKET                                  equ     5
end if

SO_DEBUG                                            equ     00001H
SO_ACCEPTCONN                                       equ     00002H
SO_REUSEADDR                                        equ     00004H
SO_KEEPALIVE                                        equ     00008H
SO_DONTROUTE                                        equ     00010H
SO_BROADCAST                                        equ     00020H
SO_USELOOPBACK                                      equ     00040H
SO_LINGER                                           equ     00080H
SO_OOBINLINE                                        equ     00100H
SO_DONTLINGER                                       equ     0FFFFFF7FH
SO_EXCLUSIVEADDRUSE                                 equ     0FFFFFFFBH

SO_SNDBUF                                           equ     01001H
SO_RCVBUF                                           equ     01002H
SO_SNDLOWAT                                         equ     01003H
SO_RCVLOWAT                                         equ     01004H
SO_SNDTIMEO                                         equ     01005H
SO_RCVTIMEO                                         equ     01006H
SO_ERROR                                            equ     01007H
SO_TYPE                                             equ     01008H

SO_GROUP_ID                                         equ     02001H
SO_GROUP_PRIORITY                                   equ     02002H
SO_MAX_MSG_SIZE                                     equ     02003H
SO_PROTOCOL_INFOA                                   equ     02004H
SO_PROTOCOL_INFOW                                   equ     02005H

if defined APP_UNICODE
    SO_PROTOCOL_INFO                                equ     SO_PROTOCOL_INFOW
else
    SO_PROTOCOL_INFO                                equ     SO_PROTOCOL_INFOA
end if

PVD_CONFIG                                          equ     03001H
SO_CONDITIONAL_ACCEPT                               equ     03002H

TCP_NODELAY                                         equ     00001H

AF_UNSPEC                                           equ     0
AF_UNIX                                             equ     1
AF_INET                                             equ     2
AF_IMPLINK                                          equ     3
AF_PUP                                              equ     4
AF_CHAOS                                            equ     5
AF_NS                                               equ     6
AF_IPX                                              equ     AF_NS
AF_ISO                                              equ     7
AF_OSI                                              equ     AF_ISO
AF_ECMA                                             equ     8
AF_DATAKIT                                          equ     9
AF_CCITT                                            equ     10
AF_SNA                                              equ     11
AF_DECnet                                           equ     12
AF_DLI                                              equ     13
AF_LAT                                              equ     14
AF_HYLINK                                           equ     15
AF_APPLETALK                                        equ     16
AF_NETBIOS                                          equ     17
AF_VOICEVIEW                                        equ     18
AF_FIREFOX                                          equ     19
AF_UNKNOWN1                                         equ     20
AF_BAN                                              equ     21
AF_ATM                                              equ     22
AF_INET6                                            equ     23
AF_CLUSTER                                          equ     24
AF_12844                                            equ     25
AF_IRDA                                             equ     26
AF_NETDES                                           equ     28
AF_MAX                                              equ     29

PF_UNSPEC                                           equ     AF_UNSPEC
PF_UNIX                                             equ     AF_UNIX
PF_INET                                             equ     AF_INET
PF_IMPLINK                                          equ     AF_IMPLINK
PF_PUP                                              equ     AF_PUP
PF_CHAOS                                            equ     AF_CHAOS
PF_NS                                               equ     AF_NS
PF_IPX                                              equ     AF_IPX
PF_ISO                                              equ     AF_ISO
PF_OSI                                              equ     AF_OSI
PF_ECMA                                             equ     AF_ECMA
PF_DATAKIT                                          equ     AF_DATAKIT
PF_CCITT                                            equ     AF_CCITT
PF_SNA                                              equ     AF_SNA
PF_DECnet                                           equ     AF_DECnet
PF_DLI                                              equ     AF_DLI
PF_LAT                                              equ     AF_LAT
PF_HYLINK                                           equ     AF_HYLINK
PF_APPLETALK                                        equ     AF_APPLETALK
PF_VOICEVIEW                                        equ     AF_VOICEVIEW
PF_FIREFOX                                          equ     AF_FIREFOX
PF_UNKNOWN1                                         equ     AF_UNKNOWN1
PF_BAN                                              equ     AF_BAN
PF_ATM                                              equ     AF_ATM
PF_INET6                                            equ     AF_INET6
PF_MAX                                              equ     AF_MAX

SOL_SOCKET                                          equ     0FFFFH

SOMAXCONN                                           equ     07FFFFFFFH

MSG_OOB                                             equ     00001H
MSG_PEEK                                            equ     00002H
MSG_DONTROUTE                                       equ     00004H
MSG_PARTIAL                                         equ     08000H
MSG_INTERRUPT                                       equ     00010H
MSG_MAXIOVLEN                                       equ     16

MAXGETHOSTSTRUCT                                    equ     1024

FD_READ_BIT                                         equ     0
FD_READ                                             equ     (1 shl FD_READ_BIT)
FD_WRITE_BIT                                        equ     1
FD_WRITE                                            equ     (1 shl FD_WRITE_BIT)
FD_OOB_BIT                                          equ     2
FD_OOB                                              equ     (1 shl FD_OOB_BIT)
FD_ACCEPT_BIT                                       equ     3
FD_ACCEPT                                           equ     (1 shl FD_ACCEPT_BIT)
FD_CONNECT_BIT                                      equ     4
FD_CONNECT                                          equ     (1 shl FD_CONNECT_BIT)
FD_CLOSE_BIT                                        equ     5
FD_CLOSE                                            equ     (1 shl FD_CLOSE_BIT)
FD_QOS_BIT                                          equ     6
FD_QOS                                              equ     (1 shl FD_QOS_BIT)
FD_GROUP_QOS_BIT                                    equ     7
FD_GROUP_QOS                                        equ     (1 shl FD_GROUP_QOS_BIT)
FD_ROUTING_INTERFACE_CHANGE_BIT                     equ     8
FD_ROUTING_INTERFACE_CHANGE                         equ     (1 shl FD_ROUTING_INTERFACE_CHANGE_BIT)
FD_ADDRESS_LIST_CHANGE_BIT                          equ     9
FD_ADDRESS_LIST_CHANGE                              equ     (1 shl FD_ADDRESS_LIST_CHANGE_BIT)
FD_MAX_EVENTS                                       equ     10
FD_ALL_EVENTS                                       equ     ((1 shl FD_MAX_EVENTS)-1)

if ~defined WSABASEERR
    WSABASEERR                                      equ     (10000
    WSAEINTR                                        equ     (WSABASEERR+4)
    WSAEBADF                                        equ     (WSABASEERR+9)
    WSAEACCES                                       equ     (WSABASEERR+13)
    WSAEFAULT                                       equ     (WSABASEERR+14)
    WSAEINVAL                                       equ     (WSABASEERR+22)
    WSAEMFILE                                       equ     (WSABASEERR+24)
    WSAEWOULDBLOCK                                  equ     (WSABASEERR+35)
    WSAEINPROGRESS                                  equ     (WSABASEERR+36)
    WSAEALREADY                                     equ     (WSABASEERR+37)
    WSAENOTSOCK                                     equ     (WSABASEERR+38)
    WSAEDESTADDRREQ                                 equ     (WSABASEERR+39)
    WSAEMSGSIZE                                     equ     (WSABASEERR+40)
    WSAEPROTOTYPE                                   equ     (WSABASEERR+41)
    WSAENOPROTOOPT                                  equ     (WSABASEERR+42)
    WSAEPROTONOSUPPORT                              equ     (WSABASEERR+43)
    WSAESOCKTNOSUPPORT                              equ     (WSABASEERR+44)
    WSAEOPNOTSUPP                                   equ     (WSABASEERR+45)
    WSAEPFNOSUPPORT                                 equ     (WSABASEERR+46)
    WSAEAFNOSUPPORT                                 equ     (WSABASEERR+47)
    WSAEADDRINUSE                                   equ     (WSABASEERR+48)
    WSAEADDRNOTAVAIL                                equ     (WSABASEERR+49)
    WSAENETDOWN                                     equ     (WSABASEERR+50)
    WSAENETUNREACH                                  equ     (WSABASEERR+51)
    WSAENETRESET                                    equ     (WSABASEERR+52)
    WSAECONNABORTED                                 equ     (WSABASEERR+53)
    WSAECONNRESET                                   equ     (WSABASEERR+54)
    WSAENOBUFS                                      equ     (WSABASEERR+55)
    WSAEISCONN                                      equ     (WSABASEERR+56)
    WSAENOTCONN                                     equ     (WSABASEERR+57)
    WSAESHUTDOWN                                    equ     (WSABASEERR+58)
    WSAETOOMANYREFS                                 equ     (WSABASEERR+59)
    WSAETIMEDOUT                                    equ     (WSABASEERR+60)
    WSAECONNREFUSED                                 equ     (WSABASEERR+61)
    WSAELOOP                                        equ     (WSABASEERR+62)
    WSAENAMETOOLONG                                 equ     (WSABASEERR+63)
    WSAEHOSTDOWN                                    equ     (WSABASEERR+64)
    WSAEHOSTUNREACH                                 equ     (WSABASEERR+65)
    WSAENOTEMPTY                                    equ     (WSABASEERR+66)
    WSAEPROCLIM                                     equ     (WSABASEERR+67)
    WSAEUSERS                                       equ     (WSABASEERR+68)
    WSAEDQUOT                                       equ     (WSABASEERR+69)
    WSAESTALE                                       equ     (WSABASEERR+70)
    WSAEREMOTE                                      equ     (WSABASEERR+71)
    WSASYSNOTREADY                                  equ     (WSABASEERR+91)
    WSAVERNOTSUPPORTED                              equ     (WSABASEERR+92)
    WSANOTINITIALISED                               equ     (WSABASEERR+93)
    WSAEDISCON                                      equ     (WSABASEERR+101)
    WSAENOMORE                                      equ     (WSABASEERR+102)
    WSAECANCELLED                                   equ     (WSABASEERR+103)
    WSAEINVALIDPROCTABLE                            equ     (WSABASEERR+104)
    WSAEINVALIDPROVIDER                             equ     (WSABASEERR+105)
    WSAEPROVIDERFAILEDINIT                          equ     (WSABASEERR+106)
    WSASYSCALLFAILURE                               equ     (WSABASEERR+107)
    WSASERVICE_NOT_FOUND                            equ     (WSABASEERR+108)
    WSATYPE_NOT_FOUND                               equ     (WSABASEERR+109)
    WSA_E_NO_MORE                                   equ     (WSABASEERR+110)
    WSA_E_CANCELLED                                 equ     (WSABASEERR+111)
    WSAEREFUSED                                     equ     (WSABASEERR+112)
    WSAHOST_NOT_FOUND                               equ     (WSABASEERR+1001)
    WSATRY_AGAIN                                    equ     (WSABASEERR+1002)
    WSANO_RECOVERY                                  equ     (WSABASEERR+1003)
    WSANO_DATA                                      equ     (WSABASEERR+1004)
    WSA_QOS_RECEIVERS                               equ     (WSABASEERR+1005)
    WSA_QOS_SENDERS                                 equ     (WSABASEERR+1006)
    WSA_QOS_NO_SENDERS                              equ     (WSABASEERR+1007)
    WSA_QOS_NO_RECEIVERS                            equ     (WSABASEERR+1008)
    WSA_QOS_REQUEST_CONFIRMED                       equ     (WSABASEERR+1009)
    WSA_QOS_ADMISSION_FAILURE                       equ     (WSABASEERR+1010)
    WSA_QOS_POLICY_FAILURE                          equ     (WSABASEERR+1011)
    WSA_QOS_BAD_STYLE                               equ     (WSABASEERR+1012)
    WSA_QOS_BAD_OBJECT                              equ     (WSABASEERR+1013)
    WSA_QOS_TRAFFIC_CTRL_ERROR                      equ     (WSABASEERR+1014)
    WSA_QOS_GENERIC_ERROR                           equ     (WSABASEERR+1015)
    WSA_QOS_ESERVICETYPE                            equ     (WSABASEERR+1016)
    WSA_QOS_EFLOWSPEC                               equ     (WSABASEERR+1017)
    WSA_QOS_EPROVSPECBUF                            equ     (WSABASEERR+1018)
    WSA_QOS_EFILTERSTYLE                            equ     (WSABASEERR+1019)
    WSA_QOS_EFILTERTYPE                             equ     (WSABASEERR+1020)
    WSA_QOS_EFILTERCOUNT                            equ     (WSABASEERR+1021)
    WSA_QOS_EOBJLENGTH                              equ     (WSABASEERR+1022)
    WSA_QOS_EFLOWCOUNT                              equ     (WSABASEERR+1023)
    WSA_QOS_EUNKOWNPSOBJ                            equ     (WSABASEERR+1024)
    WSA_QOS_EPOLICYOBJ                              equ     (WSABASEERR+1025)
    WSA_QOS_EFLOWDESC                               equ     (WSABASEERR+1026)
    WSA_QOS_EPSFLOWSPEC                             equ     (WSABASEERR+1027)
    WSA_QOS_EPSFILTERSPEC                           equ     (WSABASEERR+1028)
    WSA_QOS_ESDMODEOBJ                              equ     (WSABASEERR+1029)
    WSA_QOS_ESHAPERATEOBJ                           equ     (WSABASEERR+1030)
    WSA_QOS_RESERVED_PETYPE                         equ     (WSABASEERR+1031)
end if

HOST_NOT_FOUND                                      equ     WSAHOST_NOT_FOUND
TRY_AGAIN                                           equ     WSATRY_AGAIN
NO_RECOVERY                                         equ     WSANO_RECOVERY
NO_DATA                                             equ     WSANO_DATA
WSANO_ADDRESS                                       equ     WSANO_DATA
NO_ADDRESS                                          equ     WSANO_ADDRESS

WSAEVENT                                            equ     HANDLE
WSAOVERLAPPED                                       equ     OVERLAPPED

WSA_IO_PENDING                                      equ     ERROR_IO_PENDING
WSA_IO_INCOMPLETE                                   equ     ERROR_IO_INCOMPLETE
WSA_INVALID_HANDLE                                  equ     ERROR_INVALID_HANDLE
WSA_INVALID_PARAMETER                               equ     ERROR_INVALID_PARAMETER
WSA_NOT_ENOUGH_MEMORY                               equ     ERROR_NOT_ENOUGH_MEMORY
WSA_OPERATION_ABORTED                               equ     ERROR_OPERATION_ABORTED

WSA_INVALID_EVENT                                   equ     NULL
WSA_MAXIMUM_WAIT_EVENTS                             equ     MAXIMUM_WAIT_OBJECTS
WSA_WAIT_FAILED                                     equ     WAIT_FAILED
WSA_WAIT_EVENT_0                                    equ     WAIT_OBJECT_0
WSA_WAIT_IO_COMPLETION                              equ     WAIT_IO_COMPLETION
WSA_WAIT_TIMEOUT                                    equ     WAIT_TIMEOUT
WSA_INFINITE                                        equ     INFINITE

WSADESCRIPTION_LEN                                  equ     256
WSASYS_STATUS_LEN                                   equ     128

CF_ACCEPT                                           equ     00000H
CF_REJECT                                           equ     00001H
CF_DEFER                                            equ     00002H

SD_RECEIVE                                          equ     000H
SD_SEND                                             equ     001H
SD_BOTH                                             equ     002H

SG_UNCONSTRAINED_GROUP                              equ     001H
SG_CONSTRAINED_GROUP                                equ     002H

MAX_PROTOCOL_CHAIN                                  equ     7

BASE_PROTOCOL                                       equ     1
LAYERED_PROTOCOL                                    equ     0

WSAPROTOCOL_LEN                                     equ     255

PFL_MULTIPLE_PROTO_ENTRIES                          equ     00000001H
PFL_RECOMMENDED_PROTO_ENTRY                         equ     00000002H
PFL_HIDDEN                                          equ     00000004H
PFL_MATCHES_PROTOCOL_ZERO                           equ     00000008H

XP1_CONNECTIONLESS                                  equ     00000001H
XP1_GUARANTEED_DELIVERY                             equ     00000002H
XP1_GUARANTEED_ORDER                                equ     00000004H
XP1_MESSAGE_ORIENTED                                equ     00000008H
XP1_PSEUDO_STREAM                                   equ     00000010H
XP1_GRACEFUL_CLOSE                                  equ     00000020H
XP1_EXPEDITED_DATA                                  equ     00000040H
XP1_CONNECT_DATA                                    equ     00000080H
XP1_DISCONNECT_DATA                                 equ     00000100H
XP1_SUPPORT_BROADCAST                               equ     00000200H
XP1_SUPPORT_MULTIPOINT                              equ     00000400H
XP1_MULTIPOINT_CONTROL_PLANE                        equ     00000800H
XP1_MULTIPOINT_DATA_PLANE                           equ     00001000H
XP1_QOS_SUPPORTED                                   equ     00002000H
XP1_INTERRUPT                                       equ     00004000H
XP1_UNI_SEND                                        equ     00008000H
XP1_UNI_RECV                                        equ     00010000H
XP1_IFS_HANDLES                                     equ     00020000H
XP1_PARTIAL_MESSAGE                                 equ     00040000H

BIGENDIAN                                           equ     0000H
LITTLEENDIAN                                        equ     0001H               

SECURITY_PROTOCOL_NONE                              equ     0000H

JL_SENDER_ONLY                                      equ     001H
JL_RECEIVER_ONLY                                    equ     002H
JL_BOTH                                             equ     004H

WSA_FLAG_OVERLAPPED                                 equ     001H
WSA_FLAG_MULTIPOINT_C_ROOT                          equ     002H
WSA_FLAG_MULTIPOINT_C_LEAF                          equ     004H
WSA_FLAG_MULTIPOINT_D_ROOT                          equ     008H
WSA_FLAG_MULTIPOINT_D_LEAF                          equ     010H

IOC_UNIX                                            equ     000000000H
IOC_WS2                                             equ     008000000H
IOC_PROTOCOL                                        equ     010000000H
IOC_VENDOR                                          equ     018000000H

TH_NETDEV                                           equ     000000001H
TH_TAPI                                             equ     000000002H

SERVICE_MULTIPLE                                    equ     1

NS_ALL                                              equ     0
NS_SAP                                              equ     1
NS_NDS                                              equ     2
NS_PEER_BROWSE                                      equ     3
NS_SLP                                              equ     5
NS_DHCP                                             equ     6
NS_TCPIP_LOCAL                                      equ     10
NS_TCPIP_HOSTS                                      equ     11
NS_DNS                                              equ     12
NS_NETBT                                            equ     13
NS_WINS                                             equ     14
NS_NBP                                              equ     20
NS_MS                                               equ     30
NS_STDA                                             equ     31
NS_NTDS                                             equ     32
NS_X500                                             equ     40
NS_NIS                                              equ     41
NS_NISPLUS                                          equ     42
NS_WRQ                                              equ     50
NS_NETDES                                           equ     60

RES_UNUSED_1                                        equ     000000001H
RES_FLUSH_CACHE                                     equ     000000002H

if ~defined RES_SERVICE
    RES_SERVICE                                     equ     000000004H
end if

SERVICE_TYPE_VALUE_IPXPORTA                         equ     'IpxSocket'
SERVICE_TYPE_VALUE_IPXPORTW                         du      'IpxSocket', 0
SERVICE_TYPE_VALUE_SAPIDA                           equ     'SapId'
SERVICE_TYPE_VALUE_SAPIDW                           du      'SapId', 0
SERVICE_TYPE_VALUE_TCPPORTA                         equ     'TcpPort'
SERVICE_TYPE_VALUE_TCPPORTW                         du      'TcpPort', 0
SERVICE_TYPE_VALUE_UDPPORTA                         equ     'UdpPort'
SERVICE_TYPE_VALUE_UDPPORTW                         du      'UdpPort', 0
SERVICE_TYPE_VALUE_OBJECTIDA                        equ     'ObjectId'
SERVICE_TYPE_VALUE_OBJECTIDW                        du      'ObjectId', 0

COMP_EQUAL                                          equ     0
COMP_NOTLESS                                        equ     1

LUP_DEEP                                            equ     00001H
LUP_CONTAINERS                                      equ     00002H
LUP_NOCONTAINERS                                    equ     00004H
LUP_NEAREST                                         equ     00008H
LUP_RETURN_NAME                                     equ     00010H
LUP_RETURN_TYPE                                     equ     00020H
LUP_RETURN_VERSION                                  equ     00040H
LUP_RETURN_COMMENT                                  equ     00080H
LUP_RETURN_ADDR                                     equ     00100H
LUP_RETURN_BLOB                                     equ     00200H
LUP_RETURN_ALIASES                                  equ     00400H
LUP_RETURN_QUERY_STRING                             equ     00800H
LUP_RETURN_ALL                                      equ     00FF0H
LUP_RES_SERVICE                                     equ     08000H
LUP_FLUSHCACHE                                      equ     01000H
LUP_FLUSHPREVIOUS                                   equ     02000H

RESULT_IS_ALIAS                                     equ     00001H

RNRSERVICE_REGISTER                                 equ     0
RNRSERVICE_DEREGISTER                               equ     1
RNRSERVICE_DELETE                                   equ     2


;======================================== Structures ======================================;
if ~defined fd_set_DEF
    fd_set_DEF equ 1
    struc fd_set {
        fd_count       dd ?
        fd_array       dd FD_SETSIZE dup(?)
    }
end if

if ~defined timeval_DEF
    timeval_DEF equ 1
    struc timeval {
        tv_sec  dd ?
        tv_usec dd ?
    }
end if

if ~defined hostent_DEF
    hostent_DEF equ 1
    struc hostent {
        h_name         xptr  ?
        h_aliases      xptr  ?
        h_addrtype     dw    ?
        h_length       dw    ?
        if defined APP_WIN64
                       dd    ?
        end if
        h_addr_list    xptr  ?
    }
end if

if ~defined netent_DEF
    netent_DEF equ 1
    struct netent
        n_name       dd ?
        n_aliases    dd ?
        n_addrtype   dw ?
        n_net        dd ?
    ends
end if

if ~defined servent_DEF
    servent_DEF equ 1
    struct servent
        s_name       dd ?
        s_aliases    dd ?
        s_port       dw ?
        s_proto      dd ?
    ends
end if

if ~defined protoent_DEF
    protoent_DEF equ 1
    struct protoent
        p_name       dd ?
        p_aliases    dd ?
        p_proto      dw ?
    ends
end if

if ~defined in_addr_DEF
    in_addr_DEF equ 1
    struct in_addr
        union
            struct
                s_b1 db ?
                s_b2 db ?
                s_b3 db ?
                s_b4 db ?
            ends
            struct
                s_w1 dw ?
                s_w2 dw ?
            ends
            S_addr dd ?
        ends
    ends
end if

if ~defined sockaddr_in_DEF
    sockaddr_in_DEF equ 1
    struc sockaddr_in {
        sin_family     dw ?
        sin_port       dw ?
        sin_addr       dd ?
        sin_zero       db 8 dup(?)
    }
end if

if ~defined WSADATA_DEF
    WSADATA_DEF equ 1
    struc WSADATA {
        wVersion       dw   ?
        wHighVersion   dw   ?
        szDescription  db   (WSADESCRIPTION_LEN+1) dup(?)
        szSystemStatus db   (WSASYS_STATUS_LEN+1) dup(?)
        iMaxSockets    dw   ?
        iMaxUdpDg      dw   ?
        _padding_      db   2 dup(?)
        lpVendorInfo   xptr ?
    }
end if

if ~defined sockaddr_DEF
    sockaddr_DEF equ 1
    struc sockaddr {
        sa_family      dw ?
        sa_data        db 14 dup(?)
    }
end if

if ~defined sockproto_DEF
    sockproto_DEF equ 1
    struct sockproto
        sp_family    dw ?
        sp_protocol  dw ?
    ends
end if

if ~defined linger_DEF
    linger_DEF equ 1
    struct linger
        l_onoff      dw ?
        l_linger     dw ?
    ends
end if

if ~defined FLOWSPEC_DEF
    FLOWSPEC_DEF equ 1
    struct FLOWSPEC
        TokenRate          dd ?
        TokenBucketSize    dd ?
        PeakBandwidth      dd ?
        Latency            dd ?
        DelayVariation     dd ?
        ServiceType        dd ?
        MaxSduSize         dd ?
        MinimumPolicedSize dd ?
    ends
end if

struct WSABUF
    len dd   ?
    buf xptr ?
ends

struct QualityOfService
    SendingFlowspec   FLOWSPEC
    ReceivingFlowspec FLOWSPEC
    ProviderSpecific  WSABUF
ends

struct WSANETWORKEVENTS
    lNetworkEvents dd ?
    iErrorCode     dd FD_MAX_EVENTS dup(?)
ends

struct WSAPROTOCOLCHAIN
    ChainLen     dd ?
    ChainEntries dd MAX_PROTOCOL_CHAIN dup(?)
ends

struct WSAPROTOCOL_INFOA
    dwServiceFlags1    dd ?
    dwServiceFlags2    dd ?
    dwServiceFlags3    dd ?
    dwServiceFlags4    dd ?
    dwProviderFlags    dd ?
    ProviderId         GUID
    dwCatalogEntryId   dd ?
    ProtocolChain      WSAPROTOCOLCHAIN
    iVersion           dd ?
    iAddressFamily     dd ?
    iMaxSockAddr       dd ?
    iMinSockAddr       dd ?
    iSocketType        dd ?
    iProtocol          dd ?
    iProtocolMaxOffset dd ?
    iNetworkByteOrder  dd ?
    iSecurityScheme    dd ?
    dwMessageSize      dd ?
    dwProviderReserved dd ?
    szProtocol         db WSAPROTOCOL_LEN+1 dup(?)
ends

struct WSAPROTOCOL_INFOW
    dwServiceFlags1    dd ?
    dwServiceFlags2    dd ?
    dwServiceFlags3    dd ?
    dwServiceFlags4    dd ?
    dwProviderFlags    dd ?
    ProviderId         GUID
    dwCatalogEntryId   dd ?
    ProtocolChain      WSAPROTOCOLCHAIN
    iVersion           dd ?
    iAddressFamily     dd ?
    iMaxSockAddr       dd ?
    iMinSockAddr       dd ?
    iSocketType        dd ?
    iProtocol          dd ?
    iProtocolMaxOffset dd ?
    iNetworkByteOrder  dd ?
    iSecurityScheme    dd ?
    dwMessageSize      dd ?
    dwProviderReserved dd ?
    szProtocol         dw WSAPROTOCOL_LEN+1 dup(?)
ends

if ~defined BLOB_DEF
    BLOB_DEF equ 1
    struct BLOB
        cbSize    dd   ?
        pBlobData xptr ?
    ends
end if

struct SOCKET_ADDRESS
    lpSockaddr      xptr ?
    iSockaddrLength dd   ?
ends

struct CSADDR_INFO
    LocalAddr   SOCKET_ADDRESS
    RemoteAddr  SOCKET_ADDRESS
    iSocketType dd ?
    iProtocol   dd ?
ends

struct SOCKET_ADDRESS_LIST
    iAddressCount dd ?
    Address       SOCKET_ADDRESS
ends

struct AFPROTOCOLS
    iAddressFamily dd ?
    iProtocol      dd ?
ends

struct WSAVERSION
    dwVersion dd ?
    ecHow     dd ?
ends

struct WSAQUERYSETA
    dwSize                  dd   ?
    lpszServiceInstanceName xptr ?
    lpServiceClassId        xptr ?
    lpVersion               xptr ?
    lpszComment             xptr ?
    dwNameSpace             dd   ?
    lpNSProviderId          xptr ?
    lpszContext             xptr ?
    dwNumberOfProtocols     dd   ?
    lpafpProtocols          xptr ?
    lpszQueryString         xptr ?
    dwNumberOfCsAddrs       dd   ?
    lpcsaBuffer             xptr ?
    dwOutputFlags           dd   ?
    lpBlob                  xptr ?
ends

struct WSAQUERYSETW
    dwSize                  dd   ?
    lpszServiceInstanceName xptr ?
    lpServiceClassId        xptr ?
    lpVersion               xptr ?
    lpszComment             xptr ?
    dwNameSpace             dd   ?
    lpNSProviderId          xptr ?
    lpszContext             xptr ?
    dwNumberOfProtocols     dd   ?
    lpafpProtocols          xptr ?
    lpszQueryString         xptr ?
    dwNumberOfCsAddrs       dd   ?
    lpcsaBuffer             xptr ?
    dwOutputFlags           dd   ?
    lpBlob                  xptr ?
ends

struct WSANSCLASSINFOA
    lpszName    xptr ?
    dwNameSpace dd   ?
    dwValueType dd   ?
    dwValueSize dd   ?
    lpValue     xptr ?
ends

struct WSANSCLASSINFOW
    lpszName    xptr ?
    dwNameSpace dd   ?
    dwValueType dd   ?
    dwValueSize dd   ?
    lpValue     xptr ?
ends

struct WSASERVICECLASSINFOA
    lpServiceClassId     xptr ?
    lpszServiceClassName xptr ?
    dwCount              dd   ?
    lpClassInfos         xptr ?
ends

struct WSASERVICECLASSINFOW
    lpServiceClassId     xptr ?
    lpszServiceClassName xptr ?
    dwCount              dd   ?
    lpClassInfos         xptr ?
ends

struct WSANAMESPACE_INFOA
    NSProviderId   GUID
    dwNameSpace    dd   ?
    fActive        dd   ?
    dwVersion      dd   ?
    lpszIdentifier xptr ?
ends

struct WSANAMESPACE_INFOW
    NSProviderId   GUID
    dwNameSpace    dd   ?
    fActive        dd   ?
    dwVersion      dd   ?
    lpszIdentifier xptr ?
ends


;======================================== Functions =======================================;
if defined APP_WIN64
    extrn '__imp_FreeAddrInfoEx' as FreeAddrInfoEx:qword
    extrn '__imp_FreeAddrInfoExW' as FreeAddrInfoExW:qword
    extrn '__imp_FreeAddrInfoW' as FreeAddrInfoW:qword
    extrn '__imp_GetAddrInfoExA' as GetAddrInfoExA:qword
    extrn '__imp_GetAddrInfoExCancel' as GetAddrInfoExCancel:qword
    extrn '__imp_GetAddrInfoExOverlappedResult' as GetAddrInfoExOverlappedResult:qword
    extrn '__imp_GetAddrInfoExW' as GetAddrInfoExW:qword
    extrn '__imp_GetAddrInfoW' as GetAddrInfoW:qword
    extrn '__imp_GetHostNameW' as GetHostNameW:qword
    extrn '__imp_GetNameInfoW' as GetNameInfoW:qword
    extrn '__imp_InetNtopW' as InetNtopW:qword
    extrn '__imp_InetPtonW' as InetPtonW:qword
    extrn '__imp_SetAddrInfoExA' as SetAddrInfoExA:qword
    extrn '__imp_SetAddrInfoExW' as SetAddrInfoExW:qword
    if ~defined WEP
        extrn '__imp_WEP' as WEP:qword
    end if
    extrn '__imp_WPUCompleteOverlappedRequest' as WPUCompleteOverlappedRequest:qword
    extrn '__imp_WPUGetProviderPathEx' as WPUGetProviderPathEx:qword
    extrn '__imp_WSAAccept' as WSAAccept:qword
    extrn '__imp_WSAAddressToStringA' as WSAAddressToStringA:qword
    extrn '__imp_WSAAddressToStringW' as WSAAddressToStringW:qword
    extrn '__imp_WSAAdvertiseProvider' as WSAAdvertiseProvider:qword
    if ~defined WSAAsyncGetHostByAddr
        extrn '__imp_WSAAsyncGetHostByAddr' as WSAAsyncGetHostByAddr:qword
    end if
    if ~defined WSAAsyncGetHostByName
        extrn '__imp_WSAAsyncGetHostByName' as WSAAsyncGetHostByName:qword
    end if
    if ~defined WSAAsyncGetProtoByName
        extrn '__imp_WSAAsyncGetProtoByName' as WSAAsyncGetProtoByName:qword
    end if
    if ~defined WSAAsyncGetProtoByNumber
        extrn '__imp_WSAAsyncGetProtoByNumber' as WSAAsyncGetProtoByNumber:qword
    end if
    if ~defined WSAAsyncGetServByName
        extrn '__imp_WSAAsyncGetServByName' as WSAAsyncGetServByName:qword
    end if
    if ~defined WSAAsyncGetServByPort
        extrn '__imp_WSAAsyncGetServByPort' as WSAAsyncGetServByPort:qword
    end if
    if ~defined WSAAsyncSelect
        extrn '__imp_WSAAsyncSelect' as WSAAsyncSelect:qword
    end if
    if ~defined WSACancelAsyncRequest
        extrn '__imp_WSACancelAsyncRequest' as WSACancelAsyncRequest:qword
    end if
    if ~defined WSACancelBlockingCall
        extrn '__imp_WSACancelBlockingCall' as WSACancelBlockingCall:qword
    end if
    if ~defined WSACleanup
        extrn '__imp_WSACleanup' as WSACleanup:qword
    end if
    extrn '__imp_WSACloseEvent' as WSACloseEvent:qword
    extrn '__imp_WSAConnect' as WSAConnect:qword
    extrn '__imp_WSAConnectByList' as WSAConnectByList:qword
    extrn '__imp_WSAConnectByNameA' as WSAConnectByNameA:qword
    extrn '__imp_WSAConnectByNameW' as WSAConnectByNameW:qword
    extrn '__imp_WSACreateEvent' as WSACreateEvent:qword
    extrn '__imp_WSADuplicateSocketA' as WSADuplicateSocketA:qword
    extrn '__imp_WSADuplicateSocketW' as WSADuplicateSocketW:qword
    extrn '__imp_WSAEnumNameSpaceProvidersA' as WSAEnumNameSpaceProvidersA:qword
    extrn '__imp_WSAEnumNameSpaceProvidersExA' as WSAEnumNameSpaceProvidersExA:qword
    extrn '__imp_WSAEnumNameSpaceProvidersExW' as WSAEnumNameSpaceProvidersExW:qword
    extrn '__imp_WSAEnumNameSpaceProvidersW' as WSAEnumNameSpaceProvidersW:qword
    extrn '__imp_WSAEnumNetworkEvents' as WSAEnumNetworkEvents:qword
    extrn '__imp_WSAEnumProtocolsA' as WSAEnumProtocolsA:qword
    extrn '__imp_WSAEnumProtocolsW' as WSAEnumProtocolsW:qword
    extrn '__imp_WSAEventSelect' as WSAEventSelect:qword
    if ~defined WSAGetLastError
        extrn '__imp_WSAGetLastError' as WSAGetLastError:qword
    end if
    extrn '__imp_WSAGetOverlappedResult' as WSAGetOverlappedResult:qword
    extrn '__imp_WSAGetQOSByName' as WSAGetQOSByName:qword
    extrn '__imp_WSAGetServiceClassInfoA' as WSAGetServiceClassInfoA:qword
    extrn '__imp_WSAGetServiceClassInfoW' as WSAGetServiceClassInfoW:qword
    extrn '__imp_WSAGetServiceClassNameByClassIdA' as WSAGetServiceClassNameByClassIdA:qword
    extrn '__imp_WSAGetServiceClassNameByClassIdW' as WSAGetServiceClassNameByClassIdW:qword
    extrn '__imp_WSAHtonl' as WSAHtonl:qword
    extrn '__imp_WSAHtons' as WSAHtons:qword
    extrn '__imp_WSAInstallServiceClassA' as WSAInstallServiceClassA:qword
    extrn '__imp_WSAInstallServiceClassW' as WSAInstallServiceClassW:qword
    extrn '__imp_WSAIoctl' as WSAIoctl:qword
    if ~defined WSAIsBlocking
        extrn '__imp_WSAIsBlocking' as WSAIsBlocking:qword
    end if
    extrn '__imp_WSAJoinLeaf' as WSAJoinLeaf:qword
    extrn '__imp_WSALookupServiceBeginA' as WSALookupServiceBeginA:qword
    extrn '__imp_WSALookupServiceBeginW' as WSALookupServiceBeginW:qword
    extrn '__imp_WSALookupServiceEnd' as WSALookupServiceEnd:qword
    extrn '__imp_WSALookupServiceNextA' as WSALookupServiceNextA:qword
    extrn '__imp_WSALookupServiceNextW' as WSALookupServiceNextW:qword
    extrn '__imp_WSANSPIoctl' as WSANSPIoctl:qword
    extrn '__imp_WSANtohl' as WSANtohl:qword
    extrn '__imp_WSANtohs' as WSANtohs:qword
    extrn '__imp_WSAPoll' as WSAPoll:qword
    extrn '__imp_WSAProviderCompleteAsyncCall' as WSAProviderCompleteAsyncCall:qword
    extrn '__imp_WSAProviderConfigChange' as WSAProviderConfigChange:qword
    extrn '__imp_WSARecv' as WSARecv:qword
    extrn '__imp_WSARecvDisconnect' as WSARecvDisconnect:qword
    extrn '__imp_WSARecvFrom' as WSARecvFrom:qword
    extrn '__imp_WSARemoveServiceClass' as WSARemoveServiceClass:qword
    extrn '__imp_WSAResetEvent' as WSAResetEvent:qword
    extrn '__imp_WSASend' as WSASend:qword
    extrn '__imp_WSASendDisconnect' as WSASendDisconnect:qword
    extrn '__imp_WSASendMsg' as WSASendMsg:qword
    extrn '__imp_WSASendTo' as WSASendTo:qword
    if ~defined WSASetBlockingHook
        extrn '__imp_WSASetBlockingHook' as WSASetBlockingHook:qword
    end if
    extrn '__imp_WSASetEvent' as WSASetEvent:qword
    if ~defined WSASetBlockingHook
        extrn '__imp_WSASetLastError' as WSASetLastError:qword
    end if
    extrn '__imp_WSASetServiceA' as WSASetServiceA:qword
    extrn '__imp_WSASetServiceW' as WSASetServiceW:qword
    extrn '__imp_WSASocketA' as WSASocketA:qword
    extrn '__imp_WSASocketW' as WSASocketW:qword
    if ~defined WSAStartup
        extrn '__imp_WSAStartup' as WSAStartup:qword
    end if
    extrn '__imp_WSAStringToAddressA' as WSAStringToAddressA:qword
    extrn '__imp_WSAStringToAddressW' as WSAStringToAddressW:qword
    extrn '__imp_WSAUnadvertiseProvider' as WSAUnadvertiseProvider:qword
    if ~defined WSAUnhookBlockingHook
        extrn '__imp_WSAUnhookBlockingHook' as WSAUnhookBlockingHook:qword
    end if
    extrn '__imp_WSAWaitForMultipleEvents' as WSAWaitForMultipleEvents:qword
    extrn '__imp_WSApSetPostRoutine' as WSApSetPostRoutine:qword
    extrn '__imp_WSCDeinstallProvider' as WSCDeinstallProvider:qword
    extrn '__imp_WSCDeinstallProvider32' as WSCDeinstallProvider32:qword
    extrn '__imp_WSCDeinstallProviderEx' as WSCDeinstallProviderEx:qword
    extrn '__imp_WSCEnableNSProvider' as WSCEnableNSProvider:qword
    extrn '__imp_WSCEnableNSProvider32' as WSCEnableNSProvider32:qword
    extrn '__imp_WSCEnumNameSpaceProviders32' as WSCEnumNameSpaceProviders32:qword
    extrn '__imp_WSCEnumNameSpaceProvidersEx32' as WSCEnumNameSpaceProvidersEx32:qword
    extrn '__imp_WSCEnumProtocols' as WSCEnumProtocols:qword
    extrn '__imp_WSCEnumProtocols32' as WSCEnumProtocols32:qword
    extrn '__imp_WSCEnumProtocolsEx' as WSCEnumProtocolsEx:qword
    extrn '__imp_WSCGetApplicationCategory' as WSCGetApplicationCategory:qword
    extrn '__imp_WSCGetApplicationCategoryEx' as WSCGetApplicationCategoryEx:qword
    extrn '__imp_WSCGetProviderInfo' as WSCGetProviderInfo:qword
    extrn '__imp_WSCGetProviderInfo32' as WSCGetProviderInfo32:qword
    extrn '__imp_WSCGetProviderPath' as WSCGetProviderPath:qword
    extrn '__imp_WSCGetProviderPath32' as WSCGetProviderPath32:qword
    extrn '__imp_WSCInstallNameSpace' as WSCInstallNameSpace:qword
    extrn '__imp_WSCInstallNameSpace32' as WSCInstallNameSpace32:qword
    extrn '__imp_WSCInstallNameSpaceEx' as WSCInstallNameSpaceEx:qword
    extrn '__imp_WSCInstallNameSpaceEx2' as WSCInstallNameSpaceEx2:qword
    extrn '__imp_WSCInstallNameSpaceEx32' as WSCInstallNameSpaceEx32:qword
    extrn '__imp_WSCInstallProvider' as WSCInstallProvider:qword
    extrn '__imp_WSCInstallProvider64_32' as WSCInstallProvider64_32:qword
    extrn '__imp_WSCInstallProviderAndChains64_32' as WSCInstallProviderAndChains64_32:qword
    extrn '__imp_WSCInstallProviderEx' as WSCInstallProviderEx:qword
    extrn '__imp_WSCSetApplicationCategory' as WSCSetApplicationCategory:qword
    extrn '__imp_WSCSetApplicationCategoryEx' as WSCSetApplicationCategoryEx:qword
    extrn '__imp_WSCSetProviderInfo' as WSCSetProviderInfo:qword
    extrn '__imp_WSCSetProviderInfo32' as WSCSetProviderInfo32:qword
    extrn '__imp_WSCUnInstallNameSpace' as WSCUnInstallNameSpace:qword
    extrn '__imp_WSCUnInstallNameSpace32' as WSCUnInstallNameSpace32:qword
    extrn '__imp_WSCUnInstallNameSpaceEx2' as WSCUnInstallNameSpaceEx2:qword
    extrn '__imp_WSCUpdateProvider' as WSCUpdateProvider:qword
    extrn '__imp_WSCUpdateProvider32' as WSCUpdateProvider32:qword
    extrn '__imp_WSCUpdateProviderEx' as WSCUpdateProviderEx:qword
    extrn '__imp_WSCWriteNameSpaceOrder' as WSCWriteNameSpaceOrder:qword
    extrn '__imp_WSCWriteNameSpaceOrder32' as WSCWriteNameSpaceOrder32:qword
    extrn '__imp_WSCWriteProviderOrder' as WSCWriteProviderOrder:qword
    extrn '__imp_WSCWriteProviderOrder32' as WSCWriteProviderOrder32:qword
    extrn '__imp_WSCWriteProviderOrderEx' as WSCWriteProviderOrderEx:qword
    extrn '__imp_WahCloseApcHelper' as WahCloseApcHelper:qword
    extrn '__imp_WahCloseHandleHelper' as WahCloseHandleHelper:qword
    extrn '__imp_WahCloseNotificationHandleHelper' as WahCloseNotificationHandleHelper:qword
    extrn '__imp_WahCloseSocketHandle' as WahCloseSocketHandle:qword
    extrn '__imp_WahCloseThread' as WahCloseThread:qword
    extrn '__imp_WahCompleteRequest' as WahCompleteRequest:qword
    extrn '__imp_WahCreateHandleContextTable' as WahCreateHandleContextTable:qword
    extrn '__imp_WahCreateNotificationHandle' as WahCreateNotificationHandle:qword
    extrn '__imp_WahCreateSocketHandle' as WahCreateSocketHandle:qword
    extrn '__imp_WahDestroyHandleContextTable' as WahDestroyHandleContextTable:qword
    extrn '__imp_WahDisableNonIFSHandleSupport' as WahDisableNonIFSHandleSupport:qword
    extrn '__imp_WahEnableNonIFSHandleSupport' as WahEnableNonIFSHandleSupport:qword
    extrn '__imp_WahEnumerateHandleContexts' as WahEnumerateHandleContexts:qword
    extrn '__imp_WahInsertHandleContext' as WahInsertHandleContext:qword
    extrn '__imp_WahNotifyAllProcesses' as WahNotifyAllProcesses:qword
    extrn '__imp_WahOpenApcHelper' as WahOpenApcHelper:qword
    extrn '__imp_WahOpenCurrentThread' as WahOpenCurrentThread:qword
    extrn '__imp_WahOpenHandleHelper' as WahOpenHandleHelper:qword
    extrn '__imp_WahOpenNotificationHandleHelper' as WahOpenNotificationHandleHelper:qword
    extrn '__imp_WahQueueUserApc' as WahQueueUserApc:qword
    extrn '__imp_WahReferenceContextByHandle' as WahReferenceContextByHandle:qword
    extrn '__imp_WahRemoveHandleContext' as WahRemoveHandleContext:qword
    extrn '__imp_WahWaitForNotification' as WahWaitForNotification:qword
    extrn '__imp_WahWriteLSPEvent' as WahWriteLSPEvent:qword
    if ~defined WSOCK32_INC
        extrn '__imp___WSAFDIsSet' as __WSAFDIsSet:qword
        extrn '__imp_accept' as accept:qword
        extrn '__imp_bind' as bind:qword
        extrn '__imp_closesocket' as closesocket:qword
        extrn '__imp_connect' as connect:qword
    end if
    extrn '__imp_freeaddrinfo' as freeaddrinfo:qword
    extrn '__imp_getaddrinfo' as getaddrinfo:qword
    if ~defined WSOCK32_INC
        extrn '__imp_gethostbyaddr' as gethostbyaddr:qword
        extrn '__imp_gethostbyname' as gethostbyname:qword
        extrn '__imp_gethostname' as gethostname:qword
    end if
    extrn '__imp_getnameinfo' as getnameinfo:qword
    if ~defined WSOCK32_INC
        extrn '__imp_getpeername' as getpeername:qword
        extrn '__imp_getprotobyname' as getprotobyname:qword
        extrn '__imp_getprotobynumber' as getprotobynumber:qword
        extrn '__imp_getservbyname' as getservbyname:qword
        extrn '__imp_getservbyport' as getservbyport:qword
        extrn '__imp_getsockname' as getsockname:qword
        extrn '__imp_getsockopt' as getsockopt:qword
        extrn '__imp_htonl' as htonl:qword
        extrn '__imp_htons' as htons:qword
        extrn '__imp_inet_addr' as inet_addr:qword
        extrn '__imp_inet_ntoa' as inet_ntoa:qword
        extrn '__imp_inet_ntop' as inet_ntop:qword
        extrn '__imp_inet_pton' as inet_pton:qword
        extrn '__imp_ioctlsocket' as ioctlsocket:qword
        extrn '__imp_listen' as listen:qword
        extrn '__imp_ntohl' as ntohl:qword
        extrn '__imp_ntohs' as ntohs:qword
        extrn '__imp_recv' as recv:qword
        extrn '__imp_recvfrom' as recvfrom:qword
        extrn '__imp_select' as select:qword
        extrn '__imp_send' as send:qword
        extrn '__imp_sendto' as sendto:qword
        extrn '__imp_setsockopt' as setsockopt:qword
        extrn '__imp_shutdown' as shutdown:qword
        extrn '__imp_socket' as socket:qword
    end if
else
    ;extrn '__imp__FreeAddrInfoEx@4' as FreeAddrInfoEx:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__FreeAddrInfoExW@4' as FreeAddrInfoExW:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__FreeAddrInfoW@4' as FreeAddrInfoW:dword
    ;extrn '__imp__GetAddrInfoExA@40' as GetAddrInfoExA:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__GetAddrInfoExCancel@4' as GetAddrInfoExCancel:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__GetAddrInfoExOverlappedResult@4' as GetAddrInfoExOverlappedResult:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__GetAddrInfoExW@40' as GetAddrInfoExW:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__GetAddrInfoW@16' as GetAddrInfoW:dword
    ;extrn '__imp__GetHostNameW@8' as GetHostNameW:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__GetNameInfoW@28' as GetNameInfoW:dword
    ;extrn '__imp__InetNtopW@16' as InetNtopW:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__InetPtonW@12' as InetPtonW:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__SetAddrInfoExA@48' as SetAddrInfoExA:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__SetAddrInfoExW@48' as SetAddrInfoExW:dword ;Not present in MASM32 ws2_32.lib
    if ~defined WEP
        extrn '__imp__WEP@0' as WEP:dword
    end if
    extrn '__imp__WPUCompleteOverlappedRequest@20' as WPUCompleteOverlappedRequest:dword
    extrn '__imp__WSAAccept@20' as WSAAccept:dword
    extrn '__imp__WSAAddressToStringA@20' as WSAAddressToStringA:dword
    extrn '__imp__WSAAddressToStringW@20' as WSAAddressToStringW:dword
    ;extrn '__imp__WSAAdvertiseProvider@8' as WSAAdvertiseProvider:dword ;Not present in MASM32 ws2_32.lib
    if ~defined WSAAsyncGetHostByAddr
        extrn '__imp__WSAAsyncGetHostByAddr@28' as WSAAsyncGetHostByAddr:dword
    end if
    if ~defined WSAAsyncGetHostByName
        extrn '__imp__WSAAsyncGetHostByName@20' as WSAAsyncGetHostByName:dword
    end if
    if ~defined WSAAsyncGetProtoByName
        extrn '__imp__WSAAsyncGetProtoByName@20' as WSAAsyncGetProtoByName:dword
    end if
    if ~defined WSAAsyncGetProtoByNumber
        extrn '__imp__WSAAsyncGetProtoByNumber@20' as WSAAsyncGetProtoByNumber:dword
    end if
    if ~defined WSAAsyncGetServByName
        extrn '__imp__WSAAsyncGetServByName@24' as WSAAsyncGetServByName:dword
    end if
    if ~defined WSAAsyncGetServByPort
        extrn '__imp__WSAAsyncGetServByPort@24' as WSAAsyncGetServByPort:dword
    end if
    if ~defined WSAAsyncSelect
        extrn '__imp__WSAAsyncSelect@16' as WSAAsyncSelect:dword
    end if
    if ~defined WSACancelAsyncRequest
        extrn '__imp__WSACancelAsyncRequest@4' as WSACancelAsyncRequest:dword
    end if
    if ~defined WSACancelBlockingCall
        extrn '__imp__WSACancelBlockingCall@0' as WSACancelBlockingCall:dword
    end if
    if ~defined WSACleanup
        extrn '__imp__WSACleanup@0' as WSACleanup:dword
    end if
    extrn '__imp__WSACloseEvent@4' as WSACloseEvent:dword
    extrn '__imp__WSAConnect@28' as WSAConnect:dword
    ;extrn '__imp__WSAConnectByList@32' as WSAConnectByList:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSAConnectByNameA@36' as WSAConnectByNameA:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSAConnectByNameW@36' as WSAConnectByNameW:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSACreateEvent@0' as WSACreateEvent:dword
    extrn '__imp__WSADuplicateSocketA@12' as WSADuplicateSocketA:dword
    extrn '__imp__WSADuplicateSocketW@12' as WSADuplicateSocketW:dword
    extrn '__imp__WSAEnumNameSpaceProvidersA@8' as WSAEnumNameSpaceProvidersA:dword
    ;extrn '__imp__WSAEnumNameSpaceProvidersExA@8' as WSAEnumNameSpaceProvidersExA:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSAEnumNameSpaceProvidersExW@8' as WSAEnumNameSpaceProvidersExW:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSAEnumNameSpaceProvidersW@8' as WSAEnumNameSpaceProvidersW:dword
    extrn '__imp__WSAEnumNetworkEvents@12' as WSAEnumNetworkEvents:dword
    extrn '__imp__WSAEnumProtocolsA@12' as WSAEnumProtocolsA:dword
    extrn '__imp__WSAEnumProtocolsW@12' as WSAEnumProtocolsW:dword
    extrn '__imp__WSAEventSelect@12' as WSAEventSelect:dword
    if ~defined WSAGetLastError
        extrn '__imp__WSAGetLastError@0' as WSAGetLastError:dword
    end if
    extrn '__imp__WSAGetOverlappedResult@20' as WSAGetOverlappedResult:dword
    extrn '__imp__WSAGetQOSByName@12' as WSAGetQOSByName:dword
    extrn '__imp__WSAGetServiceClassInfoA@16' as WSAGetServiceClassInfoA:dword
    extrn '__imp__WSAGetServiceClassInfoW@16' as WSAGetServiceClassInfoW:dword
    extrn '__imp__WSAGetServiceClassNameByClassIdA@12' as WSAGetServiceClassNameByClassIdA:dword
    extrn '__imp__WSAGetServiceClassNameByClassIdW@12' as WSAGetServiceClassNameByClassIdW:dword
    extrn '__imp__WSAHtonl@12' as WSAHtonl:dword
    extrn '__imp__WSAHtons@12' as WSAHtons:dword
    extrn '__imp__WSAInstallServiceClassA@4' as WSAInstallServiceClassA:dword
    extrn '__imp__WSAInstallServiceClassW@4' as WSAInstallServiceClassW:dword
    extrn '__imp__WSAIoctl@36' as WSAIoctl:dword
    if ~defined WSAIsBlocking
        extrn '__imp__WSAIsBlocking@0' as WSAIsBlocking:dword
    end if
    extrn '__imp__WSAJoinLeaf@32' as WSAJoinLeaf:dword
    extrn '__imp__WSALookupServiceBeginA@12' as WSALookupServiceBeginA:dword
    extrn '__imp__WSALookupServiceBeginW@12' as WSALookupServiceBeginW:dword
    extrn '__imp__WSALookupServiceEnd@4' as WSALookupServiceEnd:dword
    extrn '__imp__WSALookupServiceNextA@16' as WSALookupServiceNextA:dword
    extrn '__imp__WSALookupServiceNextW@16' as WSALookupServiceNextW:dword
    extrn '__imp__WSANSPIoctl@32' as WSANSPIoctl:dword
    extrn '__imp__WSANtohl@12' as WSANtohl:dword
    extrn '__imp__WSANtohs@12' as WSANtohs:dword
    ;extrn '__imp__WSAPoll@12' as WSAPoll:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSAProviderCompleteAsyncCall@8' as WSAProviderCompleteAsyncCall:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSAProviderConfigChange@12' as WSAProviderConfigChange:dword
    extrn '__imp__WSARecv@28' as WSARecv:dword
    extrn '__imp__WSARecvDisconnect@8' as WSARecvDisconnect:dword
    extrn '__imp__WSARecvFrom@36' as WSARecvFrom:dword
    extrn '__imp__WSARemoveServiceClass@4' as WSARemoveServiceClass:dword
    extrn '__imp__WSAResetEvent@4' as WSAResetEvent:dword
    extrn '__imp__WSASend@28' as WSASend:dword
    extrn '__imp__WSASendDisconnect@8' as WSASendDisconnect:dword
    ;extrn '__imp__WSASendMsg@24' as WSASendMsg:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSASendTo@36' as WSASendTo:dword
    if ~defined WSASetBlockingHook
        extrn '__imp__WSASetBlockingHook@4' as WSASetBlockingHook:dword
    end if
    extrn '__imp__WSASetEvent@4' as WSASetEvent:dword
    if ~defined WSASetBlockingHook
        extrn '__imp__WSASetLastError@4' as WSASetLastError:dword
    end if
    extrn '__imp__WSASetServiceA@12' as WSASetServiceA:dword
    extrn '__imp__WSASetServiceW@12' as WSASetServiceW:dword
    extrn '__imp__WSASocketA@24' as WSASocketA:dword
    extrn '__imp__WSASocketW@24' as WSASocketW:dword
    if ~defined WSAStartup
        extrn '__imp__WSAStartup@8' as WSAStartup:dword
    end if
    extrn '__imp__WSAStringToAddressA@20' as WSAStringToAddressA:dword
    extrn '__imp__WSAStringToAddressW@20' as WSAStringToAddressW:dword
    ;extrn '__imp__WSAUnadvertiseProvider@4' as WSAUnadvertiseProvider:dword ;Not present in MASM32 ws2_32.lib
    if ~defined WSAUnhookBlockingHook
        extrn '__imp__WSAUnhookBlockingHook@0' as WSAUnhookBlockingHook:dword
    end if
    extrn '__imp__WSAWaitForMultipleEvents@20' as WSAWaitForMultipleEvents:dword
    ;extrn '__imp__WSApSetPostRoutine@4' as WSApSetPostRoutine:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSCDeinstallProvider@8' as WSCDeinstallProvider:dword
    ;extrn '__imp__WSCDeinstallProvider32@8' as WSCDeinstallProvider32:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSCEnableNSProvider@8' as WSCEnableNSProvider:dword
    ;extrn '__imp__WSCEnableNSProvider32@8' as WSCEnableNSProvider32:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCEnumNameSpaceProviders32@8' as WSCEnumNameSpaceProviders32:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCEnumNameSpaceProvidersEx32@8' as WSCEnumNameSpaceProvidersEx32:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSCEnumProtocols@16' as WSCEnumProtocols:dword
    ;extrn '__imp__WSCEnumProtocols32@16' as WSCEnumProtocols32:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCGetApplicationCategory@24' as WSCGetApplicationCategory:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCGetProviderInfo@24' as WSCGetProviderInfo:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCGetProviderInfo32@24' as WSCGetProviderInfo32:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSCGetProviderPath@16' as WSCGetProviderPath:dword
    ;extrn '__imp__WSCGetProviderPath32@16' as WSCGetProviderPath32:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSCInstallNameSpace@20' as WSCInstallNameSpace:dword
    ;extrn '__imp__WSCInstallNameSpace32@20' as WSCInstallNameSpace32:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCInstallNameSpaceEx@24' as WSCInstallNameSpaceEx:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCInstallNameSpaceEx32@24' as WSCInstallNameSpaceEx32:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSCInstallProvider@20' as WSCInstallProvider:dword
    ;extrn '__imp__WSCInstallProvider64_32@20' as WSCInstallProvider64_32:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCInstallProviderAndChains64_32@36' as WSCInstallProviderAndChains64_32:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCSetApplicationCategory@28' as WSCSetApplicationCategory:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCSetProviderInfo@24' as WSCSetProviderInfo:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WSCSetProviderInfo32@24' as WSCSetProviderInfo32:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSCUnInstallNameSpace@4' as WSCUnInstallNameSpace:dword
    ;extrn '__imp__WSCUnInstallNameSpace32@4' as WSCUnInstallNameSpace32:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSCUpdateProvider@20' as WSCUpdateProvider:dword
    ;extrn '__imp__WSCUpdateProvider32@20' as WSCUpdateProvider32:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSCWriteNameSpaceOrder@8' as WSCWriteNameSpaceOrder:dword
    ;extrn '__imp__WSCWriteNameSpaceOrder32@8' as WSCWriteNameSpaceOrder32:dword ;Not present in MASM32 ws2_32.lib
    extrn '__imp__WSCWriteProviderOrder@8' as WSCWriteProviderOrder:dword
    ;extrn '__imp__WSCWriteProviderOrder32@8' as WSCWriteProviderOrder32:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahCloseApcHelper@4' as WahCloseApcHelper:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahCloseHandleHelper@4' as WahCloseHandleHelper:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahCloseNotificationHandleHelper@4' as WahCloseNotificationHandleHelper:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahCloseSocketHandle@8' as WahCloseSocketHandle:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahCloseThread@8' as WahCloseThread:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahCompleteRequest@20' as WahCompleteRequest:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahCreateHandleContextTable@4' as WahCreateHandleContextTable:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahCreateNotificationHandle@8' as WahCreateNotificationHandle:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahCreateSocketHandle@8' as WahCreateSocketHandle:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahDestroyHandleContextTable@4' as WahDestroyHandleContextTable:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahDisableNonIFSHandleSupport@0' as WahDisableNonIFSHandleSupport:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahEnableNonIFSHandleSupport@0' as WahEnableNonIFSHandleSupport:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahEnumerateHandleContexts@12' as WahEnumerateHandleContexts:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahInsertHandleContext@8' as WahInsertHandleContext:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahNotifyAllProcesses@4' as WahNotifyAllProcesses:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahOpenApcHelper@4' as WahOpenApcHelper:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahOpenCurrentThread@8' as WahOpenCurrentThread:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahOpenHandleHelper@4' as WahOpenHandleHelper:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahOpenNotificationHandleHelper@4' as WahOpenNotificationHandleHelper:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahQueueUserApc@16' as WahQueueUserApc:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahReferenceContextByHandle@8' as WahReferenceContextByHandle:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahRemoveHandleContext@8' as WahRemoveHandleContext:dword ;Not present in MASM32 ws2_32.lib
    ;extrn '__imp__WahWaitForNotification@16' as WahWaitForNotification:dword ;Not present in MASM32 ws2_32.lib
    if ~defined WSOCK32_INC
        extrn '__imp____WSAFDIsSet@8' as __WSAFDIsSet:dword
        extrn '__imp__accept@12' as accept:dword
        extrn '__imp__bind@12' as bind:dword
        extrn '__imp__closesocket@4' as closesocket:dword
        ;extrn '__imp__connect@12' as connect:dword
    end if
    extrn '__imp__freeaddrinfo@4' as freeaddrinfo:dword
    extrn '__imp__getaddrinfo@16' as getaddrinfo:dword
    if ~defined WSOCK32_INC
        extrn '__imp__gethostbyaddr@12' as gethostbyaddr:dword
        extrn '__imp__gethostbyname@4' as gethostbyname:dword
        extrn '__imp__gethostname@8' as gethostname:dword
    end if
    extrn '__imp__getnameinfo@28' as getnameinfo:dword
    if ~defined WSOCK32_INC
        extrn '__imp__getpeername@12' as getpeername:dword
        extrn '__imp__getprotobyname@4' as getprotobyname:dword
        extrn '__imp__getprotobynumber@4' as getprotobynumber:dword
        extrn '__imp__getservbyname@8' as getservbyname:dword
        extrn '__imp__getservbyport@8' as getservbyport:dword
        extrn '__imp__getsockname@12' as getsockname:dword
        extrn '__imp__getsockopt@20' as getsockopt:dword
        extrn '__imp__htonl@4' as htonl:dword
        extrn '__imp__htons@4' as htons:dword
        extrn '__imp__inet_addr@4' as inet_addr:dword
        extrn '__imp__inet_ntoa@4' as inet_ntoa:dword
        extrn '__imp__ioctlsocket@12' as ioctlsocket:dword
        extrn '__imp__listen@8' as listen:dword
        extrn '__imp__ntohl@4' as ntohl:dword
        extrn '__imp__ntohs@4' as ntohs:dword
        extrn '__imp__recv@16' as recv:dword
        extrn '__imp__recvfrom@24' as recvfrom:dword
        extrn '__imp__select@20' as select:dword
        extrn '__imp__send@16' as send:dword
        extrn '__imp__sendto@24' as sendto:dword
        extrn '__imp__setsockopt@20' as setsockopt:dword
        extrn '__imp__shutdown@8' as shutdown:dword
        extrn '__imp__socket@12' as socket:dword
    end if
end if

if defined APP_UNICODE
    SERVICE_TYPE_VALUE_SAPID equ SERVICE_TYPE_VALUE_SAPIDW
    SERVICE_TYPE_VALUE_TCPPORT equ SERVICE_TYPE_VALUE_TCPPORTW
    SERVICE_TYPE_VALUE_UDPPORT equ SERVICE_TYPE_VALUE_UDPPORTW
    SERVICE_TYPE_VALUE_OBJECTID equ SERVICE_TYPE_VALUE_OBJECTIDW
    WSAPROTOCOL_INFO fix WSAPROTOCOL_INFOW
    WSAQUERYSET fix WSAQUERYSETW
    WSANSCLASSINFO fix WSANSCLASSINFOW
    WSASERVICECLASSINFO fix WSASERVICECLASSINFOW
    WSANAMESPACE_INFO fix WSANAMESPACE_INFOW
else
    SERVICE_TYPE_VALUE_SAPID equ SERVICE_TYPE_VALUE_SAPIDA
    SERVICE_TYPE_VALUE_TCPPORT equ SERVICE_TYPE_VALUE_TCPPORTA
    SERVICE_TYPE_VALUE_UDPPORT equ SERVICE_TYPE_VALUE_UDPPORTA
    SERVICE_TYPE_VALUE_OBJECTID equ SERVICE_TYPE_VALUE_OBJECTIDA
    WSAPROTOCOL_INFO fix WSAPROTOCOL_INFOA
    WSAQUERYSET fix WSAQUERYSETA
    WSANSCLASSINFO fix WSANSCLASSINFOA
    WSASERVICECLASSINFO fix WSASERVICECLASSINFOA
    WSANAMESPACE_INFO fix WSANAMESPACE_INFOA
end if

api GetAddrInfoEx,\
    ;SetAddrInfoEx,\    ;Not present in MASM32 ws2_32.lib
    WSAAddressToString,\
    ;WSAConnectByName,\ ;Not present in MASM32 ws2_32.lib
    WSADuplicateSocket,\
    WSAEnumNameSpaceProviders,\
    ;WSAEnumNameSpaceProvidersEx,\  ;Not present in MASM32 ws2_32.lib
    WSAEnumProtocols WSAEnumProtocolsW
    WSAGetServiceClassInfo,\
    WSAGetServiceClassNameByClassId,\
    WSAInstallServiceClass,\
    WSALookupServiceBegin,\
    WSALookupServiceNext,\
    WSASetService,\
    WSASocket,\
    WSAStringToAddress

end if ;WS2_32_INC
