; ====================================================;
;                                                     ;
;    kernel32.inc for EC v2 Fasm classic projects     ;
;                   (version 1.0.6)                   ;
;                                                     ;
;         Copyright  Ramon Sala - 2018-2021          ;
;                                                     ;
; ====================================================;

if ~defined KERNEL32_INC
define KERNEL32_INC 1

GUID_MAX_POWER_SAVINGS                          equ     <0A1841308H, 03541H, 04FABH, <0BCH, 081H, 0F7H, 015H, 056H, 0F2H, 00BH, 04AH>>
GUID_MIN_POWER_SAVINGS                          equ     <08C5E7FDAH, 0E8BFH, 04A96H, <09AH, 085H, 0A6H, 0E2H, 03AH, 08CH, 063H, 05CH>>
GUID_TYPICAL_POWER_SAVINGS                      equ     <0381B4222H, 0F694H, 041F0H, <096H, 085H, 0FFH, 05BH, 0B2H, 060H, 0DFH, 02EH>>
NO_SUBGROUP_GUID                                equ     <0FEA3413EH, 07E05H, 04911H, <09AH, 071H, 070H, 003H, 031H, 0F1H, 0C2H, 094H>>
ALL_POWERSCHEMES_GUID                           equ     <068A1E95EH, 013EAH, 041E1H, <080H, 011H, 00CH, 049H, 06CH, 0A4H, 090H, 0B0H>>
GUID_POWERSCHEME_PERSONALITY                    equ     <0245D8541H, 03943H, 04422H, <0B0H, 025H, 013H, 0A7H, 084H, 0F6H, 079H, 0B7H>>
GUID_ACTIVE_POWERSCHEME                         equ     <031F9F286H, 05084H, 042FEH, <0B7H, 020H, 02BH, 002H, 064H, 099H, 037H, 063H>>
GUID_VIDEO_SUBGROUP                             equ     <07516B95FH, 0F776H, 04464H, <08CH, 053H, 006H, 016H, 07FH, 040H, 0CCH, 099H>>
GUID_VIDEO_POWERDOWN_TIMEOUT                    equ     <03C0BC021H, 0C8A8H, 04E07H, <0A9H, 073H, 06BH, 014H, 0CBH, 0CBH, 02BH, 07EH>>
GUID_VIDEO_ANNOYANCE_TIMEOUT                    equ     <082DBCF2DH, 0CD67H, 040C5H, <0BFH, 0DCH, 09FH, 01AH, 05CH, 0CDH, 046H, 063H>>
GUID_VIDEO_ADAPTIVE_PERCENT_INCREASE            equ     <0EED904DFH, 0B142H, 04183H, <0B1H, 00BH, 05AH, 011H, 097H, 0A3H, 078H, 064H>>
GUID_VIDEO_DIM_TIMEOUT                          equ     <017AAA29BH, 08B43H, 04B94H, <0AAH, 0FEH, 035H, 0F6H, 04DH, 0AAH, 0F1H, 0EEH>>
GUID_VIDEO_ADAPTIVE_POWERDOWN                   equ     <090959D22H, 0D6A1H, 049B9H, <0AFH, 093H, 0BCH, 0E8H, 085H, 0ADH, 033H, 05BH>>
GUID_MONITOR_POWER_ON                           equ     <002731015H, 04510H, 04526H, <099H, 0E6H, 0E5H, 0A1H, 07EH, 0BDH, 01AH, 0EAH>>
GUID_DEVICE_POWER_POLICY_VIDEO_BRIGHTNESS       equ     <0ADED5E82H, 0B909H, 04619H, <099H, 049H, 0F5H, 0D7H, 01DH, 0ACH, 00BH, 0CBH>>
GUID_DEVICE_POWER_POLICY_VIDEO_DIM_BRIGHTNESS   equ     <0F1FBFDE2H, 0A960H, 04165H, <09FH, 088H, 050H, 066H, 079H, 011H, 0CEH, 096H>>
GUID_VIDEO_CURRENT_MONITOR_BRIGHTNESS           equ     <08FFEE2C6H, 02D01H, 046BEH, <0ADH, 0B9H, 039H, 08AH, 0DDH, 0C5H, 0B4H, 0FFH>>
GUID_VIDEO_ADAPTIVE_DISPLAY_BRIGHTNESS          equ     <0FBD9AA66H, 09553H, 04097H, <0BAH, 044H, 0EDH, 06EH, 09DH, 065H, 0EAH, 0B8H>>
GUID_SESSION_DISPLAY_STATE                      equ     <073A5E93AH, 05BB1H, 04F93H, <089H, 05BH, 0DBH, 0D0H, 0DAH, 085H, 059H, 067H>>
GUID_CONSOLE_DISPLAY_STATE                      equ     <06FE69556H, 0704AH, 047A0H, <08FH, 024H, 0C2H, 08DH, 093H, 06FH, 0DAH, 047H>>
GUID_ALLOW_DISPLAY_REQUIRED                     equ     <0A9CEB8DAH, 0CD46H, 044FBH, <0A9H, 08BH, 002H, 0AFH, 069H, 0DEH, 046H, 023H>>
GUID_DISK_SUBGROUP                              equ     <00012EE47H, 09041H, 04B5DH, <09BH, 077H, 053H, 05FH, 0BAH, 08BH, 014H, 042H>>
GUID_DISK_POWERDOWN_TIMEOUT                     equ     <06738E2C4H, 0E8A5H, 04A42H, <0B1H, 06AH, 0E0H, 040H, 0E7H, 069H, 075H, 06EH>>
GUID_DISK_BURST_IGNORE_THRESHOLD                equ     <080E3C60EH, 0BB94H, 04AD8H, <0BBH, 0E0H, 00DH, 031H, 095H, 0EFH, 0C6H, 063H>>
GUID_DISK_ADAPTIVE_POWERDOWN                    equ     <0396A32E1H, 0499AH, 040B2H, <091H, 024H, 0A9H, 06AH, 0FEH, 070H, 076H, 067H>>
GUID_SLEEP_SUBGROUP                             equ     <0238C9FA8H, 00AADH, 041EDH, <083H, 0F4H, 097H, 0BEH, 024H, 02CH, 08FH, 020H>>
GUID_SLEEP_IDLE_THRESHOLD                       equ     <081CD32E0H, 07833H, 044F3H, <087H, 037H, 070H, 081H, 0F3H, 08DH, 01FH, 070H>>
GUID_STANDBY_TIMEOUT                            equ     <029F6C1DBH, 086DAH, 048C5H, <09FH, 0DBH, 0F2H, 0B6H, 07BH, 01FH, 044H, 0DAH>>
GUID_UNATTEND_SLEEP_TIMEOUT                     equ     <07BC4A2F9H, 0D8FCH, 04469H, <0B0H, 07BH, 033H, 0EBH, 078H, 05AH, 0ACH, 0A0H>>
GUID_HIBERNATE_TIMEOUT                          equ     <09D7815A6H, 07EE4H, 0497EH, <088H, 088H, 051H, 05AH, 005H, 0F0H, 023H, 064H>>
GUID_HIBERNATE_FASTS4_POLICY                    equ     <094AC6D29H, 073CEH, 041A6H, <080H, 09FH, 063H, 063H, 0BAH, 021H, 0B4H, 07EH>>
GUID_CRITICAL_POWER_TRANSITION                  equ     <0B7A27025H, 0E569H, 046c2H, <0A5H, 004H, 02BH, 096H, 0CAH, 0D2H, 025H, 0A1H>>
GUID_SYSTEM_AWAYMODE                            equ     <098A7F580H, 001F7H, 048AAH, <09CH, 00FH, 044H, 035H, 02CH, 029H, 0E5H, 0C0H>>
GUID_ALLOW_AWAYMODE                             equ     <025DFA149H, 05DD1H, 04736H, <0B5H, 0ABH, 0E8H, 0A3H, 07BH, 05BH, 081H, 087H>>
GUID_ALLOW_STANDBY_STATES                       equ     <0ABFC2519H, 03608H, 04C2AH, <094H, 0EAH, 017H, 01BH, 00EH, 0D5H, 046H, 0ABH>>
GUID_ALLOW_RTC_WAKE                             equ     <0BD3B718AH, 00680H, 04D9DH, <08AH, 0B2H, 0E1H, 0D2H, 0B4H, 0ACH, 080H, 06DH>>
GUID_ALLOW_SYSTEM_REQUIRED                      equ     <0A4B195F5H, 08225H, 047D8H, <080H, 012H, 09DH, 041H, 036H, 097H, 086H, 0E2H>>
GUID_SYSTEM_BUTTON_SUBGROUP                     equ     <04F971E89H, 0EEBDH, 04455H, <0A8H, 0DEH, 09EH, 059H, 004H, 00EH, 073H, 047H>>
GUID_POWERBUTTON_ACTION                         equ     <07648EFA3H, 0DD9CH, 04E3EH, <0B5H, 066H, 050H, 0F9H, 029H, 038H, 062H, 080H>>
GUID_POWERBUTTON_ACTION_FLAGS                   equ     <0857E7FACH, 0034BH, 04704H, <0ABH, 0B1H, 0BCH, 0A5H, 04AH, 0A3H, 014H, 078H>>
GUID_SLEEPBUTTON_ACTION                         equ     <096996BC0H, 0AD50H, 047ECH, <092H, 03BH, 06FH, 041H, 087H, 04DH, 0D9H, 0EBH>>
GUID_SLEEPBUTTON_ACTION_FLAGS                   equ     <02A160AB1H, 0B69DH, 04743H, <0B7H, 018H, 0BFH, 014H, 041H, 0D5H, 0E4H, 093H>>
GUID_USERINTERFACEBUTTON_ACTION                 equ     <0A7066653H, 08D6CH, 040A8H, <091H, 00EH, 0A1H, 0F5H, 04BH, 084H, 0C7H, 0E5H>>
GUID_LIDCLOSE_ACTION                            equ     <05CA83367H, 06E45H, 0459FH, <0A2H, 07BH, 047H, 06BH, 01DH, 001H, 0C9H, 036H>>
GUID_LIDCLOSE_ACTION_FLAGS                      equ     <097E969ACH, 00D6CH, 04D08H, <092H, 07CH, 0D7H, 0BDH, 07AH, 0D7H, 085H, 07BH>>
GUID_LIDOPEN_POWERSTATE                         equ     <099FF10E7H, 023B1H, 04C07H, <0A9H, 0D1H, 05CH, 032H, 006H, 0D7H, 041H, 0B4H>>
GUID_BATTERY_SUBGROUP                           equ     <0E73A048DH, 0BF27H, 04F12H, <097H, 031H, 08BH, 020H, 076H, 0E8H, 089H, 01FH>>
GUID_BATTERY_DISCHARGE_ACTION_0                 equ     <0637EA02FH, 0BBCBH, 04015H, <08EH, 02CH, 0A1H, 0C7H, 0B9H, 0C0H, 0B5H, 046H>>
GUID_BATTERY_DISCHARGE_LEVEL_0                  equ     <09A66D8D7H, 04FF7H, 04EF9H, <0B5H, 0A2H, 05AH, 032H, 06CH, 0A2H, 0A4H, 069H>>
GUID_BATTERY_DISCHARGE_FLAGS_0                  equ     <05DBB7C9FH, 038E9H, 040D2H, <097H, 049H, 04FH, 08AH, 00EH, 09FH, 064H, 00FH>>
GUID_BATTERY_DISCHARGE_ACTION_1                 equ     <0D8742DCBH, 03E6AH, 04B3CH, <0B3H, 0FEH, 037H, 046H, 023H, 0CDH, 0CFH, 006H>>
GUID_BATTERY_DISCHARGE_LEVEL_1                  equ     <08183BA9AH, 0E910H, 048DAH, <087H, 069H, 014H, 0AEH, 06DH, 0C1H, 017H, 00AH>>
GUID_BATTERY_DISCHARGE_FLAGS_1                  equ     <0BCDED951H, 0187BH, 04D05H, <0BCH, 0CCH, 0F7H, 0E5H, 019H, 060H, 0C2H, 058H>>
GUID_BATTERY_DISCHARGE_ACTION_2                 equ     <0421CBA38H, 01A8EH, 04881H, <0ACH, 089H, 0E3H, 03AH, 08BH, 004H, 0ECH, 0E4H>>
GUID_BATTERY_DISCHARGE_LEVEL_2                  equ     <007A07CA2H, 0ADAFH, 040D7H, <0B0H, 077H, 053H, 03AH, 0ADH, 0EDH, 01BH, 0FAH>>
GUID_BATTERY_DISCHARGE_FLAGS_2                  equ     <07FD2F0C4H, 0FEB7H, 04DA3H, <081H, 017H, 0E3H, 0FBH, 0EDH, 0C4H, 065H, 082H>>
GUID_BATTERY_DISCHARGE_ACTION_3                 equ     <080472613H, 09780H, 0455EH, <0B3H, 008H, 072H, 0D3H, 000H, 03CH, 0F2H, 0F8H>>
GUID_BATTERY_DISCHARGE_LEVEL_3                  equ     <058AFD5A6H, 0C2DDH, 047D2H, <09FH, 0BFH, 0EFH, 070H, 0CCH, 05CH, 059H, 065H>>
GUID_BATTERY_DISCHARGE_FLAGS_3                  equ     <073613CCFH, 0DBFAH, 04279H, <083H, 056H, 049H, 035H, 0f6H, 0bfH, 062H, 0F3H>>
GUID_PROCESSOR_SETTINGS_SUBGROUP                equ     <054533251H, 082BEH, 04824H, <096H, 0C1H, 047H, 0B6H, 00BH, 074H, 00DH, 000H>>
GUID_PROCESSOR_THROTTLE_POLICY                  equ     <057027304H, 04AF6H, 04104H, <092H, 060H, 0E3H, 0D9H, 052H, 048H, 0FCH, 036H>>
GUID_PROCESSOR_THROTTLE_MAXIMUM                 equ     <0BC5038F7H, 023E0H, 04960H, <096H, 0DAH, 033H, 0ABH, 0AFH, 059H, 035H, 0ECH>>
GUID_PROCESSOR_THROTTLE_MINIMUM                 equ     <0893DEE8EH, 02BEFH, 041E0H, <089H, 0C6H, 0B5H, 05DH, 009H, 029H, 096H, 04CH>>
GUID_PROCESSOR_ALLOW_THROTTLING                 equ     <03B04D4FDH, 01CC7H, 04F23H, <0ABH, 01CH, 0D1H, 033H, 078H, 019H, 0C4H, 0BBH>>
GUID_PROCESSOR_IDLESTATE_POLICY                 equ     <068F262A7H, 0F621H, 04069H, <0B9H, 0A5H, 048H, 074H, 016H, 09BH, 0E2H, 03CH>>
GUID_PROCESSOR_PERFSTATE_POLICY                 equ     <0BBDC3814H, 018E9H, 04463H, <08AH, 055H, 0D1H, 097H, 032H, 07CH, 045H, 0C0H>>
GUID_PROCESSOR_PERF_INCREASE_THRESHOLD          equ     <006CADF0EH, 064EDH, 0448AH, <089H, 027H, 0CEH, 07BH, 0F9H, 00EH, 0B3H, 05DH>>
GUID_PROCESSOR_PERF_DECREASE_THRESHOLD          equ     <012A0AB44H, 0FE28H, 04FA9H, <0B3H, 0BDH, 04BH, 064H, 0F4H, 049H, 060H, 0A6H>>
GUID_PROCESSOR_PERF_INCREASE_POLICY             equ     <0465E1F50H, 0B610H, 0473AH, <0ABH, 058H, 000H, 0D1H, 007H, 07DH, 0C4H, 018H>>
GUID_PROCESSOR_PERF_DECREASE_POLICY             equ     <040FBEFC7H, 02E9DH, 04D25H, <0A1H, 085H, 00CH, 0FDH, 085H, 074H, 0BAH, 0C6H>>
GUID_PROCESSOR_PERF_INCREASE_TIME               equ     <0984CF492H, 03BEDH, 04488H, <0A8H, 0F9H, 042H, 086H, 0C9H, 07BH, 0F5H, 0AAH>>
GUID_PROCESSOR_PERF_DECREASE_TIME               equ     <0D8EDEB9BH, 095CFH, 04F95H, <0A7H, 03CH, 0B0H, 061H, 097H, 036H, 093H, 0C8H>>
GUID_PROCESSOR_PERF_TIME_CHECK                  equ     <04D2B0152H, 07D5CH, 0498BH, <088H, 0E2H, 034H, 034H, 053H, 092H, 0A2H, 0C5H>>
GUID_PROCESSOR_PERF_BOOST_POLICY                equ     <045BCC044H, 0D885H, 043E2H, <086H, 005H, 0EEH, 00EH, 0C6H, 0E9H, 06BH, 059H>>
GUID_SYSTEM_COOLING_POLICY                      equ     <094D3A615H, 0A899H, 04AC5H, <0AEH, 02BH, 0E4H, 0D8H, 0F6H, 034H, 036H, 07FH>>
GUID_LOCK_CONSOLE_ON_WAKE                       equ     <00E796BDBH, 0100DH, 047D6H, <0A2H, 0D5H, 0F7H, 0D2H, 0DAH, 0A5H, 01FH, 051H>>
GUID_DEVICE_IDLE_POLICY                         equ     <04FAAB71AH, 092E5H, 04726H, <0B5H, 031H, 022H, 045H, 059H, 067H, 02DH, 019H>>
GUID_PPM_PERFSTATE_CHANGE_GUID                  equ     <0A5B32DDDH, 07F39H, 04ABCH, <0B8H, 092H, 090H, 00EH, 043H, 0B5H, 09EH, 0BBH>>
GUID_PPM_PERFSTATE_DOMAIN_CHANGE_GUID           equ     <0995E6B7FH, 0D653H, 0497AH, <0B9H, 078H, 036H, 0A3H, 00CH, 029H, 0BFH, 001H>>
GUID_PPM_IDLESTATE_CHANGE_GUID                  equ     <04838FE4FH, 0F71CH, 04E51H, <09EH, 0CCH, 084H, 030H, 0A7H, 0ACH, 04CH, 06CH>>
GUID_PPM_PERFSTATES_DATA_GUID                   equ     <05708CC20H, 07D40H, 04BF4H, <0B4H, 0AAH, 02BH, 001H, 033H, 08DH, 001H, 026H>>
GUID_PPM_IDLESTATES_DATA_GUID                   equ     <0BA138E10H, 0E250H, 04AD7H, <086H, 016H, 0CFH, 01AH, 07AH, 0D4H, 010H, 0E7H>>
GUID_PPM_IDLE_ACCOUNTING_GUID                   equ     <0E2A26F78H, 0AE07H, 04EE0H, <0A3H, 00FH, 0CEH, 054H, 0F5H, 05AH, 094H, 0CDH>>
GUID_PPM_THERMALCONSTRAINT_GUID                 equ     <0A852C2C8H, 01A4CH, 0423BH, <08CH, 02CH, 0F3H, 00DH, 082H, 093H, 01AH, 088H>>
GUID_PPM_PERFMON_PERFSTATE_GUID                 equ     <07FD18652H, 00CFEH, 040D2H, <0B0H, 0A1H, 00BH, 006H, 06AH, 087H, 075H, 09EH>>
GUID_PPM_THERMAL_POLICY_CHANGE_GUID             equ     <048F377B8H, 06880H, 04C7BH, <08BH, 0DCH, 038H, 001H, 076H, 0C6H, 065H, 04DH>>
GUID_NULL                                       equ     <000000000H, 00000H, 00000H, <000H, 000H, 000H, 000H, 000H, 000H, 000H, 000H>>

ANSI_NULL                                       equ     0
UNICODE_NULL                                    equ     0

MINCHAR                                         equ     80H
MAXCHAR                                         equ     7FH
MINSHORT                                        equ     8000H
MAXSHORT                                        equ     7FFFH
MINLONG                                         equ     80000000H
MAXLONG                                         equ     07FFFFFFFH
MAXBYTE                                         equ     0FFH
MAXWORD                                         equ     0FFFFH
MAXDWORD                                        equ     0FFFFFFFFH

NLS_VALID_LOCALE_MASK                           equ     000FFFFFH

VER_SERVER_NT                                   equ     80000000H
VER_WORKSTATION_NT                              equ     40000000H
VER_SUITE_SMALLBUSINESS                         equ     00000001H
VER_SUITE_ENTERPRISE                            equ     00000002H
VER_SUITE_BACKOFFICE                            equ     00000004H
VER_SUITE_COMMUNICATIONS                        equ     00000008H
VER_SUITE_TERMINAL                              equ     00000010H
VER_SUITE_SMALLBUSINESS_RESTRICTED              equ     00000020H
VER_SUITE_EMBEDDEDNT                            equ     00000040H
VER_SUITE_DATACENTER                            equ     00000080H
VER_SUITE_SINGLEUSERTS                          equ     00000100H
VER_SUITE_PERSONAL                              equ     00000200H
VER_SUITE_BLADE                                 equ     00000400H
VER_SUITE_EMBEDDED_RESTRICTED                   equ     00000800H
VER_SUITE_SECURITY_APPLIANCE                    equ     00001000H
VER_SUITE_STORAGE_SERVER                        equ     00002000H
VER_SUITE_COMPUTE_SERVER                        equ     00004000H
VER_SUITE_WH_SERVER                             equ     00008000H

ActivationContextBasicInformation               equ     1
ActivationContextDetailedInformation            equ     2
AssemblyDetailedInformationInActivationContext  equ     3
FileInformationInAssemblyOfAssemblyInActivationContext  equ 4
RunlevelInformationInActivationContext          equ     5
CompatibilityInformationInActivationContext     equ     6
ActivationContextManifestResourceName           equ     7
MaxActivationContextInfoClass                   equ     8

AssemblyDetailedInformationInActivationContxt   equ     3
FileInformationInAssemblyOfAssemblyInActivationContxt   equ 4

PRODUCT_UNDEFINED                               equ     00000000H

PRODUCT_ULTIMATE                                equ     00000001H
PRODUCT_HOME_BASIC                              equ     00000002H
PRODUCT_HOME_PREMIUM                            equ     00000003H
PRODUCT_ENTERPRISE                              equ     00000004H
PRODUCT_HOME_BASIC_N                            equ     00000005H
PRODUCT_BUSINESS                                equ     00000006H
PRODUCT_STANDARD_SERVER                         equ     00000007H
PRODUCT_DATACENTER_SERVER                       equ     00000008H
PRODUCT_SMALLBUSINESS_SERVER                    equ     00000009H
PRODUCT_ENTERPRISE_SERVER                       equ     0000000AH
PRODUCT_STARTER                                 equ     0000000BH
PRODUCT_DATACENTER_SERVER_CORE                  equ     0000000CH
PRODUCT_STANDARD_SERVER_CORE                    equ     0000000DH
PRODUCT_ENTERPRISE_SERVER_CORE                  equ     0000000EH
PRODUCT_ENTERPRISE_SERVER_IA64                  equ     0000000FH
PRODUCT_BUSINESS_N                              equ     00000010H
PRODUCT_WEB_SERVER                              equ     00000011H
PRODUCT_CLUSTER_SERVER                          equ     00000012H
PRODUCT_HOME_SERVER                             equ     00000013H
PRODUCT_STORAGE_EXPRESS_SERVER                  equ     00000014H
PRODUCT_STORAGE_STANDARD_SERVER                 equ     00000015H
PRODUCT_STORAGE_WORKGROUP_SERVER                equ     00000016H
PRODUCT_STORAGE_ENTERPRISE_SERVER               equ     00000017H
PRODUCT_SERVER_FOR_SMALLBUSINESS                equ     00000018H
PRODUCT_SMALLBUSINESS_SERVER_PREMIUM            equ     00000019H
PRODUCT_HOME_PREMIUM_N                          equ     0000001AH
PRODUCT_ENTERPRISE_N                            equ     0000001BH
PRODUCT_ULTIMATE_N                              equ     0000001CH
PRODUCT_WEB_SERVER_CORE                         equ     0000001DH
PRODUCT_MEDIUMBUSINESS_SERVER_MANAGEMENT        equ     0000001EH
PRODUCT_MEDIUMBUSINESS_SERVER_SECURITY          equ     0000001FH
PRODUCT_MEDIUMBUSINESS_SERVER_MESSAGING         equ     00000020H
PRODUCT_SERVER_FOUNDATION                       equ     00000021H
PRODUCT_HOME_PREMIUM_SERVER                     equ     00000022H
PRODUCT_SERVER_FOR_SMALLBUSINESS_V              equ     00000023H
PRODUCT_STANDARD_SERVER_V                       equ     00000024H
PRODUCT_DATACENTER_SERVER_V                     equ     00000025H
PRODUCT_ENTERPRISE_SERVER_V                     equ     00000026H
PRODUCT_DATACENTER_SERVER_CORE_V                equ     00000027H
PRODUCT_STANDARD_SERVER_CORE_V                  equ     00000028H
PRODUCT_ENTERPRISE_SERVER_CORE_V                equ     00000029H
PRODUCT_HYPERV                                  equ     0000002AH
PRODUCT_STORAGE_EXPRESS_SERVER_CORE             equ     0000002BH
PRODUCT_STORAGE_STANDARD_SERVER_CORE            equ     0000002CH
PRODUCT_STORAGE_WORKGROUP_SERVER_CORE           equ     0000002DH
PRODUCT_STORAGE_ENTERPRISE_SERVER_CORE          equ     0000002EH
PRODUCT_STARTER_N                               equ     0000002FH
PRODUCT_PROFESSIONAL                            equ     00000030H
PRODUCT_PROFESSIONAL_N                          equ     00000031H
PRODUCT_SB_SOLUTION_SERVER                      equ     00000032H
PRODUCT_SERVER_FOR_SB_SOLUTIONS                 equ     00000033H
PRODUCT_STANDARD_SERVER_SOLUTIONS               equ     00000034H
PRODUCT_STANDARD_SERVER_SOLUTIONS_CORE          equ     00000035H
PRODUCT_SB_SOLUTION_SERVER_EM                   equ     00000036H
PRODUCT_SERVER_FOR_SB_SOLUTIONS_EM              equ     00000037H
PRODUCT_SOLUTION_EMBEDDEDSERVER                 equ     00000038H
PRODUCT_SOLUTION_EMBEDDEDSERVER_CORE            equ     00000039H
PRODUCT_SMALLBUSINESS_SERVER_PREMIUM_CORE       equ     0000003FH
PRODUCT_ESSENTIALBUSINESS_SERVER_MGMT           equ     0000003BH
PRODUCT_ESSENTIALBUSINESS_SERVER_ADDL           equ     0000003CH
PRODUCT_ESSENTIALBUSINESS_SERVER_MGMTSVC        equ     0000003DH
PRODUCT_ESSENTIALBUSINESS_SERVER_ADDLSVC        equ     0000003EH
PRODUCT_CLUSTER_SERVER_V                        equ     00000040H
PRODUCT_EMBEDDED                                equ     00000041H
PRODUCT_STARTER_E                               equ     00000042H
PRODUCT_HOME_BASIC_E                            equ     00000043H
PRODUCT_HOME_PREMIUM_E                          equ     00000044H
PRODUCT_PROFESSIONAL_E                          equ     00000045H
PRODUCT_ENTERPRISE_E                            equ     00000046H
PRODUCT_ULTIMATE_E                              equ     00000047H
PRODUCT_UNLICENSED                              equ     0ABCDABCDH

LOCALE_USER_DEFAULT                             equ     0400H

LOCALE_SYSTEM_DEFAULT                           equ     2048
LOCALE_NOUSEROVERRIDE                           equ     80000000H

LANG_NEUTRAL                                    equ     00H
LANG_INVARIANT                                  equ     7FH

LANG_AFRIKAANS                                  equ     36H
LANG_ALBANIAN                                   equ     1CH
LANG_ALSATIAN                                   equ     84H
LANG_AMHARIC                                    equ     5EH
LANG_ARABIC                                     equ     01H
LANG_ARMENIAN                                   equ     2BH
LANG_ASSAMESE                                   equ     4DH
LANG_AZERI                                      equ     2CH
LANG_AZERBAIJANI                                equ     2CH
LANG_BANGLA                                     equ     45H
LANG_BASHKIR                                    equ     6dH
LANG_BASQUE                                     equ     2DH
LANG_BELARUSIAN                                 equ     23H
LANG_BENGALI                                    equ     45H
LANG_BRETON                                     equ     7EH
LANG_BOSNIAN                                    equ     1AH
LANG_BOSNIAN_NEUTRAL                            equ     781AH
LANG_BULGARIAN                                  equ     02H
LANG_CATALAN                                    equ     03H
LANG_CENTRAL_KURDISH                            equ     92H
LANG_CHEROKEE                                   equ     5CH
LANG_CHINESE                                    equ     04H
LANG_CHINESE_SIMPLIFIED                         equ     04H
LANG_CHINESE_TRADITIONAL                        equ     7C04H
LANG_CORSICAN                                   equ     83H
LANG_CROATIAN                                   equ     1AH
LANG_CZECH                                      equ     05H
LANG_DANISH                                     equ     06H
LANG_DARI                                       equ     8CH
LANG_DIVEHI                                     equ     65H
LANG_DUTCH                                      equ     13H
LANG_ENGLISH                                    equ     09H
LANG_ESTONIAN                                   equ     25H
LANG_FAEROESE                                   equ     38H
LANG_FARSI                                      equ     29H
LANG_FILIPINO                                   equ     64H
LANG_FINNISH                                    equ     0BH
LANG_FRENCH                                     equ     0CH
LANG_FRISIAN                                    equ     62H
LANG_FULAH                                      equ     67H
LANG_GALICIAN                                   equ     56H
LANG_GEORGIAN                                   equ     37H
LANG_GERMAN                                     equ     07H
LANG_GREEK                                      equ     08H
LANG_GREENLANDIC                                equ     6FH
LANG_GUJARATI                                   equ     47H
LANG_HAUSA                                      equ     68H
LANG_HAWAIIAN                                   equ     75H
LANG_HEBREW                                     equ     0DH
LANG_HINDI                                      equ     39H
LANG_HUNGARIAN                                  equ     0EH
LANG_ICELANDIC                                  equ     0FH
LANG_IGBO                                       equ     70H
LANG_INDONESIAN                                 equ     21H
LANG_INUKTITUT                                  equ     5DH
LANG_IRISH                                      equ     3CH
LANG_ITALIAN                                    equ     10H
LANG_JAPANESE                                   equ     11H
LANG_KANNADA                                    equ     4BH
LANG_KASHMIRI                                   equ     60H
LANG_KAZAK                                      equ     3FH
LANG_KHMER                                      equ     53H
LANG_KICHE                                      equ     86H
LANG_KINYARWANDA                                equ     87H
LANG_KONKANI                                    equ     57H
LANG_KOREAN                                     equ     12H
LANG_KYRGYZ                                     equ     40H
LANG_LAO                                        equ     54H
LANG_LATVIAN                                    equ     26H
LANG_LITHUANIAN                                 equ     27H
LANG_LOWER_SORBIAN                              equ     2EH
LANG_LUXEMBOURGISH                              equ     6EH
LANG_MACEDONIAN                                 equ     2FH
LANG_MALAY                                      equ     3EH
LANG_MALAYALAM                                  equ     4CH
LANG_MALTESE                                    equ     3AH
LANG_MANIPURI                                   equ     58H
LANG_MAORI                                      equ     81H
LANG_MAPUDUNGUN                                 equ     7AH
LANG_MARATHI                                    equ     4EH
LANG_MOHAWK                                     equ     7CH
LANG_MONGOLIAN                                  equ     50H
LANG_NEPALI                                     equ     61H
LANG_NORWEGIAN                                  equ     14H
LANG_OCCITAN                                    equ     82H
LANG_ODIA                                       equ     48H
LANG_ORIYA                                      equ     48H
LANG_PASHTO                                     equ     63H
LANG_PERSIAN                                    equ     29H
LANG_POLISH                                     equ     15H
LANG_PORTUGUESE                                 equ     16H
LANG_PULAR                                      equ     67H
LANG_PUNJABI                                    equ     46H
LANG_QUECHUA                                    equ     6BH
LANG_ROMANIAN                                   equ     18H
LANG_ROMANSH                                    equ     17H
LANG_RUSSIAN                                    equ     19H
LANG_SAKHA                                      equ     85H
LANG_SAMI                                       equ     3BH
LANG_SANSKRIT                                   equ     4FH
LANG_SCOTTISH_GAELIC                            equ     91H
LANG_SERBIAN                                    equ     1AH
LANG_SERBIAN_NEUTRAL                            equ     7C1AH
LANG_SINDHI                                     equ     59H
LANG_SINHALESE                                  equ     5BH
LANG_SLOVAK                                     equ     1BH
LANG_SLOVENIAN                                  equ     24H
LANG_SOTHO                                      equ     6CH
LANG_SPANISH                                    equ     0AH
LANG_SWAHILI                                    equ     41H
LANG_SWEDISH                                    equ     1DH
LANG_SYRIAC                                     equ     5AH
LANG_TAJIK                                      equ     28H
LANG_TAMAZIGHT                                  equ     5FH
LANG_TAMIL                                      equ     49H
LANG_TATAR                                      equ     44H
LANG_TELUGU                                     equ     4AH
LANG_THAI                                       equ     1EH
LANG_TIBETAN                                    equ     51H
LANG_TIGRIGNA                                   equ     73H
LANG_TIGRINYA                                   equ     73H
LANG_TSWANA                                     equ     32H
LANG_TURKISH                                    equ     1FH
LANG_TURKMEN                                    equ     42H
LANG_UIGHUR                                     equ     80H
LANG_UKRAINIAN                                  equ     22H
LANG_UPPER_SORBIAN                              equ     2EH
LANG_URDU                                       equ     20H
LANG_UZBEK                                      equ     43H
LANG_VALENCIAN                                  equ     03H
LANG_VIETNAMESE                                 equ     2AH
LANG_WELSH                                      equ     52H
LANG_WOLOF                                      equ     88H
LANG_XHOSA                                      equ     34H
LANG_YAKUT                                      equ     85H
LANG_YI                                         equ     78H
LANG_YORUBA                                     equ     6AH
LANG_ZULU                                       equ     35H

SUBLANG_NEUTRAL                                 equ     00H
SUBLANG_DEFAULT                                 equ     01H
SUBLANG_SYS_DEFAULT                             equ     02H
SUBLANG_CUSTOM_DEFAULT                          equ     03H
SUBLANG_CUSTOM_UNSPECIFIED                      equ     04H
SUBLANG_UI_CUSTOM_DEFAULT                       equ     05H

SUBLANG_AFRIKAANS_SOUTH_AFRICA                  equ     01H
SUBLANG_ALBANIAN_ALBANIA                        equ     01H
SUBLANG_ALSATIAN_FRANCE                         equ     01H
SUBLANG_AMHARIC_ETHIOPIA                        equ     01H
SUBLANG_ARABIC_SAUDI_ARABIA                     equ     01H
SUBLANG_ARABIC_IRAQ                             equ     02H
SUBLANG_ARABIC_EGYPT                            equ     03H
SUBLANG_ARABIC_LIBYA                            equ     04H
SUBLANG_ARABIC_ALGERIA                          equ     05H
SUBLANG_ARABIC_MOROCCO                          equ     06H
SUBLANG_ARABIC_TUNISIA                          equ     07H
SUBLANG_ARABIC_OMAN                             equ     08H
SUBLANG_ARABIC_YEMEN                            equ     09H
SUBLANG_ARABIC_SYRIA                            equ     0AH
SUBLANG_ARABIC_JORDAN                           equ     0BH
SUBLANG_ARABIC_LEBANON                          equ     0CH
SUBLANG_ARABIC_KUWAIT                           equ     0DH
SUBLANG_ARABIC_UAE                              equ     0EH
SUBLANG_ARABIC_BAHRAIN                          equ     0FH
SUBLANG_ARABIC_QATAR                            equ     10H
SUBLANG_ARMENIAN_ARMENIA                        equ     01H
SUBLANG_ASSAMESE_INDIA                          equ     01H
SUBLANG_AZERI_LATIN                             equ     01H
SUBLANG_AZERI_CYRILLIC                          equ     02H
SUBLANG_AZERBAIJANI_AZERBAIJAN_LATIN            equ     01H
SUBLANG_AZERBAIJANI_AZERBAIJAN_CYRILLIC         equ     02H
SUBLANG_BANGLA_INDIA                            equ     01H
SUBLANG_BANGLA_BANGLADESH                       equ     02H
SUBLANG_BASHKIR_RUSSIA                          equ     01H
SUBLANG_BASQUE_BASQUE                           equ     01H
SUBLANG_BELARUSIAN_BELARUS                      equ     01H
SUBLANG_BENGALI_INDIA                           equ     01H
SUBLANG_BENGALI_BANGLADESH                      equ     02H
SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN        equ     05H
SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC     equ     08H
SUBLANG_BRETON_FRANCE                           equ     01H
SUBLANG_BULGARIAN_BULGARIA                      equ     01H
SUBLANG_CATALAN_CATALAN                         equ     01H
SUBLANG_CENTRAL_KURDISH_IRAQ                    equ     01H
SUBLANG_CHEROKEE_CHEROKEE                       equ     01H
SUBLANG_CHINESE_TRADITIONAL                     equ     01H
SUBLANG_CHINESE_SIMPLIFIED                      equ     02H
SUBLANG_CHINESE_HONGKONG                        equ     03H
SUBLANG_CHINESE_SINGAPORE                       equ     04H
SUBLANG_CHINESE_MACAU                           equ     05H
SUBLANG_CORSICAN_FRANCE                         equ     01H
SUBLANG_CZECH_CZECH_REPUBLIC                    equ     01H
SUBLANG_CROATIAN_CROATIA                        equ     01H
SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN       equ     04H
SUBLANG_DANISH_DENMARK                          equ     01H
SUBLANG_DARI_AFGHANISTAN                        equ     01H
SUBLANG_DIVEHI_MALDIVES                         equ     01H
SUBLANG_DUTCH                                   equ     01H
SUBLANG_DUTCH_BELGIAN                           equ     02H
SUBLANG_ENGLISH_US                              equ     01H
SUBLANG_ENGLISH_UK                              equ     02H
SUBLANG_ENGLISH_AUS                             equ     03H
SUBLANG_ENGLISH_CAN                             equ     04H
SUBLANG_ENGLISH_NZ                              equ     05H
SUBLANG_ENGLISH_EIRE                            equ     06H
SUBLANG_ENGLISH_SOUTH_AFRICA                    equ     07H
SUBLANG_ENGLISH_JAMAICA                         equ     08H
SUBLANG_ENGLISH_CARIBBEAN                       equ     09H
SUBLANG_ENGLISH_BELIZE                          equ     0AH
SUBLANG_ENGLISH_TRINIDAD                        equ     0BH
SUBLANG_ENGLISH_ZIMBABWE                        equ     0CH
SUBLANG_ENGLISH_PHILIPPINES                     equ     0DH
SUBLANG_ENGLISH_INDIA                           equ     10H
SUBLANG_ENGLISH_MALAYSIA                        equ     11H
SUBLANG_ENGLISH_SINGAPORE                       equ     12H
SUBLANG_ESTONIAN_ESTONIA                        equ     01H
SUBLANG_FAEROESE_FAROE_ISLANDS                  equ     01H
SUBLANG_FILIPINO_PHILIPPINES                    equ     01H
SUBLANG_FINNISH_FINLAND                         equ     01H
SUBLANG_FRENCH                                  equ     01H
SUBLANG_FRENCH_BELGIAN                          equ     02H
SUBLANG_FRENCH_CANADIAN                         equ     03H
SUBLANG_FRENCH_SWISS                            equ     04H
SUBLANG_FRENCH_LUXEMBOURG                       equ     05H
SUBLANG_FRENCH_MONACO                           equ     06H
SUBLANG_FRISIAN_NETHERLANDS                     equ     01H
SUBLANG_FULAH_SENEGAL                           equ     02H
SUBLANG_GALICIAN_GALICIAN                       equ     01H
SUBLANG_GEORGIAN_GEORGIA                        equ     01H
SUBLANG_GERMAN                                  equ     01H
SUBLANG_GERMAN_SWISS                            equ     02H
SUBLANG_GERMAN_AUSTRIAN                         equ     03H
SUBLANG_GERMAN_LUXEMBOURG                       equ     04H
SUBLANG_GERMAN_LIECHTENSTEIN                    equ     05H
SUBLANG_GREEK_GREECE                            equ     01H
SUBLANG_GREENLANDIC_GREENLAND                   equ     01H
SUBLANG_GUJARATI_INDIA                          equ     01H
SUBLANG_HAUSA_NIGERIA_LATIN                     equ     01H
SUBLANG_HAWAIIAN_US                             equ     01H
SUBLANG_HEBREW_ISRAEL                           equ     01H
SUBLANG_HINDI_INDIA                             equ     01H
SUBLANG_HUNGARIAN_HUNGARY                       equ     01H
SUBLANG_ICELANDIC_ICELAND                       equ     01H
SUBLANG_IGBO_NIGERIA                            equ     01H
SUBLANG_INDONESIAN_INDONESIA                    equ     01H
SUBLANG_INUKTITUT_CANADA                        equ     01H
SUBLANG_INUKTITUT_CANADA_LATIN                  equ     02H
SUBLANG_IRISH_IRELAND                           equ     02H
SUBLANG_ITALIAN                                 equ     01H
SUBLANG_ITALIAN_SWISS                           equ     02H
SUBLANG_JAPANESE_JAPAN                          equ     01H
SUBLANG_KANNADA_INDIA                           equ     01H
SUBLANG_KASHMIRI_SASIA                          equ     02H
SUBLANG_KASHMIRI_INDIA                          equ     02H
SUBLANG_KAZAK_KAZAKHSTAN                        equ     01H
SUBLANG_KHMER_CAMBODIA                          equ     01H
SUBLANG_KICHE_GUATEMALA                         equ     01H
SUBLANG_KINYARWANDA_RWANDA                      equ     01H
SUBLANG_KONKANI_INDIA                           equ     01H
SUBLANG_KOREAN                                  equ     01H
SUBLANG_KYRGYZ_KYRGYZSTAN                       equ     01H
SUBLANG_LAO_LAO                                 equ     01H
SUBLANG_LATVIAN_LATVIA                          equ     01H
SUBLANG_LITHUANIAN                              equ     01H
SUBLANG_LOWER_SORBIAN_GERMANY                   equ     02H
SUBLANG_LUXEMBOURGISH_LUXEMBOURG                equ     01H
SUBLANG_MACEDONIAN_MACEDONIA                    equ     01H
SUBLANG_MALAY_MALAYSIA                          equ     01H
SUBLANG_MALAY_BRUNEI_DARUSSALAM                 equ     02H
SUBLANG_MALAYALAM_INDIA                         equ     01H
SUBLANG_MALTESE_MALTA                           equ     01H
SUBLANG_MAORI_NEW_ZEALAND                       equ     01H
SUBLANG_MAPUDUNGUN_CHILE                        equ     01H
SUBLANG_MARATHI_INDIA                           equ     01H
SUBLANG_MOHAWK_MOHAWK                           equ     01H
SUBLANG_MONGOLIAN_CYRILLIC_MONGOLIA             equ     01H
SUBLANG_MONGOLIAN_PRC                           equ     02H
SUBLANG_NEPALI_INDIA                            equ     02H
SUBLANG_NEPALI_NEPAL                            equ     01H
SUBLANG_NORWEGIAN_BOKMAL                        equ     01H
SUBLANG_NORWEGIAN_NYNORSK                       equ     02H
SUBLANG_OCCITAN_FRANCE                          equ     01H
SUBLANG_ODIA_INDIA                              equ     01H
SUBLANG_ORIYA_INDIA                             equ     01H
SUBLANG_PASHTO_AFGHANISTAN                      equ     01H
SUBLANG_PERSIAN_IRAN                            equ     01H
SUBLANG_POLISH_POLAND                           equ     01H
SUBLANG_PORTUGUESE                              equ     02H
SUBLANG_PORTUGUESE_BRAZILIAN                    equ     01H
SUBLANG_PULAR_SENEGAL                           equ     02H
SUBLANG_PUNJABI_INDIA                           equ     01H
SUBLANG_PUNJABI_PAKISTAN                        equ     02H
SUBLANG_QUECHUA_BOLIVIA                         equ     01H
SUBLANG_QUECHUA_ECUADOR                         equ     02H
SUBLANG_QUECHUA_PERU                            equ     03H
SUBLANG_ROMANIAN_ROMANIA                        equ     01H
SUBLANG_ROMANSH_SWITZERLAND                     equ     01H
SUBLANG_RUSSIAN_RUSSIA                          equ     01H
SUBLANG_SAKHA_RUSSIA                            equ     01H
SUBLANG_SAMI_NORTHERN_NORWAY                    equ     01H
SUBLANG_SAMI_NORTHERN_SWEDEN                    equ     02H
SUBLANG_SAMI_NORTHERN_FINLAND                   equ     03H
SUBLANG_SAMI_LULE_NORWAY                        equ     04H
SUBLANG_SAMI_LULE_SWEDEN                        equ     05H
SUBLANG_SAMI_SOUTHERN_NORWAY                    equ     06H
SUBLANG_SAMI_SOUTHERN_SWEDEN                    equ     07H
SUBLANG_SAMI_SKOLT_FINLAND                      equ     08H
SUBLANG_SAMI_INARI_FINLAND                      equ     09H
SUBLANG_SANSKRIT_INDIA                          equ     01H
SUBLANG_SCOTTISH_GAELIC                         equ     01H
SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN        equ     06H
SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC     equ     07H
SUBLANG_SERBIAN_MONTENEGRO_LATIN                equ     0BH
SUBLANG_SERBIAN_MONTENEGRO_CYRILLIC             equ     0CH
SUBLANG_SERBIAN_SERBIA_LATIN                    equ     09H
SUBLANG_SERBIAN_SERBIA_CYRILLIC                 equ     0AH
SUBLANG_SERBIAN_CROATIA                         equ     01H
SUBLANG_SERBIAN_LATIN                           equ     02H
SUBLANG_SERBIAN_CYRILLIC                        equ     03H
SUBLANG_SINDHI_INDIA                            equ     01H
SUBLANG_SINDHI_PAKISTAN                         equ     02H
SUBLANG_SINDHI_AFGHANISTAN                      equ     02H
SUBLANG_SINHALESE_SRI_LANKA                     equ     01H
SUBLANG_SOTHO_NORTHERN_SOUTH_AFRICA             equ     01H
SUBLANG_SLOVAK_SLOVAKIA                         equ     01H
SUBLANG_SLOVENIAN_SLOVENIA                      equ     01H
SUBLANG_SPANISH                                 equ     01H
SUBLANG_SPANISH_MEXICAN                         equ     02H
SUBLANG_SPANISH_MODERN                          equ     03H
SUBLANG_SPANISH_GUATEMALA                       equ     04H
SUBLANG_SPANISH_COSTA_RICA                      equ     05H
SUBLANG_SPANISH_PANAMA                          equ     06H
SUBLANG_SPANISH_DOMINICAN_REPUBLIC              equ     07H
SUBLANG_SPANISH_VENEZUELA                       equ     08H
SUBLANG_SPANISH_COLOMBIA                        equ     09H
SUBLANG_SPANISH_PERU                            equ     0AH
SUBLANG_SPANISH_ARGENTINA                       equ     0BH
SUBLANG_SPANISH_ECUADOR                         equ     0CH
SUBLANG_SPANISH_CHILE                           equ     0DH
SUBLANG_SPANISH_URUGUAY                         equ     0EH
SUBLANG_SPANISH_PARAGUAY                        equ     0FH
SUBLANG_SPANISH_BOLIVIA                         equ     10H
SUBLANG_SPANISH_EL_SALVADOR                     equ     11H
SUBLANG_SPANISH_HONDURAS                        equ     12H
SUBLANG_SPANISH_NICARAGUA                       equ     13H
SUBLANG_SPANISH_PUERTO_RICO                     equ     14H
SUBLANG_SPANISH_US                              equ     15H
SUBLANG_SWAHILI_KENYA                           equ     01H
SUBLANG_SWEDISH                                 equ     01H
SUBLANG_SWEDISH_FINLAND                         equ     02H
SUBLANG_SYRIAC_SYRIA                            equ     01H
SUBLANG_TAJIK_TAJIKISTAN                        equ     01H
SUBLANG_TAMAZIGHT_ALGERIA_LATIN                 equ     02H
SUBLANG_TAMAZIGHT_MOROCCO_TIFINAGH              equ     04H
SUBLANG_TAMIL_INDIA                             equ     01H
SUBLANG_TAMIL_SRI_LANKA                         equ     02H
SUBLANG_TATAR_RUSSIA                            equ     01H
SUBLANG_TELUGU_INDIA                            equ     01H
SUBLANG_THAI_THAILAND                           equ     01H
SUBLANG_TIBETAN_PRC                             equ     01H
SUBLANG_TIGRIGNA_ERITREA                        equ     02H
SUBLANG_TIGRINYA_ERITREA                        equ     02H
SUBLANG_TIGRINYA_ETHIOPIA                       equ     01H
SUBLANG_TSWANA_BOTSWANA                         equ     02H
SUBLANG_TSWANA_SOUTH_AFRICA                     equ     01H
SUBLANG_TURKISH_TURKEY                          equ     01H
SUBLANG_TURKMEN_TURKMENISTAN                    equ     01H
SUBLANG_UIGHUR_PRC                              equ     01H
SUBLANG_UKRAINIAN_UKRAINE                       equ     01H
SUBLANG_UPPER_SORBIAN_GERMANY                   equ     01H
SUBLANG_URDU_PAKISTAN                           equ     01H
SUBLANG_URDU_INDIA                              equ     02H
SUBLANG_UZBEK_LATIN                             equ     01H
SUBLANG_UZBEK_CYRILLIC                          equ     02H
SUBLANG_VALENCIAN_VALENCIA                      equ     02H
SUBLANG_VIETNAMESE_VIETNAM                      equ     01H
SUBLANG_WELSH_UNITED_KINGDOM                    equ     01H
SUBLANG_WOLOF_SENEGAL                           equ     01H
SUBLANG_XHOSA_SOUTH_AFRICA                      equ     01H
SUBLANG_YAKUT_RUSSIA                            equ     01H
SUBLANG_YI_PRC                                  equ     01H
SUBLANG_YORUBA_NIGERIA                          equ     01H
SUBLANG_ZULU_SOUTH_AFRICA                       equ     01H

SORT_DEFAULT                                    equ     0H

SORT_JAPANESE_XJIS                              equ     0H
SORT_JAPANESE_UNICODE                           equ     1H
SORT_JAPANESE_RADICALSTROKE                     equ     4H

SORT_CHINESE_BIG5                               equ     0H
SORT_CHINESE_PRCP                               equ     0H
SORT_CHINESE_UNICODE                            equ     1H
SORT_CHINESE_PRC                                equ     2H
SORT_CHINESE_BOPOMOFO                           equ     3H
SORT_CHINESE_RADICALSTROKE                      equ     4H

SORT_KOREAN_KSC                                 equ     0H
SORT_KOREAN_UNICODE                             equ     1H

SORT_GERMAN_PHONE_BOOK                          equ     1H

SORT_HUNGARIAN_DEFAULT                          equ     0H
SORT_HUNGARIAN_TECHNICAL                        equ     1H

SORT_GEORGIAN_TRADITIONAL                       equ     0H
SORT_GEORGIAN_MODERN                            equ     1H

LOCALE_NAME_MAX_LENGTH                          equ     85

LOCALE_CUSTOM_DEFAULT                           equ     ((LANG_NEUTRAL or (SUBLANG_CUSTOM_DEFAULT shl 10)) or (SORT_DEFAULT shl 16))
LOCALE_CUSTOM_UNSPECIFIED                       equ     ((LANG_NEUTRAL or (SUBLANG_CUSTOM_UNSPECIFIED shl 10)) or (SORT_DEFAULT shl 16))
LOCALE_CUSTOM_UI_DEFAULT                        equ     ((LANG_NEUTRAL or (SUBLANG_UI_CUSTOM_DEFAULT shl 10)) or (SORT_DEFAULT shl 16))
LOCALE_NEUTRAL                                  equ     ((LANG_NEUTRAL or (SUBLANG_NEUTRAL shl 10)) or (SORT_DEFAULT shl 16))
LOCALE_INVARIANT                                equ     ((LANG_INVARIANT or (SUBLANG_NEUTRAL shl 10)) or (SORT_DEFAULT shl 16))

LANG_SYSTEM_DEFAULT                             equ     ((SUBLANG_SYS_DEFAULT shl 10) or LANG_NEUTRAL)
LANG_USER_DEFAULT                               equ     ((SUBLANG_DEFAULT shl 10) or LANG_NEUTRAL)

LOCALE_TRANSIENT_KEYBOARD1                      equ     02000H
LOCALE_TRANSIENT_KEYBOARD2                      equ     02400H
LOCALE_TRANSIENT_KEYBOARD3                      equ     02800H
LOCALE_TRANSIENT_KEYBOARD4                      equ     02C00H

LOCALE_UNASSIGNED_LCID                          equ     LOCALE_CUSTOM_UNSPECIFIED

STATUS_WAIT_0                                   equ     000000000H
STATUS_ABANDONED_WAIT_0                         equ     000000080H
STATUS_USER_APC                                 equ     0000000C0H
STATUS_TIMEOUT                                  equ     000000102H
STATUS_PENDING                                  equ     000000103H
DBG_EXCEPTION_HANDLED                           equ     000010001H
DBG_CONTINUE                                    equ     000010002H
STATUS_SEGMENT_NOTIFICATION                     equ     040000005H
DBG_TERMINATE_THREAD                            equ     040010003H
DBG_TERMINATE_PROCESS                           equ     040010004H
DBG_CONTROL_C                                   equ     040010005H
DBG_PRINTEXCEPTION_C                            equ     040010006H
DBG_RIPEXCEPTION                                equ     040010007H
DBG_CONTROL_BREAK                               equ     040010008H
DBG_COMMAND_EXCEPTION                           equ     040010009H
STATUS_GUARD_PAGE_VIOLATION                     equ     080000001H
STATUS_DATATYPE_MISALIGNMENT                    equ     080000002H
STATUS_BREAKPOINT                               equ     080000003H
STATUS_SINGLE_STEP                              equ     080000004H
STATUS_LONGJUMP                                 equ     080000026H
STATUS_UNWIND_CONSOLIDATE                       equ     080000029H
DBG_EXCEPTION_NOT_HANDLED                       equ     080010001H
STATUS_ACCESS_VIOLATION                         equ     0C0000005H
STATUS_IN_PAGE_ERROR                            equ     0C0000006H
STATUS_INVALID_HANDLE                           equ     0C0000008H
STATUS_INVALID_PARAMETER                        equ     0C000000DH
STATUS_NO_MEMORY                                equ     0C0000017H
STATUS_ILLEGAL_INSTRUCTION                      equ     0C000001DH
STATUS_NONCONTINUABLE_EXCEPTION                 equ     0C0000025H
STATUS_INVALID_DISPOSITION                      equ     0C0000026H
STATUS_ARRAY_BOUNDS_EXCEEDED                    equ     0C000008CH
STATUS_FLOAT_DENORMAL_OPERAND                   equ     0C000008DH
STATUS_FLOAT_DIVIDE_BY_ZERO                     equ     0C000008EH
STATUS_FLOAT_INEXACT_RESULT                     equ     0C000008FH
STATUS_FLOAT_INVALID_OPERATION                  equ     0C0000090H
STATUS_FLOAT_OVERFLOW                           equ     0C0000091H
STATUS_FLOAT_STACK_CHECK                        equ     0C0000092H
STATUS_FLOAT_UNDERFLOW                          equ     0C0000093H
STATUS_INTEGER_DIVIDE_BY_ZERO                   equ     0C0000094H
STATUS_INTEGER_OVERFLOW                         equ     0C0000095H
STATUS_PRIVILEGED_INSTRUCTION                   equ     0C0000096H
STATUS_STACK_OVERFLOW                           equ     0C00000FDH
STATUS_DLL_NOT_FOUND                            equ     0C0000135H
STATUS_ORDINAL_NOT_FOUND                        equ     0C0000138H
STATUS_ENTRYPOINT_NOT_FOUND                     equ     0C0000139H
STATUS_CONTROL_C_EXIT                           equ     0C000013AH
STATUS_DLL_INIT_FAILED                          equ     0C0000142H
STATUS_POSSIBLE_DEADLOCK                        equ     0C0000194H
STATUS_FLOAT_MULTIPLE_FAULTS                    equ     0C00002B4H
STATUS_FLOAT_MULTIPLE_TRAPS                     equ     0C00002B5H
STATUS_REG_NAT_CONSUMPTION                      equ     0C00002C9H
STATUS_STACK_BUFFER_OVERRUN                     equ     0C0000409H
STATUS_INVALID_CRUNTIME_PARAMETER               equ     0C0000417H
STATUS_ASSERTION_FAILURE                        equ     0C0000420H
STATUS_SXS_EARLY_DEACTIVATION                   equ     0C015000FH
STATUS_SXS_INVALID_DEACTIVATION                 equ     0C0150010H

MAXIMUM_WAIT_OBJECTS                            equ     64
MAXIMUM_SUSPEND_COUNT                           equ     MAXCHAR

EXCEPTION_NONCONTINUABLE                        equ     01H
EXCEPTION_UNWINDING                             equ     02H
EXCEPTION_EXIT_UNWIND                           equ     04H
EXCEPTION_STACK_INVALID                         equ     08H
EXCEPTION_NESTED_CALL                           equ     010H
EXCEPTION_TARGET_UNWIND                         equ     020H
EXCEPTION_COLLIDED_UNWIND                       equ     040H
EXCEPTION_UNWIND                                equ     (EXCEPTION_UNWINDING or EXCEPTION_EXIT_UNWIND or \
                                                        EXCEPTION_TARGET_UNWIND or EXCEPTION_COLLIDED_UNWIND)

DELETE                                          equ     000010000H
READ_CONTROL                                    equ     000020000H
WRITE_DAC                                       equ     000040000H
WRITE_OWNER                                     equ     000080000H
SYNCHRONIZE                                     equ     000100000H

STANDARD_RIGHTS_REQUIRED                        equ     0000F0000H
STANDARD_RIGHTS_READ                            equ     READ_CONTROL
STANDARD_RIGHTS_WRITE                           equ     READ_CONTROL
STANDARD_RIGHTS_EXECUTE                         equ     READ_CONTROL
STANDARD_RIGHTS_ALL                             equ     0001F0000H

SPECIFIC_RIGHTS_ALL                             equ     00000FFFFH

ACCESS_SYSTEM_SECURITY                          equ     001000000H

MAXIMUM_ALLOWED                                 equ     002000000H

GENERIC_READ                                    equ     080000000H
GENERIC_WRITE                                   equ     040000000H
GENERIC_EXECUTE                                 equ     020000000H
GENERIC_ALL                                     equ     010000000H

SID_HASH_SIZE                                   equ     32
TYPEDEF                                         SID_HASH_ENTRY, xptr

SID_REVISION                                    equ     1
SID_MAX_SUB_AUTHORITIES                         equ     15
SID_RECOMMENDED_SUB_AUTHORITIES                 equ     1

SECURITY_NULL_SID_AUTHORITY                     equ     <0,0,0,0,0,0>
SECURITY_WORLD_SID_AUTHORITY                    equ     <0,0,0,0,0,1>
SECURITY_LOCAL_SID_AUTHORITY                    equ     <0,0,0,0,0,2>
SECURITY_CREATOR_SID_AUTHORITY                  equ     <0,0,0,0,0,3>
SECURITY_NON_UNIQUE_AUTHORITY                   equ     <0,0,0,0,0,4>
SECURITY_RESOURCE_MANAGER_AUTHORITY             equ     <0,0,0,0,0,9>
SECURITY_NULL_RID                               equ     000000000H
SECURITY_WORLD_RID                              equ     000000000H
SECURITY_LOCAL_RID                              equ     000000000H
SECURITY_LOCAL_LOGON_RID                        equ     000000001H
SECURITY_CREATOR_OWNER_RID                      equ     000000000H
SECURITY_CREATOR_GROUP_RID                      equ     000000001H
SECURITY_CREATOR_OWNER_SERVER_RID               equ     000000002H
SECURITY_CREATOR_GROUP_SERVER_RID               equ     000000003H
SECURITY_CREATOR_OWNER_RIGHTS_RID               equ     000000004H

SECURITY_NT_AUTHORITY                           equ     <0,0,0,0,0,5>

SECURITY_DIALUP_RID                             equ     000000001H
SECURITY_NETWORK_RID                            equ     000000002H
SECURITY_BATCH_RID                              equ     000000003H
SECURITY_INTERACTIVE_RID                        equ     000000004H
SECURITY_LOGON_IDS_RID                          equ     000000005H
SECURITY_LOGON_IDS_RID_COUNT                    equ     3
SECURITY_SERVICE_RID                            equ     000000006H
SECURITY_ANONYMOUS_LOGON_RID                    equ     000000007H
SECURITY_PROXY_RID                              equ     000000008H
SECURITY_ENTERPRISE_CONTROLLERS_RID             equ     000000009H
SECURITY_SERVER_LOGON_RID                       equ     SECURITY_ENTERPRISE_CONTROLLERS_RID>
SECURITY_PRINCIPAL_SELF_RID                     equ     00000000AH
SECURITY_AUTHENTICATED_USER_RID                 equ     00000000BH
SECURITY_RESTRICTED_CODE_RID                    equ     00000000CH
SECURITY_TERMINAL_SERVER_RID                    equ     00000000DH
SECURITY_REMOTE_LOGON_RID                       equ     00000000EH
SECURITY_THIS_ORGANIZATION_RID                  equ     00000000FH
SECURITY_IUSER_RID                              equ     000000011H
SECURITY_LOCAL_SYSTEM_RID                       equ     000000012H
SECURITY_LOCAL_SERVICE_RID                      equ     000000013H
SECURITY_NETWORK_SERVICE_RID                    equ     000000014H
SECURITY_NT_NON_UNIQUE                          equ     000000015H
SECURITY_NT_NON_UNIQUE_SUB_AUTH_COUNT           equ     3
SECURITY_ENTERPRISE_READONLY_CONTROLLERS_RID    equ     000000016H
SECURITY_BUILTIN_DOMAIN_RID                     equ     000000020H
SECURITY_WRITE_RESTRICTED_CODE_RID              equ     000000021H
SECURITY_PACKAGE_BASE_RID                       equ     000000040H
SECURITY_PACKAGE_RID_COUNT                      equ     2
SECURITY_PACKAGE_NTLM_RID                       equ     00000000AH
SECURITY_PACKAGE_SCHANNEL_RID                   equ     00000000EH
SECURITY_PACKAGE_DIGEST_RID                     equ     000000015H
SECURITY_CRED_TYPE_BASE_RID                     equ     000000041H
SECURITY_CRED_TYPE_RID_COUNT                    equ     2
SECURITY_CRED_TYPE_THIS_ORG_CERT_RID            equ     000000001H
SECURITY_MIN_BASE_RID                           equ     000000050H
SECURITY_SERVICE_ID_BASE_RID                    equ     000000050H
SECURITY_SERVICE_ID_RID_COUNT                   equ     6
SECURITY_RESERVED_ID_BASE_RID                   equ     000000051H
SECURITY_APPPOOL_ID_BASE_RID                    equ     000000052H
SECURITY_APPPOOL_ID_RID_COUNT                   equ     6
SECURITY_VIRTUALSERVER_ID_BASE_RID              equ     000000053H
SECURITY_VIRTUALSERVER_ID_RID_COUNT             equ     6
SECURITY_USERMODEDRIVERHOST_ID_BASE_RID         equ     000000054H
SECURITY_USERMODEDRIVERHOST_ID_RID_COUNT        equ     6
SECURITY_CLOUD_INFRASTRUCTURE_SERVICES_ID_BASE_RID  equ 000000055H
SECURITY_CLOUD_INFRASTRUCTURE_SERVICES_ID_RID_COUNT equ 6
SECURITY_WMIHOST_ID_BASE_RID                    equ     000000056H
SECURITY_WMIHOST_ID_RID_COUNT                   equ     6
SECURITY_TASK_ID_BASE_RID                       equ     000000057H
SECURITY_NFS_ID_BASE_RID                        equ     000000058H
SECURITY_COM_ID_BASE_RID                        equ     000000059H
SECURITY_WINDOW_MANAGER_BASE_RID                equ     00000005AH
SECURITY_RDV_GFX_BASE_RID                       equ     00000005BH
SECURITY_DASHOST_ID_BASE_RID                    equ     00000005CH
SECURITY_DASHOST_ID_RID_COUNT                   equ     6
SECURITY_VIRTUALACCOUNT_ID_RID_COUNT            equ     6
SECURITY_MAX_BASE_RID                           equ     00000006FH
SECURITY_MAX_ALWAYS_FILTERED                    equ     0000003E7H
SECURITY_MIN_NEVER_FILTERED                     equ     0000003E8H
SECURITY_OTHER_ORGANIZATION_RID                 equ     0000003E8H
SECURITY_WINDOWSMOBILE_ID_BASE_RID              equ     000000070H

DOMAIN_USER_RID_ADMIN                           equ     0000001F4H
DOMAIN_USER_RID_GUEST                           equ     0000001F5H
DOMAIN_USER_RID_KRBTGT                          equ     0000001F6H
DOMAIN_USER_RID_MAX                             equ     0000003E7H

DOMAIN_GROUP_RID_ADMINS                         equ     000000200H
DOMAIN_GROUP_RID_USERS                          equ     000000201H
DOMAIN_GROUP_RID_GUESTS                         equ     000000202H
DOMAIN_GROUP_RID_COMPUTERS                      equ     000000203H
DOMAIN_GROUP_RID_CONTROLLERS                    equ     000000204H
DOMAIN_GROUP_RID_CERT_ADMINS                    equ     000000205H
DOMAIN_GROUP_RID_SCHEMA_ADMINS                  equ     000000206H
DOMAIN_GROUP_RID_ENTERPRISE_ADMINS              equ     000000207H
DOMAIN_GROUP_RID_POLICY_ADMINS                  equ     000000208H
DOMAIN_GROUP_RID_READONLY_CONTROLLERS           equ     000000209H
DOMAIN_GROUP_RID_CLONEABLE_CONTROLLERS          equ     00000020AH
DOMAIN_GROUP_RID_CDC_RESERVED                   equ     00000020CH
DOMAIN_GROUP_RID_PROTECTED_USERS                equ     00000020DH

DOMAIN_ALIAS_RID_ADMINS                         equ     000000220H
DOMAIN_ALIAS_RID_USERS                          equ     000000221H
DOMAIN_ALIAS_RID_GUESTS                         equ     000000222H
DOMAIN_ALIAS_RID_POWER_USERS                    equ     000000223H

DOMAIN_ALIAS_RID_ACCOUNT_OPS                    equ     000000224H
DOMAIN_ALIAS_RID_SYSTEM_OPS                     equ     000000225H
DOMAIN_ALIAS_RID_PRINT_OPS                      equ     000000226H
DOMAIN_ALIAS_RID_BACKUP_OPS                     equ     000000227H

DOMAIN_ALIAS_RID_REPLICATOR                     equ     000000228H
DOMAIN_ALIAS_RID_RAS_SERVERS                    equ     000000229H
DOMAIN_ALIAS_RID_PREW2KCOMPACCESS               equ     00000022AH
DOMAIN_ALIAS_RID_REMOTE_DESKTOP_USERS           equ     00000022BH
DOMAIN_ALIAS_RID_NETWORK_CONFIGURATION_OPS      equ     00000022CH
DOMAIN_ALIAS_RID_INCOMING_FOREST_TRUST_BUILDERS equ     00000022DH
DOMAIN_ALIAS_RID_MONITORING_USERS               equ     00000022EH
DOMAIN_ALIAS_RID_LOGGING_USERS                  equ     00000022FH
DOMAIN_ALIAS_RID_AUTHORIZATIONACCESS            equ     000000230H
DOMAIN_ALIAS_RID_TS_LICENSE_SERVERS             equ     000000231H
DOMAIN_ALIAS_RID_DCOM_USERS                     equ     000000232H
DOMAIN_ALIAS_RID_IUSERS                         equ     000000238H
DOMAIN_ALIAS_RID_CRYPTO_OPERATORS               equ     000000239H
DOMAIN_ALIAS_RID_CACHEABLE_PRINCIPALS_GROUP     equ     00000023BH
DOMAIN_ALIAS_RID_NON_CACHEABLE_PRINCIPALS_GROUP equ     00000023CH
DOMAIN_ALIAS_RID_EVENT_LOG_READERS_GROUP        equ     00000023DH
DOMAIN_ALIAS_RID_CERTSVC_DCOM_ACCESS_GROUP      equ     00000023EH
DOMAIN_ALIAS_RID_RDS_REMOTE_ACCESS_SERVERS      equ     00000023FH
DOMAIN_ALIAS_RID_RDS_ENDPOINT_SERVERS           equ     000000240H
DOMAIN_ALIAS_RID_RDS_MANAGEMENT_SERVERS         equ     000000241H
DOMAIN_ALIAS_RID_HYPER_V_ADMINS                 equ     000000242H
DOMAIN_ALIAS_RID_ACCESS_CONTROL_ASSISTANCE_OPS  equ     000000243H
DOMAIN_ALIAS_RID_REMOTE_MANAGEMENT_USERS        equ     000000244H

SECURITY_MANDATORY_LABEL_AUTHORITY              equ     <0,0,0,0,0,16>
SECURITY_MANDATORY_UNTRUSTED_RID                equ     000000000H
SECURITY_MANDATORY_LOW_RID                      equ     000001000H
SECURITY_MANDATORY_MEDIUM_RID                   equ     000002000H
SECURITY_MANDATORY_MEDIUM_PLUS_RID              equ     (SECURITY_MANDATORY_MEDIUM_RID + 0100H)
SECURITY_MANDATORY_HIGH_RID                     equ     000003000H
SECURITY_MANDATORY_SYSTEM_RID                   equ     000004000H
SECURITY_MANDATORY_PROTECTED_PROCESS_RID        equ     000005000H

SECURITY_MANDATORY_MAXIMUM_USER_RID             equ     SECURITY_MANDATORY_SYSTEM_RID

WinNullSid                                      equ     0
WinWorldSid                                     equ     1
WinLocalSid                                     equ     2
WinCreatorOwnerSid                              equ     3
WinCreatorGroupSid                              equ     4
WinCreatorOwnerServerSid                        equ     5
WinCreatorGroupServerSid                        equ     6
WinNtAuthoritySid                               equ     7
WinDialupSid                                    equ     8
WinNetworkSid                                   equ     9
WinBatchSid                                     equ     10
WinInteractiveSid                               equ     11
WinServiceSid                                   equ     12
WinAnonymousSid                                 equ     13
WinProxySid                                     equ     14
WinEnterpriseControllersSid                     equ     15
WinSelfSid                                      equ     16
WinAuthenticatedUserSid                         equ     17
WinRestrictedCodeSid                            equ     18
WinTerminalServerSid                            equ     19
WinRemoteLogonIdSid                             equ     20
WinLogonIdsSid                                  equ     21
WinLocalSystemSid                               equ     22
WinLocalServiceSid                              equ     23
WinNetworkServiceSid                            equ     24
WinBuiltinDomainSid                             equ     25
WinBuiltinAdministratorsSid                     equ     26
WinBuiltinUsersSid                              equ     27
WinBuiltinGuestsSid                             equ     28
WinBuiltinPowerUsersSid                         equ     29
WinBuiltinAccountOperatorsSid                   equ     30
WinBuiltinSystemOperatorsSid                    equ     31
WinBuiltinPrintOperatorsSid                     equ     32
WinBuiltinBackupOperatorsSid                    equ     33
WinBuiltinReplicatorSid                         equ     34
WinBuiltinPreWindows2000CompatibleAccessSid     equ     35
WinBuiltinRemoteDesktopUsersSid                 equ     36
WinBuiltinNetworkConfigurationOperatorsSid      equ     37
WinAccountAdministratorSid                      equ     38
WinAccountGuestSid                              equ     39
WinAccountKrbtgtSid                             equ     40
WinAccountDomainAdminsSid                       equ     41
WinAccountDomainUsersSid                        equ     42
WinAccountDomainGuestsSid                       equ     43
WinAccountComputersSid                          equ     44
WinAccountControllersSid                        equ     45
WinAccountCertAdminsSid                         equ     46
WinAccountSchemaAdminsSid                       equ     47
WinAccountEnterpriseAdminsSid                   equ     48
WinAccountPolicyAdminsSid                       equ     49
WinAccountRasAndIasServersSid                   equ     50
WinNTLMAuthenticationSid                        equ     51
WinDigestAuthenticationSid                      equ     52
WinSChannelAuthenticationSid                    equ     53
WinThisOrganizationSid                          equ     54
WinOtherOrganizationSid                         equ     55
WinBuiltinIncomingForestTrustBuildersSid        equ     56
WinBuiltinPerfMonitoringUsersSid                equ     57
WinBuiltinPerfLoggingUsersSid                   equ     58
WinBuiltinAuthorizationAccessSid                equ     59
WinBuiltinTerminalServerLicenseServersSid       equ     60
WinBuiltinDCOMUsersSid                          equ     61
WinBuiltinIUsersSid                             equ     62
WinIUserSid                                     equ     63
WinBuiltinCryptoOperatorsSid                    equ     64
WinUntrustedLabelSid                            equ     65
WinLowLabelSid                                  equ     66
WinMediumLabelSid                               equ     67
WinHighLabelSid                                 equ     68
WinSystemLabelSid                               equ     69
WinWriteRestrictedCodeSid                       equ     70
WinCreatorOwnerRightsSid                        equ     71
WinCacheablePrincipalsGroupSid                  equ     72
WinNonCacheablePrincipalsGroupSid               equ     73
WinEnterpriseReadonlyControllersSid             equ     74
WinAccountReadonlyControllersSid                equ     75
WinBuiltinEventLogReadersGroup                  equ     76
WinNewEnterpriseReadonlyControllersSid          equ     77
WinBuiltinCertSvcDComAccessGroup                equ     78
WinMediumPlusLabelSid                           equ     79
WinLocalLogonSid                                equ     80
WinConsoleLogonSid                              equ     81
WinThisOrganizationCertificateSid               equ     82

SYSTEM_LUID                                     equ     <03E7H,00H>
ANONYMOUS_LOGON_LUID                            equ     <03E6H,00H>
LOCALSERVICE_LUID                               equ     <03E5H,00H>
NETWORKSERVICE_LUID                             equ     <03E4H,00H>
IUSER_LUID                                      equ     <03E3H,00H>

SE_GROUP_MANDATORY                              equ     000000001H
SE_GROUP_ENABLED_BY_DEFAULT                     equ     000000002H
SE_GROUP_ENABLED                                equ     000000004H
SE_GROUP_OWNER                                  equ     000000008H
SE_GROUP_USE_FOR_DENY_ONLY                      equ     000000010H
SE_GROUP_INTEGRITY                              equ     000000020H
SE_GROUP_INTEGRITY_ENABLED                      equ     000000040H
SE_GROUP_LOGON_ID                               equ     0C0000000H
SE_GROUP_RESOURCE                               equ     020000000H

SE_GROUP_VALID_ATTRIBUTES                       equ     (SE_GROUP_MANDATORY or SE_GROUP_ENABLED_BY_DEFAULT or \
                                                        SE_GROUP_ENABLED or SE_GROUP_OWNER or \
                                                        SE_GROUP_USE_FOR_DENY_ONLY or SE_GROUP_LOGON_ID or \
                                                        SE_GROUP_RESOURCE or SE_GROUP_INTEGRITY)

ACL_REVISION                                    equ     2
ACL_REVISION1                                   equ     1
ACL_REVISION2                                   equ     2
ACL_REVISION3                                   equ     3
ACL_REVISION4                                   equ     4
ACL_REVISION_DS                                 equ     4

MIN_ACL_REVISION                                equ     ACL_REVISION2
MAX_ACL_REVISION                                equ     ACL_REVISION4

ACCESS_MIN_MS_ACE_TYPE                          equ     00H
ACCESS_ALLOWED_ACE_TYPE                         equ     00H
ACCESS_DENIED_ACE_TYPE                          equ     01H
SYSTEM_AUDIT_ACE_TYPE                           equ     02H
SYSTEM_ALARM_ACE_TYPE                           equ     03H
ACCESS_MAX_MS_V2_ACE_TYPE                       equ     03H

ACCESS_ALLOWED_COMPOUND_ACE_TYPE                equ     04H
ACCESS_MAX_MS_V3_ACE_TYPE                       equ     04H

ACCESS_MIN_MS_OBJECT_ACE_TYPE                   equ     05H
ACCESS_ALLOWED_OBJECT_ACE_TYPE                  equ     05H
ACCESS_DENIED_OBJECT_ACE_TYPE                   equ     06H
SYSTEM_AUDIT_OBJECT_ACE_TYPE                    equ     07H
SYSTEM_ALARM_OBJECT_ACE_TYPE                    equ     08H
ACCESS_MAX_MS_OBJECT_ACE_TYPE                   equ     08H

ACCESS_MAX_MS_V4_ACE_TYPE                       equ     08H
ACCESS_MAX_MS_ACE_TYPE                          equ     08H
ACCESS_ALLOWED_CALLBACK_ACE_TYPE                equ     09H
ACCESS_DENIED_CALLBACK_ACE_TYPE                 equ     0AH
ACCESS_ALLOWED_CALLBACK_OBJECT_ACE_TYPE         equ     0BH
ACCESS_DENIED_CALLBACK_OBJECT_ACE_TYPE          equ     0CH
SYSTEM_AUDIT_CALLBACK_ACE_TYPE                  equ     0DH
SYSTEM_ALARM_CALLBACK_ACE_TYPE                  equ     0EH
SYSTEM_AUDIT_CALLBACK_OBJECT_ACE_TYPE           equ     0FH
SYSTEM_ALARM_CALLBACK_OBJECT_ACE_TYPE           equ     010H

SYSTEM_MANDATORY_LABEL_ACE_TYPE                 equ     011H
SYSTEM_RESOURCE_ATTRIBUTE_ACE_TYPE              equ     012H
SYSTEM_SCOPED_POLICY_ID_ACE_TYPE                equ     013H
SYSTEM_PROCESS_TRUST_LABEL_ACE_TYPE             equ     014H
ACCESS_MAX_MS_V5_ACE_TYPE                       equ     014H

SYSTEM_MANDATORY_LABEL_NO_WRITE_UP              equ     01H
SYSTEM_MANDATORY_LABEL_NO_READ_UP               equ     02H
SYSTEM_MANDATORY_LABEL_NO_EXECUTE_UP            equ     04H

SYSTEM_MANDATORY_LABEL_VALID_MASK               equ     (SYSTEM_MANDATORY_LABEL_NO_WRITE_UP or \
                                                        SYSTEM_MANDATORY_LABEL_NO_READ_UP or \
                                                        SYSTEM_MANDATORY_LABEL_NO_EXECUTE_UP)

OBJECT_INHERIT_ACE                              equ     01H
CONTAINER_INHERIT_ACE                           equ     02H
NO_PROPAGATE_INHERIT_ACE                        equ     04H
INHERIT_ONLY_ACE                                equ     08H
INHERITED_ACE                                   equ     010H
VALID_INHERIT_FLAGS                             equ     01FH

SUCCESSFUL_ACCESS_ACE_FLAG                      equ     040H
FAILED_ACCESS_ACE_FLAG                          equ     080H

ACE_OBJECT_TYPE_PRESENT                         equ     01H
ACE_INHERITED_OBJECT_TYPE_PRESENT               equ     02H

SECURITY_DESCRIPTOR_REVISION                    equ     1
SECURITY_DESCRIPTOR_REVISION1                   equ     1

SECURITY_DESCRIPTOR_MIN_LENGTH                  equ     SIZEOF SECURITY_DESCRIPTOR

SE_OWNER_DEFAULTED                              equ     00001H
SE_GROUP_DEFAULTED                              equ     00002H
SE_DACL_PRESENT                                 equ     00004H
SE_DACL_DEFAULTED                               equ     00008H
SE_SACL_PRESENT                                 equ     00010H
SE_SACL_DEFAULTED                               equ     00020H
SE_DACL_AUTO_INHERIT_REQ                        equ     00100H
SE_SACL_AUTO_INHERIT_REQ                        equ     00200H
SE_DACL_AUTO_INHERITED                          equ     00400H
SE_SACL_AUTO_INHERITED                          equ     00800H
SE_DACL_PROTECTED                               equ     01000H
SE_SACL_PROTECTED                               equ     02000H
SE_RM_CONTROL_VALID                             equ     04000H
SE_SELF_RELATIVE                                equ     08000H

ACCESS_OBJECT_GUID                              equ     0
ACCESS_PROPERTY_SET_GUID                        equ     1
ACCESS_PROPERTY_GUID                            equ     2
ACCESS_MAX_LEVEL                                equ     4

AUDIT_ALLOW_NO_PRIVILEGE                        equ     01H

ACCESS_DS_SOURCE_A                              equ     <DS>
ACCESS_DS_SOURCE_W                              equ     L("DS")
ACCESS_DS_OBJECT_TYPE_NAME_A                    equ     <Directory Service Object>
ACCESS_DS_OBJECT_TYPE_NAME_W                    equ     L("Directory Service Object")

SE_PRIVILEGE_ENABLED_BY_DEFAULT                 equ     000000001H
SE_PRIVILEGE_ENABLED                            equ     000000002H
SE_PRIVILEGE_REMOVED                            equ     000000004H
SE_PRIVILEGE_USED_FOR_ACCESS                    equ     080000000H

SE_PRIVILEGE_VALID_ATTRIBUTES                   equ     (SE_PRIVILEGE_ENABLED_BY_DEFAULT or SE_PRIVILEGE_ENABLED or \
                                                        SE_PRIVILEGE_REMOVED or SE_PRIVILEGE_USED_FOR_ACCESS)

PRIVILEGE_SET_ALL_NECESSARY                     equ     1

SE_CREATE_TOKEN_NAME                            equ     TEXT("SeCreateTokenPrivilege")
SE_ASSIGNPRIMARYTOKEN_NAME                      equ     TEXT("SeAssignPrimaryTokenPrivilege")
SE_LOCK_MEMORY_NAME                             equ     TEXT("SeLockMemoryPrivilege")
SE_INCREASE_QUOTA_NAME                          equ     TEXT("SeIncreaseQuotaPrivilege")
SE_UNSOLICITED_INPUT_NAME                       equ     TEXT("SeUnsolicitedInputPrivilege")
SE_MACHINE_ACCOUNT_NAME                         equ     TEXT("SeMachineAccountPrivilege")
SE_TCB_NAME                                     equ     TEXT("SeTcbPrivilege")
SE_SECURITY_NAME                                equ     TEXT("SeSecurityPrivilege")
SE_TAKE_OWNERSHIP_NAME                          equ     TEXT("SeTakeOwnershipPrivilege")
SE_LOAD_DRIVER_NAME                             equ     TEXT("SeLoadDriverPrivilege")
SE_SYSTEM_PROFILE_NAME                          equ     TEXT("SeSystemProfilePrivilege")
SE_SYSTEMTIME_NAME                              equ     TEXT("SeSystemtimePrivilege")
SE_PROF_SINGLE_PROCESS_NAME                     equ     TEXT("SeProfileSingleProcessPrivilege")
SE_INC_BASE_PRIORITY_NAME                       equ     TEXT("SeIncreaseBasePriorityPrivilege")
SE_CREATE_PAGEFILE_NAME                         equ     TEXT("SeCreatePagefilePrivilege")
SE_CREATE_PERMANENT_NAME                        equ     TEXT("SeCreatePermanentPrivilege")
SE_BACKUP_NAME                                  equ     TEXT("SeBackupPrivilege")
SE_RESTORE_NAME                                 equ     TEXT("SeRestorePrivilege")
SE_SHUTDOWN_NAME                                equ     TEXT("SeShutdownPrivilege")
SE_DEBUG_NAME                                   equ     TEXT("SeDebugPrivilege")
SE_AUDIT_NAME                                   equ     TEXT("SeAuditPrivilege")
SE_SYSTEM_ENVIRONMENT_NAME                      equ     TEXT("SeSystemEnvironmentPrivilege")
SE_CHANGE_NOTIFY_NAME                           equ     TEXT("SeChangeNotifyPrivilege")
SE_REMOTE_SHUTDOWN_NAME                         equ     TEXT("SeRemoteShutdownPrivilege")
SE_UNDOCK_NAME                                  equ     TEXT("SeUndockPrivilege")
SE_SYNC_AGENT_NAME                              equ     TEXT("SeSyncAgentPrivilege")
SE_ENABLE_DELEGATION_NAME                       equ     TEXT("SeEnableDelegationPrivilege")
SE_MANAGE_VOLUME_NAME                           equ     TEXT("SeManageVolumePrivilege")
SE_IMPERSONATE_NAME                             equ     TEXT("SeImpersonatePrivilege")
SE_CREATE_GLOBAL_NAME                           equ     TEXT("SeCreateGlobalPrivilege")
SE_TRUSTED_CREDMAN_ACCESS_NAME                  equ     TEXT("SeTrustedCredManAccessPrivilege")
SE_RELABEL_NAME                                 equ     TEXT("SeRelabelPrivilege")
SE_INC_WORKING_SET_NAME                         equ     TEXT("SeIncreaseWorkingSetPrivilege")
SE_TIME_ZONE_NAME                               equ     TEXT("SeTimeZonePrivilege")
SE_CREATE_SYMBOLIC_LINK_NAME                    equ     TEXT("SeCreateSymbolicLinkPrivilege")

TOKEN_ASSIGN_PRIMARY                            equ     00001H
TOKEN_DUPLICATE                                 equ     00002H
TOKEN_IMPERSONATE                               equ     00004H
TOKEN_QUERY                                     equ     00008H
TOKEN_QUERY_SOURCE                              equ     00010H
TOKEN_ADJUST_PRIVILEGES                         equ     00020H
TOKEN_ADJUST_GROUPS                             equ     00040H
TOKEN_ADJUST_DEFAULT                            equ     00080H
TOKEN_ADJUST_SESSIONID                          equ     00100H

TOKEN_ALL_ACCESS_P                              equ     (STANDARD_RIGHTS_REQUIRED or TOKEN_ASSIGN_PRIMARY or \
                                                        TOKEN_DUPLICATE or TOKEN_IMPERSONATE or TOKEN_QUERY or \
                                                        TOKEN_ADJUST_PRIVILEGES or TOKEN_ADJUST_GROUPS or \
                                                        TOKEN_ADJUST_DEFAULT)

if defined APP_WIN64
    TOKEN_ALL_ACCESS                            equ     TOKEN_ALL_ACCESS_P
else
    TOKEN_ALL_ACCESS                            equ     (TOKEN_ALL_ACCESS_P or TOKEN_ADJUST_SESSIONID)
end if

TOKEN_READ                                      equ     (STANDARD_RIGHTS_READ or TOKEN_QUERY)
TOKEN_WRITE                                     equ     (STANDARD_RIGHTS_WRITE or TOKEN_ADJUST_PRIVILEGES or \
                                                        TOKEN_ADJUST_GROUPS or TOKEN_ADJUST_DEFAULT)
TOKEN_EXECUTE                                   equ     STANDARD_RIGHTS_EXECUTE
TOKEN_TRUST_CONSTRAINT_MASK                     equ     (STANDARD_RIGHTS_READ or TOKEN_QUERY or TOKEN_QUERY_SOURCE)

POLICY_AUDIT_SUBCATEGORY_COUNT                  equ     56

TOKEN_SOURCE_LENGTH                             equ     8

TOKEN_MANDATORY_POLICY_OFF                      equ     00H
TOKEN_MANDATORY_POLICY_NO_WRITE_UP              equ     01H
TOKEN_MANDATORY_POLICY_NEW_PROCESS_MIN          equ     02H
TOKEN_MANDATORY_POLICY_VALID_MASK               equ     (TOKEN_MANDATORY_POLICY_NO_WRITE_UP or TOKEN_MANDATORY_POLICY_NEW_PROCESS_MIN)

SECURITY_DYNAMIC_TRACKING                       equ     TRUE
SECURITY_STATIC_TRACKING                        equ     FALSE
TYPEDEF                                         SECURITY_CONTEXT_TRACKING_MODE, db
TYPEDEF                                         PSECURITY_CONTEXT_TRACKING_MODE, xptr

DISABLE_MAX_PRIVILEGE                           equ     01H
SANDBOX_INERT                                   equ     02H
LUA_TOKEN                                       equ     04H
WRITE_RESTRICTED                                equ     08H

OWNER_SECURITY_INFORMATION                      equ     000000001H
GROUP_SECURITY_INFORMATION                      equ     000000002H
DACL_SECURITY_INFORMATION                       equ     000000004H
SACL_SECURITY_INFORMATION                       equ     000000008H
LABEL_SECURITY_INFORMATION                      equ     000000010H
ATTRIBUTE_SECURITY_INFORMATION                  equ     000000020H
SCOPE_SECURITY_INFORMATION                      equ     000000040H
PROCESS_TRUST_LABEL_SECURITY_INFORMATION        equ     000000080H
BACKUP_SECURITY_INFORMATION                     equ     000010000H

PROTECTED_DACL_SECURITY_INFORMATION             equ     080000000H
PROTECTED_SACL_SECURITY_INFORMATION             equ     040000000H
UNPROTECTED_DACL_SECURITY_INFORMATION           equ     020000000H
UNPROTECTED_SACL_SECURITY_INFORMATION           equ     010000000H

PROCESS_TERMINATE                               equ     00001H
PROCESS_CREATE_THREAD                           equ     00002H
PROCESS_SET_SESSIONID                           equ     00004H
PROCESS_VM_OPERATION                            equ     00008H
PROCESS_VM_READ                                 equ     00010H
PROCESS_VM_WRITE                                equ     00020H
PROCESS_DUP_HANDLE                              equ     00040H
PROCESS_CREATE_PROCESS                          equ     00080H
PROCESS_SET_QUOTA                               equ     00100H
PROCESS_SET_INFORMATION                         equ     00200H
PROCESS_QUERY_INFORMATION                       equ     00400H
PROCESS_SUSPEND_RESUME                          equ     00800H
PROCESS_QUERY_LIMITED_INFORMATION               equ     01000H
PROCESS_SET_LIMITED_INFORMATION                 equ     02000H

if (NTDDI_VERSION < NTDDI_VISTA)
    PROCESS_ALL_ACCESS                          equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 0FFFH)
else
    PROCESS_ALL_ACCESS                          equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 0FFFFH)
end if

if defined APP_WIN64
    MAXIMUM_PROCESSORS                          equ     64
else
    MAXIMUM_PROCESSORS                          equ     32
end if

THREAD_TERMINATE                                equ     00001H
THREAD_SUSPEND_RESUME                           equ     00002H
THREAD_GET_CONTEXT                              equ     00008H
THREAD_SET_CONTEXT                              equ     00010H
THREAD_QUERY_INFORMATION                        equ     00040H
THREAD_SET_INFORMATION                          equ     00020H
THREAD_SET_THREAD_TOKEN                         equ     00080H
THREAD_IMPERSONATE                              equ     00100H
THREAD_DIRECT_IMPERSONATION                     equ     00200H
THREAD_SET_LIMITED_INFORMATION                  equ     00400H
THREAD_QUERY_LIMITED_INFORMATION                equ     00800H
THREAD_RESUME                                   equ     01000H

if (NTDDI_VERSION < NTDDI_VISTA)
    THREAD_ALL_ACCESS                           equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 03FFH)
else
    THREAD_ALL_ACCESS                           equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 0FFFFH)
end if

JOB_OBJECT_ASSIGN_PROCESS                       equ     00001H
JOB_OBJECT_SET_ATTRIBUTES                       equ     00002H
JOB_OBJECT_QUERY                                equ     00004H
JOB_OBJECT_TERMINATE                            equ     00008H
JOB_OBJECT_SET_SECURITY_ATTRIBUTES              equ     00010H
JOB_OBJECT_ALL_ACCESS                           equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 01FH)

FLS_MAXIMUM_AVAILABLE                           equ     128
TLS_MINIMUM_AVAILABLE                           equ     64

THREAD_BASE_PRIORITY_LOWRT                      equ     15
THREAD_BASE_PRIORITY_MAX                        equ     2
THREAD_BASE_PRIORITY_MIN                        equ     (-2)
THREAD_BASE_PRIORITY_IDLE                       equ     (-15)

JOB_OBJECT_TERMINATE_AT_END_OF_JOB              equ     0
JOB_OBJECT_POST_AT_END_OF_JOB                   equ     1

JOB_OBJECT_MSG_END_OF_JOB_TIME                  equ     1
JOB_OBJECT_MSG_END_OF_PROCESS_TIME              equ     2
JOB_OBJECT_MSG_ACTIVE_PROCESS_LIMIT             equ     3
JOB_OBJECT_MSG_ACTIVE_PROCESS_ZERO              equ     4
JOB_OBJECT_MSG_NEW_PROCESS                      equ     6
JOB_OBJECT_MSG_EXIT_PROCESS                     equ     7
JOB_OBJECT_MSG_ABNORMAL_EXIT_PROCESS            equ     8
JOB_OBJECT_MSG_PROCESS_MEMORY_LIMIT             equ     9
JOB_OBJECT_MSG_JOB_MEMORY_LIMIT                 equ     10
JOB_OBJECT_MSG_NOTIFICATION_LIMIT               equ     11
JOB_OBJECT_MSG_JOB_CYCLE_TIME_LIMIT             equ     12

JOB_OBJECT_MSG_MINIMUM                          equ     1
JOB_OBJECT_MSG_MAXIMUM                          equ     12
JOB_OBJECT_VALID_COMPLETION_FILTER              equ     (((1 shl (JOB_OBJECT_MSG_MAXIMUM + 1))) - 1) - ((1 shl JOB_OBJECT_MSG_MINIMUM) - 1)

OB_OBJECT_LIMIT_WORKINGSET                     equ     000000001H
JOB_OBJECT_LIMIT_PROCESS_TIME                   equ     000000002H
JOB_OBJECT_LIMIT_JOB_TIME                       equ     000000004H
JOB_OBJECT_LIMIT_ACTIVE_PROCESS                 equ     000000008H
JOB_OBJECT_LIMIT_AFFINITY                       equ     000000010H
JOB_OBJECT_LIMIT_PRIORITY_CLASS                 equ     000000020H
JOB_OBJECT_LIMIT_PRESERVE_JOB_TIME              equ     000000040H
JOB_OBJECT_LIMIT_SCHEDULING_CLASS               equ     000000080H

JOB_OBJECT_LIMIT_PROCESS_MEMORY                 equ     000000100H
JOB_OBJECT_LIMIT_JOB_MEMORY                     equ     000000200H
JOB_OBJECT_LIMIT_DIE_ON_UNHANDLED_EXCEPTION     equ     000000400H
JOB_OBJECT_LIMIT_BREAKAWAY_OK                   equ     000000800H
JOB_OBJECT_LIMIT_SILENT_BREAKAWAY_OK            equ     000001000H
JOB_OBJECT_LIMIT_KILL_ON_JOB_CLOSE              equ     000002000H
JOB_OBJECT_LIMIT_SUBSET_AFFINITY                equ     000004000H
JOB_OBJECT_LIMIT_RESERVED3                      equ     000008000H
JOB_OBJECT_LIMIT_RESERVED4                      equ     000010000H
JOB_OBJECT_LIMIT_RESERVED5                      equ     000020000H
JOB_OBJECT_LIMIT_RESERVED6                      equ     000040000H

JOB_OBJECT_LIMIT_JOB_READ_BYTES                 equ     000010000H
JOB_OBJECT_LIMIT_JOB_WRITE_BYTES                equ     000020000H
JOB_OBJECT_LIMIT_RATE_CONTROL                   equ     000040000H

JOB_OBJECT_LIMIT_VALID_FLAGS                    equ     00007FFFFH

JOB_OBJECT_BASIC_LIMIT_VALID_FLAGS              equ     0000000FFH
JOB_OBJECT_EXTENDED_LIMIT_VALID_FLAGS           equ     000007FFFH
JOB_OBJECT_NOTIFICATION_LIMIT_VALID_FLAGS       equ     000070204H
JOB_OBJECT_RESERVED_LIMIT_VALID_FLAGS           equ     00007FFFFH

JOB_OBJECT_UILIMIT_NONE                         equ     000000000H
JOB_OBJECT_UILIMIT_HANDLES                      equ     000000001H
JOB_OBJECT_UILIMIT_READCLIPBOARD                equ     000000002H
JOB_OBJECT_UILIMIT_WRITECLIPBOARD               equ     000000004H
JOB_OBJECT_UILIMIT_SYSTEMPARAMETERS             equ     000000008H
JOB_OBJECT_UILIMIT_DISPLAYSETTINGS              equ     000000010H
JOB_OBJECT_UILIMIT_GLOBALATOMS                  equ     000000020H
JOB_OBJECT_UILIMIT_DESKTOP                      equ     000000040H
JOB_OBJECT_UILIMIT_EXITWINDOWS                  equ     000000080H
JOB_OBJECT_UILIMIT_ALL                          equ     0000000FFH

JOB_OBJECT_UI_VALID_FLAGS                       equ     0000000FFH

JOB_OBJECT_SECURITY_NO_ADMIN                    equ     000000001H
JOB_OBJECT_SECURITY_RESTRICTED_TOKEN            equ     000000002H
JOB_OBJECT_SECURITY_ONLY_TOKEN                  equ     000000004H
JOB_OBJECT_SECURITY_FILTER_TOKENS               equ     000000008H
JOB_OBJECT_SECURITY_VALID_FLAGS                 equ     00000000FH

EVENT_MODIFY_STATE                              equ     00002H
EVENT_ALL_ACCESS                                equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 03H)
MUTANT_QUERY_STATE                              equ     00001H
MUTANT_ALL_ACCESS                               equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or MUTANT_QUERY_STATE)
SEMAPHORE_MODIFY_STATE                          equ     00002H
SEMAPHORE_ALL_ACCESS                            equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 03H)

TIMER_QUERY_STATE                               equ     00001H
TIMER_MODIFY_STATE                              equ     00002H
TIMER_ALL_ACCESS                                equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or TIMER_QUERY_STATE or TIMER_MODIFY_STATE)

TIME_ZONE_ID_UNKNOWN                            equ     0
TIME_ZONE_ID_STANDARD                           equ     1
TIME_ZONE_ID_DAYLIGHT                           equ     2

PROCESSOR_INTEL_386                             equ     386
PROCESSOR_INTEL_486                             equ     486
PROCESSOR_INTEL_PENTIUM                         equ     586
PROCESSOR_INTEL_IA64                            equ     2200
PROCESSOR_AMD_X8664                             equ     8664
PROCESSOR_MIPS_R4000                            equ     4000
PROCESSOR_ALPHA_21064                           equ     21064
PROCESSOR_PPC_601                               equ     601
PROCESSOR_PPC_603                               equ     603
PROCESSOR_PPC_604                               equ     604
PROCESSOR_PPC_620                               equ     620
PROCESSOR_HITACHI_SH3                           equ     10003
PROCESSOR_HITACHI_SH3E                          equ     10004
PROCESSOR_HITACHI_SH4                           equ     10005
PROCESSOR_MOTOROLA_821                          equ     821
PROCESSOR_SHx_SH3                               equ     103
PROCESSOR_SHx_SH4                               equ     104
PROCESSOR_STRONGARM                             equ     2577
PROCESSOR_ARM720                                equ     1824
PROCESSOR_ARM820                                equ     2080
PROCESSOR_ARM920                                equ     2336
PROCESSOR_ARM_7TDMI                             equ     70001
PROCESSOR_OPTIL                                 equ     0494FH

PROCESSOR_ARCHITECTURE_INTEL                    equ     0
PROCESSOR_ARCHITECTURE_MIPS                     equ     1
PROCESSOR_ARCHITECTURE_ALPHA                    equ     2
PROCESSOR_ARCHITECTURE_PPC                      equ     3
PROCESSOR_ARCHITECTURE_SHX                      equ     4
PROCESSOR_ARCHITECTURE_ARM                      equ     5
PROCESSOR_ARCHITECTURE_IA64                     equ     6
PROCESSOR_ARCHITECTURE_ALPHA64                  equ     7
PROCESSOR_ARCHITECTURE_MSIL                     equ     8
PROCESSOR_ARCHITECTURE_AMD64                    equ     9
PROCESSOR_ARCHITECTURE_IA32_ON_WIN64            equ     10

PROCESSOR_ARCHITECTURE_NEUTRAL                  equ     11
PROCESSOR_ARCHITECTURE_UNKNOWN                  equ     0FFFFH

PF_FLOATING_POINT_PRECISION_ERRATA              equ     0
PF_FLOATING_POINT_EMULATED                      equ     1
PF_COMPARE_EXCHANGE_DOUBLE                      equ     2
PF_MMX_INSTRUCTIONS_AVAILABLE                   equ     3
PF_PPC_MOVEMEM_64BIT_OK                         equ     4
PF_ALPHA_BYTE_INSTRUCTIONS                      equ     5
PF_XMMI_INSTRUCTIONS_AVAILABLE                  equ     6
PF_3DNOW_INSTRUCTIONS_AVAILABLE                 equ     7
PF_RDTSC_INSTRUCTION_AVAILABLE                  equ     8
PF_PAE_ENABLED                                  equ     9
PF_XMMI64_INSTRUCTIONS_AVAILABLE                equ     10
PF_SSE_DAZ_MODE_AVAILABLE                       equ     11
PF_NX_ENABLED                                   equ     12
PF_SSE3_INSTRUCTIONS_AVAILABLE                  equ     13
PF_COMPARE_EXCHANGE128                          equ     14
PF_COMPARE64_EXCHANGE128                        equ     15
PF_CHANNELS_ENABLED                             equ     16
PF_XSAVE_ENABLED                                equ     17
PF_ARM_VFP_32_REGISTERS_AVAILABLE               equ     18
PF_ARM_NEON_INSTRUCTIONS_AVAILABLE              equ     19
PF_SECOND_LEVEL_ADDRESS_TRANSLATION             equ     20
PF_VIRT_FIRMWARE_ENABLED                        equ     21
PF_RDWRFSGSBASE_AVAILABLE                       equ     22
PF_FASTFAIL_AVAILABLE                           equ     23
PF_ARM_DIVIDE_INSTRUCTION_AVAILABLE             equ     24
PF_ARM_64BIT_LOADSTORE_ATOMIC                   equ     25
PF_ARM_EXTERNAL_CACHE_AVAILABLE                 equ     26
PF_ARM_FMAC_INSTRUCTIONS_AVAILABLE              equ     27
PF_RDRAND_INSTRUCTION_AVAILABLE                 equ     28

SECTION_QUERY                                   equ     00001H
SECTION_MAP_WRITE                               equ     00002H
SECTION_MAP_READ                                equ     00004H
SECTION_MAP_EXECUTE                             equ     00008H
SECTION_EXTEND_SIZE                             equ     00010H
SECTION_MAP_EXECUTE_EXPLICIT                    equ     00020H
SECTION_ALL_ACCESS                              equ     (STANDARD_RIGHTS_REQUIRED or SECTION_QUERY or SECTION_MAP_WRITE or \
                                                        SECTION_MAP_READ or SECTION_MAP_EXECUTE or SECTION_EXTEND_SIZE)

SESSION_QUERY_ACCESS                            equ     00001H
SESSION_MODIFY_ACCESS                           equ     00002H
SESSION_ALL_ACCESS                              equ     (STANDARD_RIGHTS_REQUIRED or SESSION_QUERY_ACCESS or SESSION_MODIFY_ACCESS)

PAGE_NOACCESS                                   equ     001H
PAGE_READONLY                                   equ     002H
PAGE_READWRITE                                  equ     004H
PAGE_WRITECOPY                                  equ     008H
PAGE_EXECUTE                                    equ     010H
PAGE_EXECUTE_READ                               equ     020H
PAGE_EXECUTE_READWRITE                          equ     040H
PAGE_EXECUTE_WRITECOPY                          equ     080H

PAGE_GUARD                                      equ     0100H
PAGE_NOCACHE                                    equ     0200H
PAGE_WRITECOMBINE                               equ     0400H
PAGE_REVERT_TO_FILE_MAP                         equ     080000000H

MEM_COMMIT                                      equ     01000H
MEM_RESERVE                                     equ     02000H
MEM_DECOMMIT                                    equ     04000H
MEM_RELEASE                                     equ     08000H
MEM_FREE                                        equ     010000H
MEM_PRIVATE                                     equ     020000H
MEM_MAPPED                                      equ     040000H
MEM_RESET                                       equ     080000H
MEM_TOP_DOWN                                    equ     0100000H
MEM_WRITE_WATCH                                 equ     0200000H
MEM_PHYSICAL                                    equ     0400000H
MEM_ROTATE                                      equ     0800000H
MEM_DIFFERENT_IMAGE_BASE_OK                     equ     0800000H
MEM_RESET_UNDO                                  equ     01000000H
MEM_LARGE_PAGES                                 equ     020000000H
MEM_4MB_PAGES                                   equ     080000000H

SEC_IMAGE                                       equ     01000000H
MEM_IMAGE                                       equ     SEC_IMAGE

WRITE_WATCH_FLAG_RESET                          equ     001H

FILE_READ_DATA                                  equ     00001H
FILE_LIST_DIRECTORY                             equ     00001H
FILE_WRITE_DATA                                 equ     00002H
FILE_ADD_FILE                                   equ     00002H

FILE_APPEND_DATA                                equ     00004H
FILE_ADD_SUBDIRECTORY                           equ     00004H
FILE_CREATE_PIPE_INSTANCE                       equ     00004H
FILE_READ_EA                                    equ     00008H
FILE_WRITE_EA                                   equ     00010H
FILE_EXECUTE                                    equ     00020H
FILE_TRAVERSE                                   equ     00020H
FILE_DELETE_CHILD                               equ     00040H
FILE_READ_ATTRIBUTES                            equ     00080H
FILE_WRITE_ATTRIBUTES                           equ     00100H

FILE_ALL_ACCESS                                 equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 01FFH)
FILE_GENERIC_READ                               equ     (STANDARD_RIGHTS_READ or FILE_READ_DATA or FILE_READ_ATTRIBUTES or \
                                                        FILE_READ_EA or SYNCHRONIZE)
FILE_GENERIC_WRITE                              equ     (STANDARD_RIGHTS_WRITE or FILE_WRITE_DATA or \
                                                        FILE_WRITE_ATTRIBUTES or FILE_WRITE_EA or \
                                                        FILE_APPEND_DATA or SYNCHRONIZE)
FILE_GENERIC_EXECUTE                            equ     (STANDARD_RIGHTS_EXECUTE or FILE_READ_ATTRIBUTES or \
                                                        FILE_EXECUTE or SYNCHRONIZE)

FILE_SHARE_READ                                 equ     000000001H
FILE_SHARE_WRITE                                equ     000000002H
FILE_SHARE_DELETE                               equ     000000004H

FILE_ATTRIBUTE_READONLY                         equ     000000001H
FILE_ATTRIBUTE_HIDDEN                           equ     000000002H
FILE_ATTRIBUTE_SYSTEM                           equ     000000004H
FILE_ATTRIBUTE_DIRECTORY                        equ     000000010H
FILE_ATTRIBUTE_ARCHIVE                          equ     000000020H
FILE_ATTRIBUTE_DEVICE                           equ     000000040H
FILE_ATTRIBUTE_NORMAL                           equ     000000080H
FILE_ATTRIBUTE_TEMPORARY                        equ     000000100H
FILE_ATTRIBUTE_SPARSE_FILE                      equ     000000200H
FILE_ATTRIBUTE_REPARSE_POINT                    equ     000000400H
FILE_ATTRIBUTE_COMPRESSED                       equ     000000800H
FILE_ATTRIBUTE_OFFLINE                          equ     000001000H
FILE_ATTRIBUTE_NOT_CONTENT_INDEXED              equ     000002000H
FILE_ATTRIBUTE_ENCRYPTED                        equ     000004000H
FILE_ATTRIBUTE_INTEGRITY_STREAM                 equ     000008000H
FILE_ATTRIBUTE_VIRTUAL                          equ     000010000H
FILE_ATTRIBUTE_NO_SCRUB_DATA                    equ     000020000H
FILE_ATTRIBUTE_EA                               equ     000040000H

FILE_NOTIFY_CHANGE_FILE_NAME                    equ     000000001H
FILE_NOTIFY_CHANGE_DIR_NAME                     equ     000000002H
FILE_NOTIFY_CHANGE_ATTRIBUTES                   equ     000000004H
FILE_NOTIFY_CHANGE_SIZE                         equ     000000008H
FILE_NOTIFY_CHANGE_LAST_WRITE                   equ     000000010H
FILE_NOTIFY_CHANGE_LAST_ACCESS                  equ     000000020H
FILE_NOTIFY_CHANGE_CREATION                     equ     000000040H
FILE_NOTIFY_CHANGE_SECURITY                     equ     000000100H

FILE_ACTION_ADDED                               equ     000000001H
FILE_ACTION_REMOVED                             equ     000000002H
FILE_ACTION_MODIFIED                            equ     000000003H
FILE_ACTION_RENAMED_OLD_NAME                    equ     000000004H
FILE_ACTION_RENAMED_NEW_NAME                    equ     000000005H

FILE_CASE_SENSITIVE_SEARCH                      equ     000000001H
FILE_CASE_PRESERVED_NAMES                       equ     000000002H
FILE_UNICODE_ON_DISK                            equ     000000004H
FILE_PERSISTENT_ACLS                            equ     000000008H
FILE_FILE_COMPRESSION                           equ     000000010H
FILE_VOLUME_QUOTAS                              equ     000000020H
FILE_SUPPORTS_SPARSE_FILES                      equ     000000040H
FILE_SUPPORTS_REPARSE_POINTS                    equ     000000080H
FILE_SUPPORTS_REMOTE_STORAGE                    equ     000000100H
FILE_VOLUME_IS_COMPRESSED                       equ     000008000H
FILE_SUPPORTS_OBJECT_IDS                        equ     000010000H
FILE_SUPPORTS_ENCRYPTION                        equ     000020000H
FILE_NAMED_STREAMS                              equ     000040000H
FILE_READ_ONLY_VOLUME                           equ     000080000H
FILE_SEQUENTIAL_WRITE_ONCE                      equ     000100000H
FILE_SUPPORTS_TRANSACTIONS                      equ     000200000H
FILE_SUPPORTS_HARD_LINKS                        equ     000400000H
FILE_SUPPORTS_EXTENDED_ATTRIBUTES               equ     000800000H
FILE_SUPPORTS_OPEN_BY_FILE_ID                   equ     001000000H
FILE_SUPPORTS_USN_JOURNAL                       equ     002000000H
FILE_SUPPORTS_INTEGRITY_STREAMS                 equ     004000000H
FILE_INVALID_FILE_ID                            equ     (-1)

MAILSLOT_NO_MESSAGE                             equ     (-1)
MAILSLOT_WAIT_FOREVER                           equ     (-1)

MAXIMUM_REPARSE_DATA_BUFFER_SIZE                equ     (16 * 1024)

IO_REPARSE_TAG_RESERVED_ZERO                    equ     0
IO_REPARSE_TAG_RESERVED_ONE                     equ     1
IO_REPARSE_TAG_RESERVED_RANGE                   equ     IO_REPARSE_TAG_RESERVED_ONE

IO_REPARSE_TAG_MOUNT_POINT                      equ     0A0000003H
IO_REPARSE_TAG_HSM                              equ     0C0000004H
IO_REPARSE_TAG_HSM2                             equ     080000006H
IO_REPARSE_TAG_SIS                              equ     080000007H
IO_REPARSE_TAG_WIM                              equ     080000008H
IO_REPARSE_TAG_CSV                              equ     080000009H
IO_REPARSE_TAG_DFS                              equ     08000000AH
IO_REPARSE_TAG_SYMLINK                          equ     0A000000CH
IO_REPARSE_TAG_DFSR                             equ     080000012H
IO_REPARSE_TAG_DEDUP                            equ     080000013H
IO_REPARSE_TAG_NFS                              equ     080000014H
IO_REPARSE_TAG_FILE_PLACEHOLDER                 equ     080000015H
IO_REPARSE_TAG_WOF                              equ     080000017H

IO_COMPLETION_MODIFY_STATE                      equ     00002H
IO_COMPLETION_ALL_ACCESS                        equ     (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 03H)

DUPLICATE_CLOSE_SOURCE                          equ     000000001H
DUPLICATE_SAME_ACCESS                           equ     000000002H

POWER_SYSTEM_MAXIMUM                            equ     7

ES_SYSTEM_REQUIRED                              equ     000000001H
ES_DISPLAY_REQUIRED                             equ     000000002H
ES_USER_PRESENT                                 equ     000000004H
ES_AWAYMODE_REQUIRED                            equ     000000040H
ES_CONTINUOUS                                   equ     080000000H

IMAGE_DOS_SIGNATURE                             equ     05A4DH
IMAGE_OS2_SIGNATURE                             equ     0454EH
IMAGE_OS2_SIGNATURE_LE                          equ     0454CH
IMAGE_VXD_SIGNATURE                             equ     0454CH
IMAGE_NT_SIGNATURE                              equ     000004550H

IMAGE_SIZEOF_FILE_HEADER                        equ     20

IMAGE_FILE_RELOCS_STRIPPED                      equ     00001H
IMAGE_FILE_EXECUTABLE_IMAGE                     equ     00002H
IMAGE_FILE_LINE_NUMS_STRIPPED                   equ     00004H
IMAGE_FILE_LOCAL_SYMS_STRIPPED                  equ     00008H
IMAGE_FILE_AGGRESIVE_WS_TRIM                    equ     00010H
IMAGE_FILE_LARGE_ADDRESS_AWARE                  equ     00020H
IMAGE_FILE_BYTES_REVERSED_LO                    equ     00080H
IMAGE_FILE_32BIT_MACHINE                        equ     00100H
IMAGE_FILE_DEBUG_STRIPPED                       equ     00200H
IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP              equ     00400H
IMAGE_FILE_NET_RUN_FROM_SWAP                    equ     00800H
IMAGE_FILE_SYSTEM                               equ     01000H
IMAGE_FILE_DLL                                  equ     02000H
IMAGE_FILE_UP_SYSTEM_ONLY                       equ     04000H
IMAGE_FILE_BYTES_REVERSED_HI                    equ     08000H

IMAGE_FILE_MACHINE_UNKNOWN                      equ     0
IMAGE_FILE_MACHINE_I386                         equ     014cH
IMAGE_FILE_MACHINE_R3000                        equ     0162H
IMAGE_FILE_MACHINE_R4000                        equ     0166H
IMAGE_FILE_MACHINE_R10000                       equ     0168H
IMAGE_FILE_MACHINE_WCEMIPSV2                    equ     0169H
IMAGE_FILE_MACHINE_ALPHA                        equ     0184H
IMAGE_FILE_MACHINE_POWERPC                      equ     01F0H
IMAGE_FILE_MACHINE_SH3                          equ     01a2H
IMAGE_FILE_MACHINE_SH3E                         equ     01a4H
IMAGE_FILE_MACHINE_SH4                          equ     01a6H
IMAGE_FILE_MACHINE_ARM                          equ     01c0H
IMAGE_FILE_MACHINE_THUMB                        equ     01c2H
IMAGE_FILE_MACHINE_IA64                         equ     0200H
IMAGE_FILE_MACHINE_MIPS16                       equ     0266H
IMAGE_FILE_MACHINE_MIPSFPU                      equ     0366H
IMAGE_FILE_MACHINE_MIPSFPU16                    equ     0466H
IMAGE_FILE_MACHINE_ALPHA64                      equ     0284H
IMAGE_FILE_MACHINE_AXP64                        equ     IMAGE_FILE_MACHINE_ALPHA64
IMAGE_FILE_MACHINE_CEF                          equ     0C0EFH
IMAGE_FILE_MACHINE_EBC                          equ     0EBCH
IMAGE_FILE_MACHINE_AMD64                        equ     8664H
IMAGE_FILE_MACHINE_M32R                         equ     9041H
IMAGE_FILE_MACHINE_CEE                          equ     0C0EEH

IMAGE_SIZEOF_ROM_OPTIONAL_HEADER                equ     56
IMAGE_SIZEOF_STD_OPTIONAL_HEADER                equ     28
IMAGE_SIZEOF_NT_OPTIONAL32_HEADER               equ     224
IMAGE_SIZEOF_NT_OPTIONAL64_HEADER               equ     240

IMAGE_NT_OPTIONAL_HDR32_MAGIC                   equ     10bH
IMAGE_NT_OPTIONAL_HDR64_MAGIC                   equ     20bH
IMAGE_ROM_OPTIONAL_HDR_MAGIC                    equ     107H

IMAGE_SUBSYSTEM_UNKNOWN                         equ     0
IMAGE_SUBSYSTEM_NATIVE                          equ     1
IMAGE_SUBSYSTEM_WINDOWS_GUI                     equ     2
IMAGE_SUBSYSTEM_WINDOWS_CUI                     equ     3
IMAGE_SUBSYSTEM_OS2_CUI                         equ     5
IMAGE_SUBSYSTEM_POSIX_CUI                       equ     7
IMAGE_SUBSYSTEM_NATIVE_WINDOWS                  equ     8
IMAGE_SUBSYSTEM_WINDOWS_CE_GUI                  equ     9
IMAGE_SUBSYSTEM_EFI_APPLICATION                 equ     10
IMAGE_SUBSYSTEM_EFI_BOOT_SERVICE_DRIVER         equ     11
IMAGE_SUBSYSTEM_EFI_RUNTIME_DRIVER              equ     12
IMAGE_SUBSYSTEM_EFI_ROM                         equ     13
IMAGE_SUBSYSTEM_XBOX                            equ     14
IMAGE_SUBSYSTEM_WINDOWS_BOOT_APPLICATION        equ     16

IMAGE_DLLCHARACTERISTICS_NO_BIND                equ     0800H
IMAGE_DLLCHARACTERISTICS_WDM_DRIVER             equ     2000H
IMAGE_DLLCHARACTERISTICS_TERMINAL_SERVER_AWARE  equ     8000H
IMAGE_DLLCHARACTERISTICS_DYNAMIC_BASE           equ     0040H
IMAGE_DLLCHARACTERISTICS_FORCE_INTEGRITY        equ     0080H
IMAGE_DLLCHARACTERISTICS_NX_COMPAT              equ     0100H
IMAGE_DLLCHARACTERISTICS_NO_ISOLATION           equ     0200H
IMAGE_DLLCHARACTERISTICS_NO_SEH                 equ     0400H

IMAGE_DIRECTORY_ENTRY_EXPORT                    equ     0
IMAGE_DIRECTORY_ENTRY_IMPORT                    equ     1
IMAGE_DIRECTORY_ENTRY_RESOURCE                  equ     2
IMAGE_DIRECTORY_ENTRY_EXCEPTION                 equ     3
IMAGE_DIRECTORY_ENTRY_SECURITY                  equ     4
IMAGE_DIRECTORY_ENTRY_BASERELOC                 equ     5
IMAGE_DIRECTORY_ENTRY_DEBUG                     equ     6
IMAGE_DIRECTORY_ENTRY_COPYRIGHT                 equ     7
IMAGE_DIRECTORY_ENTRY_ARCHITECTURE              equ     7
IMAGE_DIRECTORY_ENTRY_GLOBALPTR                 equ     8
IMAGE_DIRECTORY_ENTRY_TLS                       equ     9
IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG               equ     10
IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT              equ     11
IMAGE_DIRECTORY_ENTRY_IAT                       equ     12
IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT              equ     13
IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR            equ     14

IMAGE_SIZEOF_SHORT_NAME                         equ     8
IMAGE_SIZEOF_SECTION_HEADER                     equ     40

IMAGE_SIZEOF_SYMBOL                             equ     18

IMAGE_SYM_UNDEFINED                             equ     0
IMAGE_SYM_ABSOLUTE                              equ     (-1)
IMAGE_SYM_DEBUG                                 equ     (-2)

IMAGE_SYM_TYPE_NULL                             equ     0000H
IMAGE_SYM_TYPE_VOID                             equ     0001H
IMAGE_SYM_TYPE_CHAR                             equ     0002H
IMAGE_SYM_TYPE_SHORT                            equ     0003H
IMAGE_SYM_TYPE_INT                              equ     0004H
IMAGE_SYM_TYPE_LONG                             equ     0005H
IMAGE_SYM_TYPE_FLOAT                            equ     0006H
IMAGE_SYM_TYPE_DOUBLE                           equ     0007H
IMAGE_SYM_TYPE_STRUCT                           equ     0008H
IMAGE_SYM_TYPE_UNION                            equ     0009H
IMAGE_SYM_TYPE_ENUM                             equ     000AH
IMAGE_SYM_TYPE_MOE                              equ     000BH
IMAGE_SYM_TYPE_BYTE                             equ     000CH
IMAGE_SYM_TYPE_WORD                             equ     000DH
IMAGE_SYM_TYPE_UINT                             equ     000EH
IMAGE_SYM_TYPE_DWORD                            equ     000FH
IMAGE_SYM_TYPE_PCODE                            equ     8000H

IMAGE_SYM_DTYPE_NULL                            equ     0
IMAGE_SYM_DTYPE_POINTER                         equ     1
IMAGE_SYM_DTYPE_FUNCTION                        equ     2
IMAGE_SYM_DTYPE_ARRAY                           equ     3

IMAGE_SYM_CLASS_END_OF_FUNCTION                 equ     (-1)
IMAGE_SYM_CLASS_NULL                            equ     0000H
IMAGE_SYM_CLASS_AUTOMATIC                       equ     0001H
IMAGE_SYM_CLASS_EXTERNAL                        equ     0002H
IMAGE_SYM_CLASS_STATIC                          equ     0003H
IMAGE_SYM_CLASS_REGISTER                        equ     0004H
IMAGE_SYM_CLASS_EXTERNAL_DEF                    equ     0005H
IMAGE_SYM_CLASS_LABEL                           equ     0006H
IMAGE_SYM_CLASS_UNDEFINED_LABEL                 equ     0007H
IMAGE_SYM_CLASS_MEMBER_OF_STRUCT                equ     0008H
IMAGE_SYM_CLASS_ARGUMENT                        equ     0009H
IMAGE_SYM_CLASS_STRUCT_TAG                      equ     000AH
IMAGE_SYM_CLASS_MEMBER_OF_UNION                 equ     000BH
IMAGE_SYM_CLASS_UNION_TAG                       equ     000CH
IMAGE_SYM_CLASS_TYPE_DEFINITION                 equ     000DH
IMAGE_SYM_CLASS_UNDEFINED_STATIC                equ     000EH
IMAGE_SYM_CLASS_ENUM_TAG                        equ     000FH
IMAGE_SYM_CLASS_MEMBER_OF_ENUM                  equ     0010H
IMAGE_SYM_CLASS_REGISTER_PARAM                  equ     0011H
IMAGE_SYM_CLASS_BIT_FIELD                       equ     0012H

IMAGE_SYM_CLASS_FAR_EXTERNAL                    equ     0044H

IMAGE_SYM_CLASS_BLOCK                           equ     0064H
IMAGE_SYM_CLASS_FUNCTION                        equ     0065H
IMAGE_SYM_CLASS_END_OF_STRUCT                   equ     0066H
IMAGE_SYM_CLASS_FILE                            equ     0067H
IMAGE_SYM_CLASS_SECTION                         equ     0068H
IMAGE_SYM_CLASS_WEAK_EXTERNAL                   equ     0069H

IMAGE_SIZEOF_AUX_SYMBOL                         equ     18

IMAGE_COMDAT_SELECT_NODUPLICATES                equ     1
IMAGE_COMDAT_SELECT_ANY                         equ     2
IMAGE_COMDAT_SELECT_SAME_SIZE                   equ     3
IMAGE_COMDAT_SELECT_EXACT_MATCH                 equ     4
IMAGE_COMDAT_SELECT_ASSOCIATIVE                 equ     5
IMAGE_COMDAT_SELECT_LARGEST                     equ     6
IMAGE_COMDAT_SELECT_NEWEST                      equ     7

IMAGE_WEAK_EXTERN_SEARCH_NOLIBRARY              equ     1
IMAGE_WEAK_EXTERN_SEARCH_LIBRARY                equ     2
IMAGE_WEAK_EXTERN_SEARCH_ALIAS                  equ     3

IMAGE_SIZEOF_RELOCATION                         equ     10

IMAGE_REL_I386_ABSOLUTE                         equ     0000H
IMAGE_REL_I386_DIR16                            equ     0001H
IMAGE_REL_I386_REL16                            equ     0002H
IMAGE_REL_I386_DIR32                            equ     0006H
IMAGE_REL_I386_DIR32NB                          equ     0007H
IMAGE_REL_I386_SEG12                            equ     0009H
IMAGE_REL_I386_SECTION                          equ     000AH
IMAGE_REL_I386_SECREL                           equ     000BH
IMAGE_REL_I386_REL32                            equ     0014H

IMAGE_REL_MIPS_ABSOLUTE                         equ     0000H
IMAGE_REL_MIPS_REFHALF                          equ     0001H
IMAGE_REL_MIPS_REFWORD                          equ     0002H
IMAGE_REL_MIPS_JMPADDR                          equ     0003H
IMAGE_REL_MIPS_REFHI                            equ     0004H
IMAGE_REL_MIPS_REFLO                            equ     0005H
IMAGE_REL_MIPS_GPREL                            equ     0006H
IMAGE_REL_MIPS_LITERAL                          equ     0007H
IMAGE_REL_MIPS_SECTION                          equ     000AH
IMAGE_REL_MIPS_SECREL                           equ     000BH
IMAGE_REL_MIPS_SECRELLO                         equ     000CH
IMAGE_REL_MIPS_SECRELHI                         equ     000DH
IMAGE_REL_MIPS_TOKEN                            equ     000EH
IMAGE_REL_MIPS_JMPADDR16                        equ     0010H
IMAGE_REL_MIPS_REFWORDNB                        equ     0022H
IMAGE_REL_MIPS_PAIR                             equ     0025H

IMAGE_REL_ALPHA_ABSOLUTE                        equ     0000H
IMAGE_REL_ALPHA_REFLONG                         equ     0001H
IMAGE_REL_ALPHA_REFQUAD                         equ     0002H
IMAGE_REL_ALPHA_GPREL32                         equ     0003H
IMAGE_REL_ALPHA_LITERAL                         equ     0004H
IMAGE_REL_ALPHA_LITUSE                          equ     0005H
IMAGE_REL_ALPHA_GPDISP                          equ     0006H
IMAGE_REL_ALPHA_BRADDR                          equ     0007H
IMAGE_REL_ALPHA_HINT                            equ     0008H
IMAGE_REL_ALPHA_INLINE_REFLONG                  equ     0009H
IMAGE_REL_ALPHA_REFHI                           equ     000AH
IMAGE_REL_ALPHA_REFLO                           equ     000BH
IMAGE_REL_ALPHA_PAIR                            equ     000CH
IMAGE_REL_ALPHA_MATCH                           equ     000DH
IMAGE_REL_ALPHA_SECTION                         equ     000EH
IMAGE_REL_ALPHA_SECREL                          equ     000FH
IMAGE_REL_ALPHA_REFLONGNB                       equ     0010H
IMAGE_REL_ALPHA_SECRELLO                        equ     0011H
IMAGE_REL_ALPHA_SECRELHI                        equ     0012H
IMAGE_REL_ALPHA_REFQ3                           equ     0013H
IMAGE_REL_ALPHA_REFQ2                           equ     0014H
IMAGE_REL_ALPHA_REFQ1                           equ     0015H
IMAGE_REL_ALPHA_GPRELLO                         equ     0016H
IMAGE_REL_ALPHA_GPRELHI                         equ     0017H

IMAGE_REL_PPC_ABSOLUTE                          equ     0000H
IMAGE_REL_PPC_ADDR64                            equ     0001H
IMAGE_REL_PPC_ADDR32                            equ     0002H
IMAGE_REL_PPC_ADDR24                            equ     0003H
IMAGE_REL_PPC_ADDR16                            equ     0004H
IMAGE_REL_PPC_ADDR14                            equ     0005H
IMAGE_REL_PPC_REL24                             equ     0006H
IMAGE_REL_PPC_REL14                             equ     0007H
IMAGE_REL_PPC_TOCREL16                          equ     0008H
IMAGE_REL_PPC_TOCREL14                          equ     0009H

IMAGE_REL_PPC_ADDR32NB                          equ     000AH
IMAGE_REL_PPC_SECREL                            equ     000BH
IMAGE_REL_PPC_SECTION                           equ     000CH
IMAGE_REL_PPC_IFGLUE                            equ     000DH
IMAGE_REL_PPC_IMGLUE                            equ     000EH
IMAGE_REL_PPC_SECREL16                          equ     000FH
IMAGE_REL_PPC_REFHI                             equ     0010H
IMAGE_REL_PPC_REFLO                             equ     0011H
IMAGE_REL_PPC_PAIR                              equ     0012H
IMAGE_REL_PPC_SECRELLO                          equ     0013H
IMAGE_REL_PPC_SECRELHI                          equ     0014H
IMAGE_REL_PPC_GPREL                             equ     0015H
IMAGE_REL_PPC_TOKEN                             equ     0016H

IMAGE_REL_PPC_TYPEMASK                          equ     00FFH

IMAGE_REL_PPC_NEG                               equ     0100H
IMAGE_REL_PPC_BRTAKEN                           equ     0200H
IMAGE_REL_PPC_BRNTAKEN                          equ     0400H
IMAGE_REL_PPC_TOCDEFN                           equ     0800H

IMAGE_REL_SH3_ABSOLUTE                          equ     0000H
IMAGE_REL_SH3_DIRECT16                          equ     0001H
IMAGE_REL_SH3_DIRECT32                          equ     0002H
IMAGE_REL_SH3_DIRECT8                           equ     0003H
IMAGE_REL_SH3_DIRECT8_WORD                      equ     0004H
IMAGE_REL_SH3_DIRECT8_LONG                      equ     0005H
IMAGE_REL_SH3_DIRECT4                           equ     0006H
IMAGE_REL_SH3_DIRECT4_WORD                      equ     0007H
IMAGE_REL_SH3_DIRECT4_LONG                      equ     0008H
IMAGE_REL_SH3_PCREL8_WORD                       equ     0009H
IMAGE_REL_SH3_PCREL8_LONG                       equ     000AH
IMAGE_REL_SH3_PCREL12_WORD                      equ     000BH
IMAGE_REL_SH3_STARTOF_SECTION                   equ     000CH
IMAGE_REL_SH3_SIZEOF_SECTION                    equ     000DH
IMAGE_REL_SH3_SECTION                           equ     000EH
IMAGE_REL_SH3_SECREL                            equ     000FH
IMAGE_REL_SH3_DIRECT32_NB                       equ     0010H
IMAGE_REL_SH3_GPREL4_LONG                       equ     0011H
IMAGE_REL_SH3_TOKEN                             equ     0012H
IMAGE_REL_SHM_PCRELPT                           equ     0013H
IMAGE_REL_SHM_REFLO                             equ     0014H
IMAGE_REL_SHM_REFHALF                           equ     0015H
IMAGE_REL_SHM_RELLO                             equ     0016H
IMAGE_REL_SHM_RELHALF                           equ     0017H
IMAGE_REL_SHM_PAIR                              equ     0018H

IMAGE_REL_SH_NOMODE                             equ     8000H

IMAGE_REL_ARM_ABSOLUTE                          equ     0000H
IMAGE_REL_ARM_ADDR32                            equ     0001H
IMAGE_REL_ARM_ADDR32NB                          equ     0002H
IMAGE_REL_ARM_BRANCH24                          equ     0003H
IMAGE_REL_ARM_BRANCH11                          equ     0004H
IMAGE_REL_ARM_TOKEN                             equ     0005H
IMAGE_REL_ARM_GPREL12                           equ     0006H
IMAGE_REL_ARM_GPREL7                            equ     0007H
IMAGE_REL_ARM_BLX24                             equ     0008H
IMAGE_REL_ARM_BLX11                             equ     0009H
IMAGE_REL_ARM_SECTION                           equ     000EH
IMAGE_REL_ARM_SECREL                            equ     000FH

IMAGE_REL_AM_ABSOLUTE                           equ     0000H
IMAGE_REL_AM_ADDR32                             equ     0001H
IMAGE_REL_AM_ADDR32NB                           equ     0002H
IMAGE_REL_AM_CALL32                             equ     0003H
IMAGE_REL_AM_FUNCINFO                           equ     0004H
IMAGE_REL_AM_REL32_1                            equ     0005H
IMAGE_REL_AM_REL32_2                            equ     0006H
IMAGE_REL_AM_SECREL                             equ     0007H
IMAGE_REL_AM_SECTION                            equ     0008H
IMAGE_REL_AM_TOKEN                              equ     0009H

IMAGE_REL_AMD64_ABSOLUTE                        equ     0000H
IMAGE_REL_AMD64_ADDR64                          equ     0001H
IMAGE_REL_AMD64_ADDR32                          equ     0002H
IMAGE_REL_AMD64_ADDR32NB                        equ     0003H
IMAGE_REL_AMD64_REL32                           equ     0004H
IMAGE_REL_AMD64_REL32_1                         equ     0005H
IMAGE_REL_AMD64_REL32_2                         equ     0006H
IMAGE_REL_AMD64_REL32_3                         equ     0007H
IMAGE_REL_AMD64_REL32_4                         equ     0008H
IMAGE_REL_AMD64_REL32_5                         equ     0009H
IMAGE_REL_AMD64_SECTION                         equ     000AH
IMAGE_REL_AMD64_SECREL                          equ     000BH
IMAGE_REL_AMD64_SECREL7                         equ     000CH
IMAGE_REL_AMD64_TOKEN                           equ     000DH
IMAGE_REL_AMD64_SREL32                          equ     000EH
IMAGE_REL_AMD64_PAIR                            equ     000FH
IMAGE_REL_AMD64_SSPAN32                         equ     0010H

IMAGE_REL_IA64_ABSOLUTE                         equ     0000H
IMAGE_REL_IA64_IMM14                            equ     0001H
IMAGE_REL_IA64_IMM22                            equ     0002H
IMAGE_REL_IA64_IMM64                            equ     0003H
IMAGE_REL_IA64_DIR32                            equ     0004H
IMAGE_REL_IA64_DIR64                            equ     0005H
IMAGE_REL_IA64_PCREL21B                         equ     0006H
IMAGE_REL_IA64_PCREL21M                         equ     0007H
IMAGE_REL_IA64_PCREL21F                         equ     0008H
IMAGE_REL_IA64_GPREL22                          equ     0009H
IMAGE_REL_IA64_LTOFF22                          equ     000AH
IMAGE_REL_IA64_SECTION                          equ     000BH
IMAGE_REL_IA64_SECREL22                         equ     000CH
IMAGE_REL_IA64_SECREL64I                        equ     000DH
IMAGE_REL_IA64_SECREL32                         equ     000EH
IMAGE_REL_IA64_LTOFF64                          equ     000FH
IMAGE_REL_IA64_DIR32NB                          equ     0010H
IMAGE_REL_IA64_SREL22                           equ     0011H
IMAGE_REL_IA64_UREL22                           equ     0012H
IMAGE_REL_IA64_SREL32                           equ     0013H
IMAGE_REL_IA64_UREL32                           equ     0014H
IMAGE_REL_IA64_ADDEND                           equ     001FH

IMAGE_REL_CEF_ABSOLUTE                          equ     0000H
IMAGE_REL_CEF_ADDR32                            equ     0001H
IMAGE_REL_CEF_ADDR64                            equ     0002H
IMAGE_REL_CEF_ADDR32NB                          equ     0003H
IMAGE_REL_CEF_SECTION                           equ     0004H
IMAGE_REL_CEF_SECREL                            equ     0005H
IMAGE_REL_CEF_TOKEN                             equ     0006H

IMAGE_REL_CEE_ABSOLUTE                          equ     0000H
IMAGE_REL_CEE_ADDR32                            equ     0001H
IMAGE_REL_CEE_ADDR64                            equ     0002H
IMAGE_REL_CEE_ADDR32NB                          equ     0003H
IMAGE_REL_CEE_SECTION                           equ     0004H
IMAGE_REL_CEE_SECREL                            equ     0005H
IMAGE_REL_CEE_TOKEN                             equ     0006H

IMAGE_REL_M32R_ABSOLUTE                         equ     0000H
IMAGE_REL_M32R_ADDR32                           equ     0001H
IMAGE_REL_M32R_ADDR32NB                         equ     0002H
IMAGE_REL_M32R_ADDR24                           equ     0003H
IMAGE_REL_M32R_GPREL16                          equ     0004H
IMAGE_REL_M32R_PCREL24                          equ     0005H
IMAGE_REL_M32R_PCREL16                          equ     0006H
IMAGE_REL_M32R_PCREL8                           equ     0007H
IMAGE_REL_M32R_REFHALF                          equ     0008H
IMAGE_REL_M32R_REFHI                            equ     0009H
IMAGE_REL_M32R_REFLO                            equ     000AH
IMAGE_REL_M32R_PAIR                             equ     000BH
IMAGE_REL_M32R_SECTION                          equ     000CH
IMAGE_REL_M32R_SECREL32                         equ     000DH
IMAGE_REL_M32R_TOKEN                            equ     000EH

IMAGE_REL_EBC_ABSOLUTE                          equ     0000H
IMAGE_REL_EBC_ADDR32NB                          equ     0001H
IMAGE_REL_EBC_REL32                             equ     0002H
IMAGE_REL_EBC_SECTION                           equ     0003H
IMAGE_REL_EBC_SECREL                            equ     0004H

IMAGE_SIZEOF_LINENUMBER                         equ     6
IMAGE_SIZEOF_BASE_RELOCATION                    equ     8

IMAGE_REL_BASED_ABSOLUTE                        equ     0
IMAGE_REL_BASED_HIGH                            equ     1
IMAGE_REL_BASED_LOW                             equ     2
IMAGE_REL_BASED_HIGHLOW                         equ     3
IMAGE_REL_BASED_HIGHADJ                         equ     4
IMAGE_REL_BASED_MIPS_JMPADDR                    equ     5
IMAGE_REL_BASED_SECTION                         equ     6
IMAGE_REL_BASED_REL32                           equ     7

IMAGE_REL_BASED_MIPS_JMPADDR16                  equ     9
IMAGE_REL_BASED_IA64_IMM64                      equ     9
IMAGE_REL_BASED_DIR64                           equ     10
IMAGE_REL_BASED_HIGH3ADJ                        equ     11

IMAGE_ARCHIVE_START_SIZE                        equ     8
IMAGE_ARCHIVE_START                             equ     A("!<arch>", 10)
IMAGE_ARCHIVE_END                               equ     A("`", 10)
IMAGE_ARCHIVE_PAD                               equ     10
IMAGE_ARCHIVE_LINKER_MEMBER                     equ     </               >
IMAGE_ARCHIVE_LONGNAMES_MEMBER                  equ     <//              >

IMAGE_ORDINAL_FLAG64                            equ     8000000000000000H
IMAGE_ORDINAL_FLAG32                            equ     80000000H

IMAGE_RESOURCE_NAME_IS_STRING                   equ     80000000H
IMAGE_RESOURCE_DATA_IS_DIRECTORY                equ     80000000H

IMAGE_DEBUG_TYPE_UNKNOWN                        equ     0
IMAGE_DEBUG_TYPE_COFF                           equ     1
IMAGE_DEBUG_TYPE_CODEVIEW                       equ     2
IMAGE_DEBUG_TYPE_FPO                            equ     3
IMAGE_DEBUG_TYPE_MISC                           equ     4
IMAGE_DEBUG_TYPE_EXCEPTION                      equ     5
IMAGE_DEBUG_TYPE_FIXUP                          equ     6
IMAGE_DEBUG_TYPE_OMAP_TO_SRC                    equ     7
IMAGE_DEBUG_TYPE_OMAP_FROM_SRC                  equ     8
IMAGE_DEBUG_TYPE_BORLAND                        equ     9
IMAGE_DEBUG_TYPE_RESERVED10                     equ     10
IMAGE_DEBUG_TYPE_CLSID                          equ     11

FRAME_FPO                                       equ     0
FRAME_TRAP                                      equ     1
FRAME_TSS                                       equ     2
FRAME_NONFPO                                    equ     3

SIZEOF_RFPO_DATA                                equ     16

IMAGE_DEBUG_MISC_EXENAME                        equ     1

IMAGE_SEPARATE_DEBUG_SIGNATURE                  equ     4944H
IMAGE_SEPARATE_DEBUG_FLAGS_MASK                 equ     8000H
IMAGE_SEPARATE_DEBUG_MISMATCH                   equ     8000H

IMPORT_OBJECT_HDR_SIG2                          equ     0FFFFH

N_BTMASK                                        equ     000FH
N_TMASK                                         equ     0030H
N_TMASK1                                        equ     00C0H
N_TMASK2                                        equ     00F0H
N_BTSHFT                                        equ     4
N_TSHIFT                                        equ     2

FAST_FAIL_LEGACY_GS_VIOLATION                   equ     0
FAST_FAIL_VTGUARD_CHECK_FAILURE                 equ     1
FAST_FAIL_STACK_COOKIE_CHECK_FAILURE            equ     2
FAST_FAIL_CORRUPT_LIST_ENTRY                    equ     3
FAST_FAIL_INCORRECT_STACK                       equ     4
FAST_FAIL_INVALID_ARG                           equ     5
FAST_FAIL_GS_COOKIE_INIT                        equ     6
FAST_FAIL_FATAL_APP_EXIT                        equ     7
FAST_FAIL_RANGE_CHECK_FAILURE                   equ     8
FAST_FAIL_UNSAFE_REGISTRY_ACCESS                equ     9
FAST_FAIL_GUARD_ICALL_CHECK_FAILURE             equ     10
FAST_FAIL_GUARD_WRITE_CHECK_FAILURE             equ     11
FAST_FAIL_INVALID_FIBER_SWITCH                  equ     12
FAST_FAIL_INVALID_SET_OF_CONTEXT                equ     13
FAST_FAIL_INVALID_REFERENCE_COUNT               equ     14
FAST_FAIL_INVALID_JUMP_BUFFER                   equ     18
FAST_FAIL_MRDATA_MODIFIED                       equ     19
FAST_FAIL_CERTIFICATION_FAILURE                 equ     20
FAST_FAIL_INVALID_EXCEPTION_CHAIN               equ     21
FAST_FAIL_CRYPTO_LIBRARY                        equ     22
FAST_FAIL_INVALID_CALL_IN_DLL_CALLOUT           equ     23
FAST_FAIL_INVALID_IMAGE_BASE                    equ     24
FAST_FAIL_DLOAD_PROTECTION_FAILURE              equ     25
FAST_FAIL_UNSAFE_EXTENSION_CALL                 equ     26
FAST_FAIL_INVALID_FAST_FAIL_CODE                equ     0FFFFFFFFH

HEAP_NO_SERIALIZE                               equ     00000001H
HEAP_GROWABLE                                   equ     00000002H
HEAP_GENERATE_EXCEPTIONS                        equ     00000004H
HEAP_ZERO_MEMORY                                equ     00000008H
HEAP_REALLOC_IN_PLACE_ONLY                      equ     00000010H
HEAP_TAIL_CHECKING_ENABLED                      equ     00000020H
HEAP_FREE_CHECKING_ENABLED                      equ     00000040H
HEAP_DISABLE_COALESCE_ON_FREE                   equ     00000080H
HEAP_CREATE_ALIGN_16                            equ     00010000H
HEAP_CREATE_ENABLE_TRACING                      equ     00020000H
HEAP_MAXIMUM_TAG                                equ     0FFFH
HEAP_PSEUDO_TAG_FLAG                            equ     8000H
HEAP_TAG_SHIFT                                  equ     18

IS_TEXT_UNICODE_ASCII16                         equ     0001H
IS_TEXT_UNICODE_REVERSE_ASCII16                 equ     0010H
IS_TEXT_UNICODE_STATISTICS                      equ     0002H
IS_TEXT_UNICODE_REVERSE_STATISTICS              equ     0020H
IS_TEXT_UNICODE_CONTROLS                        equ     0004H
IS_TEXT_UNICODE_REVERSE_CONTROLS                equ     0040H
IS_TEXT_UNICODE_SIGNATURE                       equ     0008H
IS_TEXT_UNICODE_REVERSE_SIGNATURE               equ     0080H
IS_TEXT_UNICODE_ILLEGAL_CHARS                   equ     0100H
IS_TEXT_UNICODE_ODD_LENGTH                      equ     0200H
IS_TEXT_UNICODE_DBCS_LEADBYTE                   equ     0400H
IS_TEXT_UNICODE_NULL_BYTES                      equ     1000H
IS_TEXT_UNICODE_UNICODE_MASK                    equ     000FH
IS_TEXT_UNICODE_REVERSE_MASK                    equ     00F0H
IS_TEXT_UNICODE_NOT_UNICODE_MASK                equ     0F00H
IS_TEXT_UNICODE_NOT_ASCII_MASK                  equ     0F000H

COMPRESSION_FORMAT_NONE                         equ     0000H
COMPRESSION_FORMAT_DEFAULT                      equ     0001H
COMPRESSION_FORMAT_LZNT1                        equ     0002H
COMPRESSION_FORMAT_XPRESS                       equ     0003H
COMPRESSION_FORMAT_XPRESS_HUFF                  equ     0004H
COMPRESSION_ENGINE_STANDARD                     equ     0000H
COMPRESSION_ENGINE_MAXIMUM                      equ     0100H
COMPRESSION_ENGINE_HIBER                        equ     0200H

MESSAGE_RESOURCE_UNICODE                        equ     0001H

VER_EQUAL                                       equ     1
VER_GREATER                                     equ     2
VER_GREATER_EQUAL                               equ     3
VER_LESS                                        equ     4
VER_LESS_EQUAL                                  equ     5
VER_AND                                         equ     6
VER_OR                                          equ     7

VER_CONDITION_MASK                              equ     7
VER_NUM_BITS_PER_CONDITION_MASK                 equ     3

VER_MINORVERSION                                equ     0000001H
VER_MAJORVERSION                                equ     0000002H
VER_BUILDNUMBER                                 equ     0000004H
VER_PLATFORMID                                  equ     0000008H
VER_SERVICEPACKMINOR                            equ     0000010H
VER_SERVICEPACKMAJOR                            equ     0000020H
VER_SUITENAME                                   equ     0000040H
VER_PRODUCT_TYPE                                equ     0000080H

VER_NT_WORKSTATION                              equ     0000001H
VER_NT_DOMAIN_CONTROLLER                        equ     0000002H
VER_NT_SERVER                                   equ     0000003H

VER_PLATFORM_WIN32s                             equ     0
VER_PLATFORM_WIN32_WINDOWS                      equ     1
VER_PLATFORM_WIN32_NT                           equ     2
VER_PLATFORM_WIN32_CE                           equ     3

RTL_CRITSECT_TYPE                               equ     0
RTL_RESOURCE_TYPE                               equ     1

SEF_DACL_AUTO_INHERIT                           equ     01H
SEF_SACL_AUTO_INHERIT                           equ     02H
SEF_DEFAULT_DESCRIPTOR_FOR_OBJECT               equ     04H
SEF_AVOID_PRIVILEGE_CHECK                       equ     08H
SEF_AVOID_OWNER_CHECK                           equ     10H
SEF_DEFAULT_OWNER_FROM_PARENT                   equ     20H
SEF_DEFAULT_GROUP_FROM_PARENT                   equ     40H
SEF_MACL_NO_WRITE_UP                            equ     100H
SEF_MACL_NO_READ_UP                             equ     200H
SEF_MACL_NO_EXECUTE_UP                          equ     0400H
SEF_AI_USE_EXTRA_PARAMS                         equ     0800H
SEF_AVOID_OWNER_RESTRICTION                     equ     01000H
SEF_MACL_VALID_FLAGS                            equ     (SEF_MACL_NO_WRITE_UP or SEF_MACL_NO_READ_UP or SEF_MACL_NO_EXECUTE_UP)

WT_EXECUTEDEFAULT                               equ     00000000H
WT_EXECUTEINIOTHREAD                            equ     00000001H
WT_EXECUTEINUITHREAD                            equ     00000002H
WT_EXECUTEINWAITTHREAD                          equ     00000004H
WT_EXECUTEONLYONCE                              equ     00000008H
WT_EXECUTEINTIMERTHREAD                         equ     00000020H
WT_EXECUTELONGFUNCTION                          equ     00000010H
WT_EXECUTEINPERSISTENTIOTHREAD                  equ     00000040H
WT_EXECUTEINPERSISTENTTHREAD                    equ     00000080H
WT_TRANSFER_IMPERSONATION                       equ     00000100H

WT_EXECUTEINLONGTHREAD                          equ     00000010H
WT_EXECUTEDELETEWAIT                            equ     00000008H

DLL_PROCESS_ATTACH                              equ     1
DLL_THREAD_ATTACH                               equ     2
DLL_THREAD_DETACH                               equ     3
DLL_PROCESS_DETACH                              equ     0

EVENTLOG_SEQUENTIAL_READ                        equ     0001H
EVENTLOG_SEEK_READ                              equ     0002H
EVENTLOG_FORWARDS_READ                          equ     0004H
EVENTLOG_BACKWARDS_READ                         equ     0008H

EVENTLOG_SUCCESS                                equ     0000H
EVENTLOG_ERROR_TYPE                             equ     0001H
EVENTLOG_WARNING_TYPE                           equ     0002H
EVENTLOG_INFORMATION_TYPE                       equ     0004H
EVENTLOG_AUDIT_SUCCESS                          equ     0008H
EVENTLOG_AUDIT_FAILURE                          equ     0010H

EVENTLOG_START_PAIRED_EVENT                     equ     0001H
EVENTLOG_END_PAIRED_EVENT                       equ     0002H
EVENTLOG_END_ALL_PAIRED_EVENTS                  equ     0004H
EVENTLOG_PAIRED_EVENT_ACTIVE                    equ     0008H
EVENTLOG_PAIRED_EVENT_INACTIVE                  equ     0010H

MAXLOGICALLOGNAMESIZE                           equ     256

KEY_QUERY_VALUE                                 equ     0001H
KEY_SET_VALUE                                   equ     0002H
KEY_CREATE_SUB_KEY                              equ     0004H
KEY_ENUMERATE_SUB_KEYS                          equ     0008H
KEY_NOTIFY                                      equ     0010H
KEY_CREATE_LINK                                 equ     0020H
KEY_WOW64_32KEY                                 equ     0200H
KEY_WOW64_64KEY                                 equ     0100H
KEY_WOW64_RES                                   equ     0300H

KEY_READ                                        equ     ((STANDARD_RIGHTS_READ or KEY_QUERY_VALUE or KEY_ENUMERATE_SUB_KEYS or KEY_NOTIFY) and (NOT SYNCHRONIZE))
KEY_WRITE                                       equ     ((STANDARD_RIGHTS_WRITE or KEY_SET_VALUE or KEY_CREATE_SUB_KEY) and (NOT SYNCHRONIZE))
KEY_ALL_ACCESS                                  equ     ((STANDARD_RIGHTS_ALL or KEY_QUERY_VALUE or KEY_SET_VALUE or KEY_CREATE_SUB_KEY or KEY_ENUMERATE_SUB_KEYS or KEY_NOTIFY or KEY_CREATE_LINK) and (NOT SYNCHRONIZE))
KEY_EXECUTE                                     equ     KEY_READ

REG_OPTION_RESERVED                             equ     00000000H
REG_LEGAL_OPTION                                equ     (REG_OPTION_RESERVED or REG_OPTION_NON_VOLATILE or REG_OPTION_VOLATILE or REG_OPTION_CREATE_LINK or REG_OPTION_BACKUP_RESTORE or REG_OPTION_OPEN_LINK)
REG_LEGAL_CHANGE_FILTER                         equ     (REG_NOTIFY_CHANGE_NAME or REG_NOTIFY_CHANGE_ATTRIBUTES or REG_NOTIFY_CHANGE_LAST_SET or REG_NOTIFY_CHANGE_SECURITY)

REG_STANDARD_FORMAT                             equ     1
REG_LATEST_FORMAT                               equ     2
REG_NO_COMPRESSION                              equ     4

REG_WHOLE_HIVE_VOLATILE                         equ     00000001H
REG_REFRESH_HIVE                                equ     00000002H
REG_NO_LAZY_FLUSH                               equ     00000004H
REG_FORCE_RESTORE                               equ     00000008H
REG_APP_HIVE                                    equ     00000010H
REG_PROCESS_PRIVATE                             equ     00000020H
REG_START_JOURNAL                               equ     00000040H
REG_HIVE_EXACT_FILE_GROWTH                      equ     00000080H
REG_HIVE_NO_RM                                  equ     00000100H
REG_HIVE_SINGLE_LOG                             equ     00000200H
REG_BOOT_HIVE                                   equ     00000400H
REG_LOAD_HIVE_OPEN_HANDLE                       equ     00000800H
REG_FLUSH_HIVE_FILE_GROWTH                      equ     00001000H

REG_FORCE_UNLOAD                                equ     1

SERVICE_KERNEL_DRIVER                           equ     00000001H
SERVICE_FILE_SYSTEM_DRIVER                      equ     00000002H
SERVICE_ADAPTER                                 equ     00000004H
SERVICE_RECOGNIZER_DRIVER                       equ     00000008H
SERVICE_DRIVER                                  equ     (SERVICE_KERNEL_DRIVER or SERVICE_FILE_SYSTEM_DRIVER or SERVICE_RECOGNIZER_DRIVER)

SERVICE_WIN32_OWN_PROCESS                       equ     00000010H
SERVICE_WIN32_SHARE_PROCESS                     equ     00000020H
SERVICE_WIN32                                   equ     (SERVICE_WIN32_OWN_PROCESS or SERVICE_WIN32_SHARE_PROCESS)

SERVICE_INTERACTIVE_PROCESS                     equ     00000100H

SERVICE_TYPE_ALL                                equ     (SERVICE_WIN32 or SERVICE_ADAPTER or SERVICE_DRIVER or SERVICE_INTERACTIVE_PROCESS)

SERVICE_BOOT_START                              equ     00000000H
SERVICE_SYSTEM_START                            equ     00000001H
SERVICE_AUTO_START                              equ     00000002H
SERVICE_DEMAND_START                            equ     00000003H
SERVICE_DISABLED                                equ     00000004H

SERVICE_ERROR_IGNORE                            equ     00000000H
SERVICE_ERROR_NORMAL                            equ     00000001H
SERVICE_ERROR_SEVERE                            equ     00000002H
SERVICE_ERROR_CRITICAL                          equ     00000003H

CM_SERVICE_NETWORK_BOOT_LOAD                    equ     00000001H
CM_SERVICE_VIRTUAL_DISK_BOOT_LOAD               equ     00000002H
CM_SERVICE_USB_DISK_BOOT_LOAD                   equ     00000004H
CM_SERVICE_SD_DISK_BOOT_LOAD                    equ     00000008H
CM_SERVICE_USB3_DISK_BOOT_LOAD                  equ     00000010H
CM_SERVICE_MEASURED_BOOT_LOAD                   equ     00000020H
CM_SERVICE_VERIFIER_BOOT_LOAD                   equ     00000040H
CM_SERVICE_WINPE_BOOT_LOAD                      equ     00000080H

CM_SERVICE_VALID_PROMOTION_MASKA                equ     (CM_SERVICE_NETWORK_BOOT_LOAD or CM_SERVICE_VIRTUAL_DISK_BOOT_LOAD or \
                                                        CM_SERVICE_USB_DISK_BOOT_LOAD or CM_SERVICE_SD_DISK_BOOT_LOAD or \
                                                        CM_SERVICE_USB3_DISK_BOOT_LOAD or CM_SERVICE_MEASURED_BOOT_LOAD)
CM_SERVICE_VALID_PROMOTION_MASKB                equ     (CM_SERVICE_VERIFIER_BOOT_LOAD or CM_SERVICE_WINPE_BOOT_LOAD)
CM_SERVICE_VALID_PROMOTION_MASK                 equ     (CM_SERVICE_VALID_PROMOTION_MASKA or CM_SERVICE_VALID_PROMOTION_MASKB)

TAPE_ERASE_SHORT                                equ     0
TAPE_ERASE_LONG                                 equ     1

TAPE_LOAD                                       equ     0
TAPE_UNLOAD                                     equ     1
TAPE_TENSION                                    equ     2
TAPE_LOCK                                       equ     3
TAPE_UNLOCK                                     equ     4
TAPE_FORMAT                                     equ     5

TAPE_SETMARKS                                   equ     0
TAPE_FILEMARKS                                  equ     1
TAPE_SHORT_FILEMARKS                            equ     2
TAPE_LONG_FILEMARKS                             equ     3

TAPE_ABSOLUTE_POSITION                          equ     0
TAPE_LOGICAL_POSITION                           equ     1
TAPE_PSEUDO_LOGICAL_POSITION                    equ     2

TAPE_REWIND                                     equ     0
TAPE_ABSOLUTE_BLOCK                             equ     1
TAPE_LOGICAL_BLOCK                              equ     2
TAPE_PSEUDO_LOGICAL_BLOCK                       equ     3
TAPE_SPACE_END_OF_DATA                          equ     4
TAPE_SPACE_RELATIVE_BLOCKS                      equ     5
TAPE_SPACE_FILEMARKS                            equ     6
TAPE_SPACE_SEQUENTIAL_FMKS                      equ     7
TAPE_SPACE_SETMARKS                             equ     8
TAPE_SPACE_SEQUENTIAL_SMKS                      equ     9

TAPE_DRIVE_FIXED                                equ     00000001H
TAPE_DRIVE_SELECT                               equ     00000002H
TAPE_DRIVE_INITIATOR                            equ     00000004H
TAPE_DRIVE_ERASE_SHORT                          equ     00000010H
TAPE_DRIVE_ERASE_LONG                           equ     00000020H
TAPE_DRIVE_ERASE_BOP_ONLY                       equ     00000040H
TAPE_DRIVE_ERASE_IMMEDIATE                      equ     00000080H
TAPE_DRIVE_TAPE_CAPACITY                        equ     00000100H
TAPE_DRIVE_TAPE_REMAINING                       equ     00000200H
TAPE_DRIVE_FIXED_BLOCK                          equ     00000400H
TAPE_DRIVE_VARIABLE_BLOCK                       equ     00000800H
TAPE_DRIVE_WRITE_PROTECT                        equ     00001000H
TAPE_DRIVE_EOT_WZ_SIZE                          equ     00002000H
TAPE_DRIVE_ECC                                  equ     00010000H
TAPE_DRIVE_COMPRESSION                          equ     00020000H
TAPE_DRIVE_PADDING                              equ     00040000H
TAPE_DRIVE_REPORT_SMKS                          equ     00080000H
TAPE_DRIVE_GET_ABSOLUTE_BLK                     equ     00100000H
TAPE_DRIVE_GET_LOGICAL_BLK                      equ     00200000H
TAPE_DRIVE_SET_EOT_WZ_SIZE                      equ     00400000H
TAPE_DRIVE_EJECT_MEDIA                          equ     01000000H
TAPE_DRIVE_CLEAN_REQUESTS                       equ     02000000H
TAPE_DRIVE_SET_CMP_BOP_ONLY                     equ     04000000H
TAPE_DRIVE_RESERVED_BIT                         equ     80000000H
TAPE_DRIVE_LOAD_UNLOAD                          equ     80000001H
TAPE_DRIVE_TENSION                              equ     80000002H
TAPE_DRIVE_LOCK_UNLOCK                          equ     80000004H
TAPE_DRIVE_REWIND_IMMEDIATE                     equ     80000008H
TAPE_DRIVE_SET_BLOCK_SIZE                       equ     80000010H
TAPE_DRIVE_LOAD_UNLD_IMMED                      equ     80000020H
TAPE_DRIVE_TENSION_IMMED                        equ     80000040H
TAPE_DRIVE_LOCK_UNLK_IMMED                      equ     80000080H
TAPE_DRIVE_SET_ECC                              equ     80000100H
TAPE_DRIVE_SET_COMPRESSION                      equ     80000200H
TAPE_DRIVE_SET_PADDING                          equ     80000400H
TAPE_DRIVE_SET_REPORT_SMKS                      equ     80000800H
TAPE_DRIVE_ABSOLUTE_BLK                         equ     80001000H
TAPE_DRIVE_ABS_BLK_IMMED                        equ     80002000H
TAPE_DRIVE_LOGICAL_BLK                          equ     80004000H
TAPE_DRIVE_LOG_BLK_IMMED                        equ     80008000H
TAPE_DRIVE_END_OF_DATA                          equ     80010000H
TAPE_DRIVE_RELATIVE_BLKS                        equ     80020000H
TAPE_DRIVE_FILEMARKS                            equ     80040000H
TAPE_DRIVE_SEQUENTIAL_FMKS                      equ     80080000H
TAPE_DRIVE_SETMARKS                             equ     80100000H
TAPE_DRIVE_SEQUENTIAL_SMKS                      equ     80200000H
TAPE_DRIVE_REVERSE_POSITION                     equ     80400000H
TAPE_DRIVE_SPACE_IMMEDIATE                      equ     80800000H
TAPE_DRIVE_WRITE_SETMARKS                       equ     81000000H
TAPE_DRIVE_WRITE_FILEMARKS                      equ     82000000H
TAPE_DRIVE_WRITE_SHORT_FMKS                     equ     84000000H
TAPE_DRIVE_WRITE_LONG_FMKS                      equ     88000000H
TAPE_DRIVE_WRITE_MARK_IMMED                     equ     90000000H
TAPE_DRIVE_FORMAT                               equ     0A0000000H
TAPE_DRIVE_FORMAT_IMMEDIATE                     equ     0C0000000H
TAPE_DRIVE_HIGH_FEATURES                        equ     80000000H

TAPE_FIXED_PARTITIONS                           equ     0
TAPE_SELECT_PARTITIONS                          equ     1
TAPE_INITIATOR_PARTITIONS                       equ     2

TAPE_QUERY_DRIVE_PARAMETERS                     equ     0
TAPE_QUERY_MEDIA_CAPACITY                       equ     1
TAPE_CHECK_FOR_DRIVE_PROBLEM                    equ     2
TAPE_QUERY_IO_ERROR_DATA                        equ     3
TAPE_QUERY_DEVICE_ERROR_DATA                    equ     4

CONTEXT_i386                                    equ     00010000H
CONTEXT_i486                                    equ     00010000H
CONTEXT_AMD64                                   equ     100000H
CONTEXT_IA64                                    equ     00080000H

LEGACY_SAVE_AREA_LENGTH                         equ     SIZEOF XMM_SAVE_AREA32

EXCEPTION_READ_FAULT                            equ     0
EXCEPTION_WRITE_FAULT                           equ     1
EXCEPTION_EXECUTE_FAULT                         equ     8

UNWIND_HISTORY_TABLE_SIZE                       equ     12

SidTypeUser                                     equ     1
SidTypeGroup                                    equ     2
SidTypeDomain                                   equ     3
SidTypeAlias                                    equ     4
SidTypeWellKnownGroup                           equ     5
SidTypeDeletedAccount                           equ     6
SidTypeInvalid                                  equ     7
SidTypeUnknown                                  equ     8
SidTypeComputer                                 equ     9

AclRevisionInformation                          equ     1
AclSizeInformation                              equ     2

AuditEventObjectAccess                          equ     0
AuditEventDirectoryServiceAccess                equ     1

SecurityAnonymous                               equ     0
SecurityIdentification                          equ     1
SecurityImpersonation                           equ     2
SecurityDelegation                              equ     3

SECURITY_MAX_IMPERSONATION_LEVEL                equ     SecurityDelegation
SECURITY_MIN_IMPERSONATION_LEVEL                equ     SecurityAnonymous
DEFAULT_IMPERSONATION_LEVEL                     equ     SecurityImpersonation

TokenPrimary                                    equ     1
TokenImpersonation                              equ     2

TokenElevationTypeDefault                       equ     1
TokenElevationTypeFull                          equ     2
TokenElevationTypeLimited                       equ     3

TokenUser                                       equ     1
TokenGroups                                     equ     2
TokenPrivileges                                 equ     3
TokenOwner                                      equ     4
TokenPrimaryGroup                               equ     5
TokenDefaultDacl                                equ     6
TokenSource                                     equ     7
TokenType                                       equ     8
TokenImpersonationLevel                         equ     9
TokenStatistics                                 equ     10
TokenRestrictedSids                             equ     11
TokenSessionId                                  equ     12
TokenGroupsAndPrivileges                        equ     13
TokenSessionReference                           equ     14
TokenSandBoxInert                               equ     15
TokenAuditPolicy                                equ     16
TokenOrigin                                     equ     17
TokenElevationType                              equ     18
TokenLinkedToken                                equ     19
TokenElevation                                  equ     20
TokenHasRestrictions                            equ     21
TokenAccessInformation                          equ     22
TokenVirtualizationAllowed                      equ     23
TokenVirtualizationEnabled                      equ     24
TokenIntegrityLevel                             equ     25
TokenUIAccess                                   equ     26
TokenMandatoryPolicy                            equ     27
TokenLogonSid                                   equ     28
MaxTokenInfoClass                               equ     29

MandatoryLevelUntrusted                         equ     0
MandatoryLevelLow                               equ     1
MandatoryLevelMedium                            equ     2
MandatoryLevelHigh                              equ     3
MandatoryLevelSystem                            equ     4
MandatoryLevelSecureProcess                     equ     5
MandatoryLevelCount                             equ     6

JobObjectBasicAccountingInformation             equ     1
JobObjectBasicLimitInformation                  equ     2
JobObjectBasicProcessIdList                     equ     3
JobObjectBasicUIRestrictions                    equ     4
JobObjectSecurityLimitInformation               equ     5
JobObjectEndOfJobTimeInformation                equ     6
JobObjectAssociateCompletionPortInformation     equ     7
JobObjectBasicAndIoAccountingInformation        equ     8
JobObjectExtendedLimitInformation               equ     9
JobObjectJobSetInformation                      equ     10
MaxJobObjectInfoClass                           equ     11

RelationProcessorCore                           equ     0
RelationNumaNode                                equ     1
RelationCache                                   equ     2
RelationProcessorPackage                        equ     3

CacheUnified                                    equ     0
CacheInstruction                                equ     1
CacheData                                       equ     2
CacheTrace                                      equ     3

LTP_PC_SMT                                      equ     01H
CACHE_FULLY_ASSOCIATIVE                         equ     0FFH

FLUSH_FLAGS_FILE_DATA_ONLY                      equ     00000001H

LT_DONT_CARE                                    equ     0
LT_LOWEST_LATENCY                               equ     1

DIAGNOSTIC_REASON_VERSION                       equ     0

DIAGNOSTIC_REASON_SIMPLE_STRING                 equ     00000001H
DIAGNOSTIC_REASON_DETAILED_STRING               equ     00000002H
DIAGNOSTIC_REASON_NOT_SPECIFIED                 equ     80000000H
DIAGNOSTIC_REASON_INVALID_FLAGS                 equ     (NOT 80000003H)

POWER_REQUEST_CONTEXT_VERSION                   equ     0

POWER_REQUEST_CONTEXT_SIMPLE_STRING             equ     00000001H
POWER_REQUEST_CONTEXT_DETAILED_STRING           equ     00000002H

PowerRequestDisplayRequired                     equ     0
PowerRequestSystemRequired                      equ     1
PowerRequestAwayModeRequired                    equ     2
PowerRequestMaximum                             equ     3

PowerSystemUnspecified                          equ     0
PowerSystemWorking                              equ     1
PowerSystemSleeping1                            equ     2
PowerSystemSleeping2                            equ     3
PowerSystemSleeping3                            equ     4
PowerSystemHibernate                            equ     5
PowerSystemShutdown                             equ     6
PowerSystemMaximum                              equ     7

PowerActionNone                                 equ     0
PowerActionReserved                             equ     1
PowerActionSleep                                equ     2
PowerActionHibernate                            equ     3
PowerActionShutdown                             equ     4
PowerActionShutdownReset                        equ     5
PowerActionShutdownOff                          equ     6
PowerActionWarmEject                            equ     7

PowerDeviceUnspecified                          equ     0
PowerDeviceD0                                   equ     1
PowerDeviceD1                                   equ     2
PowerDeviceD2                                   equ     3
PowerDeviceD3                                   equ     4
PowerDeviceMaximum                              equ     5

PDCAP_D0_SUPPORTED                              equ     00000001H
PDCAP_D1_SUPPORTED                              equ     00000002H
PDCAP_D2_SUPPORTED                              equ     00000004H
PDCAP_D3_SUPPORTED                              equ     00000008H
PDCAP_WAKE_FROM_D0_SUPPORTED                    equ     00000010H
PDCAP_WAKE_FROM_D1_SUPPORTED                    equ     00000020H
PDCAP_WAKE_FROM_D2_SUPPORTED                    equ     00000040H
PDCAP_WAKE_FROM_D3_SUPPORTED                    equ     00000080H
PDCAP_WARM_EJECT_SUPPORTED                      equ     00000100H

SystemPowerPolicyAc                             equ     0
SystemPowerPolicyDc                             equ     1
VerifySystemPolicyAc                            equ     2
VerifySystemPolicyDc                            equ     3
SystemPowerCapabilities                         equ     4
SystemBatteryState                              equ     5
SystemPowerStateHandler                         equ     6
ProcessorStateHandler                           equ     7
SystemPowerPolicyCurrent                        equ     8
AdministratorPowerPolicy                        equ     9
SystemReserveHiberFile                          equ     10
ProcessorInformation                            equ     11
SystemPowerInformation                          equ     12
ProcessorStateHandler2                          equ     13
LastWakeTime                                    equ     14
LastSleepTime                                   equ     15
SystemExecutionState                            equ     16
SystemPowerStateNotifyHandler                   equ     17
ProcessorPowerPolicyAc                          equ     18
ProcessorPowerPolicyDc                          equ     19
VerifyProcessorPowerPolicyAc                    equ     20
VerifyProcessorPowerPolicyDc                    equ     21
ProcessorPowerPolicyCurrent                     equ     22
SystemPowerStateLogging                         equ     23
SystemPowerLoggingEntry                         equ     24
SetPowerSettingValue                            equ     25
NotifyUserPowerSetting                          equ     26
PowerInformationLevelUnused0                    equ     27
PowerInformationLevelUnused1                    equ     28
SystemVideoState                                equ     29
TraceApplicationPowerMessage                    equ     30
TraceApplicationPowerMessageEnd                 equ     31
ProcessorPerfStates                             equ     32
ProcessorIdleStates                             equ     33
ProcessorCap                                    equ     34
SystemWakeSource                                equ     35
SystemHiberFileInformation                      equ     36
TraceServicePowerMessage                        equ     37
ProcessorLoad                                   equ     38
PowerShutdownNotification                       equ     39
MonitorCapabilities                             equ     40
SessionPowerInit                                equ     41
SessionDisplayState                             equ     42
PowerRequestCreate                              equ     43
PowerRequestAction                              equ     44
GetPowerRequestList                             equ     45
ProcessorInformationEx                          equ     46
NotifyUserModeLegacyPowerEvent                  equ     47
GroupPark                                       equ     48
ProcessorIdleDomains                            equ     49
WakeTimerList                                   equ     50
SystemHiberFileSize                             equ     51
PowerInformationLevelMaximum                    equ     52

PO_TRANSITION_VETO_TYPE_WINDOW                  equ     00000001H
PO_TRANSITION_VETO_TYPE_SERVICE                 equ     00000002H
PO_TRANSITION_VETO_TYPE_DRIVER                  equ     00000004H

PO_TRANSITION_VETO_TYPE_ALL                     equ     (PO_TRANSITION_VETO_TYPE_WINDOW or PO_TRANSITION_VETO_TYPE_SERVICE)

PoAc                                            equ     0
PoDc                                            equ     1
PoHot                                           equ     2
PoConditionMaximum                              equ     3

POWER_SETTING_VALUE_VERSION                     equ     01H

PlatformRoleUnspecified                         equ     0
PlatformRoleDesktop                             equ     1
PlatformRoleMobile                              equ     2
PlatformRoleWorkstation                         equ     3
PlatformRoleEnterpriseServer                    equ     4
PlatformRoleSOHOServer                          equ     5
PlatformRoleAppliancePC                         equ     6
PlatformRolePerformanceServer                   equ     7
PlatformRoleSlate                               equ     8
PlatformRoleMaximum                             equ     9

POWER_PLATFORM_ROLE_V1                          equ     1
POWER_PLATFORM_ROLE_V1_MAX                      equ     8

POWER_PLATFORM_ROLE_V2                          equ     2
POWER_PLATFORM_ROLE_V2_MAX                      equ     9

if (NTDDI_VERSION >= NTDDI_WIN8)
    POWER_PLATFORM_ROLE_VERSION                 equ     POWER_PLATFORM_ROLE_V2
    POWER_PLATFORM_ROLE_VERSION_MAX             equ     POWER_PLATFORM_ROLE_V2_MAX
else
    POWER_PLATFORM_ROLE_VERSION                 equ     POWER_PLATFORM_ROLE_V1
    POWER_PLATFORM_ROLE_VERSION_MAX             equ     POWER_PLATFORM_ROLE_V1_MAX
end if

DeviceWakeSourceType                            equ     0
FixedWakeSourceType                             equ     1

FixedWakeSourcePowerButton                      equ     0
FixedWakeSourceSleepButton                      equ     1
FixedWakeSourceRtc                              equ     2

PROC_IDLE_BUCKET_COUNT                          equ     6

ACPI_PPM_SOFTWARE_ALL                           equ     0FCH
ACPI_PPM_SOFTWARE_ANY                           equ     0FDH
ACPI_PPM_HARDWARE_ALL                           equ     0FEH
MS_PPM_SOFTWARE_ALL                             equ     01H

POWER_ACTION_QUERY_ALLOWED                      equ     00000001H
POWER_ACTION_UI_ALLOWED                         equ     00000002H
POWER_ACTION_OVERRIDE_APPS                      equ     00000004H
POWER_ACTION_PSEUDO_TRANSITION                  equ     08000000H
POWER_ACTION_LIGHTEST_FIRST                     equ     10000000H
POWER_ACTION_LOCK_CONSOLE                       equ     20000000H
POWER_ACTION_DISABLE_WAKES                      equ     40000000H
POWER_ACTION_CRITICAL                           equ     80000000H

POWER_LEVEL_USER_NOTIFY_TEXT                    equ     00000001H
POWER_LEVEL_USER_NOTIFY_SOUND                   equ     00000002H
POWER_LEVEL_USER_NOTIFY_EXEC                    equ     00000004H
POWER_USER_NOTIFY_BUTTON                        equ     00000008H
POWER_USER_NOTIFY_SHUTDOWN                      equ     00000010H
POWER_FORCE_TRIGGER_RESET                       equ     80000000H

BATTERY_DISCHARGE_FLAGS_EVENTCODE_MASK          equ     00000007H
BATTERY_DISCHARGE_FLAGS_ENABLE                  equ     80000000H

NUM_DISCHARGE_POLICIES                          equ     4
DISCHARGE_POLICY_CRITICAL                       equ     0
DISCHARGE_POLICY_LOW                            equ     1

PROCESSOR_IDLESTATE_POLICY_COUNT                equ     03H

PO_THROTTLE_NONE                                equ     0
PO_THROTTLE_CONSTANT                            equ     1
PO_THROTTLE_DEGRADE                             equ     2
PO_THROTTLE_ADAPTIVE                            equ     3
PO_THROTTLE_MAXIMUM                             equ     4

PERFSTATE_POLICY_CHANGE_IDEAL                   equ     00H
PERFSTATE_POLICY_CHANGE_SINGLE                  equ     01H
PERFSTATE_POLICY_CHANGE_ROCKET                  equ     02H
PERFSTATE_POLICY_CHANGE_MAX                     equ     PERFSTATE_POLICY_CHANGE_ROCKET

ACTIVATION_CONTEXT_SECTION_ASSEMBLY_INFORMATION equ     1
ACTIVATION_CONTEXT_SECTION_DLL_REDIRECTION      equ     2
ACTIVATION_CONTEXT_SECTION_WINDOW_CLASS_REDIRECTION equ 3
ACTIVATION_CONTEXT_SECTION_COM_SERVER_REDIRECTION equ   4
ACTIVATION_CONTEXT_SECTION_COM_INTERFACE_REDIRECTION equ 5
ACTIVATION_CONTEXT_SECTION_COM_TYPE_LIBRARY_REDIRECTION equ 6
ACTIVATION_CONTEXT_SECTION_COM_PROGID_REDIRECTION equ   7
ACTIVATION_CONTEXT_SECTION_GLOBAL_OBJECT_RENAME_TABLE equ 8
ACTIVATION_CONTEXT_SECTION_CLR_SURROGATES       equ     9
ACTIVATION_CONTEXT_SECTION_APPLICATION_SETTINGS equ     10
ACTIVATION_CONTEXT_SECTION_COMPATIBILITY_INFO   equ     11

IMAGE_SCN_TYPE_REG                              equ     00000000H
IMAGE_SCN_TYPE_DSECT                            equ     00000001H
IMAGE_SCN_TYPE_NOLOAD                           equ     00000002H
IMAGE_SCN_TYPE_GROUP                            equ     00000004H
IMAGE_SCN_TYPE_NO_PAD                           equ     00000008H
IMAGE_SCN_TYPE_COPY                             equ     00000010H

IMAGE_SCN_CNT_CODE                              equ     00000020H
IMAGE_SCN_CNT_INITIALIZED_DATA                  equ     00000040H
IMAGE_SCN_CNT_UNINITIALIZED_DATA                equ     00000080H

IMAGE_SCN_LNK_OTHER                             equ     00000100H
IMAGE_SCN_LNK_INFO                              equ     00000200H
IMAGE_SCN_TYPE_OVER                             equ     00000400H
IMAGE_SCN_LNK_REMOVE                            equ     00000800H
IMAGE_SCN_LNK_COMDAT                            equ     00001000H

IMAGE_SCN_NO_DEFER_SPEC_EXC                     equ     00004000H
IMAGE_SCN_GPREL                                 equ     00008000H
IMAGE_SCN_MEM_FARDATA                           equ     00008000H
IMAGE_SCN_MEM_PURGEABLE                         equ     00020000H
IMAGE_SCN_MEM_16BIT                             equ     00020000H
IMAGE_SCN_MEM_LOCKED                            equ     00040000H
IMAGE_SCN_MEM_PRELOAD                           equ     00080000H

IMAGE_SCN_ALIGN_1BYTES                          equ     00100000H
IMAGE_SCN_ALIGN_2BYTES                          equ     00200000H
IMAGE_SCN_ALIGN_4BYTES                          equ     00300000H
IMAGE_SCN_ALIGN_8BYTES                          equ     00400000H
IMAGE_SCN_ALIGN_16BYTES                         equ     00500000H
IMAGE_SCN_ALIGN_32BYTES                         equ     00600000H
IMAGE_SCN_ALIGN_64BYTES                         equ     00700000H
IMAGE_SCN_ALIGN_128BYTES                        equ     00800000H
IMAGE_SCN_ALIGN_256BYTES                        equ     00900000H
IMAGE_SCN_ALIGN_512BYTES                        equ     00A00000H
IMAGE_SCN_ALIGN_1024BYTES                       equ     00B00000H
IMAGE_SCN_ALIGN_2048BYTES                       equ     00C00000H
IMAGE_SCN_ALIGN_4096BYTES                       equ     00D00000H
IMAGE_SCN_ALIGN_8192BYTES                       equ     00E00000H
IMAGE_SCN_ALIGN_MASK                            equ     00F00000H

IMAGE_SCN_LNK_NRELOC_OVFL                       equ     01000000H
IMAGE_SCN_MEM_DISCARDABLE                       equ     02000000H
IMAGE_SCN_MEM_NOT_CACHED                        equ     04000000H
IMAGE_SCN_MEM_NOT_PAGED                         equ     08000000H
IMAGE_SCN_MEM_SHARED                            equ     10000000H
IMAGE_SCN_MEM_EXECUTE                           equ     20000000H
IMAGE_SCN_MEM_READ                              equ     40000000H
IMAGE_SCN_MEM_WRITE                             equ     80000000H

IMAGE_SCN_SCALE_INDEX                           equ     00000001H

IMAGE_AUX_SYMBOL_TYPE_TOKEN_DEF                 equ     1

IMAGE_SIZEOF_ARCHIVE_MEMBER_HDR                 equ     60

IMPORT_OBJECT_CODE                              equ     0
IMPORT_OBJECT_DATA                              equ     1
IMPORT_OBJECT_CONST                             equ     2

IMPORT_OBJECT_ORDINAL                           equ     0
IMPORT_OBJECT_NAME                              equ     1
IMPORT_OBJECT_NAME_NO_PREFIX                    equ     2
IMPORT_OBJECT_NAME_UNDECORATE                   equ     3

RTL_CRITICAL_SECTION_FLAG_NO_DEBUG_INFO         equ     001000000H
RTL_CRITICAL_SECTION_FLAG_DYNAMIC_SPIN          equ     002000000H
RTL_CRITICAL_SECTION_FLAG_STATIC_INIT           equ     004000000H
RTL_CRITICAL_SECTION_FLAG_RESOURCE_TYPE         equ     008000000H
RTL_CRITICAL_SECTION_FLAG_FORCE_DEBUG_INFO      equ     010000000H
RTL_CRITICAL_SECTION_ALL_FLAG_BITS              equ     0FF000000H
RTL_CRITICAL_SECTION_FLAG_RESERVED              equ     RTL_CRITICAL_SECTION_ALL_FLAG_BITS and (NOT (RTL_CRITICAL_SECTION_FLAG_NO_DEBUG_INFO or RTL_CRITICAL_SECTION_FLAG_DYNAMIC_SPIN or RTL_CRITICAL_SECTION_FLAG_RESOURCE_TYPE or RTL_CRITICAL_SECTION_FLAG_FORCE_DEBUG_INFO))
RTL_CRITICAL_SECTION_DEBUG_FLAG_STATIC_INIT     equ     000000001H

RTL_SRWLOCK_INIT                                equ     0

RTL_CONDITION_VARIABLE_INIT                     equ     00H
RTL_CONDITION_VARIABLE_LOCKMODE_SHARED          equ     01H

ACTIVATION_CONTEXT_PATH_TYPE_NONE               equ     1
ACTIVATION_CONTEXT_PATH_TYPE_WIN32_FILE         equ     2
ACTIVATION_CONTEXT_PATH_TYPE_URL                equ     3
ACTIVATION_CONTEXT_PATH_TYPE_ASSEMBLYREF        equ     4

ACTCTX_RUN_LEVEL_UNSPECIFIED                    equ     0
ACTCTX_RUN_LEVEL_AS_INVOKER                     equ     1
ACTCTX_RUN_LEVEL_HIGHEST_AVAILABLE              equ     2
ACTCTX_RUN_LEVEL_REQUIRE_ADMIN                  equ     3
ACTCTX_RUN_LEVEL_NUMBERS                        equ     4

MAX_SUPPORTED_OS_NUM                            equ     4

TRANSACTION_MANAGER_VOLATILE                    equ     000000001H
TRANSACTION_MANAGER_COMMIT_DEFAULT              equ     000000000H
TRANSACTION_MANAGER_COMMIT_SYSTEM_VOLUME        equ     000000002H
TRANSACTION_MANAGER_COMMIT_SYSTEM_HIVES         equ     000000004H
TRANSACTION_MANAGER_COMMIT_LOWEST               equ     000000008H
TRANSACTION_MANAGER_CORRUPT_FOR_RECOVERY        equ     000000010H
TRANSACTION_MANAGER_CORRUPT_FOR_PROGRESS        equ     000000020H
TRANSACTION_MANAGER_MAXIMUM_OPTION              equ     00000003FH

TRANSACTION_DO_NOT_PROMOTE                      equ     000000001H
TRANSACTION_MAXIMUM_OPTION                      equ     000000001H

TRANSACTION_NOTIFY_MASK                         equ     03FFFFFFFH
TRANSACTION_NOTIFY_PREPREPARE                   equ     000000001H
TRANSACTION_NOTIFY_PREPARE                      equ     000000002H
TRANSACTION_NOTIFY_COMMIT                       equ     000000004H
TRANSACTION_NOTIFY_ROLLBACK                     equ     000000008H
TRANSACTION_NOTIFY_PREPREPARE_COMPLETE          equ     000000010H
TRANSACTION_NOTIFY_PREPARE_COMPLETE             equ     000000020H
TRANSACTION_NOTIFY_COMMIT_COMPLETE              equ     000000040H
TRANSACTION_NOTIFY_ROLLBACK_COMPLETE            equ     000000080H
TRANSACTION_NOTIFY_RECOVER                      equ     000000100H
TRANSACTION_NOTIFY_SINGLE_PHASE_COMMIT          equ     000000200H
TRANSACTION_NOTIFY_DELEGATE_COMMIT              equ     000000400H
TRANSACTION_NOTIFY_RECOVER_QUERY                equ     000000800H
TRANSACTION_NOTIFY_ENLIST_PREPREPARE            equ     000001000H
TRANSACTION_NOTIFY_LAST_RECOVER                 equ     000002000H
TRANSACTION_NOTIFY_INDOUBT                      equ     000004000H
TRANSACTION_NOTIFY_PROPAGATE_PULL               equ     000008000H
TRANSACTION_NOTIFY_PROPAGATE_PUSH               equ     000010000H
TRANSACTION_NOTIFY_MARSHAL                      equ     000020000H
TRANSACTION_NOTIFY_ENLIST_MASK                  equ     000040000H
TRANSACTION_NOTIFY_RM_DISCONNECTED              equ     001000000H
TRANSACTION_NOTIFY_TM_ONLINE                    equ     002000000H
TRANSACTION_NOTIFY_COMMIT_REQUEST               equ     004000000H
TRANSACTION_NOTIFY_PROMOTE                      equ     008000000H
TRANSACTION_NOTIFY_PROMOTE_NEW                  equ     010000000H
TRANSACTION_NOTIFY_REQUEST_OUTCOME              equ     020000000H
TRANSACTION_NOTIFY_COMMIT_FINALIZE              equ     040000000H

TRANSACTIONMANAGER_QUERY_INFORMATION            equ     00001H
TRANSACTIONMANAGER_SET_INFORMATION              equ     00002H
TRANSACTIONMANAGER_RECOVER                      equ     00004H
TRANSACTIONMANAGER_RENAME                       equ     00008H
TRANSACTIONMANAGER_CREATE_RM                    equ     00010H
TRANSACTIONMANAGER_BIND_TRANSACTION             equ     00020H
TRANSACTIONMANAGER_GENERIC_READ                 equ     (STANDARD_RIGHTS_READ or TRANSACTIONMANAGER_QUERY_INFORMATION)
TRANSACTIONMANAGER_GENERIC_WRITE                equ     (STANDARD_RIGHTS_WRITE or TRANSACTIONMANAGER_SET_INFORMATION or \
                                                        TRANSACTIONMANAGER_RECOVER or TRANSACTIONMANAGER_RENAME or \
                                                        TRANSACTIONMANAGER_CREATE_RM)
TRANSACTIONMANAGER_GENERIC_EXECUTE              equ     STANDARD_RIGHTS_EXECUTE
TRANSACTIONMANAGER_ALL_ACCESS                   equ     (STANDARD_RIGHTS_REQUIRED or TRANSACTIONMANAGER_GENERIC_READ or \
                                                        TRANSACTIONMANAGER_GENERIC_WRITE or TRANSACTIONMANAGER_GENERIC_EXECUTE or \
                                                        TRANSACTIONMANAGER_BIND_TRANSACTION)

TRANSACTION_QUERY_INFORMATION                   equ     00001H
TRANSACTION_SET_INFORMATION                     equ     00002H
TRANSACTION_ENLIST                              equ     00004H
TRANSACTION_COMMIT                              equ     00008H
TRANSACTION_ROLLBACK                            equ     00010H
TRANSACTION_PROPAGATE                           equ     00020H
TRANSACTION_RIGHT_RESERVED1                     equ     00040H

TRANSACTION_GENERIC_READ                        equ     (STANDARD_RIGHTS_READ or TRANSACTION_QUERY_INFORMATION or SYNCHRONIZE)
TRANSACTION_GENERIC_WRITE                       equ     (STANDARD_RIGHTS_WRITE or TRANSACTION_SET_INFORMATION or \
                                                        TRANSACTION_COMMIT or TRANSACTION_ENLIST or TRANSACTION_ROLLBACK or \
                                                        TRANSACTION_PROPAGATE or SYNCHRONIZE)
TRANSACTION_GENERIC_EXECUTE                     equ     (STANDARD_RIGHTS_EXECUTE or TRANSACTION_COMMIT or \
                                                        TRANSACTION_ROLLBACK or SYNCHRONIZE)
TRANSACTION_ALL_ACCESS                          equ     (STANDARD_RIGHTS_REQUIRED or TRANSACTION_GENERIC_READ or \
                                                        TRANSACTION_GENERIC_WRITE or TRANSACTION_GENERIC_EXECUTE)
TRANSACTION_RESOURCE_MANAGER_RIGHTS             equ     (TRANSACTION_GENERIC_READ or STANDARD_RIGHTS_WRITE or \
                                                        TRANSACTION_SET_INFORMATION or TRANSACTION_ENLIST or \
                                                        TRANSACTION_ROLLBACK or TRANSACTION_PROPAGATE or SYNCHRONIZE)

RESOURCEMANAGER_QUERY_INFORMATION               equ     00001H
RESOURCEMANAGER_SET_INFORMATION                 equ     00002H
RESOURCEMANAGER_RECOVER                         equ     00004H
RESOURCEMANAGER_ENLIST                          equ     00008H
RESOURCEMANAGER_GET_NOTIFICATION                equ     00010H
RESOURCEMANAGER_REGISTER_PROTOCOL               equ     00020H
RESOURCEMANAGER_COMPLETE_PROPAGATION            equ     00040H

RESOURCEMANAGER_GENERIC_READ                    equ     (STANDARD_RIGHTS_READ or RESOURCEMANAGER_QUERY_INFORMATION or SYNCHRONIZE)
RESOURCEMANAGER_GENERIC_WRITEA                  equ     (STANDARD_RIGHTS_WRITE or RESOURCEMANAGER_SET_INFORMATION or \
                                                        RESOURCEMANAGER_RECOVER or RESOURCEMANAGER_ENLIST or \
                                                        RESOURCEMANAGER_GET_NOTIFICATION or RESOURCEMANAGER_REGISTER_PROTOCOL)
RESOURCEMANAGER_GENERIC_WRITEB                  equ     (RESOURCEMANAGER_COMPLETE_PROPAGATION or SYNCHRONIZE)
RESOURCEMANAGER_GENERIC_WRITE                   equ     (RESOURCEMANAGER_GENERIC_WRITEA or RESOURCEMANAGER_GENERIC_WRITEB)
RESOURCEMANAGER_GENERIC_EXECUTE                 equ     (STANDARD_RIGHTS_EXECUTE or RESOURCEMANAGER_RECOVER or \
                                                        RESOURCEMANAGER_ENLIST or RESOURCEMANAGER_GET_NOTIFICATION or \
                                                        RESOURCEMANAGER_COMPLETE_PROPAGATION or SYNCHRONIZE)
RESOURCEMANAGER_ALL_ACCESS                      equ     (STANDARD_RIGHTS_REQUIRED or RESOURCEMANAGER_GENERIC_READ or \
                                                        RESOURCEMANAGER_GENERIC_WRITE or RESOURCEMANAGER_GENERIC_EXECUTE)

RESOURCE_MANAGER_VOLATILE                       equ     000000001H
RESOURCE_MANAGER_COMMUNICATION                  equ     000000002H
RESOURCE_MANAGER_MAXIMUM_OPTION                 equ     000000003H

ENLISTMENT_QUERY_INFORMATION                    equ     00001H
ENLISTMENT_SET_INFORMATION                      equ     00002H
ENLISTMENT_RECOVER                              equ     00004H
ENLISTMENT_SUBORDINATE_RIGHTS                   equ     00008H
ENLISTMENT_SUPERIOR_RIGHTS                      equ     00010H
ENLISTMENT_GENERIC_READ                         equ     (STANDARD_RIGHTS_READ or ENLISTMENT_QUERY_INFORMATION)
ENLISTMENT_GENERIC_WRITE                        equ     (STANDARD_RIGHTS_WRITE or ENLISTMENT_SET_INFORMATION or \
                                                        ENLISTMENT_RECOVER or ENLISTMENT_SUBORDINATE_RIGHTS or \
                                                        ENLISTMENT_SUPERIOR_RIGHTS)
ENLISTMENT_GENERIC_EXECUTE                      equ     (STANDARD_RIGHTS_EXECUTE or ENLISTMENT_RECOVER or \
                                                        ENLISTMENT_SUBORDINATE_RIGHTS or ENLISTMENT_SUPERIOR_RIGHTS)
ENLISTMENT_ALL_ACCESS                           equ     (STANDARD_RIGHTS_REQUIRED or ENLISTMENT_GENERIC_READ or \
                                                        ENLISTMENT_GENERIC_WRITE or ENLISTMENT_GENERIC_EXECUTE)

CRM_PROTOCOL_EXPLICIT_MARSHAL_ONLY              equ     000000001H
CRM_PROTOCOL_DYNAMIC_MARSHAL_INFO               equ     000000002H
CRM_PROTOCOL_MAXIMUM_OPTION                     equ     000000003H

ENLISTMENT_SUPERIOR equ     000000001H
ENLISTMENT_MAXIMUM_OPTION                       equ     000000001H

KTM_MARSHAL_BLOB_VERSION_MAJOR                  equ     1
KTM_MARSHAL_BLOB_VERSION_MINOR                  equ     1
MAX_TRANSACTION_DESCRIPTION_LENGTH              equ     64
MAX_RESOURCEMANAGER_DESCRIPTION_LENGTH          equ     64

COMIMAGE_FLAGS_ILONLY                           equ     00000001H
COMIMAGE_FLAGS_32BITREQUIRED                    equ     00000002H
COMIMAGE_FLAGS_IL_LIBRARY                       equ     00000004H
COMIMAGE_FLAGS_STRONGNAMESIGNED                 equ     00000008H
COMIMAGE_FLAGS_NATIVE_ENTRYPOINT                equ     00000010H
COMIMAGE_FLAGS_TRACKDEBUGDATA                   equ     00010000H
COR_VERSION_MAJOR_V2                            equ     2
COR_VERSION_MAJOR                               equ     2
COR_VERSION_MINOR                               equ     5
COR_DELETED_NAME_LENGTH                         equ     8
COR_VTABLEGAP_NAME_LENGTH                       equ     8
NATIVE_TYPE_MAX_CB                              equ     1
COR_ILMETHOD_SECT_SMALL_MAX_DATASIZE            equ     0FFH
IMAGE_COR_MIH_METHODRVA                         equ     01H
IMAGE_COR_MIH_EHRVA                             equ     02H
IMAGE_COR_MIH_BASICBLOCK                        equ     08H
COR_VTABLE_32BIT                                equ     01H
COR_VTABLE_64BIT                                equ     02H
COR_VTABLE_FROM_UNMANAGED                       equ     04H
COR_VTABLE_FROM_UNMANAGED_RETAIN_APPDOMAIN      equ     08H
COR_VTABLE_CALL_MOST_DERIVED                    equ     10H
IMAGE_COR_EATJ_THUNK_SIZE                       equ     20H
MAX_CLASS_NAME                                  equ     1024
MAX_PACKAGE_NAME                                equ     1024

if (NTDDI_VERSION >= NTDDI_WIN8)
    VRL_PREDEFINED_CLASS_BEGIN                  equ     (1 shl 0)
    VRL_CUSTOM_CLASS_BEGIN                      equ     (1 shl 8)
    VRL_CLASS_CONSISTENCY                       equ     (VRL_PREDEFINED_CLASS_BEGIN shl 0)
    VRL_ENABLE_KERNEL_BREAKS                    equ     (1 shl 31)

    CTMF_INCLUDE_APPCONTAINER                   equ     000000001H
    CTMF_VALID_FLAGS                            equ     CTMF_INCLUDE_APPCONTAINER
end if

if (NTDDI_VERSION > NTDDI_WIN8)
    HEAP_OPTIMIZE_RESOURCES_CURRENT_VERSION     equ     1

    struct HEAP_OPTIMIZE_RESOURCES_INFORMATION
        Version dd ?
        Flags   dd ?
    ends
end if

RTL_RUN_ONCE_INIT                               equ     0
RTL_RUN_ONCE_CHECK_ONLY                         equ     000000001H
RTL_RUN_ONCE_ASYNC                              equ     000000002H
RTL_RUN_ONCE_INIT_FAILED                        equ     000000004H

RTL_RUN_ONCE_CTX_RESERVED_BITS                  equ     2

IMAGE_BASE                                      equ     400000H

;========================================  Functions ======================================;
if defined APP_WIN64
    import kernel32,\
    __C_specific_handler,'__C_specific_handler',\
    __chkstk,'__chkstk',\
    _hread,'_hread',\
    _hwrite,'_hwrite',\
    _lclose,'_lclose',\
    _lcreat,'_lcreat',\
    _llseek,'_llseek',\
    _lopen,'_lopen',\
    _lread,'_lread',\
    _lwrite,'_lwrite',\
    AcquireSRWLockExclusive,'AcquireSRWLockExclusive',\
    AcquireSRWLockShared,'AcquireSRWLockShared',\
    AcquireStateLock,'AcquireStateLock',\
    ActivateActCtx,'ActivateActCtx',\
    AddAtomA,'AddAtomA',\
    AddAtomW,'AddAtomW',\
    AddConsoleAliasA,'AddConsoleAliasA',\
    AddConsoleAliasW,'AddConsoleAliasW',\
    AddDllDirectory,'AddDllDirectory',\
    AddIntegrityLabelToBoundaryDescriptor,'AddIntegrityLabelToBoundaryDescriptor',\
    AddLocalAlternateComputerNameA,'AddLocalAlternateComputerNameA',\
    AddLocalAlternateComputerNameW,'AddLocalAlternateComputerNameW',\
    AddRefActCtx,'AddRefActCtx',\
    AddResourceAttributeAce,'AddResourceAttributeAce',\
    AddScopedPolicyIDAce,'AddScopedPolicyIDAce',\
    AddSecureMemoryCacheCallback,'AddSecureMemoryCacheCallback',\
    AddSIDToBoundaryDescriptor,'AddSIDToBoundaryDescriptor',\
    AddVectoredContinueHandler,'AddVectoredContinueHandler',\
    AddVectoredExceptionHandler,'AddVectoredExceptionHandler',\
    AdjustCalendarDate,'AdjustCalendarDate',\
    AllocateUserPhysicalPages,'AllocateUserPhysicalPages',\
    AllocateUserPhysicalPagesNuma,'AllocateUserPhysicalPagesNuma',\
    AllocConsole,'AllocConsole',\
    ApplicationRecoveryFinished,'ApplicationRecoveryFinished',\
    ApplicationRecoveryInProgress,'ApplicationRecoveryInProgress',\
    AreFileApisANSI,'AreFileApisANSI',\
    AssignProcessToJobObject,'AssignProcessToJobObject',\
    AttachConsole,'AttachConsole',\
    BackupRead,'BackupRead',\
    BackupSeek,'BackupSeek',\
    BackupWrite,'BackupWrite',\
    BaseFormatTimeOut,'BaseFormatTimeOut',\
    BaseGetNamedObjectDirectory,'BaseGetNamedObjectDirectory',\
    Basep8BitStringToDynamicUnicodeString,'Basep8BitStringToDynamicUnicodeString',\
    Beep,'Beep',\
    BeginUpdateResourceA,'BeginUpdateResourceA',\
    BeginUpdateResourceW,'BeginUpdateResourceW',\
    BindIoCompletionCallback,'BindIoCompletionCallback',\
    BuildCommDCBA,'BuildCommDCBA',\
    BuildCommDCBAndTimeoutsA,'BuildCommDCBAndTimeoutsA',\
    BuildCommDCBAndTimeoutsW,'BuildCommDCBAndTimeoutsW',\
    BuildCommDCBW,'BuildCommDCBW',\
    CallbackMayRunLong,'CallbackMayRunLong',\
    CallNamedPipeA,'CallNamedPipeA',\
    CallNamedPipeW,'CallNamedPipeW',\
    CalloutOnFiberStack,'CalloutOnFiberStack',\
    CancelDeviceWakeupRequest,'CancelDeviceWakeupRequest',\
    CancelIo,'CancelIo',\
    CancelIoEx,'CancelIoEx',\
    CancelSynchronousIo,'CancelSynchronousIo',\
    CancelThreadpoolIo,'CancelThreadpoolIo',\
    CancelWaitableTimer,'CancelWaitableTimer',\
    CeipIsOptedIn,'CeipIsOptedIn',\
    ChangeTimerQueueTimer,'ChangeTimerQueueTimer',\
    CheckElevationEnabled,'CheckElevationEnabled',\
    CheckNameLegalDOS8Dot3A,'CheckNameLegalDOS8Dot3A',\
    CheckNameLegalDOS8Dot3W,'CheckNameLegalDOS8Dot3W',\
    CheckRemoteDebuggerPresent,'CheckRemoteDebuggerPresent',\
    CheckTokenCapability,'CheckTokenCapability',\
    CheckTokenMembershipEx,'CheckTokenMembershipEx',\
    ClearCommBreak,'ClearCommBreak',\
    ClearCommError,'ClearCommError',\
    CloseHandle,'CloseHandle',\
    ClosePackageInfo,'ClosePackageInfo',\
    ClosePrivateNamespace,'ClosePrivateNamespace',\
    CloseProfileUserMapping,'CloseProfileUserMapping',\
    CloseThreadpool,'CloseThreadpool',\
    CloseThreadpoolCleanupGroup,'CloseThreadpoolCleanupGroup',\
    CloseThreadpoolCleanupGroupMembers,'CloseThreadpoolCleanupGroupMembers',\
    CloseThreadpoolIo,'CloseThreadpoolIo',\
    CloseThreadpoolTimer,'CloseThreadpoolTimer',\
    CloseThreadpoolWait,'CloseThreadpoolWait',\
    CloseThreadpoolWork,'CloseThreadpoolWork',\
    CommConfigDialogA,'CommConfigDialogA',\
    CommConfigDialogW,'CommConfigDialogW',\
    CompareFileTime,'CompareFileTime',\
    CompareStringA,'CompareStringA',\
    CompareStringEx,'CompareStringEx',\
    CompareStringOrdinal,'CompareStringOrdinal',\
    CompareStringW,'CompareStringW',\
    ConnectNamedPipe,'ConnectNamedPipe',\
    ConsoleMenuControl,'ConsoleMenuControl',\
    ContinueDebugEvent,'ContinueDebugEvent',\
    ConvertCalDateTimeToSystemTime,'ConvertCalDateTimeToSystemTime',\
    ConvertDefaultLocale,'ConvertDefaultLocale',\
    ConvertFiberToThread,'ConvertFiberToThread',\
    ConvertSystemTimeToCalDateTime,'ConvertSystemTimeToCalDateTime',\
    ConvertThreadToFiber,'ConvertThreadToFiber',\
    ConvertThreadToFiberEx,'ConvertThreadToFiberEx',\
    CopyContext,'CopyContext',\
    CopyExtendedContext,'CopyExtendedContext',\
    CopyFile2,'CopyFile2',\
    CopyFileA,'CopyFileA',\
    CopyFileExA,'CopyFileExA',\
    CopyFileExW,'CopyFileExW',\
    CopyFileTransactedA,'CopyFileTransactedA',\
    CopyFileTransactedW,'CopyFileTransactedW',\
    CopyFileW,'CopyFileW',\
    CreateActCtxA,'CreateActCtxA',\
    CreateActCtxW,'CreateActCtxW',\
    CreateBoundaryDescriptorA,'CreateBoundaryDescriptorA',\
    CreateBoundaryDescriptorW,'CreateBoundaryDescriptorW',\
    CreateConsoleScreenBuffer,'CreateConsoleScreenBuffer',\
    CreateDirectoryA,'CreateDirectoryA',\
    CreateDirectoryExA,'CreateDirectoryExA',\
    CreateDirectoryExW,'CreateDirectoryExW',\
    CreateDirectoryTransactedA,'CreateDirectoryTransactedA',\
    CreateDirectoryTransactedW,'CreateDirectoryTransactedW',\
    CreateDirectoryW,'CreateDirectoryW',\
    CreateEnclave,'CreateEnclave',\
    CreateEventA,'CreateEventA',\
    CreateEventExA,'CreateEventExA',\
    CreateEventExW,'CreateEventExW',\
    CreateEventW,'CreateEventW',\
    CreateFiber,'CreateFiber',\
    CreateFiberEx,'CreateFiberEx',\
    CreateFile2,'CreateFile2',\
    CreateFileA,'CreateFileA',\
    CreateFileMappingA,'CreateFileMappingA',\
    CreateFileMappingFromApp,'CreateFileMappingFromApp',\
    CreateFileMappingNumaA,'CreateFileMappingNumaA',\
    CreateFileMappingNumaW,'CreateFileMappingNumaW',\
    CreateFileMappingW,'CreateFileMappingW',\
    CreateFileTransactedA,'CreateFileTransactedA',\
    CreateFileTransactedW,'CreateFileTransactedW',\
    CreateFileW,'CreateFileW',\
    CreateHardLinkA,'CreateHardLinkA',\
    CreateHardLinkTransactedA,'CreateHardLinkTransactedA',\
    CreateHardLinkTransactedW,'CreateHardLinkTransactedW',\
    CreateHardLinkW,'CreateHardLinkW',\
    CreateIoCompletionPort,'CreateIoCompletionPort',\
    CreateJobObjectA,'CreateJobObjectA',\
    CreateJobObjectW,'CreateJobObjectW',\
    CreateJobSet,'CreateJobSet',\
    CreateMailslotA,'CreateMailslotA',\
    CreateMailslotW,'CreateMailslotW',\
    CreateMemoryResourceNotification,'CreateMemoryResourceNotification',\
    CreateMutexA,'CreateMutexA',\
    CreateMutexExA,'CreateMutexExA',\
    CreateMutexExW,'CreateMutexExW',\
    CreateMutexW,'CreateMutexW',\
    CreateNamedPipeA,'CreateNamedPipeA',\
    CreateNamedPipeW,'CreateNamedPipeW',\
    CreatePipe,'CreatePipe',\
    CreatePrivateNamespaceA,'CreatePrivateNamespaceA',\
    CreatePrivateNamespaceW,'CreatePrivateNamespaceW',\
    CreateProcessA,'CreateProcessA',\
    CreateProcessInternalA,'CreateProcessInternalA',\
    CreateProcessInternalW,'CreateProcessInternalW',\
    CreateProcessW,'CreateProcessW',\
    CreateRemoteThread,'CreateRemoteThread',\
    CreateRemoteThreadEx,'CreateRemoteThreadEx',\
    CreateSemaphoreA,'CreateSemaphoreA',\
    CreateSemaphoreExA,'CreateSemaphoreExA',\
    CreateSemaphoreExW,'CreateSemaphoreExW',\
    CreateSemaphoreW,'CreateSemaphoreW',\
    CreateSymbolicLinkA,'CreateSymbolicLinkA',\
    CreateSymbolicLinkTransactedA,'CreateSymbolicLinkTransactedA',\
    CreateSymbolicLinkTransactedW,'CreateSymbolicLinkTransactedW',\
    CreateSymbolicLinkW,'CreateSymbolicLinkW',\
    CreateTapePartition,'CreateTapePartition',\
    CreateThread,'CreateThread',\
    CreateThreadpool,'CreateThreadpool',\
    CreateThreadpoolCleanupGroup,'CreateThreadpoolCleanupGroup',\
    CreateThreadpoolIo,'CreateThreadpoolIo',\
    CreateThreadpoolTimer,'CreateThreadpoolTimer',\
    CreateThreadpoolWait,'CreateThreadpoolWait',\
    CreateThreadpoolWork,'CreateThreadpoolWork',\
    CreateTimerQueue,'CreateTimerQueue',\
    CreateTimerQueueTimer,'CreateTimerQueueTimer',\
    CreateToolhelp32Snapshot,'CreateToolhelp32Snapshot',\
    CreateUmsCompletionList,'CreateUmsCompletionList',\
    CreateUmsThreadContext,'CreateUmsThreadContext',\
    CreateWaitableTimerA,'CreateWaitableTimerA',\
    CreateWaitableTimerExA,'CreateWaitableTimerExA',\
    CreateWaitableTimerExW,'CreateWaitableTimerExW',\
    CreateWaitableTimerW,'CreateWaitableTimerW',\
    DeactivateActCtx,'DeactivateActCtx',\
    DebugActiveProcess,'DebugActiveProcess',\
    DebugActiveProcessStop,'DebugActiveProcessStop',\
    DebugBreak,'DebugBreak',\
    DebugBreakProcess,'DebugBreakProcess',\
    DebugSetProcessKillOnExit,'DebugSetProcessKillOnExit',\
    DecodePointer,'DecodePointer',\
    DecodeSystemPointer,'DecodeSystemPointer',\
    DefineDosDeviceA,'DefineDosDeviceA',\
    DefineDosDeviceW,'DefineDosDeviceW',\
    DelayLoadFailureHook,'DelayLoadFailureHook',\
    DeleteAtom,'DeleteAtom',\
    DeleteBoundaryDescriptor,'DeleteBoundaryDescriptor',\
    DeleteCriticalSection,'DeleteCriticalSection',\
    DeleteFiber,'DeleteFiber',\
    DeleteFileA,'DeleteFileA',\
    DeleteFileTransactedA,'DeleteFileTransactedA',\
    DeleteFileTransactedW,'DeleteFileTransactedW',\
    DeleteFileW,'DeleteFileW',\
    DeleteProcThreadAttributeList,'DeleteProcThreadAttributeList',\
    DeleteSynchronizationBarrier,'DeleteSynchronizationBarrier',\
    DeleteTimerQueue,'DeleteTimerQueue',\
    DeleteTimerQueueEx,'DeleteTimerQueueEx',\
    DeleteTimerQueueTimer,'DeleteTimerQueueTimer',\
    DeleteUmsCompletionList,'DeleteUmsCompletionList',\
    DeleteUmsThreadContext,'DeleteUmsThreadContext',\
    DeleteVolumeMountPointA,'DeleteVolumeMountPointA',\
    DeleteVolumeMountPointW,'DeleteVolumeMountPointW',\
    DequeueUmsCompletionListItems,'DequeueUmsCompletionListItems',\
    DeviceIoControl,'DeviceIoControl',\
    DisableThreadLibraryCalls,'DisableThreadLibraryCalls',\
    DisableThreadProfiling,'DisableThreadProfiling',\
    DisassociateCurrentThreadFromCallback,'DisassociateCurrentThreadFromCallback',\
    DiscardVirtualMemory,'DiscardVirtualMemory',\
    DisconnectNamedPipe,'DisconnectNamedPipe',\
    DnsHostnameToComputerNameA,'DnsHostnameToComputerNameA',\
    DnsHostnameToComputerNameW,'DnsHostnameToComputerNameW',\
    DosDateTimeToFileTime,'DosDateTimeToFileTime',\
    DosPathToSessionPathA,'DosPathToSessionPathA',\
    DosPathToSessionPathW,'DosPathToSessionPathW',\
    DuplicateConsoleHandle,'DuplicateConsoleHandle',\
    DuplicateHandle,'DuplicateHandle',\
    EnableThreadProfiling,'EnableThreadProfiling',\
    EncodePointer,'EncodePointer',\
    EncodeSystemPointer,'EncodeSystemPointer',\
    EndUpdateResourceA,'EndUpdateResourceA',\
    EndUpdateResourceW,'EndUpdateResourceW',\
    EnterCriticalSection,'EnterCriticalSection',\
    EnterSynchronizationBarrier,'EnterSynchronizationBarrier',\
    EnterUmsSchedulingMode,'EnterUmsSchedulingMode',\
    EnumCalendarInfoA,'EnumCalendarInfoA',\
    EnumCalendarInfoExA,'EnumCalendarInfoExA',\
    EnumCalendarInfoExEx,'EnumCalendarInfoExEx',\
    EnumCalendarInfoExW,'EnumCalendarInfoExW',\
    EnumCalendarInfoW,'EnumCalendarInfoW',\
    EnumDateFormatsA,'EnumDateFormatsA',\
    EnumDateFormatsExA,'EnumDateFormatsExA',\
    EnumDateFormatsExEx,'EnumDateFormatsExEx',\
    EnumDateFormatsExW,'EnumDateFormatsExW',\
    EnumDateFormatsW,'EnumDateFormatsW',\
    EnumerateLocalComputerNamesA,'EnumerateLocalComputerNamesA',\
    EnumerateLocalComputerNamesW,'EnumerateLocalComputerNamesW',\
    EnumLanguageGroupLocalesA,'EnumLanguageGroupLocalesA',\
    EnumLanguageGroupLocalesW,'EnumLanguageGroupLocalesW',\
    EnumResourceLanguagesA,'EnumResourceLanguagesA',\
    EnumResourceLanguagesExA,'EnumResourceLanguagesExA',\
    EnumResourceLanguagesExW,'EnumResourceLanguagesExW',\
    EnumResourceLanguagesW,'EnumResourceLanguagesW',\
    EnumResourceNamesA,'EnumResourceNamesA',\
    EnumResourceNamesExA,'EnumResourceNamesExA',\
    EnumResourceNamesExW,'EnumResourceNamesExW',\
    EnumResourceNamesW,'EnumResourceNamesW',\
    EnumResourceTypesA,'EnumResourceTypesA',\
    EnumResourceTypesExA,'EnumResourceTypesExA',\
    EnumResourceTypesExW,'EnumResourceTypesExW',\
    EnumResourceTypesW,'EnumResourceTypesW',\
    EnumSystemCodePagesA,'EnumSystemCodePagesA',\
    EnumSystemCodePagesW,'EnumSystemCodePagesW',\
    EnumSystemFirmwareTables,'EnumSystemFirmwareTables',\
    EnumSystemGeoID,'EnumSystemGeoID',\
    EnumSystemLanguageGroupsA,'EnumSystemLanguageGroupsA',\
    EnumSystemLanguageGroupsW,'EnumSystemLanguageGroupsW',\
    EnumSystemLocalesA,'EnumSystemLocalesA',\
    EnumSystemLocalesEx,'EnumSystemLocalesEx',\
    EnumSystemLocalesW,'EnumSystemLocalesW',\
    EnumTimeFormatsA,'EnumTimeFormatsA',\
    EnumTimeFormatsEx,'EnumTimeFormatsEx',\
    EnumTimeFormatsW,'EnumTimeFormatsW',\
    EnumUILanguagesA,'EnumUILanguagesA',\
    EnumUILanguagesW,'EnumUILanguagesW',\
    EraseTape,'EraseTape',\
    EscapeCommFunction,'EscapeCommFunction',\
    ExecuteUmsThread,'ExecuteUmsThread',\
    ExitProcess,'ExitProcess',\
    ExitThread,'ExitThread',\
    ExitVDM,'ExitVDM',\
    ExpandEnvironmentStringsA,'ExpandEnvironmentStringsA',\
    ExpandEnvironmentStringsW,'ExpandEnvironmentStringsW',\
    ExpungeConsoleCommandHistoryA,'ExpungeConsoleCommandHistoryA',\
    ExpungeConsoleCommandHistoryW,'ExpungeConsoleCommandHistoryW',\
    FatalAppExitA,'FatalAppExitA',\
    FatalAppExitW,'FatalAppExitW',\
    FatalExit,'FatalExit',\
    FileTimeToDosDateTime,'FileTimeToDosDateTime',\
    FileTimeToLocalFileTime,'FileTimeToLocalFileTime',\
    FileTimeToSystemTime,'FileTimeToSystemTime',\
    FillConsoleOutputAttribute,'FillConsoleOutputAttribute',\
    FillConsoleOutputCharacterA,'FillConsoleOutputCharacterA',\
    FillConsoleOutputCharacterW,'FillConsoleOutputCharacterW',\
    FindActCtxSectionGuid,'FindActCtxSectionGuid',\
    FindActCtxSectionStringA,'FindActCtxSectionStringA',\
    FindActCtxSectionStringW,'FindActCtxSectionStringW',\
    FindAtomA,'FindAtomA',\
    FindAtomW,'FindAtomW',\
    FindClose,'FindClose',\
    FindCloseChangeNotification,'FindCloseChangeNotification',\
    FindFirstChangeNotificationA,'FindFirstChangeNotificationA',\
    FindFirstChangeNotificationW,'FindFirstChangeNotificationW',\
    FindFirstFileA,'FindFirstFileA',\
    FindFirstFileExA,'FindFirstFileExA',\
    FindFirstFileExW,'FindFirstFileExW',\
    FindFirstFileNameTransactedW,'FindFirstFileNameTransactedW',\
    FindFirstFileNameW,'FindFirstFileNameW',\
    FindFirstFileTransactedA,'FindFirstFileTransactedA',\
    FindFirstFileTransactedW,'FindFirstFileTransactedW',\
    FindFirstFileW,'FindFirstFileW',\
    FindFirstStreamTransactedW,'FindFirstStreamTransactedW',\
    FindFirstStreamW,'FindFirstStreamW',\
    FindFirstVolumeA,'FindFirstVolumeA',\
    FindFirstVolumeMountPointA,'FindFirstVolumeMountPointA',\
    FindFirstVolumeMountPointW,'FindFirstVolumeMountPointW',\
    FindFirstVolumeW,'FindFirstVolumeW',\
    FindNextChangeNotification,'FindNextChangeNotification',\
    FindNextFileA,'FindNextFileA',\
    FindNextFileNameW,'FindNextFileNameW',\
    FindNextFileW,'FindNextFileW',\
    FindNextStreamW,'FindNextStreamW',\
    FindNextVolumeA,'FindNextVolumeA',\
    FindNextVolumeMountPointA,'FindNextVolumeMountPointA',\
    FindNextVolumeMountPointW,'FindNextVolumeMountPointW',\
    FindNextVolumeW,'FindNextVolumeW',\
    FindNLSString,'FindNLSString',\
    FindNLSStringEx,'FindNLSStringEx',\
    FindPackagesByPackageFamily,'FindPackagesByPackageFamily',\
    FindResourceA,'FindResourceA',\
    FindResourceExA,'FindResourceExA',\
    FindResourceExW,'FindResourceExW',\
    FindResourceW,'FindResourceW',\
    FindStringOrdinal,'FindStringOrdinal',\
    FindVolumeClose,'FindVolumeClose',\
    FindVolumeMountPointClose,'FindVolumeMountPointClose',\
    FlsAlloc,'FlsAlloc',\
    FlsFree,'FlsFree',\
    FlsGetValue,'FlsGetValue',\
    FlsSetValue,'FlsSetValue',\
    FlushConsoleInputBuffer,'FlushConsoleInputBuffer',\
    FlushFileBuffers,'FlushFileBuffers',\
    FlushInstructionCache,'FlushInstructionCache',\
    FlushProcessWriteBuffers,'FlushProcessWriteBuffers',\
    FlushViewOfFile,'FlushViewOfFile',\
    FoldStringA,'FoldStringA',\
    FoldStringW,'FoldStringW',\
    FormatApplicationUserModelId,'FormatApplicationUserModelId',\
    FormatMessageA,'FormatMessageA',\
    FormatMessageW,'FormatMessageW',\
    FreeConsole,'FreeConsole',\
    FreeEnvironmentStringsA,'FreeEnvironmentStringsA',\
    FreeEnvironmentStringsW,'FreeEnvironmentStringsW',\
    FreeLibrary,'FreeLibrary',\
    FreeLibraryAndExitThread,'FreeLibraryAndExitThread',\
    FreeLibraryWhenCallbackReturns,'FreeLibraryWhenCallbackReturns',\
    FreeMemoryJobObject,'FreeMemoryJobObject',\
    FreeResource,'FreeResource',\
    FreeUserPhysicalPages,'FreeUserPhysicalPages',\
    GenerateConsoleCtrlEvent,'GenerateConsoleCtrlEvent',\
    GetACP,'GetACP',\
    GetActiveProcessorCount,'GetActiveProcessorCount',\
    GetActiveProcessorGroupCount,'GetActiveProcessorGroupCount',\
    GetAppContainerNamedObjectPath,'GetAppContainerNamedObjectPath',\
    GetApplicationRecoveryCallback,'GetApplicationRecoveryCallback',\
    GetApplicationRestartSettings,'GetApplicationRestartSettings',\
    GetApplicationUserModelId,'GetApplicationUserModelId',\
    GetAtomNameA,'GetAtomNameA',\
    GetAtomNameW,'GetAtomNameW',\
    GetBinaryTypeA,'GetBinaryTypeA',\
    GetBinaryTypeW,'GetBinaryTypeW',\
    GetCachedSigningLevel,'GetCachedSigningLevel',\
    GetCalendarDateFormatEx,'GetCalendarDateFormatEx',\
    GetCalendarInfoA,'GetCalendarInfoA',\
    GetCalendarInfoEx,'GetCalendarInfoEx',\
    GetCalendarInfoW,'GetCalendarInfoW',\
    GetCalendarSupportedDateRange,'GetCalendarSupportedDateRange',\
    GetCommandLineA,'GetCommandLineA',\
    GetCommandLineW,'GetCommandLineW',\
    GetCommConfig,'GetCommConfig',\
    GetCommMask,'GetCommMask',\
    GetCommModemStatus,'GetCommModemStatus',\
    GetCommProperties,'GetCommProperties',\
    GetCommState,'GetCommState',\
    GetCommTimeouts,'GetCommTimeouts',\
    GetComPlusPackageInstallStatus,'GetComPlusPackageInstallStatus',\
    GetCompressedFileSizeA,'GetCompressedFileSizeA',\
    GetCompressedFileSizeTransactedA,'GetCompressedFileSizeTransactedA',\
    GetCompressedFileSizeTransactedW,'GetCompressedFileSizeTransactedW',\
    GetCompressedFileSizeW,'GetCompressedFileSizeW',\
    GetComputerNameA,'GetComputerNameA',\
    GetComputerNameExA,'GetComputerNameExA',\
    GetComputerNameExW,'GetComputerNameExW',\
    GetComputerNameW,'GetComputerNameW',\
    GetConsoleAliasA,'GetConsoleAliasA',\
    GetConsoleAliasesA,'GetConsoleAliasesA',\
    GetConsoleAliasesLengthA,'GetConsoleAliasesLengthA',\
    GetConsoleAliasesLengthW,'GetConsoleAliasesLengthW',\
    GetConsoleAliasesW,'GetConsoleAliasesW',\
    GetConsoleAliasExesA,'GetConsoleAliasExesA',\
    GetConsoleAliasExesLengthA,'GetConsoleAliasExesLengthA',\
    GetConsoleAliasExesLengthW,'GetConsoleAliasExesLengthW',\
    GetConsoleAliasExesW,'GetConsoleAliasExesW',\
    GetConsoleAliasW,'GetConsoleAliasW',\
    GetConsoleCP,'GetConsoleCP',\
    GetConsoleCursorInfo,'GetConsoleCursorInfo',\
    GetConsoleDisplayMode,'GetConsoleDisplayMode',\
    GetConsoleFontInfo,'GetConsoleFontInfo',\
    GetConsoleFontSize,'GetConsoleFontSize',\
    GetConsoleHistoryInfo,'GetConsoleHistoryInfo',\
    GetConsoleMode,'GetConsoleMode',\
    GetConsoleNlsMode,'GetConsoleNlsMode',\
    GetConsoleOriginalTitleA,'GetConsoleOriginalTitleA',\
    GetConsoleOriginalTitleW,'GetConsoleOriginalTitleW',\
    GetConsoleOutputCP,'GetConsoleOutputCP',\
    GetConsoleProcessList,'GetConsoleProcessList',\
    GetConsoleScreenBufferInfo,'GetConsoleScreenBufferInfo',\
    GetConsoleScreenBufferInfoEx,'GetConsoleScreenBufferInfoEx',\
    GetConsoleSelectionInfo,'GetConsoleSelectionInfo',\
    GetConsoleTitleA,'GetConsoleTitleA',\
    GetConsoleTitleW,'GetConsoleTitleW',\
    GetConsoleWindow,'GetConsoleWindow',\
    GetCPInfo,'GetCPInfo',\
    GetCPInfoExA,'GetCPInfoExA',\
    GetCPInfoExW,'GetCPInfoExW',\
    GetCurrencyFormatA,'GetCurrencyFormatA',\
    GetCurrencyFormatEx,'GetCurrencyFormatEx',\
    GetCurrencyFormatW,'GetCurrencyFormatW',\
    GetCurrentActCtx,'GetCurrentActCtx',\
    GetCurrentApplicationUserModelId,'GetCurrentApplicationUserModelId',\
    GetCurrentConsoleFont,'GetCurrentConsoleFont',\
    GetCurrentConsoleFontEx,'GetCurrentConsoleFontEx',\
    GetCurrentDirectoryA,'GetCurrentDirectoryA',\
    GetCurrentDirectoryW,'GetCurrentDirectoryW',\
    GetCurrentPackageFamilyName,'GetCurrentPackageFamilyName',\
    GetCurrentPackageFullName,'GetCurrentPackageFullName',\
    GetCurrentPackageId,'GetCurrentPackageId',\
    GetCurrentPackageInfo,'GetCurrentPackageInfo',\
    GetCurrentPackagePath,'GetCurrentPackagePath',\
    GetCurrentProcess,'GetCurrentProcess',\
    GetCurrentProcessId,'GetCurrentProcessId',\
    GetCurrentProcessorNumber,'GetCurrentProcessorNumber',\
    GetCurrentProcessorNumberEx,'GetCurrentProcessorNumberEx',\
    GetCurrentThread,'GetCurrentThread',\
    GetCurrentThreadId,'GetCurrentThreadId',\
    GetCurrentThreadStackLimits,'GetCurrentThreadStackLimits',\
    GetCurrentUmsThread,'GetCurrentUmsThread',\
    GetDateFormatA,'GetDateFormatA',\
    GetDateFormatEx,'GetDateFormatEx',\
    GetDateFormatW,'GetDateFormatW',\
    GetDefaultCommConfigA,'GetDefaultCommConfigA',\
    GetDefaultCommConfigW,'GetDefaultCommConfigW',\
    GetDevicePowerState,'GetDevicePowerState',\
    GetDiskFreeSpaceA,'GetDiskFreeSpaceA',\
    GetDiskFreeSpaceExA,'GetDiskFreeSpaceExA',\
    GetDiskFreeSpaceExW,'GetDiskFreeSpaceExW',\
    GetDiskFreeSpaceW,'GetDiskFreeSpaceW',\
    GetDllDirectoryA,'GetDllDirectoryA',\
    GetDllDirectoryW,'GetDllDirectoryW',\
    GetDriveTypeA,'GetDriveTypeA',\
    GetDriveTypeW,'GetDriveTypeW',\
    GetDurationFormat,'GetDurationFormat',\
    GetDurationFormatEx,'GetDurationFormatEx',\
    GetDynamicTimeZoneInformation,'GetDynamicTimeZoneInformation',\
    GetEnabledXStateFeatures,'GetEnabledXStateFeatures',\
    GetEnvironmentStringsA,'GetEnvironmentStringsA',\
    GetEnvironmentStringsW,'GetEnvironmentStringsW',\
    GetEnvironmentVariableA,'GetEnvironmentVariableA',\
    GetEnvironmentVariableW,'GetEnvironmentVariableW',\
    GetErrorMode,'GetErrorMode',\
    GetExitCodeProcess,'GetExitCodeProcess',\
    GetExitCodeThread,'GetExitCodeThread',\
    GetFileAttributesA,'GetFileAttributesA',\
    GetFileAttributesExA,'GetFileAttributesExA',\
    GetFileAttributesExW,'GetFileAttributesExW',\
    GetFileAttributesTransactedA,'GetFileAttributesTransactedA',\
    GetFileAttributesTransactedW,'GetFileAttributesTransactedW',\
    GetFileAttributesW,'GetFileAttributesW',\
    GetFileBandwidthReservation,'GetFileBandwidthReservation',\
    GetFileInformationByHandle,'GetFileInformationByHandle',\
    GetFileInformationByHandleEx,'GetFileInformationByHandleEx',\
    GetFileMUIInfo,'GetFileMUIInfo',\
    GetFileMUIPath,'GetFileMUIPath',\
    GetFileSize,'GetFileSize',\
    GetFileSizeEx,'GetFileSizeEx',\
    GetFileTime,'GetFileTime',\
    GetFileType,'GetFileType',\
    GetFinalPathNameByHandleA,'GetFinalPathNameByHandleA',\
    GetFinalPathNameByHandleW,'GetFinalPathNameByHandleW',\
    GetFirmwareEnvironmentVariableA,'GetFirmwareEnvironmentVariableA',\
    GetFirmwareEnvironmentVariableExA,'GetFirmwareEnvironmentVariableExA',\
    GetFirmwareEnvironmentVariableExW,'GetFirmwareEnvironmentVariableExW',\
    GetFirmwareEnvironmentVariableW,'GetFirmwareEnvironmentVariableW',\
    GetFirmwareType,'GetFirmwareType',\
    GetFullPathNameA,'GetFullPathNameA',\
    GetFullPathNameTransactedA,'GetFullPathNameTransactedA',\
    GetFullPathNameTransactedW,'GetFullPathNameTransactedW',\
    GetFullPathNameW,'GetFullPathNameW',\
    GetGeoInfoA,'GetGeoInfoA',\
    GetGeoInfoW,'GetGeoInfoW',\
    GetHandleInformation,'GetHandleInformation',\
    GetLargePageMinimum,'GetLargePageMinimum',\
    GetLargestConsoleWindowSize,'GetLargestConsoleWindowSize',\
    GetLastError,'GetLastError',\
    GetLocaleInfoA,'GetLocaleInfoA',\
    GetLocaleInfoEx,'GetLocaleInfoEx',\
    GetLocaleInfoW,'GetLocaleInfoW',\
    GetLocalTime,'GetLocalTime',\
    GetLogicalDrives,'GetLogicalDrives',\
    GetLogicalDriveStringsA,'GetLogicalDriveStringsA',\
    GetLogicalDriveStringsW,'GetLogicalDriveStringsW',\
    GetLogicalProcessorInformation,'GetLogicalProcessorInformation',\
    GetLogicalProcessorInformationEx,'GetLogicalProcessorInformationEx',\
    GetLongPathNameA,'GetLongPathNameA',\
    GetLongPathNameTransactedA,'GetLongPathNameTransactedA',\
    GetLongPathNameTransactedW,'GetLongPathNameTransactedW',\
    GetLongPathNameW,'GetLongPathNameW',\
    GetMailslotInfo,'GetMailslotInfo',\
    GetMaximumProcessorCount,'GetMaximumProcessorCount',\
    GetMaximumProcessorGroupCount,'GetMaximumProcessorGroupCount',\
    GetMemoryErrorHandlingCapabilities,'GetMemoryErrorHandlingCapabilities',\
    GetModuleFileNameA,'GetModuleFileNameA',\
    GetModuleFileNameW,'GetModuleFileNameW',\
    GetModuleHandleA,'GetModuleHandleA',\
    GetModuleHandleExA,'GetModuleHandleExA',\
    GetModuleHandleExW,'GetModuleHandleExW',\
    GetModuleHandleW,'GetModuleHandleW',\
    GetNamedPipeAttribute,'GetNamedPipeAttribute',\
    GetNamedPipeClientComputerNameA,'GetNamedPipeClientComputerNameA',\
    GetNamedPipeClientComputerNameW,'GetNamedPipeClientComputerNameW',\
    GetNamedPipeClientProcessId,'GetNamedPipeClientProcessId',\
    GetNamedPipeClientSessionId,'GetNamedPipeClientSessionId',\
    GetNamedPipeHandleStateA,'GetNamedPipeHandleStateA',\
    GetNamedPipeHandleStateW,'GetNamedPipeHandleStateW',\
    GetNamedPipeInfo,'GetNamedPipeInfo',\
    GetNamedPipeServerProcessId,'GetNamedPipeServerProcessId',\
    GetNamedPipeServerSessionId,'GetNamedPipeServerSessionId',\
    GetNativeSystemInfo,'GetNativeSystemInfo',\
    GetNextUmsListItem,'GetNextUmsListItem',\
    GetNextVDMCommand,'GetNextVDMCommand',\
    GetNLSVersion,'GetNLSVersion',\
    GetNLSVersionEx,'GetNLSVersionEx',\
    GetNumaAvailableMemoryNode,'GetNumaAvailableMemoryNode',\
    GetNumaAvailableMemoryNodeEx,'GetNumaAvailableMemoryNodeEx',\
    GetNumaHighestNodeNumber,'GetNumaHighestNodeNumber',\
    GetNumaNodeNumberFromHandle,'GetNumaNodeNumberFromHandle',\
    GetNumaNodeProcessorMask,'GetNumaNodeProcessorMask',\
    GetNumaNodeProcessorMaskEx,'GetNumaNodeProcessorMaskEx',\
    GetNumaProcessorNode,'GetNumaProcessorNode',\
    GetNumaProcessorNodeEx,'GetNumaProcessorNodeEx',\
    GetNumaProximityNode,'GetNumaProximityNode',\
    GetNumaProximityNodeEx,'GetNumaProximityNodeEx',\
    GetNumberFormatA,'GetNumberFormatA',\
    GetNumberFormatEx,'GetNumberFormatEx',\
    GetNumberFormatW,'GetNumberFormatW',\
    GetNumberOfConsoleFonts,'GetNumberOfConsoleFonts',\
    GetNumberOfConsoleInputEvents,'GetNumberOfConsoleInputEvents',\
    GetNumberOfConsoleMouseButtons,'GetNumberOfConsoleMouseButtons',\
    GetOEMCP,'GetOEMCP',\
    GetOverlappedResult,'GetOverlappedResult',\
    GetOverlappedResultEx,'GetOverlappedResultEx',\
    GetPackageApplicationIds,'GetPackageApplicationIds',\
    GetPackageFamilyName,'GetPackageFamilyName',\
    GetPackageFullName,'GetPackageFullName',\
    GetPackageId,'GetPackageId',\
    GetPackageInfo,'GetPackageInfo',\
    GetPackagePath,'GetPackagePath',\
    GetPackagePathByFullName,'GetPackagePathByFullName',\
    GetPackagesByPackageFamily,'GetPackagesByPackageFamily',\
    GetPhysicallyInstalledSystemMemory,'GetPhysicallyInstalledSystemMemory',\
    GetPriorityClass,'GetPriorityClass',\
    GetPrivateProfileIntA,'GetPrivateProfileIntA',\
    GetPrivateProfileIntW,'GetPrivateProfileIntW',\
    GetPrivateProfileSectionA,'GetPrivateProfileSectionA',\
    GetPrivateProfileSectionNamesA,'GetPrivateProfileSectionNamesA',\
    GetPrivateProfileSectionNamesW,'GetPrivateProfileSectionNamesW',\
    GetPrivateProfileSectionW,'GetPrivateProfileSectionW',\
    GetPrivateProfileStringA,'GetPrivateProfileStringA',\
    GetPrivateProfileStringW,'GetPrivateProfileStringW',\
    GetPrivateProfileStructA,'GetPrivateProfileStructA',\
    GetPrivateProfileStructW,'GetPrivateProfileStructW',\
    GetProcAddress,'GetProcAddress',\
    GetProcessAffinityMask,'GetProcessAffinityMask',\
    GetProcessDefaultCpuSets,'GetProcessDefaultCpuSets',\
    GetProcessDEPPolicy,'GetProcessDEPPolicy',\
    GetProcessGroupAffinity,'GetProcessGroupAffinity',\
    GetProcessHandleCount,'GetProcessHandleCount',\
    GetProcessHeap,'GetProcessHeap',\
    GetProcessHeaps,'GetProcessHeaps',\
    GetProcessId,'GetProcessId',\
    GetProcessIdOfThread,'GetProcessIdOfThread',\
    GetProcessInformation,'GetProcessInformation',\
    GetProcessIoCounters,'GetProcessIoCounters',\
    GetProcessMitigationPolicy,'GetProcessMitigationPolicy',\
    GetProcessorSystemCycleTime,'GetProcessorSystemCycleTime',\
    GetProcessPreferredUILanguages,'GetProcessPreferredUILanguages',\
    GetProcessPriorityBoost,'GetProcessPriorityBoost',\
    GetProcessShutdownParameters,'GetProcessShutdownParameters',\
    GetProcessTimes,'GetProcessTimes',\
    GetProcessUserModeExceptionPolicy,'GetProcessUserModeExceptionPolicy',\
    GetProcessVersion,'GetProcessVersion',\
    GetProcessWorkingSetSize,'GetProcessWorkingSetSize',\
    GetProcessWorkingSetSizeEx,'GetProcessWorkingSetSizeEx',\
    GetProductInfo,'GetProductInfo',\
    GetProfileIntA,'GetProfileIntA',\
    GetProfileIntW,'GetProfileIntW',\
    GetProfileSectionA,'GetProfileSectionA',\
    GetProfileSectionW,'GetProfileSectionW',\
    GetProfileStringA,'GetProfileStringA',\
    GetProfileStringW,'GetProfileStringW',\
    GetQueuedCompletionStatus,'GetQueuedCompletionStatus',\
    GetQueuedCompletionStatusEx,'GetQueuedCompletionStatusEx',\
    GetShortPathNameA,'GetShortPathNameA',\
    GetShortPathNameW,'GetShortPathNameW',\
    GetStagedPackagePathByFullName,'GetStagedPackagePathByFullName',\
    GetStartupInfoA,'GetStartupInfoA',\
    GetStartupInfoW,'GetStartupInfoW',\
    GetStdHandle,'GetStdHandle',\
    GetStringScripts,'GetStringScripts',\
    GetStringTypeA,'GetStringTypeA',\
    GetStringTypeExA,'GetStringTypeExA',\
    GetStringTypeExW,'GetStringTypeExW',\
    GetStringTypeW,'GetStringTypeW',\
    GetSystemCpuSetInformation,'GetSystemCpuSetInformation',\
    GetSystemDefaultLangID,'GetSystemDefaultLangID',\
    GetSystemDefaultLCID,'GetSystemDefaultLCID',\
    GetSystemDefaultLocaleName,'GetSystemDefaultLocaleName',\
    GetSystemDefaultUILanguage,'GetSystemDefaultUILanguage',\
    GetSystemDEPPolicy,'GetSystemDEPPolicy',\
    GetSystemDirectoryA,'GetSystemDirectoryA',\
    GetSystemDirectoryW,'GetSystemDirectoryW',\
    GetSystemFileCacheSize,'GetSystemFileCacheSize',\
    GetSystemFirmwareTable,'GetSystemFirmwareTable',\
    GetSystemInfo,'GetSystemInfo',\
    GetSystemPowerStatus,'GetSystemPowerStatus',\
    GetSystemPreferredUILanguages,'GetSystemPreferredUILanguages',\
    GetSystemRegistryQuota,'GetSystemRegistryQuota',\
    GetSystemTime,'GetSystemTime',\
    GetSystemTimeAdjustment,'GetSystemTimeAdjustment',\
    GetSystemTimeAsFileTime,'GetSystemTimeAsFileTime',\
    GetSystemTimePreciseAsFileTime,'GetSystemTimePreciseAsFileTime',\
    GetSystemTimes,'GetSystemTimes',\
    GetSystemWindowsDirectoryA,'GetSystemWindowsDirectoryA',\
    GetSystemWindowsDirectoryW,'GetSystemWindowsDirectoryW',\
    GetSystemWow64DirectoryA,'GetSystemWow64DirectoryA',\
    GetSystemWow64DirectoryW,'GetSystemWow64DirectoryW',\
    GetTapeParameters,'GetTapeParameters',\
    GetTapePosition,'GetTapePosition',\
    GetTapeStatus,'GetTapeStatus',\
    GetTempFileNameA,'GetTempFileNameA',\
    GetTempFileNameW,'GetTempFileNameW',\
    GetTempPathA,'GetTempPathA',\
    GetTempPathW,'GetTempPathW',\
    GetThreadContext,'GetThreadContext',\
    GetThreadErrorMode,'GetThreadErrorMode',\
    GetThreadGroupAffinity,'GetThreadGroupAffinity',\
    GetThreadId,'GetThreadId',\
    GetThreadIdealProcessorEx,'GetThreadIdealProcessorEx',\
    GetThreadInformation,'GetThreadInformation',\
    GetThreadIOPendingFlag,'GetThreadIOPendingFlag',\
    GetThreadLocale,'GetThreadLocale',\
    GetThreadPreferredUILanguages,'GetThreadPreferredUILanguages',\
    GetThreadPriority,'GetThreadPriority',\
    GetThreadPriorityBoost,'GetThreadPriorityBoost',\
    GetThreadSelectedCpuSets,'GetThreadSelectedCpuSets',\
    GetThreadSelectorEntry,'GetThreadSelectorEntry',\
    GetThreadTimes,'GetThreadTimes',\
    GetThreadUILanguage,'GetThreadUILanguage',\
    GetTickCount,'GetTickCount',\
    GetTickCount64,'GetTickCount64',\
    GetTimeFormatA,'GetTimeFormatA',\
    GetTimeFormatEx,'GetTimeFormatEx',\
    GetTimeFormatW,'GetTimeFormatW',\
    GetTimeZoneInformation,'GetTimeZoneInformation',\
    GetTimeZoneInformationForYear,'GetTimeZoneInformationForYear',\
    GetUILanguageInfo,'GetUILanguageInfo',\
    GetUmsCompletionListEvent,'GetUmsCompletionListEvent',\
    GetUmsSystemThreadInformation,'GetUmsSystemThreadInformation',\
    GetUserDefaultLangID,'GetUserDefaultLangID',\
    GetUserDefaultLCID,'GetUserDefaultLCID',\
    GetUserDefaultLocaleName,'GetUserDefaultLocaleName',\
    GetUserDefaultUILanguage,'GetUserDefaultUILanguage',\
    GetUserGeoID,'GetUserGeoID',\
    GetUserPreferredUILanguages,'GetUserPreferredUILanguages',\
    GetVDMCurrentDirectories,'GetVDMCurrentDirectories',\
    GetUserNameA,'GetUserNameA',\
    GetUserNameW,'GetUserNameW',\
    GetVersion,'GetVersion',\
    GetVersionExA,'GetVersionExA',\
    GetVersionExW,'GetVersionExW',\
    GetVolumeInformationA,'GetVolumeInformationA',\
    GetVolumeInformationByHandleW,'GetVolumeInformationByHandleW',\
    GetVolumeInformationW,'GetVolumeInformationW',\
    GetVolumeNameForVolumeMountPointA,'GetVolumeNameForVolumeMountPointA',\
    GetVolumeNameForVolumeMountPointW,'GetVolumeNameForVolumeMountPointW',\
    GetVolumePathNameA,'GetVolumePathNameA',\
    GetVolumePathNamesForVolumeNameA,'GetVolumePathNamesForVolumeNameA',\
    GetVolumePathNamesForVolumeNameW,'GetVolumePathNamesForVolumeNameW',\
    GetVolumePathNameW,'GetVolumePathNameW',\
    GetWindowsDirectoryA,'GetWindowsDirectoryA',\
    GetWindowsDirectoryW,'GetWindowsDirectoryW',\
    GetWriteWatch,'GetWriteWatch',\
    GetXStateFeaturesMask,'GetXStateFeaturesMask',\
    GlobalAddAtomA,'GlobalAddAtomA',\
    GlobalAddAtomExA,'GlobalAddAtomExA',\
    GlobalAddAtomExW,'GlobalAddAtomExW',\
    GlobalAddAtomW,'GlobalAddAtomW',\
    GlobalAlloc,'GlobalAlloc',\
    GlobalCompact,'GlobalCompact',\
    GlobalDeleteAtom,'GlobalDeleteAtom',\
    GlobalFindAtomA,'GlobalFindAtomA',\
    GlobalFindAtomW,'GlobalFindAtomW',\
    GlobalFix,'GlobalFix',\
    GlobalFlags,'GlobalFlags',\
    GlobalFree,'GlobalFree',\
    GlobalGetAtomNameA,'GlobalGetAtomNameA',\
    GlobalGetAtomNameW,'GlobalGetAtomNameW',\
    GlobalHandle,'GlobalHandle',\
    GlobalLock,'GlobalLock',\
    GlobalMemoryStatus,'GlobalMemoryStatus',\
    GlobalMemoryStatusEx,'GlobalMemoryStatusEx',\
    GlobalReAlloc,'GlobalReAlloc',\
    GlobalSize,'GlobalSize',\
    GlobalUnfix,'GlobalUnfix',\
    GlobalUnlock,'GlobalUnlock',\
    GlobalUnWire,'GlobalUnWire',\
    GlobalWire,'GlobalWire',\
    Heap32First,'Heap32First',\
    Heap32ListFirst,'Heap32ListFirst',\
    Heap32ListNext,'Heap32ListNext',\
    Heap32Next,'Heap32Next',\
    HeapAlloc,'HeapAlloc',\
    HeapCompact,'HeapCompact',\
    HeapCreate,'HeapCreate',\
    HeapDestroy,'HeapDestroy',\
    HeapFree,'HeapFree',\
    HeapLock,'HeapLock',\
    HeapQueryInformation,'HeapQueryInformation',\
    HeapReAlloc,'HeapReAlloc',\
    HeapSetInformation,'HeapSetInformation',\
    HeapSize,'HeapSize',\
    HeapUnlock,'HeapUnlock',\
    HeapValidate,'HeapValidate',\
    HeapWalk,'HeapWalk',\
    IdnToAscii,'IdnToAscii',\
    IdnToNameprepUnicode,'IdnToNameprepUnicode',\
    IdnToUnicode,'IdnToUnicode',\
    InitAtomTable,'InitAtomTable',\
    InitializeConditionVariable,'InitializeConditionVariable',\
    InitializeContext,'InitializeContext',\
    InitializeCriticalSection,'InitializeCriticalSection',\
    InitializeCriticalSectionAndSpinCount,'InitializeCriticalSectionAndSpinCount',\
    InitializeCriticalSectionEx,'InitializeCriticalSectionEx',\
    InitializeEnclave,'InitializeEnclave',\
    InitializeProcThreadAttributeList,'InitializeProcThreadAttributeList',\
    InitializeSListHead,'InitializeSListHead',\
    InitializeSRWLock,'InitializeSRWLock',\
    InitializeSynchronizationBarrier,'InitializeSynchronizationBarrier',\
    InitOnceBeginInitialize,'InitOnceBeginInitialize',\
    InitOnceComplete,'InitOnceComplete',\
    InitOnceExecuteOnce,'InitOnceExecuteOnce',\
    InitOnceInitialize,'InitOnceInitialize',\
    InstallELAMCertificateInfo,'InstallELAMCertificateInfo',\
    InterlockedExchangeAdd,'InterlockedExchangeAdd',\
    InterlockedFlushSList,'InterlockedFlushSList',\
    InterlockedPopEntrySList,'InterlockedPopEntrySList',\
    InterlockedPushEntrySList,'InterlockedPushEntrySList',\
    InterlockedPushListSList,'InterlockedPushListSList',\
    InterlockedPushListSListEx,'InterlockedPushListSListEx',\
    InvalidateConsoleDIBits,'InvalidateConsoleDIBits',\
    IsBadCodePtr,'IsBadCodePtr',\
    IsBadHugeReadPtr,'IsBadHugeReadPtr',\
    IsBadHugeWritePtr,'IsBadHugeWritePtr',\
    IsBadReadPtr,'IsBadReadPtr',\
    IsBadStringPtrA,'IsBadStringPtrA',\
    IsBadStringPtrW,'IsBadStringPtrW',\
    IsBadWritePtr,'IsBadWritePtr',\
    IsCalendarLeapDay,'IsCalendarLeapDay',\
    IsCalendarLeapMonth,'IsCalendarLeapMonth',\
    IsCalendarLeapYear,'IsCalendarLeapYear',\
    IsDBCSLeadByte,'IsDBCSLeadByte',\
    IsDBCSLeadByteEx,'IsDBCSLeadByteEx',\
    IsDebuggerPresent,'IsDebuggerPresent',\
    IsEnclaveTypeSupported,'IsEnclaveTypeSupported',\
    IsNativeVhdBoot,'IsNativeVhdBoot',\
    IsNLSDefinedString,'IsNLSDefinedString',\
    IsNormalizedString,'IsNormalizedString',\
    IsProcessCritical,'IsProcessCritical',\
    IsProcessInJob,'IsProcessInJob',\
    IsProcessorFeaturePresent,'IsProcessorFeaturePresent',\
    IsSystemResumeAutomatic,'IsSystemResumeAutomatic',\
    IsThreadAFiber,'IsThreadAFiber',\
    IsThreadpoolTimerSet,'IsThreadpoolTimerSet',\
    IsTimeZoneRedirectionEnabled,'IsTimeZoneRedirectionEnabled',\
    IsValidCalDateTime,'IsValidCalDateTime',\
    IsValidCodePage,'IsValidCodePage',\
    IsValidLanguageGroup,'IsValidLanguageGroup',\
    IsValidLocale,'IsValidLocale',\
    IsValidLocaleName,'IsValidLocaleName',\
    IsValidNLSVersion,'IsValidNLSVersion',\
    IsWow64Process,'IsWow64Process',\
    K32EmptyWorkingSet,'K32EmptyWorkingSet',\
    K32EnumDeviceDrivers,'K32EnumDeviceDrivers',\
    K32EnumPageFilesA,'K32EnumPageFilesA',\
    K32EnumPageFilesW,'K32EnumPageFilesW',\
    K32EnumProcesses,'K32EnumProcesses',\
    K32EnumProcessModules,'K32EnumProcessModules',\
    K32EnumProcessModulesEx,'K32EnumProcessModulesEx',\
    K32GetDeviceDriverBaseNameA,'K32GetDeviceDriverBaseNameA',\
    K32GetDeviceDriverBaseNameW,'K32GetDeviceDriverBaseNameW',\
    K32GetDeviceDriverFileNameA,'K32GetDeviceDriverFileNameA',\
    K32GetDeviceDriverFileNameW,'K32GetDeviceDriverFileNameW',\
    K32GetMappedFileNameA,'K32GetMappedFileNameA',\
    K32GetMappedFileNameW,'K32GetMappedFileNameW',\
    K32GetModuleBaseNameA,'K32GetModuleBaseNameA',\
    K32GetModuleBaseNameW,'K32GetModuleBaseNameW',\
    K32GetModuleFileNameExA,'K32GetModuleFileNameExA',\
    K32GetModuleFileNameExW,'K32GetModuleFileNameExW',\
    K32GetModuleInformation,'K32GetModuleInformation',\
    K32GetPerformanceInfo,'K32GetPerformanceInfo',\
    K32GetProcessImageFileNameA,'K32GetProcessImageFileNameA',\
    K32GetProcessImageFileNameW,'K32GetProcessImageFileNameW',\
    K32GetProcessMemoryInfo,'K32GetProcessMemoryInfo',\
    K32GetWsChanges,'K32GetWsChanges',\
    K32GetWsChangesEx,'K32GetWsChangesEx',\
    K32InitializeProcessForWsWatch,'K32InitializeProcessForWsWatch',\
    K32QueryWorkingSet,'K32QueryWorkingSet',\
    K32QueryWorkingSetEx,'K32QueryWorkingSetEx',\
    LCIDToLocaleName,'LCIDToLocaleName',\
    LCMapStringA,'LCMapStringA',\
    LCMapStringEx,'LCMapStringEx',\
    LCMapStringW,'LCMapStringW',\
    LeaveCriticalSection,'LeaveCriticalSection',\
    LeaveCriticalSectionWhenCallbackReturns,'LeaveCriticalSectionWhenCallbackReturns',\
    LoadAppInitDlls,'LoadAppInitDlls',\
    LoadEnclaveData,'LoadEnclaveData',\
    LoadLibraryA,'LoadLibraryA',\
    LoadLibraryExA,'LoadLibraryExA',\
    LoadLibraryExW,'LoadLibraryExW',\
    LoadLibraryW,'LoadLibraryW',\
    LoadModule,'LoadModule',\
    LoadPackagedLibrary,'LoadPackagedLibrary',\
    LoadResource,'LoadResource',\
    LoadStringBaseExW,'LoadStringBaseExW',\
    LoadStringBaseW,'LoadStringBaseW',\
    LocalAlloc,'LocalAlloc',\
    LocalCompact,'LocalCompact',\
    LocaleNameToLCID,'LocaleNameToLCID',\
    LocalFileTimeToFileTime,'LocalFileTimeToFileTime',\
    LocalFlags,'LocalFlags',\
    LocalFree,'LocalFree',\
    LocalHandle,'LocalHandle',\
    LocalLock,'LocalLock',\
    LocalReAlloc,'LocalReAlloc',\
    LocalShrink,'LocalShrink',\
    LocalSize,'LocalSize',\
    LocalUnlock,'LocalUnlock',\
    LocateXStateFeature,'LocateXStateFeature',\
    LockFile,'LockFile',\
    LockFileEx,'LockFileEx',\
    LockResource,'LockResource',\
    lstrcatA,'lstrcatA',\
    lstrcatW,'lstrcatW',\
    lstrcmpA,'lstrcmpA',\
    lstrcmpiA,'lstrcmpiA',\
    lstrcmpiW,'lstrcmpiW',\
    lstrcmpW,'lstrcmpW',\
    lstrcpyA,'lstrcpyA',\
    lstrcpynA,'lstrcpynA',\
    lstrcpynW,'lstrcpynW',\
    lstrcpyW,'lstrcpyW',\
    lstrlenA,'lstrlenA',\
    lstrlenW,'lstrlenW',\
    MapUserPhysicalPages,'MapUserPhysicalPages',\
    MapUserPhysicalPagesScatter,'MapUserPhysicalPagesScatter',\
    MapViewOfFile,'MapViewOfFile',\
    MapViewOfFileEx,'MapViewOfFileEx',\
    MapViewOfFileExNuma,'MapViewOfFileExNuma',\
    MapViewOfFileFromApp,'MapViewOfFileFromApp',\
    Module32First,'Module32First',\
    Module32FirstW,'Module32FirstW',\
    Module32Next,'Module32Next',\
    Module32NextW,'Module32NextW',\
    MoveFileA,'MoveFileA',\
    MoveFileExA,'MoveFileExA',\
    MoveFileExW,'MoveFileExW',\
    MoveFileTransactedA,'MoveFileTransactedA',\
    MoveFileTransactedW,'MoveFileTransactedW',\
    MoveFileW,'MoveFileW',\
    MoveFileWithProgressA,'MoveFileWithProgressA',\
    MoveFileWithProgressW,'MoveFileWithProgressW',\
    MulDiv,'MulDiv',\
    MultiByteToWideChar,'MultiByteToWideChar',\
    NeedCurrentDirectoryForExePathA,'NeedCurrentDirectoryForExePathA',\
    NeedCurrentDirectoryForExePathW,'NeedCurrentDirectoryForExePathW',\
    NormalizeString,'NormalizeString',\
    NotifyUILanguageChange,'NotifyUILanguageChange',\
    OfferVirtualMemory,'OfferVirtualMemory',\
    OOBEComplete,'OOBEComplete',\
    OpenConsoleW,'OpenConsoleW',\
    OpenEncryptedFileRawA,'OpenEncryptedFileRawA',\
    OpenEncryptedFileRawW,'OpenEncryptedFileRawW',\
    OpenEventA,'OpenEventA',\
    OpenEventW,'OpenEventW',\
    OpenFile,'OpenFile',\
    OpenFileById,'OpenFileById',\
    OpenFileMappingA,'OpenFileMappingA',\
    OpenFileMappingW,'OpenFileMappingW',\
    OpenJobObjectA,'OpenJobObjectA',\
    OpenJobObjectW,'OpenJobObjectW',\
    OpenMutexA,'OpenMutexA',\
    OpenMutexW,'OpenMutexW',\
    OpenPackageInfoByFullName,'OpenPackageInfoByFullName',\
    OpenPrivateNamespaceA,'OpenPrivateNamespaceA',\
    OpenPrivateNamespaceW,'OpenPrivateNamespaceW',\
    OpenProcess,'OpenProcess',\
    OpenProcessToken,'OpenProcessToken',\
    OpenProfileUserMapping,'OpenProfileUserMapping',\
    OpenSemaphoreA,'OpenSemaphoreA',\
    OpenSemaphoreW,'OpenSemaphoreW',\
    OpenThread,'OpenThread',\
    OpenThreadToken,'OpenThreadToken',\
    OpenWaitableTimerA,'OpenWaitableTimerA',\
    OpenWaitableTimerW,'OpenWaitableTimerW',\
    OutputDebugStringA,'OutputDebugStringA',\
    OutputDebugStringW,'OutputDebugStringW',\
    PackageFamilyNameFromFullName,'PackageFamilyNameFromFullName',\
    PackageFamilyNameFromId,'PackageFamilyNameFromId',\
    PackageFullNameFromId,'PackageFullNameFromId',\
    PackageIdFromFullName,'PackageIdFromFullName',\
    PackageNameAndPublisherIdFromFamilyName,'PackageNameAndPublisherIdFromFamilyName',\
    ParseApplicationUserModelId,'ParseApplicationUserModelId',\
    PeekConsoleInputA,'PeekConsoleInputA',\
    PeekConsoleInputW,'PeekConsoleInputW',\
    PeekNamedPipe,'PeekNamedPipe',\
    PostQueuedCompletionStatus,'PostQueuedCompletionStatus',\
    PowerClearRequest,'PowerClearRequest',\
    PowerCreateRequest,'PowerCreateRequest',\
    PowerSetRequest,'PowerSetRequest',\
    PrefetchVirtualMemory,'PrefetchVirtualMemory',\
    PrepareTape,'PrepareTape',\
    PrivCopyFileExW,'PrivCopyFileExW',\
    Process32First,'Process32First',\
    Process32FirstW,'Process32FirstW',\
    Process32Next,'Process32Next',\
    Process32NextW,'Process32NextW',\
    ProcessIdToSessionId,'ProcessIdToSessionId',\
    PssCaptureSnapshot,'PssCaptureSnapshot',\
    PssDuplicateSnapshot,'PssDuplicateSnapshot',\
    PssFreeSnapshot,'PssFreeSnapshot',\
    PssQuerySnapshot,'PssQuerySnapshot',\
    PssWalkMarkerCreate,'PssWalkMarkerCreate',\
    PssWalkMarkerFree,'PssWalkMarkerFree',\
    PssWalkMarkerGetPosition,'PssWalkMarkerGetPosition',\
    PssWalkMarkerSeekToBeginning,'PssWalkMarkerSeekToBeginning',\
    PssWalkMarkerSetPosition,'PssWalkMarkerSetPosition',\
    PssWalkSnapshot,'PssWalkSnapshot',\
    PulseEvent,'PulseEvent',\
    PurgeComm,'PurgeComm',\
    QueryActCtxSettingsW,'QueryActCtxSettingsW',\
    QueryActCtxW,'QueryActCtxW',\
    QueryDepthSList,'QueryDepthSList',\
    QueryDosDeviceA,'QueryDosDeviceA',\
    QueryDosDeviceW,'QueryDosDeviceW',\
    QueryFullProcessImageNameA,'QueryFullProcessImageNameA',\
    QueryFullProcessImageNameW,'QueryFullProcessImageNameW',\
    QueryIdleProcessorCycleTime,'QueryIdleProcessorCycleTime',\
    QueryIdleProcessorCycleTimeEx,'QueryIdleProcessorCycleTimeEx',\
    QueryInformationJobObject,'QueryInformationJobObject',\
    QueryIoRateControlInformationJobObject,'QueryIoRateControlInformationJobObject',\
    QueryMemoryResourceNotification,'QueryMemoryResourceNotification',\
    QueryPerformanceCounter,'QueryPerformanceCounter',\
    QueryPerformanceFrequency,'QueryPerformanceFrequency',\
    QueryProcessAffinityUpdateMode,'QueryProcessAffinityUpdateMode',\
    QueryProcessCycleTime,'QueryProcessCycleTime',\
    QueryProtectedPolicy,'QueryProtectedPolicy',\
    QueryThreadCycleTime,'QueryThreadCycleTime',\
    QueryThreadpoolStackInformation,'QueryThreadpoolStackInformation',\
    QueryThreadProfiling,'QueryThreadProfiling',\
    QueryUmsThreadInformation,'QueryUmsThreadInformation',\
    QueryUnbiasedInterruptTime,'QueryUnbiasedInterruptTime',\
    QueueUserAPC,'QueueUserAPC',\
    QueueUserWorkItem,'QueueUserWorkItem',\
    RaiseException,'RaiseException',\
    RaiseFailFastException,'RaiseFailFastException',\
    ReadConsoleA,'ReadConsoleA',\
    ReadConsoleInputA,'ReadConsoleInputA',\
    ReadConsoleInputExA,'ReadConsoleInputExA',\
    ReadConsoleInputExW,'ReadConsoleInputExW',\
    ReadConsoleInputW,'ReadConsoleInputW',\
    ReadConsoleOutputA,'ReadConsoleOutputA',\
    ReadConsoleOutputAttribute,'ReadConsoleOutputAttribute',\
    ReadConsoleOutputCharacterA,'ReadConsoleOutputCharacterA',\
    ReadConsoleOutputCharacterW,'ReadConsoleOutputCharacterW',\
    ReadConsoleOutputW,'ReadConsoleOutputW',\
    ReadConsoleW,'ReadConsoleW',\
    ReadDirectoryChangesW,'ReadDirectoryChangesW',\
    ReadFile,'ReadFile',\
    ReadFileEx,'ReadFileEx',\
    ReadFileScatter,'ReadFileScatter',\
    ReadProcessMemory,'ReadProcessMemory',\
    ReadThreadProfilingData,'ReadThreadProfilingData',\
    ReclaimVirtualMemory,'ReclaimVirtualMemory',\
    RegCloseKey,'RegCloseKey',\
    RegCopyTreeW,'RegCopyTreeW',\
    RegCreateKeyExA,'RegCreateKeyExA',\
    RegCreateKeyExW,'RegCreateKeyExW',\
    RegDeleteKeyExA,'RegDeleteKeyExA',\
    RegDeleteKeyExW,'RegDeleteKeyExW',\
    RegDeleteTreeA,'RegDeleteTreeA',\
    RegDeleteTreeW,'RegDeleteTreeW',\
    RegDeleteValueA,'RegDeleteValueA',\
    RegDeleteValueW,'RegDeleteValueW',\
    RegDisablePredefinedCacheEx,'RegDisablePredefinedCacheEx',\
    RegEnumKeyExA,'RegEnumKeyExA',\
    RegEnumKeyExW,'RegEnumKeyExW',\
    RegEnumValueA,'RegEnumValueA',\
    RegEnumValueW,'RegEnumValueW',\
    RegFlushKey,'RegFlushKey',\
    RegGetKeySecurity,'RegGetKeySecurity',\
    RegGetValueA,'RegGetValueA',\
    RegGetValueW,'RegGetValueW',\
    RegisterApplicationRecoveryCallback,'RegisterApplicationRecoveryCallback',\
    RegisterApplicationRestart,'RegisterApplicationRestart',\
    RegisterBadMemoryNotification,'RegisterBadMemoryNotification',\
    RegisterWaitForSingleObject,'RegisterWaitForSingleObject',\
    RegisterWaitUntilOOBECompleted,'RegisterWaitUntilOOBECompleted',\
    RegLoadKeyA,'RegLoadKeyA',\
    RegLoadKeyW,'RegLoadKeyW',\
    RegLoadMUIStringA,'RegLoadMUIStringA',\
    RegLoadMUIStringW,'RegLoadMUIStringW',\
    RegNotifyChangeKeyValue,'RegNotifyChangeKeyValue',\
    RegOpenCurrentUser,'RegOpenCurrentUser',\
    RegOpenKeyExA,'RegOpenKeyExA',\
    RegOpenKeyExW,'RegOpenKeyExW',\
    RegOpenUserClassesRoot,'RegOpenUserClassesRoot',\
    RegQueryInfoKeyA,'RegQueryInfoKeyA',\
    RegQueryInfoKeyW,'RegQueryInfoKeyW',\
    RegQueryValueExA,'RegQueryValueExA',\
    RegQueryValueExW,'RegQueryValueExW',\
    RegRestoreKeyA,'RegRestoreKeyA',\
    RegRestoreKeyW,'RegRestoreKeyW',\
    RegSaveKeyExA,'RegSaveKeyExA',\
    RegSaveKeyExW,'RegSaveKeyExW',\
    RegSetKeySecurity,'RegSetKeySecurity',\
    RegSetValueExA,'RegSetValueExA',\
    RegSetValueExW,'RegSetValueExW',\
    RegUnLoadKeyA,'RegUnLoadKeyA',\
    RegUnLoadKeyW,'RegUnLoadKeyW',\
    ReleaseActCtx,'ReleaseActCtx',\
    ReleaseMutex,'ReleaseMutex',\
    ReleaseMutexWhenCallbackReturns,'ReleaseMutexWhenCallbackReturns',\
    ReleaseSemaphore,'ReleaseSemaphore',\
    ReleaseSemaphoreWhenCallbackReturns,'ReleaseSemaphoreWhenCallbackReturns',\
    ReleaseSRWLockExclusive,'ReleaseSRWLockExclusive',\
    ReleaseSRWLockShared,'ReleaseSRWLockShared',\
    RemoveDirectoryA,'RemoveDirectoryA',\
    RemoveDirectoryTransactedA,'RemoveDirectoryTransactedA',\
    RemoveDirectoryTransactedW,'RemoveDirectoryTransactedW',\
    RemoveDirectoryW,'RemoveDirectoryW',\
    RemoveDllDirectory,'RemoveDllDirectory',\
    RemoveSecureMemoryCacheCallback,'RemoveSecureMemoryCacheCallback',\
    RemoveVectoredContinueHandler,'RemoveVectoredContinueHandler',\
    RemoveVectoredExceptionHandler,'RemoveVectoredExceptionHandler',\
    ReOpenFile,'ReOpenFile',\
    ReplaceFileA,'ReplaceFileA',\
    ReplaceFileW,'ReplaceFileW',\
    ReplacePartitionUnit,'ReplacePartitionUnit',\
    RequestDeviceWakeup,'RequestDeviceWakeup',\
    RequestWakeupLatency,'RequestWakeupLatency',\
    ResetEvent,'ResetEvent',\
    ResetWriteWatch,'ResetWriteWatch',\
    ResolveDelayLoadedAPI,'ResolveDelayLoadedAPI',\
    ResolveDelayLoadsFromDll,'ResolveDelayLoadsFromDll',\
    ResolveLocaleName,'ResolveLocaleName',\
    RestoreLastError,'RestoreLastError',\
    ResumeThread,'ResumeThread',\
    RtlAddFunctionTable,'RtlAddFunctionTable',\
    RtlCaptureContext,'RtlCaptureContext',\
    RtlCaptureStackBackTrace,'RtlCaptureStackBackTrace',\
    RtlCompareMemory,'RtlCompareMemory',\
    RtlCopyMemory,'RtlCopyMemory',\
    RtlDeleteFunctionTable,'RtlDeleteFunctionTable',\
    RtlFillMemory,'RtlFillMemory',\
    RtlInstallFunctionTableCallback,'RtlInstallFunctionTableCallback',\
    RtlLookupFunctionEntry,'RtlLookupFunctionEntry',\
    RtlMoveMemory,'RtlMoveMemory',\
    RtlPcToFileHeader,'RtlPcToFileHeader',\
    RtlRaiseException,'RtlRaiseException',\
    RtlRestoreContext,'RtlRestoreContext',\
    RtlUnwind,'RtlUnwind',\
    RtlUnwindEx,'RtlUnwindEx',\
    RtlVirtualUnwind,'RtlVirtualUnwind',\
    RtlZeroMemory,'RtlZeroMemory',\
    ScrollConsoleScreenBufferA,'ScrollConsoleScreenBufferA',\
    ScrollConsoleScreenBufferW,'ScrollConsoleScreenBufferW',\
    SearchPathA,'SearchPathA',\
    SearchPathW,'SearchPathW',\
    SetCachedSigningLevel,'SetCachedSigningLevel',\
    SetCalendarInfoA,'SetCalendarInfoA',\
    SetCalendarInfoW,'SetCalendarInfoW',\
    SetCommBreak,'SetCommBreak',\
    SetCommConfig,'SetCommConfig',\
    SetCommMask,'SetCommMask',\
    SetCommState,'SetCommState',\
    SetCommTimeouts,'SetCommTimeouts',\
    SetComputerNameA,'SetComputerNameA',\
    SetComputerNameExA,'SetComputerNameExA',\
    SetComputerNameExW,'SetComputerNameExW',\
    SetComputerNameW,'SetComputerNameW',\
    SetConsoleActiveScreenBuffer,'SetConsoleActiveScreenBuffer',\
    SetConsoleCP,'SetConsoleCP',\
    SetConsoleCtrlHandler,'SetConsoleCtrlHandler',\
    SetConsoleCursor,'SetConsoleCursor',\
    SetConsoleCursorInfo,'SetConsoleCursorInfo',\
    SetConsoleCursorPosition,'SetConsoleCursorPosition',\
    SetConsoleDisplayMode,'SetConsoleDisplayMode',\
    SetConsoleFont,'SetConsoleFont',\
    SetConsoleHardwareState,'SetConsoleHardwareState',\
    SetConsoleHistoryInfo,'SetConsoleHistoryInfo',\
    SetConsoleIcon,'SetConsoleIcon',\
    SetConsoleMaximumWindowSize,'SetConsoleMaximumWindowSize',\
    SetConsoleMode,'SetConsoleMode',\
    SetConsoleNlsMode,'SetConsoleNlsMode',\
    SetConsoleNumberOfCommandsA,'SetConsoleNumberOfCommandsA',\
    SetConsoleNumberOfCommandsW,'SetConsoleNumberOfCommandsW',\
    SetConsoleOS2OemFormat,'SetConsoleOS2OemFormat',\
    SetConsoleOutputCP,'SetConsoleOutputCP',\
    SetConsolePalette,'SetConsolePalette',\
    SetConsoleScreenBufferInfoEx,'SetConsoleScreenBufferInfoEx',\
    SetConsoleScreenBufferSize,'SetConsoleScreenBufferSize',\
    SetConsoleTextAttribute,'SetConsoleTextAttribute',\
    SetConsoleTitleA,'SetConsoleTitleA',\
    SetConsoleTitleW,'SetConsoleTitleW',\
    SetConsoleWindowInfo,'SetConsoleWindowInfo',\
    SetCriticalSectionSpinCount,'SetCriticalSectionSpinCount',\
    SetCurrentConsoleFontEx,'SetCurrentConsoleFontEx',\
    SetCurrentDirectoryA,'SetCurrentDirectoryA',\
    SetCurrentDirectoryW,'SetCurrentDirectoryW',\
    SetDefaultCommConfigA,'SetDefaultCommConfigA',\
    SetDefaultCommConfigW,'SetDefaultCommConfigW',\
    SetDefaultDllDirectories,'SetDefaultDllDirectories',\
    SetDllDirectoryA,'SetDllDirectoryA',\
    SetDllDirectoryW,'SetDllDirectoryW',\
    SetDynamicTimeZoneInformation,'SetDynamicTimeZoneInformation',\
    SetEndOfFile,'SetEndOfFile',\
    SetEnvironmentStringsA,'SetEnvironmentStringsA',\
    SetEnvironmentStringsW,'SetEnvironmentStringsW',\
    SetEnvironmentVariableA,'SetEnvironmentVariableA',\
    SetEnvironmentVariableW,'SetEnvironmentVariableW',\
    SetErrorMode,'SetErrorMode',\
    SetEvent,'SetEvent',\
    SetEventWhenCallbackReturns,'SetEventWhenCallbackReturns',\
    SetFileApisToANSI,'SetFileApisToANSI',\
    SetFileApisToOEM,'SetFileApisToOEM',\
    SetFileAttributesA,'SetFileAttributesA',\
    SetFileAttributesTransactedA,'SetFileAttributesTransactedA',\
    SetFileAttributesTransactedW,'SetFileAttributesTransactedW',\
    SetFileAttributesW,'SetFileAttributesW',\
    SetFileBandwidthReservation,'SetFileBandwidthReservation',\
    SetFileCompletionNotificationModes,'SetFileCompletionNotificationModes',\
    SetFileInformationByHandle,'SetFileInformationByHandle',\
    SetFileIoOverlappedRange,'SetFileIoOverlappedRange',\
    SetFilePointer,'SetFilePointer',\
    SetFilePointerEx,'SetFilePointerEx',\
    SetFileShortNameA,'SetFileShortNameA',\
    SetFileShortNameW,'SetFileShortNameW',\
    SetFileTime,'SetFileTime',\
    SetFileValidData,'SetFileValidData',\
    SetFirmwareEnvironmentVariableA,'SetFirmwareEnvironmentVariableA',\
    SetFirmwareEnvironmentVariableExA,'SetFirmwareEnvironmentVariableExA',\
    SetFirmwareEnvironmentVariableExW,'SetFirmwareEnvironmentVariableExW',\
    SetFirmwareEnvironmentVariableW,'SetFirmwareEnvironmentVariableW',\
    SetHandleCount,'SetHandleCount',\
    SetHandleInformation,'SetHandleInformation',\
    SetInformationJobObject,'SetInformationJobObject',\
    SetIoRateControlInformationJobObject,'SetIoRateControlInformationJobObject',\
    SetLastConsoleEventActive,'SetLastConsoleEventActive',\
    SetLastError,'SetLastError',\
    SetLocaleInfoA,'SetLocaleInfoA',\
    SetLocaleInfoW,'SetLocaleInfoW',\
    SetLocalPrimaryComputerNameA,'SetLocalPrimaryComputerNameA',\
    SetLocalPrimaryComputerNameW,'SetLocalPrimaryComputerNameW',\
    SetLocalTime,'SetLocalTime',\
    SetMailslotInfo,'SetMailslotInfo',\
    SetMessageWaitingIndicator,'SetMessageWaitingIndicator',\
    SetNamedPipeAttribute,'SetNamedPipeAttribute',\
    SetNamedPipeHandleState,'SetNamedPipeHandleState',\
    SetPriorityClass,'SetPriorityClass',\
    SetProcessAffinityMask,'SetProcessAffinityMask',\
    SetProcessAffinityUpdateMode,'SetProcessAffinityUpdateMode',\
    SetProcessDefaultCpuSets,'SetProcessDefaultCpuSets',\
    SetProcessDEPPolicy,'SetProcessDEPPolicy',\
    SetProcessInformation,'SetProcessInformation',\
    SetProcessMitigationPolicy,'SetProcessMitigationPolicy',\
    SetProcessPreferredUILanguages,'SetProcessPreferredUILanguages',\
    SetProcessPriorityBoost,'SetProcessPriorityBoost',\
    SetProcessShutdownParameters,'SetProcessShutdownParameters',\
    SetProcessUserModeExceptionPolicy,'SetProcessUserModeExceptionPolicy',\
    SetProcessWorkingSetSize,'SetProcessWorkingSetSize',\
    SetProcessWorkingSetSizeEx,'SetProcessWorkingSetSizeEx',\
    SetProtectedPolicy,'SetProtectedPolicy',\
    SetSearchPathMode,'SetSearchPathMode',\
    SetStdHandle,'SetStdHandle',\
    SetStdHandleEx,'SetStdHandleEx',\
    SetSystemFileCacheSize,'SetSystemFileCacheSize',\
    SetSystemPowerState,'SetSystemPowerState',\
    SetSystemTime,'SetSystemTime',\
    SetSystemTimeAdjustment,'SetSystemTimeAdjustment',\
    SetTapeParameters,'SetTapeParameters',\
    SetTapePosition,'SetTapePosition',\
    SetTermsrvAppInstallMode,'SetTermsrvAppInstallMode',\
    SetThreadAffinityMask,'SetThreadAffinityMask',\
    SetThreadContext,'SetThreadContext',\
    SetThreadErrorMode,'SetThreadErrorMode',\
    SetThreadExecutionState,'SetThreadExecutionState',\
    SetThreadGroupAffinity,'SetThreadGroupAffinity',\
    SetThreadIdealProcessor,'SetThreadIdealProcessor',\
    SetThreadIdealProcessorEx,'SetThreadIdealProcessorEx',\
    SetThreadInformation,'SetThreadInformation',\
    SetThreadLocale,'SetThreadLocale',\
    SetThreadpoolStackInformation,'SetThreadpoolStackInformation',\
    SetThreadpoolThreadMaximum,'SetThreadpoolThreadMaximum',\
    SetThreadpoolThreadMinimum,'SetThreadpoolThreadMinimum',\
    SetThreadpoolTimer,'SetThreadpoolTimer',\
    SetThreadpoolWait,'SetThreadpoolWait',\
    SetThreadpoolWaitEx,'SetThreadpoolWaitEx',\
    SetThreadPreferredUILanguages,'SetThreadPreferredUILanguages',\
    SetThreadPriority,'SetThreadPriority',\
    SetThreadPriorityBoost,'SetThreadPriorityBoost',\
    SetThreadSelectedCpuSets,'SetThreadSelectedCpuSets',\
    SetThreadStackGuarantee,'SetThreadStackGuarantee',\
    SetThreadToken,'SetThreadToken',\
    SetThreadUILanguage,'SetThreadUILanguage',\
    SetTimerQueueTimer,'SetTimerQueueTimer',\
    SetTimeZoneInformation,'SetTimeZoneInformation',\
    SetUmsThreadInformation,'SetUmsThreadInformation',\
    SetUnhandledExceptionFilter,'SetUnhandledExceptionFilter',\
    SetupComm,'SetupComm',\
    SetUserGeoID,'SetUserGeoID',\
    SetVDMCurrentDirectories,'SetVDMCurrentDirectories',\
    SetVolumeLabelA,'SetVolumeLabelA',\
    SetVolumeLabelW,'SetVolumeLabelW',\
    SetVolumeMountPointA,'SetVolumeMountPointA',\
    SetVolumeMountPointW,'SetVolumeMountPointW',\
    SetWaitableTimer,'SetWaitableTimer',\
    SetXStateFeaturesMask,'SetXStateFeaturesMask',\
    ShowConsoleCursor,'ShowConsoleCursor',\
    SignalObjectAndWait,'SignalObjectAndWait',\
    SizeofResource,'SizeofResource',\
    Sleep,'Sleep',\
    SleepConditionVariableCS,'SleepConditionVariableCS',\
    SleepConditionVariableSRW,'SleepConditionVariableSRW',\
    SleepEx,'SleepEx',\
    StartThreadpoolIo,'StartThreadpoolIo',\
    SubmitThreadpoolWork,'SubmitThreadpoolWork',\
    SuspendThread,'SuspendThread',\
    SwitchToFiber,'SwitchToFiber',\
    SwitchToThread,'SwitchToThread',\
    SystemTimeToFileTime,'SystemTimeToFileTime',\
    SystemTimeToTzSpecificLocalTime,'SystemTimeToTzSpecificLocalTime',\
    SystemTimeToTzSpecificLocalTimeEx,'SystemTimeToTzSpecificLocalTimeEx',\
    TerminateJobObject,'TerminateJobObject',\
    TerminateProcess,'TerminateProcess',\
    TerminateThread,'TerminateThread',\
    Thread32First,'Thread32First',\
    Thread32Next,'Thread32Next',\
    timeBeginPeriod,'timeBeginPeriod',\
    timeEndPeriod,'timeEndPeriod',\
    timeGetDevCaps,'timeGetDevCaps',\
    timeGetSystemTime,'timeGetSystemTime',\
    timeGetTime,'timeGetTime',\
    TlsAlloc,'TlsAlloc',\
    TlsFree,'TlsFree',\
    TlsGetValue,'TlsGetValue',\
    TlsSetValue,'TlsSetValue',\
    Toolhelp32ReadProcessMemory,'Toolhelp32ReadProcessMemory',\
    TransactNamedPipe,'TransactNamedPipe',\
    TransmitCommChar,'TransmitCommChar',\
    TryAcquireSRWLockExclusive,'TryAcquireSRWLockExclusive',\
    TryAcquireSRWLockShared,'TryAcquireSRWLockShared',\
    TryEnterCriticalSection,'TryEnterCriticalSection',\
    TrySubmitThreadpoolCallback,'TrySubmitThreadpoolCallback',\
    TzSpecificLocalTimeToSystemTime,'TzSpecificLocalTimeToSystemTime',\
    TzSpecificLocalTimeToSystemTimeEx,'TzSpecificLocalTimeToSystemTimeEx',\
    uaw_lstrcmpiW,'uaw_lstrcmpiW',\
    uaw_lstrcmpW,'uaw_lstrcmpW',\
    uaw_lstrlenW,'uaw_lstrlenW',\
    uaw_wcschr,'uaw_wcschr',\
    uaw_wcscpy,'uaw_wcscpy',\
    uaw_wcsicmp,'uaw_wcsicmp',\
    uaw_wcslen,'uaw_wcslen',\
    uaw_wcsrchr,'uaw_wcsrchr',\
    UmsThreadYield,'UmsThreadYield',\
    UnhandledExceptionFilter,'UnhandledExceptionFilter',\
    UnlockFile,'UnlockFile',\
    UnlockFileEx,'UnlockFileEx',\
    UnmapViewOfFile,'UnmapViewOfFile',\
    UnregisterApplicationRecoveryCallback,'UnregisterApplicationRecoveryCallback',\
    UnregisterApplicationRestart,'UnregisterApplicationRestart',\
    UnregisterBadMemoryNotification,'UnregisterBadMemoryNotification',\
    UnregisterWait,'UnregisterWait',\
    UnregisterWaitEx,'UnregisterWaitEx',\
    UnregisterWaitUntilOOBECompleted,'UnregisterWaitUntilOOBECompleted',\
    UpdateCalendarDayOfWeek,'UpdateCalendarDayOfWeek',\
    UpdateProcThreadAttribute,'UpdateProcThreadAttribute',\
    UpdateResourceA,'UpdateResourceA',\
    UpdateResourceW,'UpdateResourceW',\
    VerifyScripts,'VerifyScripts',\
    VerifyVersionInfoA,'VerifyVersionInfoA',\
    VerifyVersionInfoW,'VerifyVersionInfoW',\
    VerSetConditionMask,'VerSetConditionMask',\
    VirtualAlloc,'VirtualAlloc',\
    VirtualAllocEx,'VirtualAllocEx',\
    VirtualAllocExNuma,'VirtualAllocExNuma',\
    VirtualFree,'VirtualFree',\
    VirtualFreeEx,'VirtualFreeEx',\
    VirtualLock,'VirtualLock',\
    VirtualProtect,'VirtualProtect',\
    VirtualProtectEx,'VirtualProtectEx',\
    VirtualQuery,'VirtualQuery',\
    VirtualQueryEx,'VirtualQueryEx',\
    VirtualUnlock,'VirtualUnlock',\
    WaitCommEvent,'WaitCommEvent',\
    WaitForDebugEvent,'WaitForDebugEvent',\
    WaitForDebugEventEx,'WaitForDebugEventEx',\
    WaitForMultipleObjects,'WaitForMultipleObjects',\
    WaitForMultipleObjectsEx,'WaitForMultipleObjectsEx',\
    WaitForSingleObject,'WaitForSingleObject',\
    WaitForSingleObjectEx,'WaitForSingleObjectEx',\
    WaitForThreadpoolIoCallbacks,'WaitForThreadpoolIoCallbacks',\
    WaitForThreadpoolTimerCallbacks,'WaitForThreadpoolTimerCallbacks',\
    WaitForThreadpoolWaitCallbacks,'WaitForThreadpoolWaitCallbacks',\
    WaitForThreadpoolWorkCallbacks,'WaitForThreadpoolWorkCallbacks',\
    WaitNamedPipeA,'WaitNamedPipeA',\
    WaitNamedPipeW,'WaitNamedPipeW',\
    WakeAllConditionVariable,'WakeAllConditionVariable',\
    WakeConditionVariable,'WakeConditionVariable',\
    WerGetFlags,'WerGetFlags',\
    WerRegisterFile,'WerRegisterFile',\
    WerRegisterMemoryBlock,'WerRegisterMemoryBlock',\
    WerRegisterRuntimeExceptionModule,'WerRegisterRuntimeExceptionModule',\
    WerSetFlags,'WerSetFlags',\
    WerUnregisterFile,'WerUnregisterFile',\
    WerUnregisterMemoryBlock,'WerUnregisterMemoryBlock',\
    WerUnregisterRuntimeExceptionModule,'WerUnregisterRuntimeExceptionModule',\
    WideCharToMultiByte,'WideCharToMultiByte',\
    WinExec,'WinExec',\
    Wow64DisableWow64FsRedirection,'Wow64DisableWow64FsRedirection',\
    Wow64EnableWow64FsRedirection,'Wow64EnableWow64FsRedirection',\
    Wow64GetThreadContext,'Wow64GetThreadContext',\
    Wow64GetThreadSelectorEntry,'Wow64GetThreadSelectorEntry',\
    Wow64RevertWow64FsRedirection,'Wow64RevertWow64FsRedirection',\
    Wow64SetThreadContext,'Wow64SetThreadContext',\
    Wow64SuspendThread,'Wow64SuspendThread',\
    WriteConsoleA,'WriteConsoleA',\
    WriteConsoleInputA,'WriteConsoleInputA',\
    WriteConsoleInputW,'WriteConsoleInputW',\
    WriteConsoleOutputA,'WriteConsoleOutputA',\
    WriteConsoleOutputAttribute,'WriteConsoleOutputAttribute',\
    WriteConsoleOutputCharacterA,'WriteConsoleOutputCharacterA',\
    WriteConsoleOutputCharacterW,'WriteConsoleOutputCharacterW',\
    WriteConsoleOutputW,'WriteConsoleOutputW',\
    WriteConsoleW,'WriteConsoleW',\
    WriteFile,'WriteFile',\
    WriteFileEx,'WriteFileEx',\
    WriteFileGather,'WriteFileGather',\
    WritePrivateProfileSectionA,'WritePrivateProfileSectionA',\
    WritePrivateProfileSectionW,'WritePrivateProfileSectionW',\
    WritePrivateProfileStringA,'WritePrivateProfileStringA',\
    WritePrivateProfileStringW,'WritePrivateProfileStringW',\
    WritePrivateProfileStructA,'WritePrivateProfileStructA',\
    WritePrivateProfileStructW,'WritePrivateProfileStructW',\
    WriteProcessMemory,'WriteProcessMemory',\
    WriteProfileSectionA,'WriteProfileSectionA',\
    WriteProfileSectionW,'WriteProfileSectionW',\
    WriteProfileStringA,'WriteProfileStringA',\
    WriteProfileStringW,'WriteProfileStringW',\
    WriteTapemark,'WriteTapemark',\
    WTSGetActiveConsoleSessionId,'WTSGetActiveConsoleSessionId',\
    ZombifyActCtx,'ZombifyActCtx'
else
    import kernel32,\
    _hread,'_hread',\
    _hwrite,'_hwrite',\
    _lclose,'_lclose',\
    _lcreat,'_lcreat',\
    _llseek,'_llseek',\
    _lopen,'_lopen',\
    _lread,'_lread',\
    _lwrite,'_lwrite',\
    AcquireSRWLockExclusive,'AcquireSRWLockExclusive',\
    AcquireSRWLockShared,'AcquireSRWLockShared',\
    AcquireStateLock,'AcquireStateLock',\
    ActivateActCtx,'ActivateActCtx',\
    AddAtomA,'AddAtomA',\
    AddAtomW,'AddAtomW',\
    AddConsoleAliasA,'AddConsoleAliasA',\
    AddConsoleAliasW,'AddConsoleAliasW',\
    AddDllDirectory,'AddDllDirectory',\
    AddIntegrityLabelToBoundaryDescriptor,'AddIntegrityLabelToBoundaryDescriptor',\
    AddLocalAlternateComputerNameA,'AddLocalAlternateComputerNameA',\
    AddLocalAlternateComputerNameW,'AddLocalAlternateComputerNameW',\
    AddRefActCtx,'AddRefActCtx',\
    AddResourceAttributeAce,'AddResourceAttributeAce',\
    AddScopedPolicyIDAce,'AddScopedPolicyIDAce',\
    AddSecureMemoryCacheCallback,'AddSecureMemoryCacheCallback',\
    AddSIDToBoundaryDescriptor,'AddSIDToBoundaryDescriptor',\
    AddVectoredContinueHandler,'AddVectoredContinueHandler',\
    AddVectoredExceptionHandler,'AddVectoredExceptionHandler',\
    AdjustCalendarDate,'AdjustCalendarDate',\
    AllocateUserPhysicalPages,'AllocateUserPhysicalPages',\
    AllocateUserPhysicalPagesNuma,'AllocateUserPhysicalPagesNuma',\
    AllocConsole,'AllocConsole',\
    ApplicationRecoveryFinished,'ApplicationRecoveryFinished',\
    ApplicationRecoveryInProgress,'ApplicationRecoveryInProgress',\
    AreFileApisANSI,'AreFileApisANSI',\
    AssignProcessToJobObject,'AssignProcessToJobObject',\
    AttachConsole,'AttachConsole',\
    BackupRead,'BackupRead',\
    BackupSeek,'BackupSeek',\
    BackupWrite,'BackupWrite',\
    BaseFormatTimeOut,'BaseFormatTimeOut',\
    BaseGetNamedObjectDirectory,'BaseGetNamedObjectDirectory',\
    Basep8BitStringToDynamicUnicodeString,'Basep8BitStringToDynamicUnicodeString',\
    Beep,'Beep',\
    BeginUpdateResourceA,'BeginUpdateResourceA',\
    BeginUpdateResourceW,'BeginUpdateResourceW',\
    BindIoCompletionCallback,'BindIoCompletionCallback',\
    BuildCommDCBA,'BuildCommDCBA',\
    BuildCommDCBAndTimeoutsA,'BuildCommDCBAndTimeoutsA',\
    BuildCommDCBAndTimeoutsW,'BuildCommDCBAndTimeoutsW',\
    BuildCommDCBW,'BuildCommDCBW',\
    CallbackMayRunLong,'CallbackMayRunLong',\
    CallNamedPipeA,'CallNamedPipeA',\
    CallNamedPipeW,'CallNamedPipeW',\
    CalloutOnFiberStack,'CalloutOnFiberStack',\
    CancelDeviceWakeupRequest,'CancelDeviceWakeupRequest',\
    CancelIo,'CancelIo',\
    CancelIoEx,'CancelIoEx',\
    CancelSynchronousIo,'CancelSynchronousIo',\
    CancelThreadpoolIo,'CancelThreadpoolIo',\
    CancelWaitableTimer,'CancelWaitableTimer',\
    CeipIsOptedIn,'CeipIsOptedIn',\
    ChangeTimerQueueTimer,'ChangeTimerQueueTimer',\
    CheckElevationEnabled,'CheckElevationEnabled',\
    CheckNameLegalDOS8Dot3A,'CheckNameLegalDOS8Dot3A',\
    CheckNameLegalDOS8Dot3W,'CheckNameLegalDOS8Dot3W',\
    CheckRemoteDebuggerPresent,'CheckRemoteDebuggerPresent',\
    CheckTokenCapability,'CheckTokenCapability',\
    CheckTokenMembershipEx,'CheckTokenMembershipEx',\
    ClearCommBreak,'ClearCommBreak',\
    ClearCommError,'ClearCommError',\
    CloseHandle,'CloseHandle',\
    ClosePackageInfo,'ClosePackageInfo',\
    ClosePrivateNamespace,'ClosePrivateNamespace',\
    CloseThreadpool,'CloseThreadpool',\
    CloseThreadpoolCleanupGroup,'CloseThreadpoolCleanupGroup',\
    CloseThreadpoolCleanupGroupMembers,'CloseThreadpoolCleanupGroupMembers',\
    CloseThreadpoolIo,'CloseThreadpoolIo',\
    CloseThreadpoolTimer,'CloseThreadpoolTimer',\
    CloseThreadpoolWait,'CloseThreadpoolWait',\
    CloseThreadpoolWork,'CloseThreadpoolWork',\
    CommConfigDialogA,'CommConfigDialogA',\
    CommConfigDialogW,'CommConfigDialogW',\
    CompareFileTime,'CompareFileTime',\
    CompareStringA,'CompareStringA',\
    CompareStringEx,'CompareStringEx',\
    CompareStringOrdinal,'CompareStringOrdinal',\
    CompareStringW,'CompareStringW',\
    ConnectNamedPipe,'ConnectNamedPipe',\
    ConsoleMenuControl,'ConsoleMenuControl',\
    ContinueDebugEvent,'ContinueDebugEvent',\
    ConvertCalDateTimeToSystemTime,'ConvertCalDateTimeToSystemTime',\
    ConvertDefaultLocale,'ConvertDefaultLocale',\
    ConvertFiberToThread,'ConvertFiberToThread',\
    ConvertSystemTimeToCalDateTime,'ConvertSystemTimeToCalDateTime',\
    ConvertThreadToFiber,'ConvertThreadToFiber',\
    ConvertThreadToFiberEx,'ConvertThreadToFiberEx',\
    CopyContext,'CopyContext',\
    CopyExtendedContext,'CopyExtendedContext',\
    CopyFile2,'CopyFile2',\
    CopyFileA,'CopyFileA',\
    CopyFileExA,'CopyFileExA',\
    CopyFileExW,'CopyFileExW',\
    CopyFileTransactedA,'CopyFileTransactedA',\
    CopyFileTransactedW,'CopyFileTransactedW',\
    CopyFileW,'CopyFileW',\
    CreateActCtxA,'CreateActCtxA',\
    CreateActCtxW,'CreateActCtxW',\
    CreateBoundaryDescriptorA,'CreateBoundaryDescriptorA',\
    CreateBoundaryDescriptorW,'CreateBoundaryDescriptorW',\
    CreateConsoleScreenBuffer,'CreateConsoleScreenBuffer',\
    CreateDirectoryA,'CreateDirectoryA',\
    CreateDirectoryExA,'CreateDirectoryExA',\
    CreateDirectoryExW,'CreateDirectoryExW',\
    CreateDirectoryTransactedA,'CreateDirectoryTransactedA',\
    CreateDirectoryTransactedW,'CreateDirectoryTransactedW',\
    CreateDirectoryW,'CreateDirectoryW',\
    CreateEnclave,'CreateEnclave',\
    CreateEventA,'CreateEventA',\
    CreateEventExA,'CreateEventExA',\
    CreateEventExW,'CreateEventExW',\
    CreateEventW,'CreateEventW',\
    CreateFiber,'CreateFiber',\
    CreateFiberEx,'CreateFiberEx',\
    CreateFile2,'CreateFile2',\
    CreateFileA,'CreateFileA',\
    CreateFileMappingA,'CreateFileMappingA',\
    CreateFileMappingFromApp,'CreateFileMappingFromApp',\
    CreateFileMappingNumaA,'CreateFileMappingNumaA',\
    CreateFileMappingNumaW,'CreateFileMappingNumaW',\
    CreateFileMappingW,'CreateFileMappingW',\
    CreateFileTransactedA0,'CreateFileTransactedA',\
    CreateFileTransactedW0,'CreateFileTransactedW',\
    CreateFileW,'CreateFileW',\
    CreateHardLinkA,'CreateHardLinkA',\
    CreateHardLinkTransactedA,'CreateHardLinkTransactedA',\
    CreateHardLinkTransactedW,'CreateHardLinkTransactedW',\
    CreateHardLinkW,'CreateHardLinkW',\
    CreateIoCompletionPort,'CreateIoCompletionPort',\
    CreateJobObjectA,'CreateJobObjectA',\
    CreateJobObjectW,'CreateJobObjectW',\
    CreateJobSet,'CreateJobSet',\
    CreateMailslotA,'CreateMailslotA',\
    CreateMailslotW,'CreateMailslotW',\
    CreateMemoryResourceNotification,'CreateMemoryResourceNotification',\
    CreateMutexA,'CreateMutexA',\
    CreateMutexExA,'CreateMutexExA',\
    CreateMutexExW,'CreateMutexExW',\
    CreateMutexW,'CreateMutexW',\
    CreateNamedPipeA,'CreateNamedPipeA',\
    CreateNamedPipeW,'CreateNamedPipeW',\
    CreatePipe,'CreatePipe',\
    CreatePrivateNamespaceA,'CreatePrivateNamespaceA',\
    CreatePrivateNamespaceW,'CreatePrivateNamespaceW',\
    CreateProcessA0,'CreateProcessA',\
    CreateProcessInternalA0,'CreateProcessInternalA',\
    CreateProcessInternalW0,'CreateProcessInternalW',\
    CreateProcessW0,'CreateProcessW',\
    CreateRemoteThread,'CreateRemoteThread',\
    CreateRemoteThreadEx,'CreateRemoteThreadEx',\
    CreateSemaphoreA,'CreateSemaphoreA',\
    CreateSemaphoreExA,'CreateSemaphoreExA',\
    CreateSemaphoreExW,'CreateSemaphoreExW',\
    CreateSemaphoreW,'CreateSemaphoreW',\
    CreateSymbolicLinkA,'CreateSymbolicLinkA',\
    CreateSymbolicLinkTransactedA,'CreateSymbolicLinkTransactedA',\
    CreateSymbolicLinkTransactedW,'CreateSymbolicLinkTransactedW',\
    CreateSymbolicLinkW,'CreateSymbolicLinkW',\
    CreateTapePartition,'CreateTapePartition',\
    CreateThread,'CreateThread',\
    CreateThreadpool,'CreateThreadpool',\
    CreateThreadpoolCleanupGroup,'CreateThreadpoolCleanupGroup',\
    CreateThreadpoolIo,'CreateThreadpoolIo',\
    CreateThreadpoolTimer,'CreateThreadpoolTimer',\
    CreateThreadpoolWait,'CreateThreadpoolWait',\
    CreateThreadpoolWork,'CreateThreadpoolWork',\
    CreateTimerQueue,'CreateTimerQueue',\
    CreateTimerQueueTimer,'CreateTimerQueueTimer',\
    CreateToolhelp32Snapshot,'CreateToolhelp32Snapshot',\
    CreateWaitableTimerA,'CreateWaitableTimerA',\
    CreateWaitableTimerExA,'CreateWaitableTimerExA',\
    CreateWaitableTimerExW,'CreateWaitableTimerExW',\
    CreateWaitableTimerW,'CreateWaitableTimerW',\
    DeactivateActCtx,'DeactivateActCtx',\
    DebugActiveProcess,'DebugActiveProcess',\
    DebugActiveProcessStop,'DebugActiveProcessStop',\
    DebugBreak,'DebugBreak',\
    DebugBreakProcess,'DebugBreakProcess',\
    DebugSetProcessKillOnExit,'DebugSetProcessKillOnExit',\
    DecodePointer,'DecodePointer',\
    DecodeSystemPointer,'DecodeSystemPointer',\
    DefineDosDeviceA,'DefineDosDeviceA',\
    DefineDosDeviceW,'DefineDosDeviceW',\
    DelayLoadFailureHook,'DelayLoadFailureHook',\
    DeleteAtom,'DeleteAtom',\
    DeleteBoundaryDescriptor,'DeleteBoundaryDescriptor',\
    DeleteCriticalSection,'DeleteCriticalSection',\
    DeleteFiber,'DeleteFiber',\
    DeleteFileA,'DeleteFileA',\
    DeleteFileTransactedA,'DeleteFileTransactedA',\
    DeleteFileTransactedW,'DeleteFileTransactedW',\
    DeleteFileW,'DeleteFileW',\
    DeleteProcThreadAttributeList,'DeleteProcThreadAttributeList',\
    DeleteSynchronizationBarrier,'DeleteSynchronizationBarrier',\
    DeleteTimerQueue,'DeleteTimerQueue',\
    DeleteTimerQueueEx,'DeleteTimerQueueEx',\
    DeleteTimerQueueTimer,'DeleteTimerQueueTimer',\
    DeleteVolumeMountPointA,'DeleteVolumeMountPointA',\
    DeleteVolumeMountPointW,'DeleteVolumeMountPointW',\
    DeviceIoControl,'DeviceIoControl',\
    DisableThreadLibraryCalls,'DisableThreadLibraryCalls',\
    DisableThreadProfiling,'DisableThreadProfiling',\
    DisassociateCurrentThreadFromCallback,'DisassociateCurrentThreadFromCallback',\
    DiscardVirtualMemory,'DiscardVirtualMemory',\
    DisconnectNamedPipe,'DisconnectNamedPipe',\
    DnsHostnameToComputerNameA,'DnsHostnameToComputerNameA',\
    DnsHostnameToComputerNameW,'DnsHostnameToComputerNameW',\
    DosDateTimeToFileTime,'DosDateTimeToFileTime',\
    DosPathToSessionPathA,'DosPathToSessionPathA',\
    DosPathToSessionPathW,'DosPathToSessionPathW',\
    DuplicateConsoleHandle,'DuplicateConsoleHandle',\
    DuplicateHandle,'DuplicateHandle',\
    EnableThreadProfiling,'EnableThreadProfiling',\
    EncodePointer,'EncodePointer',\
    EncodeSystemPointer,'EncodeSystemPointer',\
    EndUpdateResourceA,'EndUpdateResourceA',\
    EndUpdateResourceW,'EndUpdateResourceW',\
    EnterCriticalSection,'EnterCriticalSection',\
    EnterSynchronizationBarrier,'EnterSynchronizationBarrier',\
    EnumCalendarInfoA,'EnumCalendarInfoA',\
    EnumCalendarInfoExA,'EnumCalendarInfoExA',\
    EnumCalendarInfoExEx,'EnumCalendarInfoExEx',\
    EnumCalendarInfoExW,'EnumCalendarInfoExW',\
    EnumCalendarInfoW,'EnumCalendarInfoW',\
    EnumDateFormatsA,'EnumDateFormatsA',\
    EnumDateFormatsExA,'EnumDateFormatsExA',\
    EnumDateFormatsExEx,'EnumDateFormatsExEx',\
    EnumDateFormatsExW,'EnumDateFormatsExW',\
    EnumDateFormatsW,'EnumDateFormatsW',\
    EnumerateLocalComputerNamesA,'EnumerateLocalComputerNamesA',\
    EnumerateLocalComputerNamesW,'EnumerateLocalComputerNamesW',\
    EnumLanguageGroupLocalesA,'EnumLanguageGroupLocalesA',\
    EnumLanguageGroupLocalesW,'EnumLanguageGroupLocalesW',\
    EnumResourceLanguagesA,'EnumResourceLanguagesA',\
    EnumResourceLanguagesExA,'EnumResourceLanguagesExA',\
    EnumResourceLanguagesExW,'EnumResourceLanguagesExW',\
    EnumResourceLanguagesW,'EnumResourceLanguagesW',\
    EnumResourceNamesA,'EnumResourceNamesA',\
    EnumResourceNamesExA,'EnumResourceNamesExA',\
    EnumResourceNamesExW,'EnumResourceNamesExW',\
    EnumResourceNamesW,'EnumResourceNamesW',\
    EnumResourceTypesA,'EnumResourceTypesA',\
    EnumResourceTypesExA,'EnumResourceTypesExA',\
    EnumResourceTypesExW,'EnumResourceTypesExW',\
    EnumResourceTypesW,'EnumResourceTypesW',\
    EnumSystemCodePagesA,'EnumSystemCodePagesA',\
    EnumSystemCodePagesW,'EnumSystemCodePagesW',\
    EnumSystemFirmwareTables,'EnumSystemFirmwareTables',\
    EnumSystemGeoID,'EnumSystemGeoID',\
    EnumSystemLanguageGroupsA,'EnumSystemLanguageGroupsA',\
    EnumSystemLanguageGroupsW,'EnumSystemLanguageGroupsW',\
    EnumSystemLocalesA,'EnumSystemLocalesA',\
    EnumSystemLocalesEx,'EnumSystemLocalesEx',\
    EnumSystemLocalesW,'EnumSystemLocalesW',\
    EnumTimeFormatsA,'EnumTimeFormatsA',\
    EnumTimeFormatsEx,'EnumTimeFormatsEx',\
    EnumTimeFormatsW,'EnumTimeFormatsW',\
    EnumUILanguagesA,'EnumUILanguagesA',\
    EnumUILanguagesW,'EnumUILanguagesW',\
    EraseTape,'EraseTape',\
    EscapeCommFunction,'EscapeCommFunction',\
    ExitProcess,'ExitProcess',\
    ExitThread,'ExitThread',\
    ExitVDM,'ExitVDM',\
    ExpandEnvironmentStringsA,'ExpandEnvironmentStringsA',\
    ExpandEnvironmentStringsW,'ExpandEnvironmentStringsW',\
    ExpungeConsoleCommandHistoryA,'ExpungeConsoleCommandHistoryA',\
    ExpungeConsoleCommandHistoryW,'ExpungeConsoleCommandHistoryW',\
    FatalAppExitA,'FatalAppExitA',\
    FatalAppExitW,'FatalAppExitW',\
    FatalExit,'FatalExit',\
    FileTimeToDosDateTime,'FileTimeToDosDateTime',\
    FileTimeToLocalFileTime,'FileTimeToLocalFileTime',\
    FileTimeToSystemTime,'FileTimeToSystemTime',\
    FillConsoleOutputAttribute,'FillConsoleOutputAttribute',\
    FillConsoleOutputCharacterA,'FillConsoleOutputCharacterA',\
    FillConsoleOutputCharacterW,'FillConsoleOutputCharacterW',\
    FindActCtxSectionGuid,'FindActCtxSectionGuid',\
    FindActCtxSectionStringA,'FindActCtxSectionStringA',\
    FindActCtxSectionStringW,'FindActCtxSectionStringW',\
    FindAtomA,'FindAtomA',\
    FindAtomW,'FindAtomW',\
    FindClose,'FindClose',\
    FindCloseChangeNotification,'FindCloseChangeNotification',\
    FindFirstChangeNotificationA,'FindFirstChangeNotificationA',\
    FindFirstChangeNotificationW,'FindFirstChangeNotificationW',\
    FindFirstFileA,'FindFirstFileA',\
    FindFirstFileExA,'FindFirstFileExA',\
    FindFirstFileExW,'FindFirstFileExW',\
    FindFirstFileNameTransactedW,'FindFirstFileNameTransactedW',\
    FindFirstFileNameW,'FindFirstFileNameW',\
    FindFirstFileTransactedA,'FindFirstFileTransactedA',\
    FindFirstFileTransactedW,'FindFirstFileTransactedW',\
    FindFirstFileW,'FindFirstFileW',\
    FindFirstStreamTransactedW,'FindFirstStreamTransactedW',\
    FindFirstStreamW,'FindFirstStreamW',\
    FindFirstVolumeA,'FindFirstVolumeA',\
    FindFirstVolumeMountPointA,'FindFirstVolumeMountPointA',\
    FindFirstVolumeMountPointW,'FindFirstVolumeMountPointW',\
    FindFirstVolumeW,'FindFirstVolumeW',\
    FindNextChangeNotification,'FindNextChangeNotification',\
    FindNextFileA,'FindNextFileA',\
    FindNextFileNameW,'FindNextFileNameW',\
    FindNextFileW,'FindNextFileW',\
    FindNextStreamW,'FindNextStreamW',\
    FindNextVolumeA,'FindNextVolumeA',\
    FindNextVolumeMountPointA,'FindNextVolumeMountPointA',\
    FindNextVolumeMountPointW,'FindNextVolumeMountPointW',\
    FindNextVolumeW,'FindNextVolumeW',\
    FindNLSString,'FindNLSString',\
    FindNLSStringEx0,'FindNLSStringEx',\
    FindPackagesByPackageFamily,'FindPackagesByPackageFamily',\
    FindResourceA,'FindResourceA',\
    FindResourceExA,'FindResourceExA',\
    FindResourceExW,'FindResourceExW',\
    FindResourceW,'FindResourceW',\
    FindStringOrdinal,'FindStringOrdinal',\
    FindVolumeClose,'FindVolumeClose',\
    FindVolumeMountPointClose,'FindVolumeMountPointClose',\
    FlsAlloc,'FlsAlloc',\
    FlsFree,'FlsFree',\
    FlsGetValue,'FlsGetValue',\
    FlsSetValue,'FlsSetValue',\
    FlushConsoleInputBuffer,'FlushConsoleInputBuffer',\
    FlushFileBuffers,'FlushFileBuffers',\
    FlushInstructionCache,'FlushInstructionCache',\
    FlushProcessWriteBuffers,'FlushProcessWriteBuffers',\
    FlushViewOfFile,'FlushViewOfFile',\
    FoldStringA,'FoldStringA',\
    FoldStringW,'FoldStringW',\
    FormatApplicationUserModelId,'FormatApplicationUserModelId',\
    FormatMessageA,'FormatMessageA',\
    FormatMessageW,'FormatMessageW',\
    FreeConsole,'FreeConsole',\
    FreeEnvironmentStringsA,'FreeEnvironmentStringsA',\
    FreeEnvironmentStringsW,'FreeEnvironmentStringsW',\
    FreeLibrary,'FreeLibrary',\
    FreeLibraryAndExitThread,'FreeLibraryAndExitThread',\
    FreeLibraryWhenCallbackReturns,'FreeLibraryWhenCallbackReturns',\
    FreeMemoryJobObject,'FreeMemoryJobObject',\
    FreeResource,'FreeResource',\
    FreeUserPhysicalPages,'FreeUserPhysicalPages',\
    GenerateConsoleCtrlEvent,'GenerateConsoleCtrlEvent',\
    GetACP,'GetACP',\
    GetActiveProcessorCount,'GetActiveProcessorCount',\
    GetActiveProcessorGroupCount,'GetActiveProcessorGroupCount',\
    GetAppContainerNamedObjectPath,'GetAppContainerNamedObjectPath',\
    GetApplicationRecoveryCallback,'GetApplicationRecoveryCallback',\
    GetApplicationRestartSettings,'GetApplicationRestartSettings',\
    GetApplicationUserModelId,'GetApplicationUserModelId',\
    GetAtomNameA,'GetAtomNameA',\
    GetAtomNameW,'GetAtomNameW',\
    GetBinaryTypeA,'GetBinaryTypeA',\
    GetBinaryTypeW,'GetBinaryTypeW',\
    GetCachedSigningLevel,'GetCachedSigningLevel',\
    GetCalendarDateFormatEx,'GetCalendarDateFormatEx',\
    GetCalendarInfoA,'GetCalendarInfoA',\
    GetCalendarInfoEx,'GetCalendarInfoEx',\
    GetCalendarInfoW,'GetCalendarInfoW',\
    GetCalendarSupportedDateRange,'GetCalendarSupportedDateRange',\
    GetCommandLineA,'GetCommandLineA',\
    GetCommandLineW,'GetCommandLineW',\
    GetCommConfig,'GetCommConfig',\
    GetCommMask,'GetCommMask',\
    GetCommModemStatus,'GetCommModemStatus',\
    GetCommProperties,'GetCommProperties',\
    GetCommState,'GetCommState',\
    GetCommTimeouts,'GetCommTimeouts',\
    GetComPlusPackageInstallStatus,'GetComPlusPackageInstallStatus',\
    GetCompressedFileSizeA,'GetCompressedFileSizeA',\
    GetCompressedFileSizeTransactedA,'GetCompressedFileSizeTransactedA',\
    GetCompressedFileSizeTransactedW,'GetCompressedFileSizeTransactedW',\
    GetCompressedFileSizeW,'GetCompressedFileSizeW',\
    GetComputerNameA,'GetComputerNameA',\
    GetComputerNameExA,'GetComputerNameExA',\
    GetComputerNameExW,'GetComputerNameExW',\
    GetComputerNameW,'GetComputerNameW',\
    GetConsoleAliasA,'GetConsoleAliasA',\
    GetConsoleAliasesA,'GetConsoleAliasesA',\
    GetConsoleAliasesLengthA,'GetConsoleAliasesLengthA',\
    GetConsoleAliasesLengthW,'GetConsoleAliasesLengthW',\
    GetConsoleAliasesW,'GetConsoleAliasesW',\
    GetConsoleAliasExesA,'GetConsoleAliasExesA',\
    GetConsoleAliasExesLengthA,'GetConsoleAliasExesLengthA',\
    GetConsoleAliasExesLengthW,'GetConsoleAliasExesLengthW',\
    GetConsoleAliasExesW,'GetConsoleAliasExesW',\
    GetConsoleAliasW,'GetConsoleAliasW',\
    GetConsoleCP,'GetConsoleCP',\
    GetConsoleCursorInfo,'GetConsoleCursorInfo',\
    GetConsoleDisplayMode,'GetConsoleDisplayMode',\
    GetConsoleFontInfo,'GetConsoleFontInfo',\
    GetConsoleFontSize,'GetConsoleFontSize',\
    GetConsoleHistoryInfo,'GetConsoleHistoryInfo',\
    GetConsoleMode,'GetConsoleMode',\
    GetConsoleNlsMode,'GetConsoleNlsMode',\
    GetConsoleOriginalTitleA,'GetConsoleOriginalTitleA',\
    GetConsoleOriginalTitleW,'GetConsoleOriginalTitleW',\
    GetConsoleOutputCP,'GetConsoleOutputCP',\
    GetConsoleProcessList,'GetConsoleProcessList',\
    GetConsoleScreenBufferInfo,'GetConsoleScreenBufferInfo',\
    GetConsoleScreenBufferInfoEx,'GetConsoleScreenBufferInfoEx',\
    GetConsoleSelectionInfo,'GetConsoleSelectionInfo',\
    GetConsoleTitleA,'GetConsoleTitleA',\
    GetConsoleTitleW,'GetConsoleTitleW',\
    GetConsoleWindow,'GetConsoleWindow',\
    GetCPInfo,'GetCPInfo',\
    GetCPInfoExA,'GetCPInfoExA',\
    GetCPInfoExW,'GetCPInfoExW',\
    GetCurrencyFormatA,'GetCurrencyFormatA',\
    GetCurrencyFormatEx,'GetCurrencyFormatEx',\
    GetCurrencyFormatW,'GetCurrencyFormatW',\
    GetCurrentActCtx,'GetCurrentActCtx',\
    GetCurrentApplicationUserModelId,'GetCurrentApplicationUserModelId',\
    GetCurrentConsoleFont,'GetCurrentConsoleFont',\
    GetCurrentConsoleFontEx,'GetCurrentConsoleFontEx',\
    GetCurrentDirectoryA,'GetCurrentDirectoryA',\
    GetCurrentDirectoryW,'GetCurrentDirectoryW',\
    GetCurrentPackageFamilyName,'GetCurrentPackageFamilyName',\
    GetCurrentPackageFullName,'GetCurrentPackageFullName',\
    GetCurrentPackageId,'GetCurrentPackageId',\
    GetCurrentPackageInfo,'GetCurrentPackageInfo',\
    GetCurrentPackagePath,'GetCurrentPackagePath',\
    GetCurrentProcess,'GetCurrentProcess',\
    GetCurrentProcessId,'GetCurrentProcessId',\
    GetCurrentProcessorNumber,'GetCurrentProcessorNumber',\
    GetCurrentProcessorNumberEx,'GetCurrentProcessorNumberEx',\
    GetCurrentThread,'GetCurrentThread',\
    GetCurrentThreadId,'GetCurrentThreadId',\
    GetCurrentThreadStackLimits,'GetCurrentThreadStackLimits',\
    GetDateFormatA,'GetDateFormatA',\
    GetDateFormatEx,'GetDateFormatEx',\
    GetDateFormatW,'GetDateFormatW',\
    GetDefaultCommConfigA,'GetDefaultCommConfigA',\
    GetDefaultCommConfigW,'GetDefaultCommConfigW',\
    GetDevicePowerState,'GetDevicePowerState',\
    GetDiskFreeSpaceA,'GetDiskFreeSpaceA',\
    GetDiskFreeSpaceExA,'GetDiskFreeSpaceExA',\
    GetDiskFreeSpaceExW,'GetDiskFreeSpaceExW',\
    GetDiskFreeSpaceW,'GetDiskFreeSpaceW',\
    GetDllDirectoryA,'GetDllDirectoryA',\
    GetDllDirectoryW,'GetDllDirectoryW',\
    GetDriveTypeA,'GetDriveTypeA',\
    GetDriveTypeW,'GetDriveTypeW',\
    GetDurationFormat,'GetDurationFormat',\
    GetDurationFormatEx,'GetDurationFormatEx',\
    GetDynamicTimeZoneInformation,'GetDynamicTimeZoneInformation',\
    GetEnabledXStateFeatures,'GetEnabledXStateFeatures',\
    GetEnvironmentStringsA,'GetEnvironmentStringsA',\
    GetEnvironmentStringsW,'GetEnvironmentStringsW',\
    GetEnvironmentVariableA,'GetEnvironmentVariableA',\
    GetEnvironmentVariableW,'GetEnvironmentVariableW',\
    GetExitCodeProcess,'GetExitCodeProcess',\
    GetExitCodeThread,'GetExitCodeThread',\
    GetFileAttributesA,'GetFileAttributesA',\
    GetFileAttributesExA,'GetFileAttributesExA',\
    GetFileAttributesExW,'GetFileAttributesExW',\
    GetFileAttributesTransactedA,'GetFileAttributesTransactedA',\
    GetFileAttributesTransactedW,'GetFileAttributesTransactedW',\
    GetFileAttributesW,'GetFileAttributesW',\
    GetFileBandwidthReservation,'GetFileBandwidthReservation',\
    GetFileInformationByHandle,'GetFileInformationByHandle',\
    GetFileInformationByHandleEx,'GetFileInformationByHandleEx',\
    GetFileMUIInfo,'GetFileMUIInfo',\
    GetFileMUIPath,'GetFileMUIPath',\
    GetFileSize,'GetFileSize',\
    GetFileSizeEx,'GetFileSizeEx',\
    GetFileTime,'GetFileTime',\
    GetFileType,'GetFileType',\
    GetFinalPathNameByHandleA,'GetFinalPathNameByHandleA',\
    GetFinalPathNameByHandleW,'GetFinalPathNameByHandleW',\
    GetFirmwareEnvironmentVariableA,'GetFirmwareEnvironmentVariableA',\
    GetFirmwareEnvironmentVariableExA,'GetFirmwareEnvironmentVariableExA',\
    GetFirmwareEnvironmentVariableExW,'GetFirmwareEnvironmentVariableExW',\
    GetFirmwareEnvironmentVariableW,'GetFirmwareEnvironmentVariableW',\
    GetFirmwareType,'GetFirmwareType',\
    GetFullPathNameA,'GetFullPathNameA',\
    GetFullPathNameTransactedA,'GetFullPathNameTransactedA',\
    GetFullPathNameTransactedW,'GetFullPathNameTransactedW',\
    GetFullPathNameW,'GetFullPathNameW',\
    GetGeoInfoA,'GetGeoInfoA',\
    GetGeoInfoW,'GetGeoInfoW',\
    GetHandleInformation,'GetHandleInformation',\
    GetLargePageMinimum,'GetLargePageMinimum',\
    GetLargestConsoleWindowSize,'GetLargestConsoleWindowSize',\
    GetLastError,'GetLastError',\
    GetLocaleInfoA,'GetLocaleInfoA',\
    GetLocaleInfoEx,'GetLocaleInfoEx',\
    GetLocaleInfoW,'GetLocaleInfoW',\
    GetLocalTime,'GetLocalTime',\
    GetLogicalDrives,'GetLogicalDrives',\
    GetLogicalDriveStringsA,'GetLogicalDriveStringsA',\
    GetLogicalDriveStringsW,'GetLogicalDriveStringsW',\
    GetLogicalProcessorInformation,'GetLogicalProcessorInformation',\
    GetLogicalProcessorInformationEx,'GetLogicalProcessorInformationEx',\
    GetLongPathNameA,'GetLongPathNameA',\
    GetLongPathNameTransactedA,'GetLongPathNameTransactedA',\
    GetLongPathNameTransactedW,'GetLongPathNameTransactedW',\
    GetLongPathNameW,'GetLongPathNameW',\
    GetMailslotInfo,'GetMailslotInfo',\
    GetMaximumProcessorCount,'GetMaximumProcessorCount',\
    GetMaximumProcessorGroupCount,'GetMaximumProcessorGroupCount',\
    GetMemoryErrorHandlingCapabilities,'GetMemoryErrorHandlingCapabilities',\
    GetModuleFileNameA,'GetModuleFileNameA',\
    GetModuleFileNameW,'GetModuleFileNameW',\
    GetModuleHandleA,'GetModuleHandleA',\
    GetModuleHandleExA,'GetModuleHandleExA',\
    GetModuleHandleExW,'GetModuleHandleExW',\
    GetModuleHandleW,'GetModuleHandleW',\
    GetNamedPipeAttribute,'GetNamedPipeAttribute',\
    GetNamedPipeClientComputerNameA,'GetNamedPipeClientComputerNameA',\
    GetNamedPipeClientComputerNameW,'GetNamedPipeClientComputerNameW',\
    GetNamedPipeClientProcessId,'GetNamedPipeClientProcessId',\
    GetNamedPipeClientSessionId,'GetNamedPipeClientSessionId',\
    GetNamedPipeHandleStateA,'GetNamedPipeHandleStateA',\
    GetNamedPipeHandleStateW,'GetNamedPipeHandleStateW',\
    GetNamedPipeInfo,'GetNamedPipeInfo',\
    GetNamedPipeServerProcessId,'GetNamedPipeServerProcessId',\
    GetNamedPipeServerSessionId,'GetNamedPipeServerSessionId',\
    GetNativeSystemInfo,'GetNativeSystemInfo',\
    GetNextVDMCommand,'GetNextVDMCommand',\
    GetNLSVersion,'GetNLSVersion',\
    GetNLSVersionEx,'GetNLSVersionEx',\
    GetNumaAvailableMemoryNode,'GetNumaAvailableMemoryNode',\
    GetNumaAvailableMemoryNodeEx,'GetNumaAvailableMemoryNodeEx',\
    GetNumaHighestNodeNumber,'GetNumaHighestNodeNumber',\
    GetNumaNodeNumberFromHandle,'GetNumaNodeNumberFromHandle',\
    GetNumaNodeProcessorMask,'GetNumaNodeProcessorMask',\
    GetNumaNodeProcessorMaskEx,'GetNumaNodeProcessorMaskEx',\
    GetNumaProcessorNode,'GetNumaProcessorNode',\
    GetNumaProcessorNodeEx,'GetNumaProcessorNodeEx',\
    GetNumaProximityNode,'GetNumaProximityNode',\
    GetNumaProximityNodeEx,'GetNumaProximityNodeEx',\
    GetNumberFormatA,'GetNumberFormatA',\
    GetNumberFormatEx,'GetNumberFormatEx',\
    GetNumberFormatW,'GetNumberFormatW',\
    GetNumberOfConsoleFonts,'GetNumberOfConsoleFonts',\
    GetNumberOfConsoleInputEvents,'GetNumberOfConsoleInputEvents',\
    GetNumberOfConsoleMouseButtons,'GetNumberOfConsoleMouseButtons',\
    GetOEMCP,'GetOEMCP',\
    GetOverlappedResult,'GetOverlappedResult',\
    GetOverlappedResultEx,'GetOverlappedResultEx',\
    GetPackageApplicationIds,'GetPackageApplicationIds',\
    GetPackageFamilyName,'GetPackageFamilyName',\
    GetPackageFullName,'GetPackageFullName',\
    GetPackageId,'GetPackageId',\
    GetPackageInfo,'GetPackageInfo',\
    GetPackagePath,'GetPackagePath',\
    GetPackagePathByFullName,'GetPackagePathByFullName',\
    GetPackagesByPackageFamily,'GetPackagesByPackageFamily',\
    GetPhysicallyInstalledSystemMemory,'GetPhysicallyInstalledSystemMemory',\
    GetPriorityClass,'GetPriorityClass',\
    GetPrivateProfileIntA,'GetPrivateProfileIntA',\
    GetPrivateProfileIntW,'GetPrivateProfileIntW',\
    GetPrivateProfileSectionA,'GetPrivateProfileSectionA',\
    GetPrivateProfileSectionNamesA,'GetPrivateProfileSectionNamesA',\
    GetPrivateProfileSectionNamesW,'GetPrivateProfileSectionNamesW',\
    GetPrivateProfileSectionW,'GetPrivateProfileSectionW',\
    GetPrivateProfileStringA,'GetPrivateProfileStringA',\
    GetPrivateProfileStringW,'GetPrivateProfileStringW',\
    GetPrivateProfileStructA,'GetPrivateProfileStructA',\
    GetPrivateProfileStructW,'GetPrivateProfileStructW',\
    GetProcAddress,'GetProcAddress',\
    GetProcessAffinityMask,'GetProcessAffinityMask',\
    GetProcessDefaultCpuSets,'GetProcessDefaultCpuSets',\
    GetProcessDEPPolicy,'GetProcessDEPPolicy',\
    GetProcessGroupAffinity,'GetProcessGroupAffinity',\
    GetProcessHandleCount,'GetProcessHandleCount',\
    GetProcessHeap,'GetProcessHeap',\
    GetProcessHeaps,'GetProcessHeaps',\
    GetProcessId,'GetProcessId',\
    GetProcessIdOfThread,'GetProcessIdOfThread',\
    GetProcessInformation,'GetProcessInformation',\
    GetProcessIoCounters,'GetProcessIoCounters',\
    GetProcessMitigationPolicy,'GetProcessMitigationPolicy',\
    GetProcessorSystemCycleTime,'GetProcessorSystemCycleTime',\
    GetProcessPreferredUILanguages,'GetProcessPreferredUILanguages',\
    GetProcessPriorityBoost,'GetProcessPriorityBoost',\
    GetProcessShutdownParameters,'GetProcessShutdownParameters',\
    GetProcessTimes,'GetProcessTimes',\
    GetProcessUserModeExceptionPolicy,'GetProcessUserModeExceptionPolicy',\
    GetProcessVersion,'GetProcessVersion',\
    GetProcessWorkingSetSize,'GetProcessWorkingSetSize',\
    GetProcessWorkingSetSizeEx,'GetProcessWorkingSetSizeEx',\
    GetProductInfo,'GetProductInfo',\
    GetProfileIntA,'GetProfileIntA',\
    GetProfileIntW,'GetProfileIntW',\
    GetProfileSectionA,'GetProfileSectionA',\
    GetProfileSectionW,'GetProfileSectionW',\
    GetProfileStringA,'GetProfileStringA',\
    GetProfileStringW,'GetProfileStringW',\
    GetQueuedCompletionStatus,'GetQueuedCompletionStatus',\
    GetQueuedCompletionStatusEx,'GetQueuedCompletionStatusEx',\
    GetShortPathNameA,'GetShortPathNameA',\
    GetShortPathNameW,'GetShortPathNameW',\
    GetStagedPackagePathByFullName,'GetStagedPackagePathByFullName',\
    GetStartupInfoA,'GetStartupInfoA',\
    GetStartupInfoW,'GetStartupInfoW',\
    GetStdHandle,'GetStdHandle',\
    GetStringScripts,'GetStringScripts',\
    GetStringTypeA,'GetStringTypeA',\
    GetStringTypeExA,'GetStringTypeExA',\
    GetStringTypeExW,'GetStringTypeExW',\
    GetStringTypeW,'GetStringTypeW',\
    GetSystemCpuSetInformation,'GetSystemCpuSetInformation',\
    GetSystemDefaultLangID,'GetSystemDefaultLangID',\
    GetSystemDefaultLCID,'GetSystemDefaultLCID',\
    GetSystemDefaultLocaleName,'GetSystemDefaultLocaleName',\
    GetSystemDefaultUILanguage,'GetSystemDefaultUILanguage',\
    GetSystemDEPPolicy,'GetSystemDEPPolicy',\
    GetSystemDirectoryA,'GetSystemDirectoryA',\
    GetSystemDirectoryW,'GetSystemDirectoryW',\
    GetSystemFileCacheSize,'GetSystemFileCacheSize',\
    GetSystemFirmwareTable,'GetSystemFirmwareTable',\
    GetSystemInfo,'GetSystemInfo',\
    GetSystemPowerStatus,'GetSystemPowerStatus',\
    GetSystemPreferredUILanguages,'GetSystemPreferredUILanguages',\
    GetSystemRegistryQuota,'GetSystemRegistryQuota',\
    GetSystemTime,'GetSystemTime',\
    GetSystemTimeAdjustment,'GetSystemTimeAdjustment',\
    GetSystemTimeAsFileTime,'GetSystemTimeAsFileTime',\
    GetSystemTimePreciseAsFileTime,'GetSystemTimePreciseAsFileTime',\
    GetSystemTimes,'GetSystemTimes',\
    GetSystemWindowsDirectoryA,'GetSystemWindowsDirectoryA',\
    GetSystemWindowsDirectoryW,'GetSystemWindowsDirectoryW',\
    GetSystemWow64DirectoryA,'GetSystemWow64DirectoryA',\
    GetSystemWow64DirectoryW,'GetSystemWow64DirectoryW',\
    GetTapeParameters,'GetTapeParameters',\
    GetTapePosition,'GetTapePosition',\
    GetTapeStatus,'GetTapeStatus',\
    GetTempFileNameA,'GetTempFileNameA',\
    GetTempFileNameW,'GetTempFileNameW',\
    GetTempPathA,'GetTempPathA',\
    GetTempPathW,'GetTempPathW',\
    GetThreadContext,'GetThreadContext',\
    GetThreadErrorMode,'GetThreadErrorMode',\
    GetThreadGroupAffinity,'GetThreadGroupAffinity',\
    GetThreadId,'GetThreadId',\
    GetThreadIdealProcessorEx,'GetThreadIdealProcessorEx',\
    GetThreadInformation,'GetThreadInformation',\
    GetThreadIOPendingFlag,'GetThreadIOPendingFlag',\
    GetThreadLocale,'GetThreadLocale',\
    GetThreadPreferredUILanguages,'GetThreadPreferredUILanguages',\
    GetThreadPriority,'GetThreadPriority',\
    GetThreadPriorityBoost,'GetThreadPriorityBoost',\
    GetThreadSelectedCpuSets,'GetThreadSelectedCpuSets',\
    GetThreadSelectorEntry,'GetThreadSelectorEntry',\
    GetThreadTimes,'GetThreadTimes',\
    GetThreadUILanguage,'GetThreadUILanguage',\
    GetTickCount,'GetTickCount',\
    GetTickCount64,'GetTickCount64',\
    GetTimeFormatA,'GetTimeFormatA',\
    GetTimeFormatEx,'GetTimeFormatEx',\
    GetTimeFormatW,'GetTimeFormatW',\
    GetTimeZoneInformation,'GetTimeZoneInformation',\
    GetTimeZoneInformationForYear,'GetTimeZoneInformationForYear',\
    GetUILanguageInfo,'GetUILanguageInfo',\
    GetUserDefaultLangID,'GetUserDefaultLangID',\
    GetUserDefaultLCID,'GetUserDefaultLCID',\
    GetUserDefaultLocaleName,'GetUserDefaultLocaleName',\
    GetUserDefaultUILanguage,'GetUserDefaultUILanguage',\
    GetUserGeoID,'GetUserGeoID',\
    GetUserPreferredUILanguages,'GetUserPreferredUILanguages',\
    GetVDMCurrentDirectories,'GetVDMCurrentDirectories',\
    GetUserNameA,'GetUserNameA',\
    GetUserNameW,'GetUserNameW',\
    GetVersion,'GetVersion',\
    GetVersionExA,'GetVersionExA',\
    GetVersionExW,'GetVersionExW',\
    GetVolumeInformationA,'GetVolumeInformationA',\
    GetVolumeInformationByHandleW,'GetVolumeInformationByHandleW',\
    GetVolumeInformationW,'GetVolumeInformationW',\
    GetVolumeNameForVolumeMountPointA,'GetVolumeNameForVolumeMountPointA',\
    GetVolumeNameForVolumeMountPointW,'GetVolumeNameForVolumeMountPointW',\
    GetVolumePathNameA,'GetVolumePathNameA',\
    GetVolumePathNamesForVolumeNameA,'GetVolumePathNamesForVolumeNameA',\
    GetVolumePathNamesForVolumeNameW,'GetVolumePathNamesForVolumeNameW',\
    GetVolumePathNameW,'GetVolumePathNameW',\
    GetWindowsDirectoryA,'GetWindowsDirectoryA',\
    GetWindowsDirectoryW,'GetWindowsDirectoryW',\
    GetWriteWatch,'GetWriteWatch',\
    GetXStateFeaturesMask,'GetXStateFeaturesMask',\
    GlobalAddAtomA,'GlobalAddAtomA',\
    GlobalAddAtomExA,'GlobalAddAtomExA',\
    GlobalAddAtomExW,'GlobalAddAtomExW',\
    GlobalAddAtomW,'GlobalAddAtomW',\
    GlobalAlloc,'GlobalAlloc',\
    GlobalCompact,'GlobalCompact',\
    GlobalDeleteAtom,'GlobalDeleteAtom',\
    GlobalFindAtomA,'GlobalFindAtomA',\
    GlobalFindAtomW,'GlobalFindAtomW',\
    GlobalFix,'GlobalFix',\
    GlobalFlags,'GlobalFlags',\
    GlobalFree,'GlobalFree',\
    GlobalGetAtomNameA,'GlobalGetAtomNameA',\
    GlobalGetAtomNameW,'GlobalGetAtomNameW',\
    GlobalHandle,'GlobalHandle',\
    GlobalLock,'GlobalLock',\
    GlobalMemoryStatus,'GlobalMemoryStatus',\
    GlobalMemoryStatusEx,'GlobalMemoryStatusEx',\
    GlobalReAlloc,'GlobalReAlloc',\
    GlobalSize,'GlobalSize',\
    GlobalUnfix,'GlobalUnfix',\
    GlobalUnlock,'GlobalUnlock',\
    GlobalUnWire,'GlobalUnWire',\
    GlobalWire,'GlobalWire',\
    Heap32First,'Heap32First',\
    Heap32ListFirst,'Heap32ListFirst',\
    Heap32ListNext,'Heap32ListNext',\
    Heap32Next,'Heap32Next',\
    HeapAlloc,'HeapAlloc',\
    HeapCompact,'HeapCompact',\
    HeapCreate,'HeapCreate',\
    HeapDestroy,'HeapDestroy',\
    HeapFree,'HeapFree',\
    HeapLock,'HeapLock',\
    HeapQueryInformation,'HeapQueryInformation',\
    HeapReAlloc,'HeapReAlloc',\
    HeapSetInformation,'HeapSetInformation',\
    HeapSize,'HeapSize',\
    HeapUnlock,'HeapUnlock',\
    HeapValidate,'HeapValidate',\
    HeapWalk,'HeapWalk',\
    IdnToAscii,'IdnToAscii',\
    IdnToNameprepUnicode,'IdnToNameprepUnicode',\
    IdnToUnicode,'IdnToUnicode',\
    InitAtomTable,'InitAtomTable',\
    InitializeConditionVariable,'InitializeConditionVariable',\
    InitializeContext,'InitializeContext',\
    InitializeCriticalSection,'InitializeCriticalSection',\
    InitializeCriticalSectionAndSpinCount,'InitializeCriticalSectionAndSpinCount',\
    InitializeCriticalSectionEx,'InitializeCriticalSectionEx',\
    InitializeEnclave,'InitializeEnclave',\
    InitializeProcThreadAttributeList,'InitializeProcThreadAttributeList',\
    InitializeSListHead,'InitializeSListHead',\
    InitializeSRWLock,'InitializeSRWLock',\
    InitializeSynchronizationBarrier,'InitializeSynchronizationBarrier',\
    InitOnceBeginInitialize,'InitOnceBeginInitialize',\
    InitOnceComplete,'InitOnceComplete',\
    InitOnceExecuteOnce,'InitOnceExecuteOnce',\
    InitOnceInitialize,'InitOnceInitialize',\
    InstallELAMCertificateInfo,'InstallELAMCertificateInfo',\
    InterlockedCompareExchange,'InterlockedCompareExchange',\
    InterlockedDecrement,'InterlockedDecrement',\
    InterlockedExchange,'InterlockedExchange',\
    InterlockedExchangeAdd,'InterlockedExchangeAdd',\
    InterlockedFlushSList,'InterlockedFlushSList',\
    InterlockedIncrement,'InterlockedIncrement',\
    InterlockedPopEntrySList,'InterlockedPopEntrySList',\
    InterlockedPushEntrySList,'InterlockedPushEntrySList',\
    InterlockedPushListSList,'InterlockedPushListSList',\
    InterlockedPushListSListEx,'InterlockedPushListSListEx',\
    InvalidateConsoleDIBits,'InvalidateConsoleDIBits',\
    IsBadCodePtr,'IsBadCodePtr',\
    IsBadHugeReadPtr,'IsBadHugeReadPtr',\
    IsBadHugeWritePtr,'IsBadHugeWritePtr',\
    IsBadReadPtr,'IsBadReadPtr',\
    IsBadStringPtrA,'IsBadStringPtrA',\
    IsBadStringPtrW,'IsBadStringPtrW',\
    IsBadWritePtr,'IsBadWritePtr',\
    IsCalendarLeapDay,'IsCalendarLeapDay',\
    IsCalendarLeapMonth,'IsCalendarLeapMonth',\
    IsCalendarLeapYear,'IsCalendarLeapYear',\
    IsDBCSLeadByte,'IsDBCSLeadByte',\
    IsDBCSLeadByteEx,'IsDBCSLeadByteEx',\
    IsDebuggerPresent,'IsDebuggerPresent',\
    IsEnclaveTypeSupported,'IsEnclaveTypeSupported',\
    IsNativeVhdBoot,'IsNativeVhdBoot',\
    IsNLSDefinedString,'IsNLSDefinedString',\
    IsNormalizedString,'IsNormalizedString',\
    IsProcessCritical,'IsProcessCritical',\
    IsProcessInJob,'IsProcessInJob',\
    IsProcessorFeaturePresent,'IsProcessorFeaturePresent',\
    IsSystemResumeAutomatic,'IsSystemResumeAutomatic',\
    IsThreadAFiber,'IsThreadAFiber',\
    IsThreadpoolTimerSet,'IsThreadpoolTimerSet',\
    IsTimeZoneRedirectionEnabled,'IsTimeZoneRedirectionEnabled',\
    IsValidCalDateTime,'IsValidCalDateTime',\
    IsValidCodePage,'IsValidCodePage',\
    IsValidLanguageGroup,'IsValidLanguageGroup',\
    IsValidLocale,'IsValidLocale',\
    IsValidLocaleName,'IsValidLocaleName',\
    IsValidNLSVersion,'IsValidNLSVersion',\
    IsWow64Process,'IsWow64Process',\
    K32EmptyWorkingSet,'K32EmptyWorkingSet',\
    K32EnumDeviceDrivers,'K32EnumDeviceDrivers',\
    K32EnumPageFilesA,'K32EnumPageFilesA',\
    K32EnumPageFilesW,'K32EnumPageFilesW',\
    K32EnumProcesses,'K32EnumProcesses',\
    K32EnumProcessModules,'K32EnumProcessModules',\
    K32EnumProcessModulesEx,'K32EnumProcessModulesEx',\
    K32GetDeviceDriverBaseNameA,'K32GetDeviceDriverBaseNameA',\
    K32GetDeviceDriverBaseNameW,'K32GetDeviceDriverBaseNameW',\
    K32GetDeviceDriverFileNameA,'K32GetDeviceDriverFileNameA',\
    K32GetDeviceDriverFileNameW,'K32GetDeviceDriverFileNameW',\
    K32GetMappedFileNameA,'K32GetMappedFileNameA',\
    K32GetMappedFileNameW,'K32GetMappedFileNameW',\
    K32GetModuleBaseNameA,'K32GetModuleBaseNameA',\
    K32GetModuleBaseNameW,'K32GetModuleBaseNameW',\
    K32GetModuleFileNameExA,'K32GetModuleFileNameExA',\
    K32GetModuleFileNameExW,'K32GetModuleFileNameExW',\
    K32GetModuleInformation,'K32GetModuleInformation',\
    K32GetPerformanceInfo,'K32GetPerformanceInfo',\
    K32GetProcessImageFileNameA,'K32GetProcessImageFileNameA',\
    K32GetProcessImageFileNameW,'K32GetProcessImageFileNameW',\
    K32GetProcessMemoryInfo,'K32GetProcessMemoryInfo',\
    K32GetWsChanges,'K32GetWsChanges',\
    K32GetWsChangesEx,'K32GetWsChangesEx',\
    K32InitializeProcessForWsWatch,'K32InitializeProcessForWsWatch',\
    K32QueryWorkingSet,'K32QueryWorkingSet',\
    K32QueryWorkingSetEx,'K32QueryWorkingSetEx',\
    LCIDToLocaleName,'LCIDToLocaleName',\
    LCMapStringA,'LCMapStringA',\
    LCMapStringEx,'LCMapStringEx',\
    LCMapStringW,'LCMapStringW',\
    LeaveCriticalSection,'LeaveCriticalSection',\
    LeaveCriticalSectionWhenCallbackReturns,'LeaveCriticalSectionWhenCallbackReturns',\
    LoadAppInitDlls,'LoadAppInitDlls',\
    LoadEnclaveData,'LoadEnclaveData',\
    LoadLibraryA,'LoadLibraryA',\
    LoadLibraryExA,'LoadLibraryExA',\
    LoadLibraryExW,'LoadLibraryExW',\
    LoadLibraryW,'LoadLibraryW',\
    LoadModule,'LoadModule',\
    LoadPackagedLibrary,'LoadPackagedLibrary',\
    LoadResource,'LoadResource',\
    LoadStringBaseExW,'LoadStringBaseExW',\
    LoadStringBaseW,'LoadStringBaseW',\
    LocalAlloc,'LocalAlloc',\
    LocalCompact,'LocalCompact',\
    LocaleNameToLCID,'LocaleNameToLCID',\
    LocalFileTimeToFileTime,'LocalFileTimeToFileTime',\
    LocalFlags,'LocalFlags',\
    LocalFree,'LocalFree',\
    LocalHandle,'LocalHandle',\
    LocalLock,'LocalLock',\
    LocalReAlloc,'LocalReAlloc',\
    LocalShrink,'LocalShrink',\
    LocalSize,'LocalSize',\
    LocalUnlock,'LocalUnlock',\
    LocateXStateFeature,'LocateXStateFeature',\
    LockFile,'LockFile',\
    LockFileEx,'LockFileEx',\
    LockResource,'LockResource',\
    lstrcatA,'lstrcatA',\
    lstrcatW,'lstrcatW',\
    lstrcmpA,'lstrcmpA',\
    lstrcmpiA,'lstrcmpiA',\
    lstrcmpiW,'lstrcmpiW',\
    lstrcmpW,'lstrcmpW',\
    lstrcpyA,'lstrcpyA',\
    lstrcpynA,'lstrcpynA',\
    lstrcpynW,'lstrcpynW',\
    lstrcpyW,'lstrcpyW',\
    lstrlenA,'lstrlenA',\
    lstrlenW,'lstrlenW',\
    MapUserPhysicalPages,'MapUserPhysicalPages',\
    MapUserPhysicalPagesScatter,'MapUserPhysicalPagesScatter',\
    MapViewOfFile,'MapViewOfFile',\
    MapViewOfFileEx,'MapViewOfFileEx',\
    MapViewOfFileExNuma,'MapViewOfFileExNuma',\
    MapViewOfFileFromApp,'MapViewOfFileFromApp',\
    Module32First,'Module32First',\
    Module32FirstW,'Module32FirstW',\
    Module32Next,'Module32Next',\
    Module32NextW,'Module32NextW',\
    MoveFileA,'MoveFileA',\
    MoveFileExA,'MoveFileExA',\
    MoveFileExW,'MoveFileExW',\
    MoveFileTransactedA,'MoveFileTransactedA',\
    MoveFileTransactedW,'MoveFileTransactedW',\
    MoveFileW,'MoveFileW',\
    MoveFileWithProgressA,'MoveFileWithProgressA',\
    MoveFileWithProgressW,'MoveFileWithProgressW',\
    MulDiv,'MulDiv',\
    MultiByteToWideChar,'MultiByteToWideChar',\
    NeedCurrentDirectoryForExePathA,'NeedCurrentDirectoryForExePathA',\
    NeedCurrentDirectoryForExePathW,'NeedCurrentDirectoryForExePathW',\
    NormalizeString,'NormalizeString',\
    NotifyUILanguageChange,'NotifyUILanguageChange',\
    OfferVirtualMemory,'OfferVirtualMemory',\
    OOBEComplete,'OOBEComplete',\
    OpenConsoleW,'OpenConsoleW',\
    OpenDataFile,'OpenDataFile',\
    OpenEncryptedFileRawA,'OpenEncryptedFileRawA',\
    OpenEncryptedFileRawW,'OpenEncryptedFileRawW',\
    OpenEventA,'OpenEventA',\
    OpenEventW,'OpenEventW',\
    OpenFile,'OpenFile',\
    OpenFileById,'OpenFileById',\
    OpenFileMappingA,'OpenFileMappingA',\
    OpenFileMappingW,'OpenFileMappingW',\
    OpenJobObjectA,'OpenJobObjectA',\
    OpenJobObjectW,'OpenJobObjectW',\
    OpenMutexA,'OpenMutexA',\
    OpenMutexW,'OpenMutexW',\
    OpenPackageInfoByFullName,'OpenPackageInfoByFullName',\
    OpenPrivateNamespaceA,'OpenPrivateNamespaceA',\
    OpenPrivateNamespaceW,'OpenPrivateNamespaceW',\
    OpenProcess,'OpenProcess',\
    OpenProcessToken,'OpenProcessToken',\
    OpenSemaphoreA,'OpenSemaphoreA',\
    OpenSemaphoreW,'OpenSemaphoreW',\
    OpenThread,'OpenThread',\
    OpenThreadToken,'OpenThreadToken',\
    OpenWaitableTimerA,'OpenWaitableTimerA',\
    OpenWaitableTimerW,'OpenWaitableTimerW',\
    OutputDebugStringA,'OutputDebugStringA',\
    OutputDebugStringW,'OutputDebugStringW',\
    PackageFamilyNameFromFullName,'PackageFamilyNameFromFullName',\
    PackageFamilyNameFromId,'PackageFamilyNameFromId',\
    PackageFullNameFromId,'PackageFullNameFromId',\
    PackageIdFromFullName,'PackageIdFromFullName',\
    PackageNameAndPublisherIdFromFamilyName,'PackageNameAndPublisherIdFromFamilyName',\
    ParseApplicationUserModelId,'ParseApplicationUserModelId',\
    PeekConsoleInputA,'PeekConsoleInputA',\
    PeekConsoleInputW,'PeekConsoleInputW',\
    PeekNamedPipe,'PeekNamedPipe',\
    PostQueuedCompletionStatus,'PostQueuedCompletionStatus',\
    PowerClearRequest,'PowerClearRequest',\
    PowerCreateRequest,'PowerCreateRequest',\
    PowerSetRequest,'PowerSetRequest',\
    PrefetchVirtualMemory,'PrefetchVirtualMemory',\
    PrepareTape,'PrepareTape',\
    PrivCopyFileExW,'PrivCopyFileExW',\
    Process32First,'Process32First',\
    Process32FirstW,'Process32FirstW',\
    Process32Next,'Process32Next',\
    Process32NextW,'Process32NextW',\
    ProcessIdToSessionId,'ProcessIdToSessionId',\
    PssCaptureSnapshot,'PssCaptureSnapshot',\
    PssDuplicateSnapshot,'PssDuplicateSnapshot',\
    PssFreeSnapshot,'PssFreeSnapshot',\
    PssQuerySnapshot,'PssQuerySnapshot',\
    PssWalkMarkerCreate,'PssWalkMarkerCreate',\
    PssWalkMarkerFree,'PssWalkMarkerFree',\
    PssWalkMarkerGetPosition,'PssWalkMarkerGetPosition',\
    PssWalkMarkerSeekToBeginning,'PssWalkMarkerSeekToBeginning',\
    PssWalkMarkerSetPosition,'PssWalkMarkerSetPosition',\
    PssWalkSnapshot,'PssWalkSnapshot',\
    PulseEvent,'PulseEvent',\
    PurgeComm,'PurgeComm',\
    QueryActCtxSettingsW,'QueryActCtxSettingsW',\
    QueryActCtxW,'QueryActCtxW',\
    QueryDepthSList,'QueryDepthSList',\
    QueryDosDeviceA,'QueryDosDeviceA',\
    QueryDosDeviceW,'QueryDosDeviceW',\
    QueryFullProcessImageNameA,'QueryFullProcessImageNameA',\
    QueryFullProcessImageNameW,'QueryFullProcessImageNameW',\
    QueryIdleProcessorCycleTime,'QueryIdleProcessorCycleTime',\
    QueryIdleProcessorCycleTimeEx,'QueryIdleProcessorCycleTimeEx',\
    QueryInformationJobObject,'QueryInformationJobObject',\
    QueryIoRateControlInformationJobObject,'QueryIoRateControlInformationJobObject',\
    QueryMemoryResourceNotification,'QueryMemoryResourceNotification',\
    QueryPerformanceCounter,'QueryPerformanceCounter',\
    QueryPerformanceFrequency,'QueryPerformanceFrequency',\
    QueryProcessAffinityUpdateMode,'QueryProcessAffinityUpdateMode',\
    QueryProcessCycleTime,'QueryProcessCycleTime',\
    QueryProtectedPolicy,'QueryProtectedPolicy',\
    QueryThreadCycleTime,'QueryThreadCycleTime',\
    QueryThreadpoolStackInformation,'QueryThreadpoolStackInformation',\
    QueryThreadProfiling,'QueryThreadProfiling',\
    QueryUnbiasedInterruptTime,'QueryUnbiasedInterruptTime',\
    QueueUserAPC,'QueueUserAPC',\
    QueueUserWorkItem,'QueueUserWorkItem',\
    RaiseException,'RaiseException',\
    RaiseFailFastException,'RaiseFailFastException',\
    ReadConsoleA,'ReadConsoleA',\
    ReadConsoleInputA,'ReadConsoleInputA',\
    ReadConsoleInputExA,'ReadConsoleInputExA',\
    ReadConsoleInputExW,'ReadConsoleInputExW',\
    ReadConsoleInputW,'ReadConsoleInputW',\
    ReadConsoleOutputA,'ReadConsoleOutputA',\
    ReadConsoleOutputAttribute,'ReadConsoleOutputAttribute',\
    ReadConsoleOutputCharacterA,'ReadConsoleOutputCharacterA',\
    ReadConsoleOutputCharacterW,'ReadConsoleOutputCharacterW',\
    ReadConsoleOutputW,'ReadConsoleOutputW',\
    ReadConsoleW,'ReadConsoleW',\
    ReadDirectoryChangesW,'ReadDirectoryChangesW',\
    ReadFile,'ReadFile',\
    ReadFileEx,'ReadFileEx',\
    ReadFileScatter,'ReadFileScatter',\
    ReadProcessMemory,'ReadProcessMemory',\
    ReadThreadProfilingData,'ReadThreadProfilingData',\
    ReclaimVirtualMemory,'ReclaimVirtualMemory',\
    RegCloseKey,'RegCloseKey',\
    RegCopyTreeW,'RegCopyTreeW',\
    RegCreateKeyExA,'RegCreateKeyExA',\
    RegCreateKeyExW,'RegCreateKeyExW',\
    RegDeleteTreeA,'RegDeleteTreeA',\
    RegDeleteTreeW,'RegDeleteTreeW',\
    RegDeleteValueA,'RegDeleteValueA',\
    RegDeleteValueW,'RegDeleteValueW',\
    RegDisablePredefinedCacheEx,'RegDisablePredefinedCacheEx',\
    RegEnumKeyExA,'RegEnumKeyExA',\
    RegEnumKeyExW,'RegEnumKeyExW',\
    RegEnumValueA,'RegEnumValueA',\
    RegEnumValueW,'RegEnumValueW',\
    RegFlushKey,'RegFlushKey',\
    RegGetKeySecurity,'RegGetKeySecurity',\
    RegGetValueA,'RegGetValueA',\
    RegGetValueW,'RegGetValueW',\
    RegisterApplicationRecoveryCallback,'RegisterApplicationRecoveryCallback',\
    RegisterApplicationRestart,'RegisterApplicationRestart',\
    RegisterBadMemoryNotification,'RegisterBadMemoryNotification',\
    RegisterWaitForSingleObject,'RegisterWaitForSingleObject',\
    RegisterWaitUntilOOBECompleted,'RegisterWaitUntilOOBECompleted',\
    RegLoadKeyA,'RegLoadKeyA',\
    RegLoadKeyW,'RegLoadKeyW',\
    RegLoadMUIStringA,'RegLoadMUIStringA',\
    RegLoadMUIStringW,'RegLoadMUIStringW',\
    RegNotifyChangeKeyValue,'RegNotifyChangeKeyValue',\
    RegOpenCurrentUser,'RegOpenCurrentUser',\
    RegOpenKeyExA,'RegOpenKeyExA',\
    RegOpenKeyExW,'RegOpenKeyExW',\
    RegOpenUserClassesRoot,'RegOpenUserClassesRoot',\
    RegQueryInfoKeyA8,'RegQueryInfoKeyA',\
    RegQueryInfoKeyW8,'RegQueryInfoKeyW',\
    RegQueryValueExA,'RegQueryValueExA',\
    RegQueryValueExW,'RegQueryValueExW',\
    RegRestoreKeyA,'RegRestoreKeyA',\
    RegRestoreKeyW,'RegRestoreKeyW',\
    RegSaveKeyExA,'RegSaveKeyExA',\
    RegSaveKeyExW,'RegSaveKeyExW',\
    RegSetKeySecurity,'RegSetKeySecurity',\
    RegSetValueExA,'RegSetValueExA',\
    RegSetValueExW,'RegSetValueExW',\
    RegUnLoadKeyA,'RegUnLoadKeyA',\
    RegUnLoadKeyW,'RegUnLoadKeyW',\
    ReleaseActCtx,'ReleaseActCtx',\
    ReleaseMutex,'ReleaseMutex',\
    ReleaseMutexWhenCallbackReturns,'ReleaseMutexWhenCallbackReturns',\
    ReleaseSemaphore,'ReleaseSemaphore',\
    ReleaseSemaphoreWhenCallbackReturns,'ReleaseSemaphoreWhenCallbackReturns',\
    ReleaseSRWLockExclusive,'ReleaseSRWLockExclusive',\
    ReleaseSRWLockShared,'ReleaseSRWLockShared',\
    RemoveDirectoryA,'RemoveDirectoryA',\
    RemoveDirectoryTransactedA,'RemoveDirectoryTransactedA',\
    RemoveDirectoryTransactedW,'RemoveDirectoryTransactedW',\
    RemoveDirectoryW,'RemoveDirectoryW',\
    RemoveDllDirectory,'RemoveDllDirectory',\
    RemoveSecureMemoryCacheCallback,'RemoveSecureMemoryCacheCallback',\
    RemoveVectoredContinueHandler,'RemoveVectoredContinueHandler',\
    RemoveVectoredExceptionHandler,'RemoveVectoredExceptionHandler',\
    ReOpenFile,'ReOpenFile',\
    ReplaceFileA,'ReplaceFileA',\
    ReplaceFileW,'ReplaceFileW',\
    ReplacePartitionUnit,'ReplacePartitionUnit',\
    RequestDeviceWakeup,'RequestDeviceWakeup',\
    RequestWakeupLatency,'RequestWakeupLatency',\
    ResetEvent,'ResetEvent',\
    ResetWriteWatch,'ResetWriteWatch',\
    ResolveDelayLoadedAPI,'ResolveDelayLoadedAPI',\
    ResolveDelayLoadsFromDll,'ResolveDelayLoadsFromDll',\
    ResolveLocaleName,'ResolveLocaleName',\
    RestoreLastError,'RestoreLastError',\
    ResumeThread,'ResumeThread',\
    RtlCaptureContext,'RtlCaptureContext',\
    RtlCaptureStackBackTrace,'RtlCaptureStackBackTrace',\
    RtlCompareMemory,'RtlCompareMemory',\
    RtlCopyMemory,'RtlCopyMemory',\
    RtlFillMemory,'RtlFillMemory',\
    RtlMoveMemory,'RtlMoveMemory',\
    RtlRaiseException,'RtlRaiseException',\
    RtlUnwind,'RtlUnwind',\
    RtlVirtualUnwind,'RtlVirtualUnwind',\
    RtlZeroMemory,'RtlZeroMemory',\
    ScrollConsoleScreenBufferA,'ScrollConsoleScreenBufferA',\
    ScrollConsoleScreenBufferW,'ScrollConsoleScreenBufferW',\
    SearchPathA,'SearchPathA',\
    SearchPathW,'SearchPathW',\
    SetCachedSigningLevel,'SetCachedSigningLevel',\
    SetCalendarInfoA,'SetCalendarInfoA',\
    SetCalendarInfoW,'SetCalendarInfoW',\
    SetCommBreak,'SetCommBreak',\
    SetCommConfig,'SetCommConfig',\
    SetCommMask,'SetCommMask',\
    SetCommState,'SetCommState',\
    SetCommTimeouts,'SetCommTimeouts',\
    SetComputerNameA,'SetComputerNameA',\
    SetComputerNameExA,'SetComputerNameExA',\
    SetComputerNameExW,'SetComputerNameExW',\
    SetComputerNameW,'SetComputerNameW',\
    SetConsoleActiveScreenBuffer,'SetConsoleActiveScreenBuffer',\
    SetConsoleCP,'SetConsoleCP',\
    SetConsoleCtrlHandler,'SetConsoleCtrlHandler',\
    SetConsoleCursor,'SetConsoleCursor',\
    SetConsoleCursorInfo,'SetConsoleCursorInfo',\
    SetConsoleCursorPosition,'SetConsoleCursorPosition',\
    SetConsoleDisplayMode,'SetConsoleDisplayMode',\
    SetConsoleFont,'SetConsoleFont',\
    SetConsoleHardwareState,'SetConsoleHardwareState',\
    SetConsoleHistoryInfo,'SetConsoleHistoryInfo',\
    SetConsoleIcon,'SetConsoleIcon',\
    SetConsoleMaximumWindowSize,'SetConsoleMaximumWindowSize',\
    SetConsoleMode,'SetConsoleMode',\
    SetConsoleNlsMode,'SetConsoleNlsMode',\
    SetConsoleNumberOfCommandsA,'SetConsoleNumberOfCommandsA',\
    SetConsoleNumberOfCommandsW,'SetConsoleNumberOfCommandsW',\
    SetConsoleOS2OemFormat,'SetConsoleOS2OemFormat',\
    SetConsoleOutputCP,'SetConsoleOutputCP',\
    SetConsolePalette,'SetConsolePalette',\
    SetConsoleScreenBufferInfoEx,'SetConsoleScreenBufferInfoEx',\
    SetConsoleScreenBufferSize,'SetConsoleScreenBufferSize',\
    SetConsoleTextAttribute,'SetConsoleTextAttribute',\
    SetConsoleTitleA,'SetConsoleTitleA',\
    SetConsoleTitleW,'SetConsoleTitleW',\
    SetConsoleWindowInfo,'SetConsoleWindowInfo',\
    SetCriticalSectionSpinCount,'SetCriticalSectionSpinCount',\
    SetCurrentConsoleFontEx,'SetCurrentConsoleFontEx',\
    SetCurrentDirectoryA,'SetCurrentDirectoryA',\
    SetCurrentDirectoryW,'SetCurrentDirectoryW',\
    SetDefaultCommConfigA,'SetDefaultCommConfigA',\
    SetDefaultCommConfigW,'SetDefaultCommConfigW',\
    SetDefaultDllDirectories,'SetDefaultDllDirectories',\
    SetDllDirectoryA,'SetDllDirectoryA',\
    SetDllDirectoryW,'SetDllDirectoryW',\
    SetDynamicTimeZoneInformation,'SetDynamicTimeZoneInformation',\
    SetEndOfFile,'SetEndOfFile',\
    SetEnvironmentStringsA,'SetEnvironmentStringsA',\
    SetEnvironmentStringsW,'SetEnvironmentStringsW',\
    SetEnvironmentVariableA,'SetEnvironmentVariableA',\
    SetEnvironmentVariableW,'SetEnvironmentVariableW',\
    SetErrorMode,'SetErrorMode',\
    SetEvent,'SetEvent',\
    SetEventWhenCallbackReturns,'SetEventWhenCallbackReturns',\
    SetFileApisToANSI,'SetFileApisToANSI',\
    SetFileApisToOEM,'SetFileApisToOEM',\
    SetFileAttributesA,'SetFileAttributesA',\
    SetFileAttributesTransactedA,'SetFileAttributesTransactedA',\
    SetFileAttributesTransactedW,'SetFileAttributesTransactedW',\
    SetFileAttributesW,'SetFileAttributesW',\
    SetFileBandwidthReservation,'SetFileBandwidthReservation',\
    SetFileCompletionNotificationModes,'SetFileCompletionNotificationModes',\
    SetFileInformationByHandle,'SetFileInformationByHandle',\
    SetFileIoOverlappedRange,'SetFileIoOverlappedRange',\
    SetFilePointer,'SetFilePointer',\
    SetFilePointerEx,'SetFilePointerEx',\
    SetFileShortNameA,'SetFileShortNameA',\
    SetFileShortNameW,'SetFileShortNameW',\
    SetFileTime,'SetFileTime',\
    SetFileValidData,'SetFileValidData',\
    SetFirmwareEnvironmentVariableA,'SetFirmwareEnvironmentVariableA',\
    SetFirmwareEnvironmentVariableExA,'SetFirmwareEnvironmentVariableExA',\
    SetFirmwareEnvironmentVariableExW,'SetFirmwareEnvironmentVariableExW',\
    SetFirmwareEnvironmentVariableW,'SetFirmwareEnvironmentVariableW',\
    SetHandleCount,'SetHandleCount',\
    SetHandleInformation,'SetHandleInformation',\
    SetInformationJobObject,'SetInformationJobObject',\
    SetIoRateControlInformationJobObject,'SetIoRateControlInformationJobObject',\
    SetLastConsoleEventActive,'SetLastConsoleEventActive',\
    SetLastError,'SetLastError',\
    SetLocaleInfoA,'SetLocaleInfoA',\
    SetLocaleInfoW,'SetLocaleInfoW',\
    SetLocalPrimaryComputerNameA,'SetLocalPrimaryComputerNameA',\
    SetLocalPrimaryComputerNameW,'SetLocalPrimaryComputerNameW',\
    SetLocalTime,'SetLocalTime',\
    SetMailslotInfo,'SetMailslotInfo',\
    SetMessageWaitingIndicator,'SetMessageWaitingIndicator',\
    SetNamedPipeAttribute,'SetNamedPipeAttribute',\
    SetNamedPipeHandleState,'SetNamedPipeHandleState',\
    SetPriorityClass,'SetPriorityClass',\
    SetProcessAffinityMask,'SetProcessAffinityMask',\
    SetProcessAffinityUpdateMode,'SetProcessAffinityUpdateMode',\
    SetProcessDefaultCpuSets,'SetProcessDefaultCpuSets',\
    SetProcessDEPPolicy,'SetProcessDEPPolicy',\
    SetProcessInformation,'SetProcessInformation',\
    SetProcessMitigationPolicy,'SetProcessMitigationPolicy',\
    SetProcessPreferredUILanguages,'SetProcessPreferredUILanguages',\
    SetProcessPriorityBoost,'SetProcessPriorityBoost',\
    SetProcessShutdownParameters,'SetProcessShutdownParameters',\
    SetProcessUserModeExceptionPolicy,'SetProcessUserModeExceptionPolicy',\
    SetProcessWorkingSetSize,'SetProcessWorkingSetSize',\
    SetProcessWorkingSetSizeEx,'SetProcessWorkingSetSizeEx',\
    SetProtectedPolicy,'SetProtectedPolicy',\
    SetSearchPathMode,'SetSearchPathMode',\
    SetStdHandle,'SetStdHandle',\
    SetStdHandleEx,'SetStdHandleEx',\
    SetSystemFileCacheSize,'SetSystemFileCacheSize',\
    SetSystemPowerState,'SetSystemPowerState',\
    SetSystemTime,'SetSystemTime',\
    SetSystemTimeAdjustment,'SetSystemTimeAdjustment',\
    SetTapeParameters,'SetTapeParameters',\
    SetTapePosition,'SetTapePosition',\
    SetTermsrvAppInstallMode,'SetTermsrvAppInstallMode',\
    SetThreadAffinityMask,'SetThreadAffinityMask',\
    SetThreadContext,'SetThreadContext',\
    SetThreadErrorMode,'SetThreadErrorMode',\
    SetThreadExecutionState,'SetThreadExecutionState',\
    SetThreadGroupAffinity,'SetThreadGroupAffinity',\
    SetThreadIdealProcessor,'SetThreadIdealProcessor',\
    SetThreadIdealProcessorEx,'SetThreadIdealProcessorEx',\
    SetThreadInformation,'SetThreadInformation',\
    SetThreadLocale,'SetThreadLocale',\
    SetThreadpoolStackInformation,'SetThreadpoolStackInformation',\
    SetThreadpoolThreadMaximum,'SetThreadpoolThreadMaximum',\
    SetThreadpoolThreadMinimum,'SetThreadpoolThreadMinimum',\
    SetThreadpoolTimer,'SetThreadpoolTimer',\
    SetThreadpoolWait,'SetThreadpoolWait',\
    SetThreadpoolWaitEx,'SetThreadpoolWaitEx',\
    SetThreadPreferredUILanguages,'SetThreadPreferredUILanguages',\
    SetThreadPriority,'SetThreadPriority',\
    SetThreadPriorityBoost,'SetThreadPriorityBoost',\
    SetThreadSelectedCpuSets,'SetThreadSelectedCpuSets',\
    SetThreadStackGuarantee,'SetThreadStackGuarantee',\
    SetThreadToken,'SetThreadToken',\
    SetThreadUILanguage,'SetThreadUILanguage',\
    SetTimerQueueTimer,'SetTimerQueueTimer',\
    SetTimeZoneInformation,'SetTimeZoneInformation',\
    SetUnhandledExceptionFilter,'SetUnhandledExceptionFilter',\
    SetupComm,'SetupComm',\
    SetUserGeoID,'SetUserGeoID',\
    SetVDMCurrentDirectories,'SetVDMCurrentDirectories',\
    SetVolumeLabelA,'SetVolumeLabelA',\
    SetVolumeLabelW,'SetVolumeLabelW',\
    SetVolumeMountPointA,'SetVolumeMountPointA',\
    SetVolumeMountPointW,'SetVolumeMountPointW',\
    SetWaitableTimer,'SetWaitableTimer',\
    SetXStateFeaturesMask,'SetXStateFeaturesMask',\
    ShowConsoleCursor,'ShowConsoleCursor',\
    SignalObjectAndWait,'SignalObjectAndWait',\
    SizeofResource,'SizeofResource',\
    Sleep,'Sleep',\
    SleepConditionVariableCS,'SleepConditionVariableCS',\
    SleepConditionVariableSRW,'SleepConditionVariableSRW',\
    SleepEx,'SleepEx',\
    StartThreadpoolIo,'StartThreadpoolIo',\
    SubmitThreadpoolWork,'SubmitThreadpoolWork',\
    SuspendThread,'SuspendThread',\
    SwitchToFiber,'SwitchToFiber',\
    SwitchToThread,'SwitchToThread',\
    SystemTimeToFileTime,'SystemTimeToFileTime',\
    SystemTimeToTzSpecificLocalTime,'SystemTimeToTzSpecificLocalTime',\
    SystemTimeToTzSpecificLocalTimeEx,'SystemTimeToTzSpecificLocalTimeEx',\
    TerminateJobObject,'TerminateJobObject',\
    TerminateProcess,'TerminateProcess',\
    TerminateThread,'TerminateThread',\
    Thread32First,'Thread32First',\
    Thread32Next,'Thread32Next',\
    TlsAlloc,'TlsAlloc',\
    TlsFree,'TlsFree',\
    TlsGetValue,'TlsGetValue',\
    TlsSetValue,'TlsSetValue',\
    Toolhelp32ReadProcessMemory,'Toolhelp32ReadProcessMemory',\
    TransactNamedPipe,'TransactNamedPipe',\
    TransmitCommChar,'TransmitCommChar',\
    TryAcquireSRWLockExclusive,'TryAcquireSRWLockExclusive',\
    TryAcquireSRWLockShared,'TryAcquireSRWLockShared',\
    TryEnterCriticalSection,'TryEnterCriticalSection',\
    TrySubmitThreadpoolCallback,'TrySubmitThreadpoolCallback',\
    TzSpecificLocalTimeToSystemTime,'TzSpecificLocalTimeToSystemTime',\
    TzSpecificLocalTimeToSystemTimeEx,'TzSpecificLocalTimeToSystemTimeEx',\
    uaw_lstrcmpiW,'uaw_lstrcmpiW',\
    uaw_lstrcmpW,'uaw_lstrcmpW',\
    uaw_lstrlenW,'uaw_lstrlenW',\
    uaw_wcschr,'uaw_wcschr',\
    uaw_wcscpy,'uaw_wcscpy',\
    uaw_wcsicmp,'uaw_wcsicmp',\
    uaw_wcslen,'uaw_wcslen',\
    uaw_wcsrchr,'uaw_wcsrchr',\
    UnhandledExceptionFilter,'UnhandledExceptionFilter',\
    UnlockFile,'UnlockFile',\
    UnlockFileEx,'UnlockFileEx',\
    UnmapViewOfFile,'UnmapViewOfFile',\
    UnregisterApplicationRecoveryCallback,'UnregisterApplicationRecoveryCallback',\
    UnregisterApplicationRestart,'UnregisterApplicationRestart',\
    UnregisterBadMemoryNotification,'UnregisterBadMemoryNotification',\
    UnregisterWait,'UnregisterWait',\
    UnregisterWaitEx,'UnregisterWaitEx',\
    UnregisterWaitUntilOOBECompleted,'UnregisterWaitUntilOOBECompleted',\
    UpdateCalendarDayOfWeek,'UpdateCalendarDayOfWeek',\
    UpdateProcThreadAttribute,'UpdateProcThreadAttribute',\
    UpdateResourceA,'UpdateResourceA',\
    UpdateResourceW,'UpdateResourceW',\
    VerifyScripts,'VerifyScripts',\
    VerifyVersionInfoA,'VerifyVersionInfoA',\
    VerifyVersionInfoW,'VerifyVersionInfoW',\
    VerSetConditionMask,'VerSetConditionMask',\
    VirtualAlloc,'VirtualAlloc',\
    VirtualAllocEx,'VirtualAllocEx',\
    VirtualAllocExNuma,'VirtualAllocExNuma',\
    VirtualFree,'VirtualFree',\
    VirtualFreeEx,'VirtualFreeEx',\
    VirtualLock,'VirtualLock',\
    VirtualProtect,'VirtualProtect',\
    VirtualProtectEx,'VirtualProtectEx',\
    VirtualQuery,'VirtualQuery',\
    VirtualQueryEx,'VirtualQueryEx',\
    VirtualUnlock,'VirtualUnlock',\
    WaitCommEvent,'WaitCommEvent',\
    WaitForDebugEvent,'WaitForDebugEvent',\
    WaitForDebugEventEx,'WaitForDebugEventEx',\
    WaitForMultipleObjects,'WaitForMultipleObjects',\
    WaitForMultipleObjectsEx,'WaitForMultipleObjectsEx',\
    WaitForSingleObject,'WaitForSingleObject',\
    WaitForSingleObjectEx,'WaitForSingleObjectEx',\
    WaitForThreadpoolIoCallbacks,'WaitForThreadpoolIoCallbacks',\
    WaitForThreadpoolTimerCallbacks,'WaitForThreadpoolTimerCallbacks',\
    WaitForThreadpoolWaitCallbacks,'WaitForThreadpoolWaitCallbacks',\
    WaitForThreadpoolWorkCallbacks,'WaitForThreadpoolWorkCallbacks',\
    WaitNamedPipeA,'WaitNamedPipeA',\
    WaitNamedPipeW,'WaitNamedPipeW',\
    WakeAllConditionVariable,'WakeAllConditionVariable',\
    WakeConditionVariable,'WakeConditionVariable',\
    WerGetFlags,'WerGetFlags',\
    WerRegisterFile,'WerRegisterFile',\
    WerRegisterMemoryBlock,'WerRegisterMemoryBlock',\
    WerRegisterRuntimeExceptionModule,'WerRegisterRuntimeExceptionModule',\
    WerSetFlags,'WerSetFlags',\
    WerUnregisterFile,'WerUnregisterFile',\
    WerUnregisterMemoryBlock,'WerUnregisterMemoryBlock',\
    WerUnregisterRuntimeExceptionModule,'WerUnregisterRuntimeExceptionModule',\
    WideCharToMultiByte,'WideCharToMultiByte',\
    WinExec,'WinExec',\
    Wow64DisableWow64FsRedirection,'Wow64DisableWow64FsRedirection',\
    Wow64EnableWow64FsRedirection,'Wow64EnableWow64FsRedirection',\
    Wow64GetThreadContext,'Wow64GetThreadContext',\
    Wow64GetThreadSelectorEntry,'Wow64GetThreadSelectorEntry',\
    Wow64RevertWow64FsRedirection,'Wow64RevertWow64FsRedirection',\
    Wow64SetThreadContext,'Wow64SetThreadContext',\
    Wow64SuspendThread,'Wow64SuspendThread',\
    WriteConsoleA,'WriteConsoleA',\
    WriteConsoleInputA,'WriteConsoleInputA',\
    WriteConsoleInputW,'WriteConsoleInputW',\
    WriteConsoleOutputA,'WriteConsoleOutputA',\
    WriteConsoleOutputAttribute,'WriteConsoleOutputAttribute',\
    WriteConsoleOutputCharacterA,'WriteConsoleOutputCharacterA',\
    WriteConsoleOutputCharacterW,'WriteConsoleOutputCharacterW',\
    WriteConsoleOutputW,'WriteConsoleOutputW',\
    WriteConsoleW,'WriteConsoleW',\
    WriteFile,'WriteFile',\
    WriteFileEx,'WriteFileEx',\
    WriteFileGather,'WriteFileGather',\
    WritePrivateProfileSectionA,'WritePrivateProfileSectionA',\
    WritePrivateProfileSectionW,'WritePrivateProfileSectionW',\
    WritePrivateProfileStringA,'WritePrivateProfileStringA',\
    WritePrivateProfileStringW,'WritePrivateProfileStringW',\
    WritePrivateProfileStructA,'WritePrivateProfileStructA',\
    WritePrivateProfileStructW,'WritePrivateProfileStructW',\
    WriteProcessMemory,'WriteProcessMemory',\
    WriteProfileSectionA,'WriteProfileSectionA',\
    WriteProfileSectionW,'WriteProfileSectionW',\
    WriteProfileStringA,'WriteProfileStringA',\
    WriteProfileStringW,'WriteProfileStringW',\
    WriteTapemark,'WriteTapemark',\
    WTSGetActiveConsoleSessionId,'WTSGetActiveConsoleSessionId',\
    ZombifyActCtx,'ZombifyActCtx'
end if

GetFreeSpace equ GlobalMemoryStatus
LockSegment equ GlobalFix
UnlockSegment equ GlobalUnfix
GetCurrentTime equ GetTickCount
MoveMemory equ RtlMoveMemory
FillMemory equ RtlFillMemory
ZeroMemory equ RtlZeroMemory
CaptureStackBackTrace equ RtlCaptureStackBackTrace
CopyMemory equ RtlCopyMemory

;Not present in MASM32 kernel32.lib
;extrn '__imp__CloseProfileUserMapping@0' as CloseProfileUserMapping:dword
;extrn '__imp__GetHandleContext@4' as GetHandleContext:dword
;extrn '__imp__SetHandleContext@8' as SetHandleContext:dword
;extrn '__imp__OpenProfileUserMapping@0' as OpenProfileUserMapping:dword
;extrn '__imp__InterlockedCompareExchange64@12' as InterlockedCompareExchange64:dword

api AddAtom,\
    AddConsoleAlias,\
    AddLocalAlternateComputerName,\
    BeginUpdateResource,\
    BuildCommDCB,\
    BuildCommDCBAndTimeouts,\
    CallNamedPipe,\
    CheckNameLegalDOS8Dot3,\
    CommConfigDialog,\
    CompareString,\
    CopyFile,\
    CopyFileEx,\
    CopyFileTransacted,\
    CreateActCtx,\
    CreateBoundaryDescriptor,\
    CreateDirectory,\
    CreateDirectoryEx,\
    CreateDirectoryTransacted,\
    CreateEvent,\
    CreateEventEx,\
    CreateFile,\
    CreateFileMapping,\
    CreateFileMappingNuma,\
    CreateFileTransacted,\
    CreateHardLink,\
    CreateHardLinkTransacted,\
    CreateJobObject,\
    CreateMailslot,\
    CreateMutex,\
    CreateMutexEx,\
    CreateNamedPipe,\
    CreatePrivateNamespace,\
    CreateProcess,\
    CreateProcessInternal,\
    CreateSemaphore,\
    CreateSemaphoreEx,\
    CreateSymbolicLink,\
    CreateSymbolicLinkTransacted,\
    CreateWaitableTimer,\
    CreateWaitableTimerEx,\
    DefineDosDevice,\
    DeleteFile,\
    DeleteFileTransacted,\
    DeleteVolumeMountPoint,\
    DnsHostnameToComputerName,\
    DosPathToSessionPath,\
    EndUpdateResource,\
    EnumCalendarInfo,\
    EnumCalendarInfoEx,\
    EnumDateFormats,\
    EnumDateFormatsEx,\
    EnumerateLocalComputerNames,\
    EnumLanguageGroupLocales,\
    EnumResourceLanguages,\
    EnumResourceLanguagesEx,\
    EnumResourceNames,\
    EnumResourceNamesEx,\
    EnumResourceTypes,\
    EnumResourceTypesEx,\
    EnumSystemCodePages,\
    EnumSystemLanguageGroups,\
    EnumSystemLocales,\
    EnumTimeFormats,\
    EnumUILanguages,\
    ExpandEnvironmentStrings,\
    ExpungeConsoleCommandHistory,\
    FatalAppExit,\
    FillConsoleOutputCharacter,\
    FindActCtxSectionString,\
    FindAtom,\
    FindFirstChangeNotification,\
    FindFirstFile,\
    FindFirstFileEx,\
    FindFirstFileTransacted,\
    FindFirstVolume,\
    FindFirstVolumeMountPoint,\
    FindNextFile,\
    FindNextVolume,\
    FindNextVolumeMountPoint,\
    FindResource,\
    FindResourceEx,\
    FoldString,\
    FormatMessage,\
    FreeEnvironmentStrings,\
    GetAtomName,\
    GetBinaryType,\
    GetCalendarInfo,\
    GetCommandLine,\
    GetCompressedFileSize,\
    GetCompressedFileSizeTransacted,\
    GetComputerName,\
    GetComputerNameEx,\
    GetConsoleAlias,\
    GetConsoleAliases,\
    GetConsoleAliasesLength,\
    GetConsoleAliasExes,\
    GetConsoleAliasExesLength,\
    GetConsoleOriginalTitle,\
    GetConsoleTitle,\
    GetCPInfoEx,\
    GetCurrencyFormat,\
    GetCurrentDirectory,\
    GetDateFormat,\
    GetDefaultCommConfig,\
    GetDiskFreeSpace,\
    GetDiskFreeSpaceEx,\
    GetDllDirectory,\
    GetDriveType,\
    GetEnvironmentStrings,\
    GetEnvironmentVariable,\
    GetFileAttributes,\
    GetFileAttributesEx,\
    GetFileAttributesTransacted,\
    GetFinalPathNameByHandle,\
    GetFirmwareEnvironmentVariable,\
    GetFirmwareEnvironmentVariableEx,\
    GetFullPathName,\
    GetFullPathNameTransacted,\
    GetGeoInfo,\
    GetLocaleInfo,\
    GetLogicalDriveStrings,\
    GetLongPathName,\
    GetLongPathNameTransacted,\
    GetModuleFileName,\
    GetModuleHandle,\
    GetModuleHandleEx,\
    GetNamedPipeClientComputerName,\
    GetNamedPipeHandleState,\
    GetNumberFormat,\
    GetPrivateProfileInt,\
    GetPrivateProfileSection,\
    GetPrivateProfileSectionNames,\
    GetPrivateProfileString,\
    GetPrivateProfileStruct,\
    GetProfileInt,\
    GetProfileSection,\
    GetProfileString,\
    GetShortPathName,\
    GetStartupInfo,\
    GetStringType,\
    GetStringTypeEx,\
    GetSystemDirectory,\
    GetSystemWindowsDirectory,\
    GetSystemWow64Directory,\
    GetTempFileName,\
    GetTempPath,\
    GetTimeFormat,\
    GetUserName,\
    GetVersionEx,\
    GetVolumeInformation,\
    GetVolumeNameForVolumeMountPoint,\
    GetVolumePathName,\
    GetVolumePathNamesForVolumeName,\
    GetWindowsDirectory,\
    GlobalAddAtom,\
    GlobalAddAtomEx,\
    GlobalFindAtom,\
    GlobalGetAtomName,\
    IsBadStringPtr,\
    K32EnumPageFiles,\
    K32GetDeviceDriverBaseName,\
    K32GetDeviceDriverFileName,\
    K32GetMappedFileName,\
    K32GetModuleBaseName,\
    K32GetModuleFileNameEx,\
    K32GetProcessImageFileName,\
    LCMapString,\
    LoadLibrary,\
    LoadLibraryEx,\
    lstrcat,\
    lstrcmp,\
    lstrcmpi,\
    lstrcpy,\
    lstrcpyn,\
    lstrlen,\
    MoveFile,\
    MoveFileEx,\
    MoveFileTransacted,\
    MoveFileWithProgress,\
    NeedCurrentDirectoryForExePath,\
    OpenEncryptedFileRaw,\
    OpenEvent,\
    OpenFileMapping,\
    OpenJobObject,\
    OpenMutex,\
    OpenPrivateNamespace,\
    OpenSemaphore,\
    OpenWaitableTimer,\
    OutputDebugString,\
    PeekConsoleInput,\
    QueryDosDevice,\
    QueryFullProcessImageName,\
    ReadConsole,\
    ReadConsoleInput,\
    ReadConsoleInputEx,\
    ReadConsoleOutput,\
    ReadConsoleOutputCharacter,\
    RegCreateKeyEx,\
    RegDeleteTree,\
    RegDeleteValue,\
    RegEnumKeyEx,\
    RegEnumValue,\
    RegGetValue,\
    RegLoadKey,\
    RegLoadMUIString,\
    RegOpenKeyEx,\
    RegQueryInfoKey,\
    RegQueryValueEx,\
    RegRestoreKey,\
    RegSaveKeyEx,\
    RegSetValueEx,\
    RegUnLoadKey,\
    RemoveDirectory,\
    RemoveDirectoryTransacted,\
    ReplaceFile,\
    ScrollConsoleScreenBuffer,\
    SearchPath,\
    SetCalendarInfo,\
    SetComputerName,\
    SetComputerNameEx,\
    SetConsoleNumberOfCommands,\
    SetConsoleTitle,\
    SetCurrentDirectory,\
    SetDefaultCommConfig,\
    SetDllDirectory,\
    SetEnvironmentStrings,\
    SetEnvironmentVariable,\
    SetFileAttributes,\
    SetFileAttributesTransacted,\
    SetFileShortName,\
    SetFirmwareEnvironmentVariable,\
    SetFirmwareEnvironmentVariableEx,\
    SetLocaleInfo,\
    SetLocalPrimaryComputerName,\
    SetVolumeLabel,\
    SetVolumeMountPoint,\
    UpdateResource,\
    VerifyVersionInfo,\
    WaitNamedPipe,\
    WriteConsole,\
    WriteConsoleInput,\
    WriteConsoleOutput,\
    WriteConsoleOutputCharacter,\
    WritePrivateProfileSection,\
    WritePrivateProfileString,\
    WritePrivateProfileStruct,\
    WriteProfileSection,\
    WriteProfileString

;======================= Undocumented functions (unknown arguments) =======================;
;__misaligned_access,'__misaligned_access',\
;ActivateActCtxWorker,'ActivateActCtxWorker',\
;AddRefActCtxWorker,'AddRefActCtxWorker',\
;AppContainerDeriveSidFromMoniker,'AppContainerDeriveSidFromMoniker',\
;AppContainerFreeMemory,'AppContainerFreeMemory',\
;AppContainerLookupDisplayNameMrtReference,'AppContainerLookupDisplayNameMrtReference',\
;AppContainerLookupMoniker,'AppContainerLookupMoniker',\
;AppContainerRegisterSid,'AppContainerRegisterSid',\
;AppContainerUnregisterSid,'AppContainerUnregisterSid',\
;AppXFreeMemory,'AppXFreeMemory',\
;AppXGetApplicationData,'AppXGetApplicationData',\
;AppXGetDevelopmentMode,'AppXGetDevelopmentMode',\
;AppXGetOSMaxVersionTested,'AppXGetOSMaxVersionTested',\
;AppXGetOSMinVersion,'AppXGetOSMinVersion',\
;AppXGetPackageCapabilities,'AppXGetPackageCapabilities',\
;AppXGetPackageSid,'AppXGetPackageSid',\
;AppXGetPackageState,'AppXGetPackageState',\
;AppXLookupDisplayName,'AppXLookupDisplayName',\
;AppXLookupMoniker,'AppXLookupMoniker',\
;AppXSetPackageState,'AppXSetPackageState',\
;BaseCheckAppcompatCache,'BaseCheckAppcompatCache',\
;BaseCheckAppcompatCacheEx,'BaseCheckAppcompatCacheEx',\
;BaseCheckAppcompatCacheExWorker,'BaseCheckAppcompatCacheExWorker',\
;BaseCheckAppcompatCacheWorker,'BaseCheckAppcompatCacheWorker',\
;BaseCheckElevation,'BaseCheckElevation',\
;BaseCheckRunApp,'BaseCheckRunApp',\
;BaseCleanupAppcompatCacheSupport,'BaseCleanupAppcompatCacheSupport',\
;BaseCleanupAppcompatCacheSupportWorker,'BaseCleanupAppcompatCacheSupportWorker',\
;BaseDestroyVDMEnvironment,'BaseDestroyVDMEnvironment',\
;BaseDllReadWriteIniFile,'BaseDllReadWriteIniFile',\
;BaseDumpAppcompatCache,'BaseDumpAppcompatCache',\
;BaseDumpAppcompatCacheWorker,'BaseDumpAppcompatCacheWorker',\
;BaseElevationPostProcessing,'BaseElevationPostProcessing',\
;BaseFlushAppcompatCache,'BaseFlushAppcompatCache',\
;BaseFlushAppcompatCacheWorker,'BaseFlushAppcompatCacheWorker',\
;BaseFormatObjectAttributes,'BaseFormatObjectAttributes',\
;BaseFreeAppCompatDataForProcessWorker,'BaseFreeAppCompatDataForProcessWorker',\
;BaseGenerateAppCompatData,'BaseGenerateAppCompatData',\
;BaseInitAppcompatCacheSupport,'BaseInitAppcompatCacheSupport',\
;BaseInitAppcompatCacheSupportWorker,'BaseInitAppcompatCacheSupportWorker',\
;BaseIsAppcompatInfrastructureDisabled,'BaseIsAppcompatInfrastructureDisabled',\
;BaseIsAppcompatInfrastructureDisabledWorker,'BaseIsAppcompatInfrastructureDisabledWorker',\
;BaseIsDosApplication,'BaseIsDosApplication',\
;BaseProcessInitPostImport,'BaseProcessInitPostImport',\
;BaseProcessStart,'BaseProcessStart',\
;BaseQueryModuleData,'BaseQueryModuleData',\
;BaseReadAppCompatDataForProcessWorker,'BaseReadAppCompatDataForProcessWorker',\
;BaseSetLastNTError,'BaseSetLastNTError',\
;BaseThreadInitThunk,'BaseThreadInitThunk',\
;BaseThreadStart,'BaseThreadStart',\
;BaseUpdateAppcompatCache,'BaseUpdateAppcompatCache',\
;BaseUpdateAppcompatCacheWorker,'BaseUpdateAppcompatCacheWorker',\
;BaseUpdateVDMEntry,'BaseUpdateVDMEntry',\
;BaseVerifyUnicodeString,'BaseVerifyUnicodeString',\
;BaseWriteErrorElevationRequiredEvent,'BaseWriteErrorElevationRequiredEvent',\
;BasepAllocateActivationContextActivationBlock,'BasepAllocateActivationContextActivationBlock',\
;BasepAnsiStringToDynamicUnicodeString,'BasepAnsiStringToDynamicUnicodeString',\
;BasepAppCompatHookDLL,'BasepAppCompatHookDLL',\
;BasepAppContainerEnvironmentExtension,'BasepAppContainerEnvironmentExtension',\
;BasepAppXExtension,'BasepAppXExtension',\
;BasepCheckAppCompat,'BasepCheckAppCompat',\
;BasepCheckBadapp,'BasepCheckBadapp',\
;BasepCheckWebBladeHashes,'BasepCheckWebBladeHashes',\
;BasepCheckWinSaferRestrictions,'BasepCheckWinSaferRestrictions',\
;BasepConstructSxsCreateProcessMessage,'BasepConstructSxsCreateProcessMessage',\
;BasepCopyEncryption,'BasepCopyEncryption',\
;BasepFreeActivationContextActivationBlock,'BasepFreeActivationContextActivationBlock',\
;BasepFreeAppCompatData,'BasepFreeAppCompatData',\
;BasepGetAppCompatData,'BasepGetAppCompatData',\
;BasepGetComputerNameFromNtPath,'BasepGetComputerNameFromNtPath',\
;BasepGetExeArchType,'BasepGetExeArchType',\
;BasepIsProcessAllowed,'BasepIsProcessAllowed',\
;BasepMapModuleHandle,'BasepMapModuleHandle',\
;BasepNotifyLoadStringResource,'BasepNotifyLoadStringResource',\
;BasepPostSuccessAppXExtension,'BasepPostSuccessAppXExtension',\
;BasepProcessInvalidImage,'BasepProcessInvalidImage',\
;BasepQueryAppCompat,'BasepQueryAppCompat',\
;BasepReleaseAppXContext,'BasepReleaseAppXContext',\
;BasepReleaseSxsCreateProcessUtilityStruct,'BasepReleaseSxsCreateProcessUtilityStruct',\
;BasepReportFault,'BasepReportFault',\
;BasepSetFileEncryptionCompression,'BasepSetFileEncryptionCompression',\
;CancelTimerQueueTimer,'CancelTimerQueueTimer',\
;CheckAllowDecryptedRemoteDestinationPolicy,'CheckAllowDecryptedRemoteDestinationPolicy',\
;CheckElevation,'CheckElevation',\
;CheckForReadOnlyResource,'CheckForReadOnlyResource',\
;CheckForReadOnlyResourceFilter,'CheckForReadOnlyResourceFilter',\
;CloseConsoleHandle,'CloseConsoleHandle',\
;CloseState,'CloseState',\
;CloseStateAtom,'CloseStateAtom',\
;CloseStateChangeNotification,'CloseStateChangeNotification',\
;CloseStateContainer,'CloseStateContainer',\
;CloseStateLock,'CloseStateLock',\
;CmdBatNotification,'CmdBatNotification',\
;CommitStateAtom,'CommitStateAtom',\
;CompareCalendarDates,'CompareCalendarDates',\
;ConsoleIMERoutine,'ConsoleIMERoutine',\
;ConvertNLSDayOfWeekToWin32DayOfWeek,'ConvertNLSDayOfWeekToWin32DayOfWeek',\
;CreateActCtxWWorker,'CreateActCtxWWorkerqword
;CreateNlsSecurityDescriptor,'CreateNlsSecurityDescriptor',\
;CreateSocketHandle,'CreateSocketHandle',\
;CreateStateAtom,'CreateStateAtom',\
;CreateStateChangeNotification,'CreateStateChangeNotification',\
;CreateStateContainer,'CreateStateContainer',\
;CreateStateLock,'CreateStateLock',\
;CreateStateSubcontainer,'CreateStateSubcontainer',\
;CtrlRoutine,'CtrlRoutine',\
;DeactivateActCtxWorker,'DeactivateActCtxWorker',\
;DeleteStateAtomValue,'DeleteStateAtomValue',\
;DeleteStateContainer,'DeleteStateContainer',\
;DeleteStateContainerValue,'DeleteStateContainerValue',\
;DnsHostnameToComputerNameExW,'DnsHostnameToComputerNameExW',\
;DuplicateEncryptionInfoFileExt,'DuplicateEncryptionInfoFileExt',\
;DuplicateStateContainerHandle,'DuplicateStateContainerHandle',\
;EnumerateStateAtomValues,'EnumerateStateAtomValues',\
;EnumerateStateContainerItems,'EnumerateStateContainerItems',\
;FindActCtxSectionGuidWorker,'FindActCtxSectionGuidWorker',\
;FindActCtxSectionStringWWorker,'FindActCtxSectionStringWWorker',\
;GetAppContainerAce,'GetAppContainerAceqword
;GetApplicationRecoveryCallbackWorker,'GetApplicationRecoveryCallbackWorker',\
;GetApplicationRestartSettingsWorker,'GetApplicationRestartSettingsWorker',\
;GetCalendarDateFormat,'GetCalendarDateFormat',\
;GetCalendarDaysInMonth,'GetCalendarDaysInMonth',\
;GetCalendarDifferenceInDays,'GetCalendarDifferenceInDays',\
;GetCalendarMonthsInYear,'GetCalendarMonthsInYear',\
;GetCalendarWeekNumber,'GetCalendarWeekNumber',\
;GetConsoleCharType,'GetConsoleCharType',\
;GetConsoleCommandHistoryA,'GetConsoleCommandHistoryA',\
;GetConsoleCommandHistoryW,'GetConsoleCommandHistoryW',\
;GetConsoleCommandHistoryLengthA,'GetConsoleCommandHistoryLengthA',\
;GetConsoleCommandHistoryLengthW,'GetConsoleCommandHistoryLengthW',\
;GetConsoleCursorMode,'GetConsoleCursorMode',\
;GetConsoleHardwareState,'GetConsoleHardwareState',\
;GetConsoleInputExeNameA,'GetConsoleInputExeNameA',\
;GetConsoleInputExeNameW,'GetConsoleInputExeNameW',\
;GetConsoleInputWaitHandle,'GetConsoleInputWaitHandle',\
;GetConsoleKeyboardLayoutNameA,'GetConsoleKeyboardLayoutNameA',\
;GetConsoleKeyboardLayoutNameW,'GetConsoleKeyboardLayoutNameW',\
;GetCPFileNameFromRegistry,'GetCPFileNameFromRegistry',\
;GetCurrentActCtxWorker,'GetCurrentActCtxWorker',\
;GetDateFormatAWorker,'GetDateFormatAWorker',\
;GetDateFormatWWorker,'GetDateFormatWWorkerqword
;GetDefaultSortkeySize,'GetDefaultSortkeySize',\
;GetEncryptedFileVersionExt,'GetEncryptedFileVersionExt',\
;GetEraNameCountedString,'GetEraNameCountedString',\
;GetHivePath,'GetHivePath',\
;GetLinguistLangSize,'GetLinguistLangSize',\
;GetNlsSectionName,'GetNlsSectionName',\
;GetRoamingLastObservedChangeTime,'GetRoamingLastObservedChangeTime',\
;GetSerializedAtomBytes,'GetSerializedAtomBytes',\
;GetStateContainerDepth,'GetStateContainerDepth',\
;GetStateFolder,'GetStateFolder',\
;GetStateRootFolder,'GetStateRootFolder',\
;GetStateSettingsFolder,'GetStateSettingsFolder',\
;GetStateVersion,'GetStateVersion',\
;GetSystemAppDataFolder,'GetSystemAppDataFolder',\
;GetSystemAppDataKey,'GetSystemAppDataKey',\
;GetTimeFormatAWorker,'GetTimeFormatAWorker',\
;GetTimeFormatWWorker,'GetTimeFormatWWorker',\
;HeapSummary,'HeapSummary',\
;HeapCreateTagsW,'HeapCreateTagsW',\
;HeapExtend,'HeapExtend',\
;HeapQueryTagW,'HeapQueryTagW',\
;HeapUsage,'HeapUsage',\
;IsValidUILanguage,'IsValidUILanguage',\
;NlsCheckPolicy,'NlsCheckPolicy',\
;NlsConvertIntegerToString,'NlsConvertIntegerToString',\
;NlsEventDataDescCreate,'NlsEventDataDescCreate',\
;NlsGetCacheUpdateCount,'NlsGetCacheUpdateCount',\
;NlsResetProcessLocale,'NlsResetProcessLocale',\
;NlsUpdateLocale,'NlsUpdateLocale',\
;NlsUpdateSystemLocale,'NlsUpdateSystemLocale',\
;NlsWriteEtwEvent,'NlsWriteEtwEvent',\
;NotifyMountMgr,'NotifyMountMgr',\
;NtVdm64CreateProcessInternalW,'NtVdm64CreateProcessInternalW',\
;OpenConsoleWStub,'OpenConsoleWStub',\
;OpenState,'OpenState',\
;OpenStateAtom,'OpenStateAtom',\
;OpenStateExplicit,'OpenStateExplicit',\
;OverrideRoamingDataModificationTimesInRange,'OverrideRoamingDataModificationTimesInRange',\
;PssWalkMarkerRewind,'PssWalkMarkerRewind',\
;PssWalkMarkerSeek,'PssWalkMarkerSeek',\
;PssWalkMarkerTell,'PssWalkMarkerTell',\
;PrivMoveFileIdentityW,'PrivMoveFileIdentityW',\
;PublishStateChangeNotification,'PublishStateChangeNotification',\
;QueryActCtxSettingsWWorker,'QueryActCtxSettingsWWorker',\
;QueryActCtxWWorker,'QueryActCtxWWorker',\
;QueryStateAtomValueInfo,'QueryStateAtomValueInfo',\
;QueryStateContainerItemInfo,'QueryStateContainerItemInfo',\
;QuirkGetData2Worker,'QuirkGetData2Worker',\
;QuirkGetDataWorker,'QuirkGetDataWorker',\
;QuirkIsEnabled2Worker,'QuirkIsEnabled2Worker',\
;QuirkIsEnabled3Worker,'QuirkIsEnabled3Worker',\
;QuirkIsEnabledForPackage2Worker,'QuirkIsEnabledForPackage2Worker',\
;QuirkIsEnabledForPackage3Worker,'QuirkIsEnabledForPackage3Worker',\
;QuirkIsEnabledForPackage4Worker,'QuirkIsEnabledForPackage4Worker',\
;QuirkIsEnabledForPackageWorker,'QuirkIsEnabledForPackageWorker',\
;QuirkIsEnabledForProcessWorker,'QuirkIsEnabledForProcessWorker',\
;QuirkIsEnabledWorker,'QuirkIsEnabledWorker',\
;RaiseInvalid16BitExeError,'RaiseInvalid16BitExeError',\
;ReadStateAtomValue,'ReadStateAtomValue',\
;ReadStateContainerValue,'ReadStateContainerValue',\
;RegisterConsoleIME,'RegisterConsoleIME',\
;RegisterConsoleOS2,'RegisterConsoleOS2',\
;RegisterConsoleVDM,'RegisterConsoleOS2',\
;RegisterStateChangeNotification,'RegisterStateChangeNotification',\
;RegisterStateLock,'RegisterStateLock',\
;RegisterWaitForInputIdle,'RegisterWaitForInputIdle',\
;RegisterWaitForSingleObjectEx,'RegisterWaitForSingleObjectEx',\
;RegisterWowBaseHandlers,'RegisterWowBaseHandlers',\
;RegisterWowExec,'RegisterWowExec',\
;RegKrnGetGlobalState,'RegKrnGetGlobalState',\
;RegKrnInitialize,'RegKrnInitialize',\
;ReleaseActCtxWorker,'ReleaseActCtxWorker',\
;ReleaseStateLock,'ReleaseStateLock',\
;RemoveLocalAlternateComputerNameA,'RemoveLocalAlternateComputerNameA',\
;RemoveLocalAlternateComputerNameW,'RemoveLocalAlternateComputerNameW',\
;ResetState,'ResetState',\
;SetClientDynamicTimeZoneInformation,'SetClientDynamicTimeZoneInformation',\
;SetClientTimeZoneInformation,'SetClientTimeZoneInformation',\
;SetComPlusPackageInstallStatus,'SetComPlusPackageInstallStatus',\
;SetComputerNameEx2W,'SetComputerNameEx2W',\
;SetConsoleCommandHistoryMode,'SetComputerNameEx2W',\
;SetConsoleCursorMode,'SetConsoleCursorMode',\
;SetConsoleInputExeNameA,'SetConsoleInputExeNameA',\
;SetConsoleInputExeNameW,'SetConsoleInputExeNameW',\
;SetConsoleKeyShortcuts,'SetConsoleKeyShortcuts',\
;SetConsoleLocalEUDC,'SetConsoleLocalEUDC',\
;SetConsoleMenuClose,'SetConsoleMenuClose',\
;SetCPGlobal,'SetCPGlobal',\
;SetRoamingLastObservedChangeTime,'SetRoamingLastObservedChangeTime',\
;SetStateVersion,'SetStateVersion',\
;SetThreadpoolTimerEx,'SetThreadpoolTimerEx',\
;SetVolumeMountPointWStub,'SetVolumeMountPointWStub',\
;SetWaitableTimerEx,'SetWaitableTimerEx',\
;SortCloseHandle,'SortCloseHandle',\
;SortGetHandle,'SortGetHandle',\
;SubscribeStateChangeNotification,'SubscribeStateChangeNotification',\
;TermsrvConvertSysRootToUserDir,'TermsrvConvertSysRootToUserDir',\
;TermsrvAppInstallMode,'TermsrvAppInstallMode',\
;TermsrvCreateRegEntry,'TermsrvCreateRegEntry',\
;TermsrvDeleteKey,'TermsrvDeleteKey',\
;TermsrvDeleteValue,'TermsrvDeleteValue',\
;TermsrvGetPreSetValue,'TermsrvGetPreSetValue',\
;TermsrvGetWindowsDirectoryA,'TermsrvGetWindowsDirectoryA',\
;TermsrvGetWindowsDirectoryW,'TermsrvGetWindowsDirectoryW',\
;TermsrvOpenRegEntry,'TermsrvOpenRegEntry',\
;TermsrvOpenUserClasses,'TermsrvOpenUserClasses',\
;TermsrvRestoreKey,'TermsrvRestoreKey',\
;TermsrvSetKeySecurity,'TermsrvSetKeySecurity',\
;TermsrvSetValueKey,'TermsrvSetValueKey',\
;TermsrvSyncUserIniFileExt,'TermsrvSyncUserIniFileExt',\
;UnmapViewOfFileEx,'UnmapViewOfFileEx',\
;UnregisterConsoleIME,'UnregisterConsoleIME',\
;UTRegister,'UTRegister',\
;UTUnRegister,'UTUnRegister',\
;UnregisterStateChangeNotification,'UnregisterStateChangeNotification',\
;UnregisterStateLock,'UnregisterStateLock',\
;UnsubscribeStateChangeNotification,'UnsubscribeStateChangeNotification',\
;ValidateLCType,'ValidateLCType',\
;ValidateLocale,'ValidateLocale',\
;VDMConsoleOperation,'VDMConsoleOperation',\
;VDMOperationStarted,'VDMOperationStarted',\
;VerifyConsoleIoHandle,'VerifyConsoleIoHandle',\
;WerGetFlagsWorker,'WerGetFlagsWorker',\
;WerRegisterFileWorker,'WerGetFlagsWorker',\
;WerRegisterMemoryBlockWorker,'WerRegisterMemoryBlockWorker',\
;WerRegisterRuntimeExceptionModuleWorker,'WerRegisterRuntimeExceptionModuleWorker',\
;WerSetFlagsWorker,'WerSetFlagsWorker',\
;WerUnregisterFileWorker,'WerUnregisterFileWorker',\
;WerUnregisterMemoryBlockWorker,'WerUnregisterMemoryBlockWorker',\
;WerUnregisterRuntimeExceptionModuleWorker,'WerUnregisterRuntimeExceptionModuleWorker',\
;WerpCleanupMessageMapping,'WerpCleanupMessageMapping',\
;WerpGetDebugger,'WerpGetDebugger',\
;WerpInitiateRemoteRecovery,'WerpInitiateRemoteRecovery',\
;WerpLaunchAeDebug,'WerpLaunchAeDebug',\
;WerpNotifyLoadStringResource,'WerpNotifyLoadStringResource',\
;WerpNotifyLoadStringResourceEx,'WerpNotifyLoadStringResourceEx',\
;WerpNotifyLoadStringResourceWorker,'WerpNotifyLoadStringResourceWorker',\
;WerpNotifyUseStringResource,'WerpNotifyUseStringResource',\
;WerpNotifyUseStringResourceWorker,'WerpNotifyUseStringResourceWorker',\
;WerpStringLookup,'WerpStringLookup',\
;WriteConsoleInputVDMA,'WriteConsoleInputVDMA',\
;WriteConsoleInputVDMW,'WriteConsoleInputVDMW',\
;WriteStateAtomValue,'WriteStateAtomValue',\
;WriteStateContainerValue,'WriteStateContainerValue',\
;ZombifyActCtxWorker,'ZombifyActCtxWorker'

;api GetConsoleCommandHistory,\
;    GetConsoleCommandHistoryLength,\
;    GetConsoleInputExeName,\
;    GetConsoleKeyboardLayoutName,\
;    RemoveLocalAlternateComputerName,\
;    SetConsoleInputExeName,\
;    TermsrvGetWindowsDirectory,\
;    WriteConsoleInputVDM

end if ;KERNEL32_INC
